# JumpProcesses.jl

[![Stable Release Docs](https://img.shields.io/badge/Stable%20Release%20Docs-SciML-blue)](https://docs.sciml.ai/JumpProcesses/stable/)
[![Master Branch Docs](https://img.shields.io/badge/Master%20Branch%20Docs-SciML-blue)](https://docs.sciml.ai/JumpProcesses/dev/)
[![DOI](https://zenodo.org/badge/80893293.svg)](https://zenodo.org/doi/10.5281/zenodo.10869721)

<!-- [![Coverage Status](https://coveralls.io/repos/github/SciML/JumpProcesses.jl/badge.svg?branch=master)](https://coveralls.io/github/SciML/JumpProcesses.jl?branch=master)
[![codecov](https://codecov.io/gh/SciML/JumpProcesses.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/SciML/JumpProcesses.jl) -->
<!-- [![Join the chat at https://julialang.zulipchat.com #sciml-bridged](https://img.shields.io/static/v1?label=Zulip&message=chat&color=9558b2&labelColor=389826)](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged) -->
[![Build Status](https://github.com/SciML/JumpProcesses.jl/workflows/CI/badge.svg)](https://github.com/SciML/JumpProcesses.jl/actions?query=workflow%3ACI)
[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor%27s%20Guide-blueviolet)](https://github.com/SciML/ColPrac)
[![SciML Code Style](https://img.shields.io/static/v1?label=code%20style&message=SciML&color=9558b2&labelColor=389826)](https://github.com/SciML/SciMLStyle)

JumpProcesses.jl provides methods for simulating jump processes, known as
stochastic simulation algorithms (SSAs), Doob's method, Gillespie methods, or
Kinetic Monte Carlo methods across different fields of science. It also enables the
incorporation of jump processes into hybrid jump-ODE and jump-SDE models,
including piecewise deterministic Markov processes (PDMPs) and jump diffusions.

JumpProcesses is a component package in the [SciML](https://sciml.ai/) ecosystem,
and one of the core solver libraries included in
[DifferentialEquations.jl](https://github.com/JuliaDiffEq/DifferentialEquations.jl).

For information on using the package,
[see the stable documentation](https://docs.sciml.ai/JumpProcesses/stable/). Use the
[in-development documentation](https://docs.sciml.ai/JumpProcesses/dev/) for the version of
the documentation which contains unreleased features.

The documentation includes

  - [a tutorial on simulating basic Poisson processes](https://docs.sciml.ai/JumpProcesses/stable/tutorials/simple_poisson_process/)
  - [a tutorial and details on using JumpProcesses to simulate jump processes via SSAs (i.e. Gillespie methods)](https://docs.sciml.ai/JumpProcesses/stable/tutorials/discrete_stochastic_example/),
  - [a tutorial on simulating jump-diffusion processes](https://docs.sciml.ai/JumpProcesses/stable/tutorials/jump_diffusion/),
  - [a reference on the types of jumps and available simulation methods](https://docs.sciml.ai/JumpProcesses/stable/jump_types/),
  - [a reference on jump time stepping methods](https://docs.sciml.ai/JumpProcesses/stable/jump_solve/),
  - [a FAQ](https://docs.sciml.ai/JumpProcesses/stable/faq) with information on changing parameters between simulations and using callbacks,
  - [the JumpProcesses.jl API documentation](https://docs.sciml.ai/JumpProcesses/stable/api/).

## Contributions welcomed!


Contact us in sciml-bridged on Slack to discuss where to get started, the [`Help wanted`](https://github.com/SciML/JumpProcesses.jl/issues/431) issue, or just open a PR to address an open issue or add new functionality. Contributions, no matter how small, are always welcome and appreciated,
including documentation editing/writing. See also the [contribution section](#contributing-and-getting-help).

## Installation

There are two ways to install `JumpProcesses.jl`. First, users may install the meta
`DifferentialEquations.jl` package, which installs and wraps `OrdinaryDiffEq.jl`
for solving ODEs, `StochasticDiffEq.jl` for solving SDEs, and `JumpProcesses.jl`,
along with a number of other useful packages for solving models involving ODEs,
SDEs and/or jump process. This single install will provide the user with all of
the facilities for developing and solving Jump problems.

To install the `DifferentialEquations.jl` package, refer to the following link
for complete [installation
details](https://docs.sciml.ai/DiffEqDocs/stable/).

If the user wishes to separately install the `JumpProcesses.jl` library, which is a
lighter dependency than `DifferentialEquations.jl`, then the following code will
install `JumpProcesses.jl` using the Julia package manager:

```julia
using Pkg
Pkg.add("JumpProcesses")
```

## Examples

### Stochastic Chemical Kinetics SIR Model

Here we consider the stochastic chemical kinetics jump process model for the
basic SIR model, involving three species, $(S,I,R)$, that can undergo the
reactions $S + I \to 2I$ and $I \to R$ (each represented as a jump process)

```julia
using JumpProcesses, Plots

# here we order S = 1, I = 2, and R = 3
# substrate stoichiometry:
substoich = [[1 => 1, 2 => 1],    # 1*S + 1*I
    [2 => 1]]                     # 1*I
# net change by each jump type
netstoich = [[1 => -1, 2 => 1],   # S -> S-1, I -> I+1
    [2 => -1, 3 => 1]]            # I -> I-1, R -> R+1
# rate constants for each jump
p = (0.1 / 1000, 0.01)

# p[1] is rate for S+I --> 2I, p[2] for I --> R
pidxs = [1, 2]

maj = MassActionJump(substoich, netstoich; param_idxs = pidxs)

u₀ = [999, 1, 0]       #[S(0),I(0),R(0)]
tspan = (0.0, 250.0)
dprob = DiscreteProblem(u₀, tspan, p)

# use the Direct method to simulate
jprob = JumpProblem(dprob, maj)

# solve as a pure jump process, i.e. using SSAStepper
sol = solve(jprob)
plot(sol)
```

![SIR Model](docs/src/assets/SIR.png)

Instead of `MassActionJump`, we could have used the less efficient, but more
flexible, `ConstantRateJump` type

```julia
rate1(u, p, t) = p[1] * u[1] * u[2]  # p[1]*S*I
function affect1!(integrator)
    integrator.u[1] -= 1         # S -> S - 1
    integrator.u[2] += 1         # I -> I + 1
end
jump = ConstantRateJump(rate1, affect1!)

rate2(u, p, t) = p[2] * u[2]      # p[2]*I
function affect2!(integrator)
    integrator.u[2] -= 1        # I -> I - 1
    integrator.u[3] += 1        # R -> R + 1
end
jump2 = ConstantRateJump(rate2, affect2!)
jprob = JumpProblem(dprob, jump, jump2)
sol = solve(jprob)
```

### Jump-ODE Example

Let's solve an ODE for exponential growth, but coupled to a constant rate jump
(Poisson) process that halves the solution each time it fires

```julia
using DifferentialEquations, Plots

# du/dt = u is the ODE part
function f(du, u, p, t)
    du[1] = u[1]
end
u₀ = [0.2]
tspan = (0.0, 10.0)
prob = ODEProblem(f, u₀, tspan)

# jump part

# fires with a constant intensity of 2
rate(u, p, t) = 2

# halve the solution when firing
affect!(integrator) = (integrator.u[1] = integrator.u[1] / 2)
jump = ConstantRateJump(rate, affect!)

# use the Direct method to handle simulating the jumps
jump_prob = JumpProblem(prob, Direct(), jump)

# now couple to the ODE, solving the ODE with the Tsit5 method
sol = solve(jump_prob, Tsit5())
plot(sol)
```

![constant_rate_jump](docs/src/assets/constant_rate_jump.png)

## Contributing and Getting Help

  - Please refer to the
    [SciML ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://github.com/SciML/ColPrac/blob/master/README.md)
    for guidance on PRs, issues, and other matters relating to contributing to SciML.

  - See the [SciML Style Guide](https://github.com/SciML/SciMLStyle) for common coding practices and other style decisions.
  - There are a few community forums for getting help and asking questions:
    
      + The #diffeq-bridged and #sciml-bridged channels in the
        [Julia Slack](https://julialang.org/slack/)
      + The #diffeq-bridged and #sciml-bridged channels in the
        [Julia Zulip](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
      + The [Julia Discourse forums](https://discourse.julialang.org)
      + See also the [SciML Community page](https://sciml.ai/community/)

struct SimpleTauLeaping <: DiffEqBase.AbstractDEAlgorithm end

struct SimpleExplicitTauLeaping{T <: AbstractFloat} <: DiffEqBase.AbstractDEAlgorithm
    epsilon::T  # Error control parameter
end

SimpleExplicitTauLeaping(; epsilon = 0.05) = SimpleExplicitTauLeaping(epsilon)

function validate_pure_leaping_inputs(jump_prob::JumpProblem, alg)
    if !(jump_prob.aggregator isa PureLeaping)
        @warn "When using $alg, please pass PureLeaping() as the aggregator to the \
        JumpProblem, i.e. call JumpProblem(::DiscreteProblem, PureLeaping(),...). \
        Passing $(jump_prob.aggregator) is deprecated and will be removed in the next breaking release."
    end
    isempty(jump_prob.jump_callback.continuous_callbacks) &&
        isempty(jump_prob.jump_callback.discrete_callbacks) &&
        isempty(jump_prob.constant_jumps) &&
        isempty(jump_prob.variable_jumps) &&
        get_num_majumps(jump_prob.massaction_jump) == 0 &&
        jump_prob.regular_jump !== nothing
end

function validate_pure_leaping_inputs(jump_prob::JumpProblem, alg::SimpleExplicitTauLeaping)
    if !(jump_prob.aggregator isa PureLeaping)
        @warn "When using $alg, please pass PureLeaping() as the aggregator to the \
        JumpProblem, i.e. call JumpProblem(::DiscreteProblem, PureLeaping(),...). \
        Passing $(jump_prob.aggregator) is deprecated and will be removed in the next breaking release."
    end
    isempty(jump_prob.jump_callback.continuous_callbacks) &&
        isempty(jump_prob.jump_callback.discrete_callbacks) &&
        isempty(jump_prob.constant_jumps) &&
        isempty(jump_prob.variable_jumps) &&
        jump_prob.massaction_jump !== nothing
end

"""
    _process_saveat(saveat, tspan, save_start, save_end)

Process `saveat` into a sorted vector of strictly interior save times (excluding
both `tspan` endpoints), and resolve `save_start`/`save_end` defaults following
OrdinaryDiffEq conventions.

Endpoint saving is controlled purely by the returned `save_start`/`save_end`
flags. When the user passes `nothing` for these, defaults are:
- No saveat or saveat is a Number: `true` for both.
- saveat is a collection: `true` if the corresponding endpoint is `in` the collection.
"""
function _process_saveat(saveat, tspan, save_start, save_end)
    t0, tf = tspan
    if isnothing(saveat)
        saveat_vec = Vector{typeof(t0)}()
        _save_start = something(save_start, true)
        _save_end = something(save_end, true)
    elseif saveat isa Number
        saveat_vec = collect(t0 + saveat:saveat:tf)
        if !isempty(saveat_vec) && last(saveat_vec) == tf
            pop!(saveat_vec)
        end
        _save_start = something(save_start, true)
        _save_end = something(save_end, true)
    else
        saveat_vec = sort!(collect(saveat))
        _save_start = something(save_start, insorted(t0, saveat_vec))
        _save_end = something(save_end, insorted(tf, saveat_vec))
        lo = searchsortedlast(saveat_vec, t0) + 1
        hi = searchsortedfirst(saveat_vec, tf) - 1
        saveat_vec = saveat_vec[lo:hi]
    end
    return saveat_vec, _save_start, _save_end
end

function DiffEqBase.solve(jump_prob::JumpProblem, alg::SimpleTauLeaping;
        seed = nothing, dt = error("dt is required for SimpleTauLeaping."),
        saveat = nothing, save_start = nothing, save_end = nothing)
    validate_pure_leaping_inputs(jump_prob, alg) ||
        error("SimpleTauLeaping can only be used with PureLeaping JumpProblems with only RegularJumps.")

    (; prob, rng) = jump_prob
    (seed !== nothing) && seed!(rng, seed)

    rj = jump_prob.regular_jump
    rate = rj.rate # rate function rate(out,u,p,t)
    numjumps = rj.numjumps # used for size information (# of jump processes)
    c = rj.c # matrix-free operator c(u_buffer, uprev, tprev, counts, p, mark)

    if !isnothing(rj.mark_dist) == nothing # https://github.com/JuliaDiffEq/DifferentialEquations.jl/issues/250
        error("Mark distributions are currently not supported in SimpleTauLeaping")
    end

    u0 = copy(prob.u0)
    du = similar(u0)
    rate_cache = zeros(float(eltype(u0)), numjumps)

    tspan = prob.tspan
    p = prob.p

    n = Int((tspan[2] - tspan[1]) / dt) + 1

    saveat_times, save_start, save_end = _process_saveat(saveat, tspan, save_start, save_end)

    if save_start
        usave = [copy(u0)]
        tsave = typeof(tspan[1])[tspan[1]]
    else
        usave = typeof(u0)[]
        tsave = typeof(tspan[1])[]
    end
    save_idx = 1

    # Pre-allocate working buffers — swap each step to avoid copying
    uprev = u0          # u0 is already a copy
    u_new = similar(u0)
    counts = zero(rate_cache)

    for i in 2:n
        tprev = tspan[1] + (i - 2) * dt
        t_new = tprev + dt
        rate(rate_cache, uprev, p, tprev)
        rate_cache .*= dt
        counts .= pois_rand.((rng,), rate_cache)
        c(du, uprev, p, tprev, counts, mark)
        u_new .= du .+ uprev

        # Save logic — only allocate (via copy) when actually saving
        if isempty(saveat_times)
            push!(usave, copy(u_new))
            push!(tsave, t_new)
        else
            while save_idx <= length(saveat_times) && t_new >= saveat_times[save_idx]
                push!(usave, copy(u_new))
                push!(tsave, saveat_times[save_idx])
                save_idx += 1
            end
        end

        uprev, u_new = u_new, uprev
    end

    # Save endpoint if requested and not already saved
    if save_end && (isempty(tsave) || tsave[end] != tspan[2])
        push!(usave, copy(uprev))
        push!(tsave, tspan[2])
    end

    sol = DiffEqBase.build_solution(prob, alg, tsave, usave,
        calculate_error = false,
        interp = DiffEqBase.ConstantInterpolation(tsave, usave))
end

# Compute the highest order of reaction (HOR) for each reaction j, as per Cao et al. (2006), Section IV.
# HOR is the sum of stoichiometric coefficients of reactants in reaction j.
# Extract the element type from reactant_stoch to avoid hardcoding type assumptions.
function compute_hor(reactant_stoch, numjumps)
    stoch_type = eltype(first(first(reactant_stoch)))
    hor = zeros(stoch_type, numjumps)
    for j in 1:numjumps
        order = sum(
            stoch for (spec_idx, stoch) in reactant_stoch[j]; init = zero(stoch_type))
        if order > 3
            error("Reaction $j has order $order, which is not supported (maximum order is 3).")
        end
        hor[j] = order
    end
    return hor
end

# Precompute reaction conditions for each species i, including:
# - max_hor: the highest order of reaction (HOR) where species i is a reactant.
# - max_stoich: the maximum stoichiometry (nu_ij) in reactions with max_hor.
# Used to optimize compute_gi, as per Cao et al. (2006), Section IV, equation (27).
function precompute_reaction_conditions(reactant_stoch, hor, numspecies, numjumps)
    hor_type = eltype(hor)
    max_hor = zeros(hor_type, numspecies)
    max_stoich = zeros(hor_type, numspecies)
    for j in 1:numjumps
        for (spec_idx, stoch) in reactant_stoch[j]
            if stoch > 0  # Species is a reactant
                if hor[j] > max_hor[spec_idx]
                    max_hor[spec_idx] = hor[j]
                    max_stoich[spec_idx] = stoch
                elseif hor[j] == max_hor[spec_idx]
                    max_stoich[spec_idx] = max(max_stoich[spec_idx], stoch)
                end
            end
        end
    end
    return max_hor, max_stoich
end

# Compute g_i for species i to bound the relative change in propensity functions,
# as per Cao et al. (2006), Section IV, equation (27).
# g_i is determined by the highest order of reaction (HOR) and maximum stoichiometry (nu_ij) where species i is a reactant:
# - HOR = 1 (first-order, e.g., S_i -> products): g_i = 1
# - HOR = 2 (second-order):
#   - nu_ij = 1 (e.g., S_i + S_k -> products): g_i = 2
#   - nu_ij = 2 (e.g., 2S_i -> products): g_i = 2 + 1/(x_i - 1)
# - HOR = 3 (third-order):
#   - nu_ij = 1 (e.g., S_i + S_k + S_m -> products): g_i = 3
#   - nu_ij = 2 (e.g., 2S_i + S_k -> products): g_i = (3/2) * (2 + 1/(x_i - 1))
#   - nu_ij = 3 (e.g., 3S_i -> products): g_i = 3 + 1/(x_i - 1) + 2/(x_i - 2)
# Uses precomputed max_hor and max_stoich to reduce work to O(num_species) per timestep.
function compute_gi(u, max_hor, max_stoich, i, t)
    one_max_hor = one(1 / one(eltype(u)))

    if max_hor[i] == 0  # No reactions involve species i as a reactant
        return one_max_hor
    elseif max_hor[i] == 1
        return one_max_hor
    elseif max_hor[i] == 2
        if max_stoich[i] == 1
            return 2 * one_max_hor
        else # if max_stoich[i] == 2
            return u[i] > one_max_hor ?
                   2 * one_max_hor + one_max_hor / (u[i] - one_max_hor) : 2 * one_max_hor  # Fallback to 2 if x_i <= 1
        end
    elseif max_hor[i] == 3
        if max_stoich[i] == 1
            return 3 * one_max_hor
        elseif max_stoich[i] == 2
            return u[i] > one_max_hor ?
                   (3 * one_max_hor / 2) *
                   (2 * one_max_hor + one_max_hor / (u[i] - one_max_hor)) : 3 * one_max_hor  # Fallback to 3 if x_i <= 1
        else # if max_stoich[i] == 3
            return u[i] > 2 * one_max_hor ?
                   3 * one_max_hor + one_max_hor / (u[i] - one_max_hor) +
                   2 * one_max_hor / (u[i] - 2 * one_max_hor) : 3 * one_max_hor  # Fallback to 3 if x_i <= 2
        end
    end
    return one_max_hor  # Default case
end

# Compute the tau-leaping step-size using equation (20) from Cao et al. (2006):
# tau = min_{i in I_rs} { max(epsilon * x_i / g_i, 1) / |mu_i(x)|, max(epsilon * x_i / g_i, 1)^2 / sigma_i^2(x) }
# where mu_i(x) and sigma_i^2(x) are defined in equations (9a) and (9b):
# mu_i(x) = sum_j nu_ij * a_j(x), sigma_i^2(x) = sum_j nu_ij^2 * a_j(x)
# I_rs is the set of reactant species (assumed to be all species here, as critical reactions are not specified).
function compute_tau(
        u, rate_cache, nu, hor, p, t, epsilon, rate, dtmin, max_hor, max_stoich, numjumps)
    rate(rate_cache, u, p, t)
    if all(<=(0), rate_cache)  # Handle case where all rates are zero or negative
        return dtmin
    end
    tau = typemax(typeof(t))
    for i in 1:length(u)
        mu = zero(eltype(u))
        sigma2 = zero(eltype(u))
        for j in 1:size(nu, 2)
            mu += nu[i, j] * rate_cache[j] # Equation (9a)
            sigma2 += nu[i, j]^2 * rate_cache[j] # Equation (9b)
        end
        gi = compute_gi(u, max_hor, max_stoich, i, t)
        bound = max(epsilon * u[i] / gi, one(eltype(u))) # max(epsilon * x_i / g_i, 1)
        mu_term = abs(mu) > 0 ? bound / abs(mu) : typemax(typeof(t)) # First term in equation (8)
        sigma_term = sigma2 > 0 ? bound^2 / sigma2 : typemax(typeof(t)) # Second term in equation (8)
        tau = min(tau, mu_term, sigma_term) # Equation (8)
    end
    return max(tau, dtmin)
end

# Function to generate a mass action rate function
function massaction_rate(maj, numjumps)
    return (out, u, p, t) -> begin
        for j in 1:numjumps
            out[j] = evalrxrate(u, j, maj)
        end
    end
end

function simple_explicit_tau_leaping_loop!(
        prob, alg, u_current, u_new, t_current, t_end, p, rng,
        rate, c, nu, hor, max_hor, max_stoich, numjumps, epsilon,
        dtmin, saveat_times, usave, tsave, du, counts, rate_cache, rate_effective, maj,
        save_end)
    save_idx = 1

    while t_current < t_end
        rate(rate_cache, u_current, p, t_current)
        if all(<=(0), rate_cache)  # No reactions can occur, step to final time
            t_current = t_end
            break
        end
        tau = compute_tau(u_current, rate_cache, nu, hor, p, t_current,
            epsilon, rate, dtmin, max_hor, max_stoich, numjumps)
        tau = min(tau, t_end - t_current)
        if !isempty(saveat_times) && save_idx <= length(saveat_times) &&
           t_current + tau > saveat_times[save_idx]
            tau = saveat_times[save_idx] - t_current
        end
        # Calculate Poisson random numbers only for positive rates
        rate_effective .= rate_cache .* tau
        for j in eachindex(counts)
            if rate_effective[j] <= zero(eltype(rate_effective))
                counts[j] = zero(eltype(counts))
            else
                counts[j] = pois_rand(rng, rate_effective[j])
            end
        end
        du .= 0
        if c !== nothing
            c(du, u_current, p, t_current, counts, nothing)
        else
            for j in 1:numjumps
                for (spec_idx, stoch) in maj.net_stoch[j]
                    du[spec_idx] += stoch * counts[j]
                end
            end
        end
        u_new .= u_current .+ du
        if any(<(0), u_new)
            # Halve tau to avoid negative populations, as per Cao et al. (2006), Section 3.3
            tau /= 2
            continue
        end
        t_new = t_current + tau

        # Save state if at a saveat time or if saveat is empty
        if isempty(saveat_times) ||
           (save_idx <= length(saveat_times) && t_new >= saveat_times[save_idx])
            push!(usave, copy(u_new))
            push!(tsave, t_new)
            if !isempty(saveat_times) && t_new >= saveat_times[save_idx]
                save_idx += 1
            end
        end

        u_current .= u_new
        t_current = t_new
    end

    # Save endpoint if requested and not already saved
    if save_end && (isempty(tsave) || tsave[end] != t_end)
        push!(usave, copy(u_current))
        push!(tsave, t_end)
    end
end

function DiffEqBase.solve(jump_prob::JumpProblem, alg::SimpleExplicitTauLeaping;
        seed = nothing,
        dtmin = nothing,
        saveat = nothing, save_start = nothing, save_end = nothing)
    validate_pure_leaping_inputs(jump_prob, alg) ||
        error("SimpleExplicitTauLeaping can only be used with PureLeaping JumpProblem with a MassActionJump.")

    prob = jump_prob.prob
    rng = jump_prob.rng
    tspan = prob.tspan

    if dtmin === nothing
        dtmin = 1e-10 * one(typeof(tspan[2]))
    end

    (seed !== nothing) && seed!(rng, seed)

    maj = jump_prob.massaction_jump
    numjumps = get_num_majumps(maj)
    rj = jump_prob.regular_jump
    # Extract rates
    rate = rj !== nothing ? rj.rate : massaction_rate(maj, numjumps)
    c = rj !== nothing ? rj.c : nothing
    u0 = copy(prob.u0)
    p = prob.p

    saveat_times, save_start, save_end = _process_saveat(saveat, tspan, save_start, save_end)

    # Initialize current state and saved history
    u_current = copy(u0)
    u_new = similar(u0)
    t_current = tspan[1]
    if save_start
        usave = [copy(u0)]
        tsave = [tspan[1]]
    else
        usave = typeof(u0)[]
        tsave = typeof(tspan[1])[]
    end
    rate_cache = zeros(float(eltype(u0)), numjumps)
    rate_effective = similar(rate_cache)
    counts = zero(rate_cache)
    du = similar(u0)
    t_end = tspan[2]
    epsilon = alg.epsilon

    # Extract net stoichiometry for state updates
    nu = zeros(float(eltype(u0)), length(u0), numjumps)
    for j in 1:numjumps
        for (spec_idx, stoch) in maj.net_stoch[j]
            nu[spec_idx, j] = stoch
        end
    end
    # Extract reactant stoichiometry for hor and gi
    reactant_stoch = maj.reactant_stoch
    hor = compute_hor(reactant_stoch, numjumps)
    max_hor, max_stoich = precompute_reaction_conditions(
        reactant_stoch, hor, length(u0), numjumps)

    simple_explicit_tau_leaping_loop!(
        prob, alg, u_current, u_new, t_current, t_end, p, rng,
        rate, c, nu, hor, max_hor, max_stoich, numjumps, epsilon,
        dtmin, saveat_times, usave, tsave, du, counts, rate_cache, rate_effective, maj,
        save_end)

    sol = DiffEqBase.build_solution(prob, alg, tsave, usave,
        calculate_error = false,
        interp = DiffEqBase.ConstantInterpolation(tsave, usave))
    return sol
end

struct EnsembleGPUKernel{Backend} <: SciMLBase.EnsembleAlgorithm
    backend::Backend
    cpu_offload::Float64
end

function EnsembleGPUKernel(backend)
    EnsembleGPUKernel(backend, 0.0)
end

function EnsembleGPUKernel()
    EnsembleGPUKernel(nothing, 0.0)
end

# Put in a separate page so it can be used by SciMLDocs.jl

pages = ["index.md",
    "Tutorials" => Any["tutorials/simple_poisson_process.md",
        "tutorials/discrete_stochastic_example.md",
        "tutorials/point_process_simulation.md",
        "tutorials/jump_diffusion.md",
        "tutorials/spatial.md"],
    "Applications" => Any["applications/advanced_point_process.md"],
    "Type Documentation" => Any["Jumps, JumpProblem, and Aggregators" => "jump_types.md",
        "Jump solvers" => "jump_solve.md"],
    "FAQ" => "faq.md",
    "API" => "api.md"
]

using JumpProcesses, DiffEqBase, OrdinaryDiffEq
using StableRNGs
rng = StableRNG(12345)

rate = (u, p, t) -> p[1] * u[1] * u[2]
affect! = function (integrator)
    integrator.u[1] -= 1
    integrator.u[2] += 1
end
jump = ConstantRateJump(rate, affect!)

rate = (u, p, t) -> p[2] * u[2]
affect! = function (integrator)
    integrator.u[2] -= 1
    integrator.u[3] += 1
end
jump2 = ConstantRateJump(rate, affect!)

u0 = [999, 1, 0]
p = (0.1 / 1000, 0.01)
tspan = (0.0, 2500.0)

dprob = DiscreteProblem(u0, tspan, p)
jprob = JumpProblem(dprob, Direct(), jump, jump2, save_positions = (false, false),
    rng = rng)
sol = solve(jprob, SSAStepper())
@test sol[3, end] == 1000

u02 = [1000, 1, 0]
p2 = (0.1 / 1000, 0.0)
dprob2 = remake(dprob, u0 = u02, p = p2)
jprob2 = remake(jprob, prob = dprob2)
sol2 = solve(jprob2, SSAStepper())
@test sol2[2, end] == 1001

tspan2 = (0.0, 25000.0)
jprob3 = remake(jprob, p = p2, tspan = tspan2)
sol3 = solve(jprob3, SSAStepper())
@test sol3[2, end] == 1000
@test sol3.t[end] == 25000.0

################ test changing MassActionJump parameters
rng = StableRNG(12345)
rs = [[2 => 1], [1 => 1, 2 => 1]]
ns = [[2 => -1, 3 => 1], [1 => -1, 2 => 1]]
pidxs = [2, 1]
maj = MassActionJump(rs, ns; param_idxs = pidxs)
dprob = DiscreteProblem(u0, tspan, p)
jprob = JumpProblem(dprob, Direct(), maj, save_positions = (false, false), rng = rng)
sol = solve(jprob, SSAStepper())
@test sol[3, end] == 1000

# update the MassActionJump
dprob2 = remake(dprob, u0 = u02, p = p2)
jprob2 = remake(jprob, prob = dprob2)
sol2 = solve(jprob2, SSAStepper())
@test sol2[2, end] == 1001

tspan2 = (0.0, 25000.0)
jprob3 = remake(jprob, p = p2, tspan = tspan2)
sol3 = solve(jprob3, SSAStepper())
@test sol3[2, end] == 1000
@test sol3.t[end] == 25000.0

#################

# test error handling
@test_throws ErrorException jprob4=remake(jprob, prob = dprob2, p = p2)
@test_throws ErrorException jprob5=remake(jprob, aggregator = RSSA())

# test for #446
let
    f(du, u, p, t) = (du .= 0; nothing)
    prob = ODEProblem(f, [0.0], (0.0, 1.0))
    rrate(u, p, t) = u[1]
    aaffect!(integrator) = (integrator.u[1] += 1; nothing)
    vrj = VariableRateJump(rrate, aaffect!)
    jprob = JumpProblem(prob, vrj; vr_aggregator = VR_Direct(), rng)
    sol = solve(jprob, Tsit5())
    @test all(==(0.0), sol[1, :])
    jprob = JumpProblem(prob, vrj; vr_aggregator = VR_DirectFW(), rng)
    sol = solve(jprob, Tsit5())
    @test all(==(0.0), sol[1, :])
    jprob = JumpProblem(prob, vrj; vr_aggregator = VR_FRM(), rng)
    sol = solve(jprob, Tsit5())
    @test all(==(0.0), sol[1, :])
    u0 = [4.0]
    jprob2 = remake(jprob; u0)
    @test jprob2.prob.u0 isa ExtendedJumpArray
    @test jprob2.prob.u0.u === u0
    sol = solve(jprob2, Tsit5())
    u = sol[1, :]
    t = sol.t
    first_nontstart = findfirst(>(t[1]), t)
    @test !isnothing(first_nontstart)
    @test all(>=(u0[1]), u[first_nontstart:end])
    u0 = deepcopy(jprob2.prob.u0)
    u0.u .= 0
    jprob3 = remake(jprob2; u0)
    sol = solve(jprob3, Tsit5())
    @test all(==(0.0), sol[1, :])
    @test_throws ErrorException jprob4=remake(jprob, u0 = 1)
end

# tests when changing u0 via a passed in prob
let
    f(du, u, p, t) = (du .= 0; nothing)
    prob = ODEProblem(f, [0.0], (0.0, 1.0))
    rrate(u, p, t) = u[1]
    aaffect!(integrator) = (integrator.u[1] += 1; nothing)
    vrj = VariableRateJump(rrate, aaffect!)
    jprob = JumpProblem(prob, vrj; vr_aggregator = VR_Direct(), rng)
    sol = solve(jprob, Tsit5())
    @test all(==(0.0), sol[1, :])
    jprob = JumpProblem(prob, vrj; vr_aggregator = VR_DirectFW(), rng)
    sol = solve(jprob, Tsit5())
    @test all(==(0.0), sol[1, :])
    jprob = JumpProblem(prob, vrj; vr_aggregator = VR_FRM(), rng)
    sol = solve(jprob, Tsit5())
    @test all(==(0.0), sol[1, :])
    u0 = [4.0]
    prob2 = remake(jprob.prob; u0)
    @test_throws ErrorException jprob2=remake(jprob; prob = prob2)
    u0eja = JumpProcesses.remake_extended_u0(jprob.prob, u0, rng)
    prob3 = remake(jprob.prob; u0 = u0eja)
    jprob3 = remake(jprob; prob = prob3)
    @test jprob3.prob.u0 isa ExtendedJumpArray
    @test jprob3.prob.u0 === u0eja
    sol = solve(jprob3, Tsit5())
    u = sol[1, :]
    t = sol.t
    first_nontstart = findfirst(>(t[1]), t)
    @test !isnothing(first_nontstart)
    @test all(>=(u0[1]), u[first_nontstart:end])
end

# bracketing intervals for RSSA-based aggregators
# see: "On the rejection-based algorithm for simulation and analysis of
#       large-scale reaction networks", Thanh et al, J. Chem. Phys., 2015
# note, expects the type of the bracketing variables [ulow,uhigh] to be the
# same as the fluct_rate and ushift.
struct BracketData{T1, T2}
    fluctrate::T1         # interval should be [1-fluctrate,1+fluctrate] * u
    threshold::T2         # for u below threshold interval is:
    Δu::T2                #   [max(u-Δu,0),u+Δu]
end

# # suggested defaults
# BracketData{T1}() = BracketData(.1, 25, 4)
BracketData{T1, T2}() where {T1, T2} = BracketData(T1(0.1), T2(25), T2(4))

# support either vectors of data for each field, or scalars
# Get fluctuation rate of species i.
@inline getfr(bd::BracketData{AbstractVector{T1}, T2}, i) where {T1, T2} = bd.fluctrate[i]
@inline getfr(bd::BracketData{T1, T2}, i) where {T1 <: Number, T2} = bd.fluctrate

# Get threshold value of species i.
@inline gettv(bd::BracketData{T1, AbstractVector{T2}}, i) where {T1, T2} = bd.threshold[i]
@inline gettv(bd::BracketData{T1, T2}, i) where {T1, T2 <: Number} = bd.threshold

@inline getΔu(bd::BracketData{T1, AbstractVector{T2}}, i) where {T1, T2} = bd.Δu[i]
@inline getΔu(bd::BracketData{T1, T2}, i) where {T1, T2 <: Number} = bd.Δu

@inline function delta_bracket(u::Integer, δ)
    (trunc(typeof(u), (one(δ) - δ) * u), trunc(typeof(u), (one(δ) + δ) * u))
end

@inline delta_bracket(u, δ) = ((one(δ) - δ) * u), ((one(δ) + δ) * u)

# Get brackets ((1-fluctrate)*u, (1+fluctrate)*u) for species i.
@inline function get_spec_brackets(bd, i, u)
    if u == zero(u)
        return zero(u), zero(u)
    elseif u < gettv(bd, i)
        Δu = getΔu(bd, i)
        return max(zero(Δu), u - Δu), u + Δu
    else
        δ = getfr(bd, i)
        return delta_bracket(u, δ)
    end
end

@inline get_spec_brackets(bd, i, u::AbstractVector) = get_spec_brackets(bd, i, u[i])

# Get propensity brackets of massaction jump k.
@inline function get_majump_brackets(ulow, uhigh, k, majumps)
    evalrxrate(ulow, k, majumps), evalrxrate(uhigh, k, majumps)
end

# for constant rate jumps we must check the ordering of the bracket values
# Get propensity brackets of constant rate jump.
@inline function get_cjump_brackets(ulow, uhigh, rate, params, t)
    rlow = rate(ulow, params, t)
    rhigh = rate(uhigh, params, t)
    return (rlow <= rhigh) ? (rlow, rhigh) : (rhigh, rlow)
end

"""
get brackets for the rate of reaction rx by first checking if the reaction is a massaction reaction
"""
@inline function get_jump_brackets(rx, p::AbstractSSAJumpAggregator, params, t)
    ma_jumps = p.ma_jumps
    num_majumps = get_num_majumps(ma_jumps)
    if rx <= num_majumps
        return get_majump_brackets(p.ulow, p.uhigh, rx, ma_jumps)
    else
        @inbounds return get_cjump_brackets(p.ulow, p.uhigh, p.rates[rx - num_majumps],
            params, t)
    end
end

# Update species i brackets in the aggregator.
@inline function update_u_brackets!(p::AbstractSSAJumpAggregator, u::AbstractVector)
    (; ulow, uhigh) = p
    @inbounds for (i, uval) in enumerate(u)
        ulow[i], uhigh[i] = get_spec_brackets(p.bracket_data, i, uval)
    end
    nothing
end

@inline function update_u_brackets!(p::AbstractSSAJumpAggregator, u::SVector)
    @inbounds for (i, uval) in enumerate(u)
        ulow, uhigh = get_spec_brackets(p.bracket_data, i, uval)
        p.ulow = setindex(p.ulow, ulow, i)
        p.uhigh = setindex(p.uhigh, uhigh, i)
    end
    nothing
end

# For ExtendedJumpArray, only iterate over the species portion (u.u), not the jump tracking portion
@inline function update_u_brackets!(p::AbstractSSAJumpAggregator, u::ExtendedJumpArray)
    update_u_brackets!(p, u.u)
end

# Set up bracketing. The aggregator must have fields
#    ulow, uhigh, cur_rate_low, cur_rate_high, sum_rate, ma_jumps, rates.
function set_bracketing!(p::AbstractSSAJumpAggregator, u, params, t)
    # species bracketing interval
    update_u_brackets!(p, u)

    # reaction rate bracketing interval
    # mass action jumps
    sum_rate = zero(p.sum_rate)
    majumps = p.ma_jumps
    crlow = p.cur_rate_low
    crhigh = p.cur_rate_high
    @inbounds for k in 1:get_num_majumps(majumps)
        crlow[k], crhigh[k] = get_majump_brackets(p.ulow, p.uhigh, k, majumps)
        sum_rate += crhigh[k]
    end

    # constant rate jumps
    k = get_num_majumps(majumps) + 1
    @inbounds for rate in p.rates
        crlow[k], crhigh[k] = get_cjump_brackets(p.ulow, p.uhigh, rate, params, t)
        sum_rate += crhigh[k]
        k += 1
    end
    p.sum_rate = sum_rate

    nothing
end

# This file is not directly included in a test case, but is used to
# benchmark and compare changes to the broadcsting
using JumpProcesses, StableRNGs, BenchmarkTools

rng = StableRNG(123)

base_case_out = zeros(500000 * 2)
base_case_in = rand(rng, 500000 * 2)
benchmark_out = ExtendedJumpArray(zeros(500000), zeros(500000))
benchmark_in = ExtendedJumpArray(rand(rng, 500000), rand(rng, 500000))

function test_single_dot(out, array)
    @inbounds @. out = array + 1.23 * array
end

println("Base-case normal broadcasting")
@benchmark test_single_dot(base_case_out, base_case_in)
println("EJA normal broadcasting")
@benchmark test_single_dot(benchmark_out, benchmark_in)

mutable struct CoupledArray{T, T2} <: AbstractArray{Float64, 1}
    u::T
    u_control::T2
    order::Bool
end

Base.length(A::CoupledArray) = length(A.u) + length(A.u_control)
Base.size(A::CoupledArray) = (length(A),)
@inline function Base.getindex(A::CoupledArray, i::Int)
    if A.order == true
        i <= length(A.u) ? A.u[i] : A.u_control[i - length(A.u)]
    else
        i <= length(A.u) ? A.u_control[i] : A.u[i - length(A.u)]
    end
end

@inline function Base.getindex(A::CoupledArray, I...)
    A[CartesianIndices(A.u, I...)]
end

@inline function Base.getindex(A::CoupledArray, I::CartesianIndex{1})
    A[I[1]]
end

@inline Base.setindex!(A::CoupledArray, v, I...) = (A[CartesianIndices(A.u, I...)] = v)
@inline Base.setindex!(A::CoupledArray, v, I::CartesianIndex{1}) = (A[I[1]] = v)
@inline function Base.setindex!(A::CoupledArray, v, i::Int)
    if A.order == true
        i <= length(A.u) ? (A.u[i] = v) : (A.u_control[i - length(A.u)] = v)
    else
        i <= length(A.u) ? (A.u_control[i] = v) : (A.u[i - length(A.u)] = v)
    end
end

Base.IndexStyle(::Type{<:CoupledArray}) = IndexLinear()
Base.similar(A::CoupledArray) = CoupledArray(similar(A.u), similar(A.u_control), A.order)
function Base.similar(A::CoupledArray, ::Type{S}) where {S}
    CoupledArray(similar(A.u, S), similar(A.u_control, S), A.order)
end

function recursivecopy!(dest::T, src::T) where {T <: CoupledArray}
    recursivecopy!(dest.u, src.u)
    recursivecopy!(dest.u_control, src.u_control)
    dest.order = src.order
end

add_idxs1(::Type{T}, expr) where {T <: CoupledArray} = :($(expr).u)
add_idxs2(::Type{T}, expr) where {T <: CoupledArray} = :($(expr).u_control)
@generated function Base.broadcast!(f, A::CoupledArray, B::Union{Number, CoupledArray}...)
    exs1 = ((add_idxs1(B[i], :(B[$i])) for i in eachindex(B))...,)
    exs2 = ((add_idxs2(B[i], :(B[$i])) for i in eachindex(B))...,)
    res = quote
        broadcast!(f, A.u, $(exs1...))
        broadcast!(f, A.u_control, $(exs2...))
    end
    res
end

Base.show(io::IO, A::CoupledArray) = show(io, A.u)
plot_indices(A::CoupledArray) = eachindex(A)
flip_u!(A::CoupledArray) = (A.order = !A.order)

using JumpProcesses
using ExplicitImports
using Aqua
using Test

@testset "QA Tests" begin
    @testset "Aqua tests" begin
        Aqua.test_all(JumpProcesses;
                      ambiguities = false,  # TODO: fix ambiguities and enable
                      deps_compat = true,
                      piracies = false,  # We define default solvers for AbstractJumpProblem
                      unbound_args = true,
                      undefined_exports = true,
                      project_extras = true,
                      stale_deps = true,
                      persistent_tasks = false)  # disabled due to false positives
    end

    @testset "ExplicitImports tests" begin
        # Check that we're using explicit imports
        @test check_no_implicit_imports(JumpProcesses) === nothing
        
        # Check for stale explicit imports (imports that are not used)
        @test check_no_stale_explicit_imports(JumpProcesses) === nothing
        
        # Allow some flexibility for non-public imports during transition
        # This can be made stricter once all non-public API usage is resolved
        @test_nowarn check_all_explicit_imports_via_owners(JumpProcesses)
    end
end

using DiffEqBase, JumpProcesses, Test
using StableRNGs
rng = StableRNG(12345)

rate_consts = [10.0]
reactant_stoich = [[1 => 1, 2 => 1]]
net_stoich = [[1 => -1, 2 => -1, 3 => 1]]
maj = MassActionJump(rate_consts, reactant_stoich, net_stoich)

n0 = [1, 1, 0]
tspan = (0, 0.2)
dprob = DiscreteProblem(n0, tspan)
jprob = JumpProblem(dprob, Direct(), maj, save_positions = (false, false), rng = rng)
ts = collect(0:0.002:tspan[2])
NA = zeros(length(ts))
Nsims = 10_000
sol = JumpProcesses.solve(EnsembleProblem(jprob), SSAStepper(), saveat = ts,
    trajectories = Nsims)

for i in 1:length(sol.u)
    NA .+= sol.u[i][1, :]
end

for i in 1:length(ts)
    @test NA[i] / Nsims≈exp(-10 * ts[i]) rtol=1e-1
end

NA = zeros(length(ts))
jprob = JumpProblem(dprob, Direct(), maj; rng = rng)
sol = nothing;
GC.gc();
sol = JumpProcesses.solve(EnsembleProblem(jprob), SSAStepper(), trajectories = Nsims)

for i in 1:Nsims
    for n in 1:length(ts)
        NA[n] += sol.u[i](ts[n])[1]
    end
end

for i in 1:length(ts)
    @test NA[i] / Nsims≈exp(-10 * ts[i]) rtol=1e-1
end

module JumpProcessesOrdinaryDiffEqCoreExt

using JumpProcesses
import DiffEqBase
import OrdinaryDiffEqCore: OrdinaryDiffEqAlgorithm, DAEAlgorithm,
    StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm

# Ambiguity fix: OrdinaryDiffEqCore defines
#   __init(::Union{..., AbstractJumpProblem}, ::Union{OrdinaryDiffEqAlgorithm,
#          DAEAlgorithm, StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm})
# which is ambiguous with JumpProcesses'
#   __init(::AbstractJumpProblem{P}, ::DEAlgorithm)
#
# This method resolves the ambiguity by being more specific in the problem type
# (AbstractJumpProblem vs Union{..., AbstractJumpProblem, ...}) while matching
# the exact algorithm union from OrdinaryDiffEqCore.
function DiffEqBase.__init(
        _jump_prob::DiffEqBase.AbstractJumpProblem{P},
        alg::Union{OrdinaryDiffEqAlgorithm, DAEAlgorithm,
            StochasticDiffEqAlgorithm, StochasticDiffEqRODEAlgorithm};
        merge_callbacks = true, kwargs...) where {P}
    kwargs = DiffEqBase.merge_problem_kwargs(_jump_prob; merge_callbacks, kwargs...)
    JumpProcesses.__jump_init(_jump_prob, alg; kwargs...)
end

end

"""
Queue method. This method handles variable intensity rates.
"""
mutable struct CoevolveJumpAggregation{T, S, F1, F2, RNG, GR, PQ} <:
               AbstractSSAJumpAggregator{T, S, F1, F2, RNG}
    next_jump::Int                    # the next jump to execute
    prev_jump::Int                    # the previous jump that was executed
    next_jump_time::T                 # the time of the next jump
    end_time::T                       # the time to stop a simulation
    cur_rates::Vector{T}              # the last computed upper bound for each rate
    sum_rate::Nothing                 # not used
    ma_jumps::S                       # MassActionJumps
    rates::F1                         # vector of rate functions
    affects!::F2                      # vector of affect functions for VariableRateJumps
    save_positions::Tuple{Bool, Bool} # tuple for whether to save the jumps before and/or after event
    rng::RNG                          # random number generator
    dep_gr::GR                        # map from jumps to jumps depending on it
    pq::PQ                            # priority queue of next time
    lrates::F1                        # vector of rate lower bound functions
    urates::F1                        # vector of rate upper bound functions
    rateintervals::F1                 # vector of interval length functions
    haslratevec::Vector{Bool}         # vector of whether an lrate was provided for this vrj
    cur_lrates::Vector{T}             # the last computed lower rate for each rate
end

function CoevolveJumpAggregation(nj::Int, njt::T, et::T, crs::Vector{T}, sr::Nothing,
        maj::S, rs::F1, affs!::F2, sps::Tuple{Bool, Bool},
        rng::RNG; u::U, dep_graph = nothing, lrates, urates,
        rateintervals, haslratevec,
        cur_lrates::Vector{T}) where {T, S, F1, F2, RNG, U}
    if dep_graph === nothing
        if (get_num_majumps(maj) == 0) || !isempty(urates)
            error("To use Coevolve a dependency graph between jumps must be supplied.")
        else
            dg = make_dependency_graph(length(u), maj)
        end
    else
        # using a Set to ensure that edges are not duplicate
        dgsets = [Set{Int}(append!(Int[], jumps, [var]))
                  for (var, jumps) in enumerate(dep_graph)]
        dg = [sort!(collect(i)) for i in dgsets]
    end

    num_jumps = get_num_majumps(maj) + length(urates)

    if length(dg) != num_jumps
        error("Number of nodes in the dependency graph must be the same as the number of jumps.")
    end

    pq = MutableBinaryMinHeap{T}()
    affecttype = F2 <: Tuple ? F2 : Any
    CoevolveJumpAggregation{T, S, F1, affecttype, RNG, typeof(dg),
        typeof(pq)}(nj, nj, njt, et, crs, sr, maj,
        rs, affs!, sps, rng, dg, pq,
        lrates, urates, rateintervals,
        haslratevec, cur_lrates)
end

# display
function num_constant_rate_jumps(aggregator::CoevolveJumpAggregation)
    length(aggregator.urates)
end

# condition for jump to occur
function (p::CoevolveJumpAggregation)(u, t, integrator)
    p.next_jump_time == t &&
        accept_next_jump!(p, integrator, integrator.u, integrator.p, integrator.t)
end

# executing jump at the next jump time
function (p::CoevolveJumpAggregation)(integrator::I) where {I <:
                                                            AbstractSSAIntegrator}
    if !accept_next_jump!(p, integrator, integrator.u, integrator.p, integrator.t)
        return nothing
    end
    affects! = p.affects!
    if affects! isa Vector{FunctionWrappers.FunctionWrapper{Nothing, Tuple{I}}}
        execute_jumps!(p, integrator, integrator.u, integrator.p, integrator.t, affects!)
    else
        error("Error, invalid affects! type. Expected a vector of function wrappers and got $(typeof(affects!))")
    end
    generate_jumps!(p, integrator, integrator.u, integrator.p, integrator.t)
    register_next_jump_time!(integrator, p, integrator.t)
    nothing
end

function (p::CoevolveJumpAggregation{
        T, S, F1, F2})(integrator::AbstractSSAIntegrator) where
        {T, S, F1, F2 <: Union{Tuple, Nothing}}
    if !accept_next_jump!(p, integrator, integrator.u, integrator.p, integrator.t)
        return nothing
    end
    execute_jumps!(p, integrator, integrator.u, integrator.p, integrator.t, p.affects!)
    generate_jumps!(p, integrator, integrator.u, integrator.p, integrator.t)
    register_next_jump_time!(integrator, p, integrator.t)
    nothing
end

# creating the JumpAggregation structure (tuple-based variable jumps)
function aggregate(aggregator::Coevolve, u, p, t, end_time, constant_jumps,
        ma_jumps, save_positions, rng; dep_graph = nothing,
        variable_jumps = nothing, kwargs...)
    RateWrapper = FunctionWrappers.FunctionWrapper{typeof(t),
        Tuple{typeof(u), typeof(p), typeof(t)}}

    ncrjs = (constant_jumps === nothing) ? 0 : length(constant_jumps)
    nvrjs = (variable_jumps === nothing) ? 0 : length(variable_jumps)
    nrjs = ncrjs + nvrjs
    affects! = Vector{Any}(undef, nrjs)
    rates = Vector{RateWrapper}(undef, nvrjs)
    lrates = similar(rates)
    rateintervals = similar(rates)
    urates = Vector{RateWrapper}(undef, nrjs)
    haslratevec = zeros(Bool, nvrjs)

    idx = 1
    if constant_jumps !== nothing
        for crj in constant_jumps
            affects![idx] = integ -> (crj.affect!(integ); nothing)
            urates[idx] = RateWrapper(crj.rate)
            idx += 1
        end
    end

    if variable_jumps !== nothing
        for (i, vrj) in enumerate(variable_jumps)
            affects![idx] = integ -> (vrj.affect!(integ); nothing)
            urates[idx] = RateWrapper(vrj.urate)
            idx += 1
            rates[i] = RateWrapper(vrj.rate)
            rateintervals[i] = RateWrapper(vrj.rateinterval)
            haslratevec[i] = haslrate(vrj)
            lrates[i] = haslratevec[i] ? RateWrapper(vrj.lrate) : RateWrapper(nullrate)
        end
    end

    num_jumps = get_num_majumps(ma_jumps) + nrjs
    cur_rates = Vector{typeof(t)}(undef, num_jumps)
    cur_lrates = zeros(typeof(t), nvrjs)
    sum_rate = nothing
    next_jump = 0
    next_jump_time = typemax(t)
    CoevolveJumpAggregation(next_jump, next_jump_time, end_time, cur_rates, sum_rate,
        ma_jumps, rates, affects!, save_positions, rng;
        u, dep_graph, lrates, urates, rateintervals, haslratevec,
        cur_lrates)
end

# set up a new simulation and calculate the first jump / jump time
function initialize!(p::CoevolveJumpAggregation, integrator, u, params, t)
    p.end_time = integrator.sol.prob.tspan[2]
    fill_rates_and_get_times!(p, u, params, t)
    generate_jumps!(p, integrator, u, params, t)
    nothing
end

# execute one jump, changing the system state
function execute_jumps!(p::CoevolveJumpAggregation, integrator, u, params, t,
        affects!)
    # execute jump
    update_state!(p, integrator, u, affects!)
    # update current jump rates and times
    update_dependent_rates!(p, integrator.u, integrator.p, t)
    nothing
end

# calculate the next jump / jump time
function generate_jumps!(p::CoevolveJumpAggregation, integrator, u, params, t)
    p.next_jump_time, p.next_jump = top_with_handle(p.pq)
    nothing
end

######################## SSA specific helper routines ########################
function accept_next_jump!(p::CoevolveJumpAggregation, integrator, u, params, t)
    (; next_jump, ma_jumps) = p

    num_majumps = get_num_majumps(ma_jumps)

    (next_jump <= num_majumps) && return true

    (; cur_rates, rates, rng, urates, cur_lrates) = p
    num_cjumps = length(urates) - length(rates)
    uidx = next_jump - num_majumps
    lidx = uidx - num_cjumps

    # lidx <= 0 indicates that we have a constant jump which we always accept
    (lidx <= 0) && return true

    @inbounds urate = cur_rates[next_jump]
    @inbounds lrate = cur_lrates[lidx]

    s = -one(t)

    # the first condition applies when the candidate time t is rejected because
    # it was longer than the rateinterval when it was proposed
    if lrate == typemax(t)
        urate = get_urate(p, uidx, u, params, t)
        s = urate == zero(t) ? typemax(t) : randexp(rng) / urate
    elseif lrate < urate
        # when the lower and upper bound are the same, then v < 1 = lrate / urate = urate / urate
        v = rand(rng) * urate
        # first inequality is less expensive and short-circuits the evaluation
        if (v > lrate)
            rate = get_rate(p, lidx, u, params, t)
            if v > rate
                urate = get_urate(p, uidx, u, params, t)
                s = urate == zero(t) ? typemax(t) : randexp(rng) / urate
            end
        end
    end

    # candidate t was accepted
    (s < 0) && return true

    # candidate t was reject, compute a new candidate time
    t = next_candidate_time!(p, u, params, t, s, lidx)
    update!(p.pq, next_jump, t)
    @inbounds cur_rates[next_jump] = urate

    p.prev_jump = next_jump
    generate_jumps!(p, integrator, integrator.u, integrator.p, integrator.t)
    register_next_jump_time!(integrator, p, integrator.t)
    u_modified!(integrator, false)

    return false
end

function update_dependent_rates!(p::CoevolveJumpAggregation, u, params, t)
    @inbounds deps = p.dep_gr[p.next_jump]
    (; cur_rates, pq) = p
    for (ix, i) in enumerate(deps)
        ti, urate_i = next_time(p, u, params, t, i)
        update!(pq, i, ti)
        @inbounds cur_rates[i] = urate_i
    end
    nothing
end

@inline function get_ma_urate(p::CoevolveJumpAggregation, i, u, params, t)
    return evalrxrate(u, i, p.ma_jumps)
end

@inline function get_urate(p::CoevolveJumpAggregation, uidx, u, params, t)
    @inbounds return p.urates[uidx](u, params, t)
end

@inline function get_rateinterval(p::CoevolveJumpAggregation, lidx, u, params, t)
    @inbounds return p.rateintervals[lidx](u, params, t)
end

@inline function get_lrate(p::CoevolveJumpAggregation, lidx, u, params, t)
    @inbounds return p.lrates[lidx](u, params, t)
end

@inline function get_rate(p::CoevolveJumpAggregation, lidx, u, params, t)
    @inbounds return p.rates[lidx](u, params, t)
end

function next_time(p::CoevolveJumpAggregation, u, params, t, i)
    (; next_jump, cur_rates, ma_jumps, rates, rng, pq, urates) = p
    num_majumps = get_num_majumps(ma_jumps)
    num_cjumps = length(urates) - length(rates)
    uidx = i - num_majumps
    lidx = uidx - num_cjumps
    urate = uidx > 0 ? get_urate(p, uidx, u, params, t) : get_ma_urate(p, i, u, params, t)
    # we can only re-use the rng in the case of constant rates because the rng
    # used to compute the next candidate time has not been accepted or rejected
    if i != next_jump && lidx <= 0
        last_urate = cur_rates[i]
        if last_urate > zero(t)
            s = urate == zero(t) ? typemax(t) : last_urate / urate * (pq[i] - t)
            return next_candidate_time!(p, u, params, t, s, lidx), urate
        end
    end
    s = urate == zero(t) ? typemax(t) : randexp(rng) / urate
    return next_candidate_time!(p, u, params, t, s, lidx), urate
end

function next_candidate_time!(p::CoevolveJumpAggregation, u, params, t, s, lidx)
    if lidx <= 0
        return t + s
    end
    (; end_time, haslratevec, cur_lrates) = p
    rateinterval = get_rateinterval(p, lidx, u, params, t)
    if s > rateinterval
        t = t + rateinterval
        # we set the lrate to typemax(t) to indicate rejection due to candidate being larger than rateinterval
        @inbounds cur_lrates[lidx] = typemax(t)
        return t
    end
    t = t + s
    if t < end_time
        lrate = haslratevec[lidx] ? get_lrate(p, lidx, u, params, t) : zero(t)
        @inbounds cur_lrates[lidx] = lrate
    else
        # no need to compute the lower bound when time is past the end time
        @inbounds cur_lrates[lidx] = typemax(t)
    end
    return t
end

# re-evaluates all rates, recalculate all jump times, and reinit the priority queue
function fill_rates_and_get_times!(p::CoevolveJumpAggregation, u, params, t)
    num_jumps = get_num_majumps(p.ma_jumps) + length(p.urates)
    p.cur_rates = zeros(typeof(t), num_jumps)
    jump_times = Vector{typeof(t)}(undef, num_jumps)
    @inbounds for i in 1:num_jumps
        jump_times[i], p.cur_rates[i] = next_time(p, u, params, t, i)
    end
    p.pq = MutableBinaryMinHeap(jump_times)
    nothing
end

using JumpProcesses, Test
const JP = JumpProcesses

fluctuation_rate = 0.1
threshold = 25
Δu = 4
bd = BracketData(fluctuation_rate, threshold, Δu)

### Getters ###
species_index = 1
# The fluctuation rate δ corresponds to species brackets (1-δ)*u, (1+δ)*u. So 0 < δ < 1. 
@test 0 < JP.getfr(bd, species_index) < 1
# If u < threshold, then the brackets are (max(u-Δu, 0), u+Δu). So 0 <= threshold and 0 <= Δu.
@test 0 <= JP.gettv(bd, species_index)
@test 0 <= JP.getΔu(bd, species_index)

### Species brackets ###
u = [3, 20, 100] # species vector
species_index = 1
@test JP.get_spec_brackets(bd, species_index, u)[1] == 0
@test JP.get_spec_brackets(bd, species_index, u)[2] == u[1] + Δu
species_index = 2
@test JP.get_spec_brackets(bd, species_index, u)[1] == u[2] - Δu
@test JP.get_spec_brackets(bd, species_index, u)[2] == u[2] + Δu
species_index = 3
@test JP.get_spec_brackets(bd, species_index, u)[1]≈u[3] * (1 - fluctuation_rate) atol=1
@test JP.get_spec_brackets(bd, species_index, u)[2]≈u[3] * (1 + fluctuation_rate) atol=1

### Reaction rate brackets ###
ulow = [2]
uhigh = [10]

# massaction
majump_rates = [0.1] # death at rate 0.1
reactstoch = [[1 => 1]]
netstoch = [[1 => -1]]
majump = MassActionJump(majump_rates, reactstoch,
    netstoch)
reaction_index = 1
@test JP.get_majump_brackets(ulow, uhigh, reaction_index, majump)[1] == majump_rates[1] * ulow[1] # low
@test JP.get_majump_brackets(ulow, uhigh, reaction_index, majump)[2] == majump_rates[1] * uhigh[1] # high

# constant rate
rate(u, params, t) = 1 / u[1]
params = nothing
t = 0.0
@test JP.get_cjump_brackets(ulow, uhigh, rate, params, t)[1] == 1 / 10 # low
@test JP.get_cjump_brackets(ulow, uhigh, rate, params, t)[2] == 1 / 2 # high

### Aggregator ###
mutable struct DummyAggregator{T, M, R, BD} <:
               JP.AbstractSSAJumpAggregator{T, M, R, Nothing, Nothing}
    ulow::Vector{Int}
    uhigh::Vector{Int}
    cur_rate_low::Vector{T}
    cur_rate_high::Vector{T}
    sum_rate::T
    ma_jumps::M
    rates::R
    bracket_data::BD
end
# one massaction jump, one constant rate jump
cur_rate_low = [0.0, 0.0]
cur_rate_high = [0.0, 0.0]
sum_rate = 0.0
p = DummyAggregator([0], [0], cur_rate_low, cur_rate_high, sum_rate, majump, [rate], bd)

u = [100]
JP.update_u_brackets!(p, u)
@test p.ulow[1]≈u[1] * (1 - fluctuation_rate) atol=1
@test p.uhigh[1]≈u[1] * (1 + fluctuation_rate) atol=1

reaction_index = 1
@test JP.get_jump_brackets(reaction_index, p, params, t)[1] == majump_rates[1] * p.ulow[1]
@test JP.get_jump_brackets(reaction_index, p, params, t)[2] == majump_rates[1] * p.uhigh[1]
reaction_index = 2
@test JP.get_jump_brackets(reaction_index, p, params, t)[1] == rate(p.uhigh, params, t)
@test JP.get_jump_brackets(reaction_index, p, params, t)[2] == rate(p.ulow, params, t)

p = DummyAggregator([0], [0], cur_rate_low, cur_rate_high, sum_rate, majump, [rate], bd)
JP.set_bracketing!(p, u, params, t)
@test p.ulow[1]≈u[1] * (1 - fluctuation_rate) atol=1
@test p.uhigh[1]≈u[1] * (1 + fluctuation_rate) atol=1
@test p.cur_rate_low[1]≈majump_rates[1] * u[1] * (1 - fluctuation_rate) atol=1
@test p.cur_rate_high[1]≈majump_rates[1] * u[1] * (1 + fluctuation_rate) atol=1
@test p.cur_rate_low[2] == rate(p.uhigh, params, t)
@test p.cur_rate_high[2] == rate(p.ulow, params, t)
@test p.sum_rate ≈ sum(p.cur_rate_high)

using JumpProcesses, OrdinaryDiffEq, StochasticDiffEq, Test
using StableRNGs, Random

# ==========================================================================
# Problem constructors
# ==========================================================================

# Constant-rate birth-death for SSAStepper / ODE-coupled tests
function make_ssa_jump_prob(; rng = StableRNG(12345))
    j1 = ConstantRateJump((u, p, t) -> 10.0, integrator -> (integrator.u[1] += 1))
    j2 = ConstantRateJump((u, p, t) -> 0.5 * u[1], integrator -> (integrator.u[1] -= 1))
    dprob = DiscreteProblem([10], (0.0, 20.0))
    JumpProblem(dprob, Direct(), j1, j2; rng)
end

# ODE + variable-rate jump
function make_vr_jump_prob(agg; rng = StableRNG(12345))
    f!(du, u, p, t) = (du[1] = -0.1 * u[1]; nothing)
    oprob = ODEProblem(f!, [100.0], (0.0, 10.0))
    vrj = VariableRateJump((u, p, t) -> 0.5 * u[1],
        integrator -> (integrator.u[1] -= 1.0))
    JumpProblem(oprob, Direct(), vrj; vr_aggregator = agg, rng)
end

# SDE + variable-rate jump
function make_sde_vr_jump_prob(agg; rng = StableRNG(12345))
    f!(du, u, p, t) = (du[1] = -0.1 * u[1]; nothing)
    g!(du, u, p, t) = (du[1] = 0.1 * u[1]; nothing)
    sprob = SDEProblem(f!, g!, [100.0], (0.0, 10.0))
    vrj = VariableRateJump((u, p, t) -> 0.5 * u[1],
        integrator -> (integrator.u[1] -= 1.0))
    JumpProblem(sprob, Direct(), vrj; vr_aggregator = agg, rng)
end

# Helpers
# First time strictly after t[1], robust to initialization saves at t=0.
first_jump_time(traj) = traj.t[findfirst(>(traj.t[1]), traj.t)]

# ==========================================================================
# 1. Serial ensemble: sequential trajectories get different RNG streams
# ==========================================================================

@testset "EnsembleSerial: distinct streams" begin
    @testset "SSAStepper" begin
        jprob = make_ssa_jump_prob()
        sol = solve(EnsembleProblem(jprob), SSAStepper(), EnsembleSerial();
            trajectories = 3)
        times = [first_jump_time(sol.u[i]) for i in 1:3]
        @test allunique(times)
    end

    @testset "ODE + VR ($agg)" for agg in (VR_FRM(), VR_Direct(), VR_DirectFW())
        jprob = make_vr_jump_prob(agg)
        sol = solve(EnsembleProblem(jprob), Tsit5(), EnsembleSerial();
            trajectories = 3)
        times = [first_jump_time(sol.u[i]) for i in 1:3]
        @test allunique(times)
        finals = [sol.u[i].u[end][1] for i in 1:3]
        @test allunique(finals)
    end

    # EM() uses a fixed time grid so jump event times aren't directly visible
    # in t[2]; we check final values instead.
    @testset "SDE + VR (VR_FRM)" begin
        jprob = make_sde_vr_jump_prob(VR_FRM())
        sol = solve(EnsembleProblem(jprob), EM(), EnsembleSerial();
            trajectories = 3, dt = 0.01, save_everystep = false)
        finals = [sol.u[i].u[end][1] for i in 1:3]
        @test allunique(finals)
    end
end

# ==========================================================================
# 2. Sequential solves on same thread: RNG advances between solves
# ==========================================================================

@testset "Sequential solves: different RNG streams" begin
    @testset "SSAStepper" begin
        jprob = make_ssa_jump_prob()
        times = [first_jump_time(solve(jprob, SSAStepper())) for _ in 1:3]
        @test allunique(times)
    end

    @testset "ODE + VR ($agg)" for agg in (VR_FRM(), VR_Direct(), VR_DirectFW())
        jprob = make_vr_jump_prob(agg)
        sols = [solve(jprob, Tsit5()) for _ in 1:3]
        times = [first_jump_time(s) for s in sols]
        @test allunique(times)
        finals = [s.u[end][1] for s in sols]
        @test allunique(finals)
    end
end

# ==========================================================================
# 3. Threaded ensemble: no data race on the shared JumpProblem
#
# The ODE/SSA path through __jump_init receives seed=nothing from
# SciMLBase, so deepcopy'd problems on non-main threads start with
# identical RNG states. We only assert completion here — uniqueness
# requires explicit seeding (tested in section 4 below).
#
# The SDE path goes through StochasticDiffEq's __init which generates
# per-trajectory seeds, so we can additionally verify uniqueness there.
# ==========================================================================

@testset "EnsembleThreads: no data race" begin
    @testset "SSAStepper" begin
        jprob = make_ssa_jump_prob()
        sol = solve(EnsembleProblem(jprob), SSAStepper(), EnsembleThreads();
            trajectories = 4)
        @test length(sol.u) == 4
    end

    @testset "ODE + VR ($agg)" for agg in (VR_FRM(), VR_Direct(), VR_DirectFW())
        jprob = make_vr_jump_prob(agg)
        # This path previously had a data race: resetted_jump_problem called
        # randexp!(_jump_prob.rng, ...) on the shared original problem.
        sol = solve(EnsembleProblem(jprob), Tsit5(), EnsembleThreads();
            trajectories = 4, save_everystep = false)
        @test length(sol.u) == 4
    end

    @testset "SDE + VR (VR_FRM): unique trajectories" begin
        jprob = make_sde_vr_jump_prob(VR_FRM())
        # StochasticDiffEq generates per-trajectory seeds and passes them to
        # resetted_jump_problem, so trajectories should be distinct.
        sol = solve(EnsembleProblem(jprob), EM(), EnsembleThreads();
            trajectories = 4, dt = 0.01, save_everystep = false)
        @test length(sol.u) == 4
        finals = [sol.u[i].u[end][1] for i in 1:4]
        @test length(unique(finals)) > 1
    end
end

# ==========================================================================
# 4. Seed-based stream independence: resetted_jump_problem and
#    reset_jump_problem! produce distinct RNG streams for different seeds
#
# This tests the mechanism that EnsembleThreads relies on (when seeds are
# provided by the caller, e.g. StochasticDiffEq) to get independent streams
# on different threads.
# ==========================================================================

@testset "resetted_jump_problem: different seeds → different streams" begin
    jprob = make_ssa_jump_prob()
    seeds = UInt64[100, 200, 300]

    # Each seed should produce a distinct aggregator RNG state
    rngs = map(seeds) do s
        jp = JumpProcesses.resetted_jump_problem(jprob, s)
        jp.jump_callback.discrete_callbacks[1].condition.rng
    end
    draws = [rand(rng) for rng in rngs]
    @test allunique(draws)

    # Same seed should be deterministic
    jp1 = JumpProcesses.resetted_jump_problem(jprob, UInt64(42))
    jp2 = JumpProcesses.resetted_jump_problem(jprob, UInt64(42))
    rng1 = jp1.jump_callback.discrete_callbacks[1].condition.rng
    rng2 = jp2.jump_callback.discrete_callbacks[1].condition.rng
    @test rand(rng1) == rand(rng2)
end

@testset "reset_jump_problem!: different seeds → different streams" begin
    seeds = UInt64[100, 200, 300]
    draws = map(seeds) do s
        jp = make_ssa_jump_prob()
        JumpProcesses.reset_jump_problem!(jp, s)
        rand(jp.jump_callback.discrete_callbacks[1].condition.rng)
    end
    @test allunique(draws)
end

@testset "_derive_jump_seed: decorrelates from input seed" begin
    seed = UInt64(12345)
    derived = JumpProcesses._derive_jump_seed(seed)
    # Derived seed should differ from input
    @test derived != seed
    # Should be deterministic
    @test derived == JumpProcesses._derive_jump_seed(seed)
    # Different inputs → different outputs
    @test JumpProcesses._derive_jump_seed(UInt64(1)) != JumpProcesses._derive_jump_seed(UInt64(2))
end

# ==========================================================================
# 5. Variable-rate: jump_u thresholds are unique per trajectory
#
# For VR_FRM, each trajectory's first jump time is determined by the initial
# jump_u threshold (set to -randexp() by the VR_FRMEventCallback initialize).
# Distinct thresholds → distinct first event times.
# ==========================================================================

@testset "VR_FRM: jump_u thresholds unique per trajectory (EnsembleSerial)" begin
    jprob = make_vr_jump_prob(VR_FRM())
    sol = solve(EnsembleProblem(jprob), Tsit5(), EnsembleSerial();
        trajectories = 3)
    event_times = [first_jump_time(sol.u[i]) for i in 1:3]
    @test allunique(event_times)
end

using Test, JumpProcesses
using StableRNGs

# tests for https://github.com/SciML/JumpProcesses.jl/issues/305

let
    rng = StableRNG(123)
    save_positions = (false, false)

    β = 0.1 / 1000.0
    ν = 0.01
    p = (β, ν, 1.0)
    rate1(u, p, t) = p[1] * u[1] * u[2]  # β*S*I
    function affect1!(integrator)
        integrator.u[1] -= 1         # S -> S - 1
        integrator.u[2] += 1         # I -> I + 1
        nothing
    end
    jump = ConstantRateJump(rate1, affect1!)

    rate2(u, p, t) = p[2] * u[2]         # ν*I
    function affect2!(integrator)
        integrator.u[2] -= 1        # I -> I - 1
        integrator.u[3] += 1        # R -> R + 1
        nothing
    end
    jump2 = ConstantRateJump(rate2, affect2!)

    # 0 --> S
    rateidxs = [3]
    reactant_stoich = [[0 => 1]]
    net_stoich = [[1 => 1]]
    maj = MassActionJump(reactant_stoich, net_stoich; param_idxs = rateidxs)

    u₀ = [999, 10, 0]
    tspan = (0.0, 250.0)
    dprob = DiscreteProblem(u₀, tspan, p)
    jprob = JumpProblem(dprob, Direct(), maj, jump, jump2; save_positions, rng)
    sol = solve(jprob, SSAStepper())

    al1 = @allocations solve(jprob, SSAStepper())

    tspan2 = (0.0, 2500.0)
    dprob2 = DiscreteProblem(u₀, tspan2, p)
    jprob2 = JumpProblem(dprob2, Direct(), maj, jump, jump2; save_positions, rng)
    sol2 = solve(jprob2, SSAStepper())

    al2 = @allocations solve(jprob2, SSAStepper())

    @test al1 == al2
end

let
    function rate(η, X, Y, K)
        return (η / K) * (K - (X + Y))
    end

    function makeprob(; T = 100.0, alg = Direct(), save_positions = (false, false),
            graphkwargs = (;), rng)
        r1(u, p, t) = rate(p[1], u[1], u[2], p[2]) * u[1]
        r2(u, p, t) = rate(p[1], u[2], u[1], p[2]) * u[2]
        r3(u, p, t) = p[3] * u[1]
        r4(u, p, t) = p[3] * u[2]
        r5(u, p, t) = p[4] * u[1] * u[2]
        r6(u, p, t) = p[5] * u[2]
        aff1!(integrator) = integrator.u[1] += 1
        aff2!(integrator) = integrator.u[2] += 1
        aff3!(integrator) = integrator.u[1] -= 1
        aff4!(integrator) = integrator.u[2] -= 1
        function aff5!(integrator)
            integrator.u[1] -= 1
            integrator.u[2] += 1
        end
        function aff6!(integrator)
            integrator.u[1] += 1
            integrator.u[2] -= 1
        end
        #    η    K    μ    γ     ρ
        p = (1.0, 1e4, 0.1, 1e-4, 0.01)
        u0 = [1000, 10]
        tspan = (0.0, T)

        dprob = DiscreteProblem(u0, tspan, p)
        jprob = JumpProblem(dprob, alg,
            ConstantRateJump(r1, aff1!), ConstantRateJump(r2, aff2!),
            ConstantRateJump(r3, aff3!),
            ConstantRateJump(r4, aff4!), ConstantRateJump(r5, aff5!),
            ConstantRateJump(r6, aff6!);
            save_positions, rng, graphkwargs...)
        return jprob
    end

    idxs1 = [1, 2, 3, 4]
    idxs2 = [1, 2, 4, 5, 6]
    idxs = collect(1:6)
    dep_graph = [copy(idxs1), copy(idxs2), copy(idxs1), copy(idxs2), copy(idxs), copy(idxs)]
    vartojumps_map = [copy(idxs1), copy(idxs2)]
    jumptovars_map = [[1], [2], [1], [2], [1, 2], [1, 2]]
    graphkwargs = (; dep_graph, vartojumps_map, jumptovars_map)

    @testset "Allocations for $agg" for agg in JumpProcesses.JUMP_AGGREGATORS
        jprob1 = makeprob(; alg = agg, T = 10.0, graphkwargs, rng = StableRNG(1234))
        stepper = SSAStepper()
        sol1 = solve(jprob1, stepper)
        sol1 = solve(jprob1, stepper)
        al1 = @allocated solve(jprob1, stepper)
        jprob2 = makeprob(; alg = agg, T = 100.0, graphkwargs, rng = StableRNG(1234))
        sol2 = solve(jprob2, stepper)
        sol2 = solve(jprob2, stepper)
        al2 = @allocated solve(jprob2, stepper)
        @test al1 == al2
    end
end

nothing

using JumpProcesses, OrdinaryDiffEq
using Test, Statistics
using StableRNGs
rng = StableRNG(12345)

# using Plots; plotlyjs()
doplot = false
#using BenchmarkTools
# dobenchmark = false

dotestmean = true
doprintmeans = false

# SSAs to test
SSAalgs = (JumpProcesses.JUMP_AGGREGATORS..., JumpProcesses.NullAggregator())

# numerical parameters
Nsims = 8000
tf = 1000.0
u0 = [1, 0, 0, 0]
expected_avg = 5.926553750000000e+02
reltol = 0.01

# average number of proteins in a simulation
function runSSAs(jump_prob; use_stepper = true)
    Psamp = zeros(Int, Nsims)
    for i in 1:Nsims
        sol = use_stepper ? solve(jump_prob, SSAStepper()) : solve(jump_prob)
        Psamp[i] = sol[3, end]
    end
    mean(Psamp)
end

function runSSAs_ode(vrjprob)
    Psamp = zeros(Float64, Nsims)
    tsave = vrjprob.prob.tspan[2]
    integrator = init(vrjprob, Tsit5(); saveat = tsave)
    solve!(integrator)
    Psamp[1] = integrator.sol[3, end]
    for i in 2:Nsims
        reinit!(integrator)
        solve!(integrator)
        Psamp[i] = integrator.sol[3, end]
    end
    return mean(Psamp)
end

# MODEL SETUP

# DNA repression model DiffEqBiological
# using DiffEqBiological
# rs = @reaction_network dtype begin
#     k1, DNA --> mRNA + DNA
#     k2, mRNA --> mRNA + P
#     k3, mRNA --> 0
#     k4, P --> 0
#     k5, DNA + P --> DNAR
#     k6, DNAR --> DNA + P
# end k1 k2 k3 k4 k5 k6

# model using mass action jumps
# ids: DNA=1, mRNA = 2, P = 3, DNAR = 4
reactstoch = [
    [1 => 1],
    [2 => 1],
    [2 => 1],
    [3 => 1],
    [1 => 1, 3 => 1],
    [4 => 1]
]
netstoch = [
    [2 => 1],
    [3 => 1],
    [2 => -1],
    [3 => -1],
    [1 => -1, 3 => -1, 4 => 1],
    [1 => 1, 3 => 1, 4 => -1]
]
spec_to_dep_jumps = [[1, 5], [2, 3], [4, 5], [6]]
jump_to_dep_specs = [[2], [3], [2], [3], [1, 3, 4], [1, 3, 4]]
rates = [0.5, (20 * log(2.0) / 120.0), (log(2.0) / 120.0), (log(2.0) / 600.0), 0.025, 1.0]
majumps = MassActionJump(rates, reactstoch, netstoch)

# TESTING:
prob = DiscreteProblem(u0, (0.0, tf), rates)

# floating point u0 tests
u0f = Float64.(u0)
probf = DiscreteProblem(u0f, (0.0, tf), rates)

# plotting one full trajectory
if doplot
    plothand = plot(reuse = false)
    for alg in SSAalgs
        local jump_prob = JumpProblem(prob, alg, majumps,
            vartojumps_map = spec_to_dep_jumps,
            jumptovars_map = jump_to_dep_specs, rng = rng)
        local sol = solve(jump_prob, SSAStepper())
        plot!(plothand, sol.t, sol[3, :], seriestype = :steppost)
    end
    display(plothand)
end

# test the means
if dotestmean
    for (i, alg) in enumerate(SSAalgs)
        local jump_prob = JumpProblem(prob, alg, majumps, save_positions = (false, false),
            vartojumps_map = spec_to_dep_jumps,
            jumptovars_map = jump_to_dep_specs, rng = rng)
        means = runSSAs(jump_prob)
        relerr = abs(means - expected_avg) / expected_avg
        doprintmeans && println("Mean from method: ", typeof(alg), " is = ", means,
            ", rel err = ", relerr)
        @test abs(means - expected_avg) < reltol * expected_avg
    end

    # test default solver dispatch (use_stepper=false) with one algorithm
    let alg = Direct()
        jump_prob = JumpProblem(prob, alg, majumps, save_positions = (false, false),
            vartojumps_map = spec_to_dep_jumps,
            jumptovars_map = jump_to_dep_specs, rng = rng)
        means = runSSAs(jump_prob; use_stepper = false)
        @test abs(means - expected_avg) < reltol * expected_avg
    end

    # test Float64 u0 with Direct and RSSA (RSSA needs explicit testing due to
    # past rejection bound issues with floating point)
    for alg in (Direct(), RSSA())
        jump_probf = JumpProblem(probf, alg, majumps, save_positions = (false, false),
            vartojumps_map = spec_to_dep_jumps,
            jumptovars_map = jump_to_dep_specs, rng = rng)
        means = runSSAs(jump_probf)
        relerr = abs(means - expected_avg) / expected_avg
        doprintmeans && println("Mean from method (Float64 u0): ", typeof(alg),
            " is = ", means, ", rel err = ", relerr)
        @test abs(means - expected_avg) < reltol * expected_avg
    end
end

# no-aggregator tests
jump_prob = JumpProblem(prob, majumps; save_positions = (false, false),
    vartojumps_map = spec_to_dep_jumps, jumptovars_map = jump_to_dep_specs, rng)
@test abs(runSSAs(jump_prob) - expected_avg) < reltol * expected_avg

jump_prob = JumpProblem(prob, majumps, save_positions = (false, false), rng = rng)
@test abs(runSSAs(jump_prob) - expected_avg) < reltol * expected_avg

# crj/vrj accuracy test
#     k1, DNA --> mRNA + DNA
#     k2, mRNA --> mRNA + P
#     k3, mRNA --> 0
#     k4, P --> 0
#     k5, DNA + P --> DNAR
#     k6, DNAR --> DNA + P
#    DNA = 1, mRNA = 2, P = 3, DNAR = 4
let
    r1(u, p, t) = p[1] * u[1]
    r2(u, p, t) = p[2] * u[2]
    r3(u, p, t) = p[3] * u[2]
    r4(u, p, t) = p[4] * u[3]
    r5(u, p, t) = p[5] * u[1] * u[3]
    r6(u, p, t) = p[6] * u[4]
    a1!(integ) = (integ.u[2] += 1; nothing)
    a2!(integ) = (integ.u[3] += 1; nothing)
    a3!(integ) = (integ.u[2] -= 1; nothing)
    a4!(integ) = (integ.u[3] -= 1; nothing)
    function a5!(integ)
        integ.u[1] -= 1
        integ.u[3] -= 1
        integ.u[4] += 1
        nothing
    end
    function a6!(integ)
        integ.u[1] += 1
        integ.u[3] += 1
        integ.u[4] -= 1
        nothing
    end
    crjs = JumpSet(ConstantRateJump(r1, a1!), ConstantRateJump(r2, a2!),
        ConstantRateJump(r3, a3!), ConstantRateJump(r4, a4!), ConstantRateJump(r5, a5!),
        ConstantRateJump(r6, a6!))
    vrjs = JumpSet(VariableRateJump(r1, a1!; save_positions = (false, false)),
        VariableRateJump(r2, a2!, save_positions = (false, false)),
        VariableRateJump(r3, a3!, save_positions = (false, false)),
        VariableRateJump(r4, a4!, save_positions = (false, false)),
        VariableRateJump(r5, a5!, save_positions = (false, false)),
        VariableRateJump(r6, a6!, save_positions = (false, false)))

    prob = DiscreteProblem(u0, (0.0, tf), rates)
    crjprob = JumpProblem(prob, crjs; save_positions = (false, false), rng)
    @test abs(runSSAs(crjprob) - expected_avg) < reltol * expected_avg

    # vrjs are very slow so test on a shorter time span and compare to the crjs
    prob = DiscreteProblem(u0, (0.0, tf / 5), rates)
    crjprob = JumpProblem(prob, crjs; save_positions = (false, false), rng)
    crjmean = runSSAs(crjprob)
    f(du, u, p, t) = (du .= 0; nothing)
    oprob = ODEProblem(f, u0f, (0.0, tf / 5), rates)

    for vr_agg in (VR_FRM(), VR_Direct(), VR_DirectFW())
        vrjprob = JumpProblem(
            oprob, vrjs; vr_aggregator = vr_agg, save_positions = (false, false), rng)
        vrjmean = runSSAs_ode(vrjprob)
        @test abs(vrjmean - crjmean) < reltol * crjmean
    end
end

using JumpProcesses, Test
const JP = JumpProcesses

fluctuation_rate = 0.1
threshold = 25
Δu = 4
bracket_data = BracketData(fluctuation_rate, threshold, Δu)

n = 3 # number of sites

# set up spatial system
spatial_system = CartesianGrid((n,)) # n sites
site_rates = JP.LowHigh(zeros(n), zeros(n))

# set up reaction rates
majump_rates = [0.1] # death at rate 0.1
reactstoch = [[1 => 1]]
netstoch = [[1 => -1]]
majump = MassActionJump(majump_rates, reactstoch,
    netstoch)
rx_rates = JP.LowHigh(JP.RxRates(n, majump))

# set up hop rates
hop_constants = [1.0]
hop_rates = JP.LowHigh(JP.HopRates(hop_constants, spatial_system))

# set up species brackets
u = 100 * ones(Int, 1, n) # 2 species, n sites
u_low_high = JP.LowHigh(u, u)
JP.update_u_brackets!(u_low_high, bracket_data, u)

# update reaction rates, hop rates and site rates
rxs = [1] # vector of all reactions
species_vec = [1] # vector of all species
integrator = Nothing # only needed for constant rate jumps
for site in 1:num_sites(spatial_system)
    JP.update_rx_rates!(rx_rates, rxs, u_low_high, integrator, site)
    JP.update_hop_rates!(hop_rates, species_vec, u_low_high, site, spatial_system)
    site_rates[site] = JP.total_site_rate(rx_rates, hop_rates, site)
end

# test species brackets
@test u_low_high.low[1, 1]≈u[1, 1] * (1 - fluctuation_rate) atol=1
@test u_low_high.high[1, 1]≈u[1, 1] * (1 + fluctuation_rate) atol=1

# test site rate brackets
site = 1
rx = 1
species = 1
@test JP.total_site_rx_rate(rx_rates.low, site) ==
      majump_rates[rx] * u_low_high.low[species, site]
@test JP.total_site_rx_rate(rx_rates.high, site) ==
      majump_rates[rx] * u_low_high.high[species, site]
@test JP.total_site_hop_rate(hop_rates.low, site) ==
      hop_constants[site] * u_low_high.low[species, site]
@test JP.total_site_hop_rate(hop_rates.high, site) ==
      hop_constants[site] * u_low_high.high[species, site]

"""
$(TYPEDEF)

Defines a jump process with a rate (i.e. hazard, intensity, or propensity) that
does not *explicitly* depend on time. More precisely, one where the rate
function is constant *between* the occurrence of jumps. For detailed examples
and usage information, see the
- [Tutorial](https://docs.sciml.ai/JumpProcesses/stable/tutorials/discrete_stochastic_example/)

## Fields

$(FIELDS)

## Examples
Suppose `u[1]` gives the number of particles and `p[1]` the probability per time
each particle can decay away. A corresponding `ConstantRateJump` for this jump
process is
```julia
rate(u,p,t) = p[1]*u[1]
affect!(integrator) = integrator.u[1] -= 1
crj = ConstantRateJump(rate, affect!)
```
Notice, here that `rate` changes in time, but is constant between the occurrence
of jumps (when `u[1]` will decrease).
"""
struct ConstantRateJump{F1, F2} <: AbstractJump
    """Function `rate(u,p,t)` that returns the jump's current rate."""
    rate::F1
    """Function `affect(integrator)` that updates the state for one occurrence of the jump."""
    affect!::F2
end

"""
$(TYPEDEF)

Defines a jump process with a rate (i.e. hazard, intensity, or propensity) that may
explicitly depend on time. More precisely, one where the rate function is allowed to change
*between* the occurrence of jumps. For detailed examples and usage information, see the
- [Tutorial](https://docs.sciml.ai/JumpProcesses/stable/tutorials/discrete_stochastic_example/)

Note that two types of `VariableRateJump`s are currently supported, with different
performance characteritistics.
- A general `VariableRateJump` or `VariableRateJump` will refer to one in which only `rate`
  and `affect` functions are specified.

    * These are the most general in what they can represent, but require the use of an
      `ODEProblem` or `SDEProblem` whose underlying timestepper handles their evolution in
      time (via the callback interface).
    * This is the least performant jump type in simulations.

- Bounded `VariableRateJump`s require passing the keyword arguments `urate` and
  `rateinterval`, corresponding to functions `urate(u, p, t)` and `rateinterval(u, p, t)`,
  see below. These must calculate a time window over which the rate function is bounded by a
  constant. Note that it is ok if the rate bound would be violated within the time interval
  due to a change in `u` arising from another `ConstantRateJump`, `MassActionJump` or
  *bounded* `VariableRateJump` being executed, as the chosen aggregator will then handle
  recalculating the rate bound and interval. *However, if the bound could be violated within
  the time interval due to a change in `u` arising from continuous dynamics such as a
  coupled ODE, SDE, or a general `VariableRateJump`, bounds should not be given.* This
  ensures the jump is classified as a general `VariableRateJump` and properly handled. One
  can also optionally provide a lower bound function, `lrate(u, p, t)`, via the `lrate`
  keyword argument. This can lead to increased performance. The validity of the lower bound
  should hold under the same conditions and rate interval as `urate`.

    * Bounded `VariableRateJump`s can currently be used in the `Coevolve` aggregator, and
      can therefore be efficiently simulated in pure-jump `DiscreteProblem`s using the
      `SSAStepper` time-stepper.
    * These can be substantially more performant than general `VariableRateJump`s without
      the rate bound functions.

Reemphasizing, the additional user provided functions leveraged by bounded
`VariableRateJumps`, `urate(u, p, t)`, `rateinterval(u, p, t)`, and the optional `lrate(u,
p, t)` require that
- For `s` in `[t, t + rateinterval(u, p, t)]`, we have that `lrate(u, p, t) <= rate(u, p, s)
  <= urate(u, p, t)`.
- It is ok if these bounds would be violated during the time window due to another
  `ConstantRateJump`, `MassActionJump` or bounded `VariableRateJump` occurring. However,
  they must remain valid if `u` changes for any other reason (for example, due to
  continuous dynamics like ODEs, SDEs, or general `VariableRateJump`s).

## Fields

$(FIELDS)

## Examples
Suppose `u[1]` gives the number of particles and `t*p[1]` the probability per time each
particle can decay away. A corresponding `VariableRateJump` for this jump process is
```julia
rate(u,p,t) = t*p[1]*u[1]
affect!(integrator) = integrator.u[1] -= 1
vrj = VariableRateJump(rate, affect!)
```

To define a bounded `VariableRateJump` that can be used with supporting aggregators such as
`Coevolve`, we must define bounds and a rate interval:
```julia
rateinterval(u,p,t) = (1 / p[1]) * 2
rate(u,p,t) = t * p[1] * u[1]
lrate(u, p, t) = rate(u, p, t)
urate(u,p,t) = rate(u, p, t + rateinterval(u,p,t))
affect!(integrator) = integrator.u[1] -= 1
vrj = VariableRateJump(rate, affect!; lrate = lrate, urate = urate,
                                      rateinterval = rateinterval)
```

## Notes
- When using an aggregator that supports bounded `VariableRateJump`s, `DiscreteProblem` can
  be used. Otherwise, `ODEProblem` or `SDEProblem` must be used.
- **When not using aggregators that support bounded `VariableRateJump`s, or when there are
  general `VariableRateJump`s, `integrator`s store an effective state type that wraps the
  main state vector.** See [`ExtendedJumpArray`](@ref) for details on using this object. In
  this case all `ConstantRateJump`, `VariableRateJump` and callback `affect!` functions
  receive an integrator with `integrator.u` an [`ExtendedJumpArray`](@ref).
- Salis H., Kaznessis Y.,  Accurate hybrid stochastic simulation of a system of coupled
  chemical or biochemical reactions, Journal of Chemical Physics, 122 (5),
  DOI:10.1063/1.1835951 is used for calculating jump times with `VariableRateJump`s within
  ODE/SDE integrators.
"""
struct VariableRateJump{R, F, R2, R3, R4, I, T, T2} <: AbstractJump
    """Function `rate(u,p,t)` that returns the jump's current rate given state
    `u`, parameters `p` and time `t`."""
    rate::R
    """Function `affect!(integrator)` that updates the state for one occurrence
    of the jump given `integrator`."""
    affect!::F
    """Optional function `lrate(u, p, t)` that computes a lower bound on the rate in the
    interval `t` to `t + rateinterval(u, p, t)` at time `t` given state `u` and parameters
    `p`. This bound must rigorously hold during the time interval as long as another
    `ConstantRateJump`, `MassActionJump`, or *bounded* `VariableRateJump` has not been
    sampled. When using aggregators that support bounded `VariableRateJump`s, currently only
    `Coevolve`, providing a lower-bound can lead to improved performance.
    """
    lrate::R2
    """Optional function `urate(u, p, t)` for general `VariableRateJump`s, but is required
    to define a bounded `VariableRateJump`, which can be used with supporting aggregators,
     currently only `Coevolve`, and offers improved computational performance. Computes an
    upper bound for the rate in the interval `t` to `t + rateinterval(u, p, t)` at time `t`
    given state `u` and parameters `p`. This bound must rigorously hold during the time
    interval as long as another `ConstantRateJump`, `MassActionJump`, or *bounded*
    `VariableRateJump` has not been sampled. """
    urate::R3
    """Optional function `rateinterval(u, p, t)` for general `VariableRateJump`s, but is
    required to define a bounded `VariableRateJump`, which can be used with supporting
     aggregators, currently only `Coevolve`, and offers improved computational performance.
    Computes the time interval from time `t` over which the `urate` and `lrate` bounds will
    hold, `t` to `t + rateinterval(u, p, t)`, given state `u` and parameters `p`. This bound
    must rigorously hold during the time interval as long as another `ConstantRateJump`,
    `MassActionJump`, or *bounded* `VariableRateJump` has not been sampled. """
    rateinterval::R4
    idxs::I
    rootfind::Bool
    interp_points::Int
    save_positions::Tuple{Bool, Bool}
    abstol::T
    reltol::T2
end

isbounded(::VariableRateJump) = true
isbounded(::VariableRateJump{R, F, R2, Nothing}) where {R, F, R2} = false
haslrate(::VariableRateJump) = true
haslrate(::VariableRateJump{R, F, Nothing}) where {R, F} = false
nullrate(u, p, t::T) where {T <: Number} = zero(T)

"""
```
function VariableRateJump(rate, affect!; lrate = nothing, urate = nothing,
                                         rateinterval = nothing, rootfind = true,
                                         idxs = nothing,
                                         save_positions = (false, true),
                                         interp_points = 10,
                                         abstol = 1e-12, reltol = 0)
```
"""
function VariableRateJump(rate, affect!;
        lrate = nothing, urate = nothing,
        rateinterval = nothing, rootfind = true,
        idxs = nothing,
        save_positions = (false, true),
        interp_points = 10,
        abstol = 1e-12, reltol = 0)
    if !(urate !== nothing && rateinterval !== nothing) &&
       !(urate === nothing && rateinterval === nothing)
        error("`urate` and `rateinterval` must both be `nothing`, or must both be defined.")
    end

    if lrate !== nothing
        (urate !== nothing) ||
            error("If a lower bound rate, `lrate`, is given than an upper bound rate, `urate`, and rate interval, `rateinterval`, must also be provided.")
    end

    VariableRateJump(rate, affect!, lrate, urate, rateinterval, idxs, rootfind,
        interp_points, save_positions, abstol, reltol)
end

"""
$(TYPEDEF)

Representation for encoding rates and multiple simultaneous jumps for use in τ-leaping type
methods.

### Constructors
- `RegularJump(rate, c, numjumps; mark_dist = nothing)`

## Fields

$(FIELDS)

## Examples
```julia
function rate!(out, u, p, t)
    out[1] = (0.1 / 1000.0) * u[1] * u[2]
    out[2] = 0.01u[2]
    nothing
end

const dc = zeros(3,2)
function c(du, u, p, t, counts, mark) 
    mul!(du, dc, counts)
    nothing
end

rj = RegularJump(rate!, c, 2)

## Notes
- `mark_dist` is not currently used or supported in τ-leaping methods.
```
"""
struct RegularJump{iip, R, C, MD}
    """
    Function `rate!(rate_vals, u, p, t)` that returns the current rates, i.e.
    intensities or propensities, for all possible jumps in `rate_vals`.
    """
    rate::R
    """
    Function `c(du, u, p, t, counts, mark)` that executes the `i`th jump `counts[i]` times,
    saving the output in `du[i]`.
    """
    c::C
    """ Number of jumps in the system."""
    numjumps::Int
    """ A distribution for marks. Not currently used or supported. """
    mark_dist::MD
    function RegularJump{iip}(rate, c, numjumps::Int; mark_dist = nothing) where {iip}
        new{iip, typeof(rate), typeof(c), typeof(mark_dist)}(rate, c, numjumps, mark_dist)
    end
end

DiffEqBase.isinplace(::RegularJump{iip, R, C, MD}) where {iip, R, C, MD} = iip

function RegularJump(rate, c, numjumps::Int; kwargs...)
    RegularJump{DiffEqBase.isinplace(rate, 4)}(rate, c, numjumps; kwargs...)
end

# deprecate old call
function RegularJump(rate, c, dc::AbstractMatrix; constant_c = false, mark_dist = nothing)
    @warn("The RegularJump interface has changed to be matrix-free. See the documentation for more details.")
    function _c(du, u, p, t, counts, mark)
        c(dc, u, p, t, mark)
        mul!(du, dc, counts)
    end
    RegularJump{true}(rate, _c, size(dc, 2); mark_dist = mark_dist)
end

"""
$(TYPEDEF)

Optimized representation for `ConstantRateJump`s that can be represented in mass
action form, offering improved performance within jump algorithms compared to
`ConstantRateJump`. For detailed examples and usage information, see the
- [Main
  Docs](https://docs.sciml.ai/JumpProcesses/stable/jump_types/#Defining-a-Mass-Action-Jump)
- [Tutorial](https://docs.sciml.ai/JumpProcesses/stable/tutorials/discrete_stochastic_example/)

### Constructors
- `MassActionJump(reactant_stoich, net_stoich; scale_rates = true, param_idxs = nothing)`

Here `reactant_stoich` denotes the reactant stoichiometry for each reaction and
`net_stoich` the net stoichiometry for each reaction.

## Fields

$(FIELDS)

## Keyword Arguments
- `scale_rates = true`, whether to rescale the reaction rate constants according
  to the stoichiometry.
- `nocopy = false`, whether the `MassActionJump` can alias the `scaled_rates` and
  `reactant_stoch` from the input. Note, if `scale_rates=true` this will
  potentially modify both of these.
- `param_idxs = nothing`, indexes in the parameter vector, `JumpProblem.prob.p`,
  that correspond to each reaction's rate.

See the tutorial and main docs for details.

## Examples
An SIR model with `S + I --> 2I` at rate β as the first reaction and `I --> R`
at rate ν as the second reaction can be encoded by
```julia
p        = (β=1e-4, ν=.01)
u0       = [999, 1, 0]       # (S,I,R)
tspan    = (0.0, 250.0)
rateidxs = [1, 2]           # i.e. [β,ν]
reactant_stoich = [
  [1 => 1, 2 => 1],         # 1*S and 1*I
  [2 => 1]                  # 1*I
]
net_stoich = [
  [1 => -1, 2 => 1],        # -1*S and 1*I
  [2 => -1, 3 => 1]         # -1*I and 1*R
]
maj = MassActionJump(reactant_stoich, net_stoich; param_idxs=rateidxs)
prob = DiscreteProblem(u0, tspan, p)
jprob = JumpProblem(prob, Direct(), maj)
```

## Notes
- By default, reaction rates are rescaled when constructing the `MassActionJump`
  as explained in the [main
  docs](https://docs.sciml.ai/JumpProcesses/stable/jump_types/#Defining-a-Mass-Action-Jump).
  Disable this with the kwarg `scale_rates=false`.
- Also see the [main
  docs](https://docs.sciml.ai/JumpProcesses/stable/jump_types/#Defining-a-Mass-Action-Jump)
  for how to specify reactions with no products or no reactants.


"""
struct MassActionJump{T, S, U, V} <: AbstractMassActionJump
    """The (scaled) reaction rate constants."""
    scaled_rates::T
    """The reactant stoichiometry vectors."""
    reactant_stoch::S
    """The net stoichiometry vectors."""
    net_stoch::U
    """Parameter mapping functor to identify reaction rate constants with parameters in `p` vectors."""
    param_mapper::V
    """Whether `update_parameters!` should apply stoichiometric scaling to rates."""
    rescale_rates_on_update::Bool

    function MassActionJump{T, S, U, V}(rates::T, rs_in::S, ns::U, pmapper::V,
            scale_rates::Bool, useiszero::Bool,
            nocopy::Bool,
            rescale_rates_on_update::Bool = scale_rates) where {T <: AbstractVector, S, U, V}
        sr = nocopy ? rates : copy(rates)
        rs = nocopy ? rs_in : copy(rs_in)
        for i in eachindex(rs)
            if useiszero && (length(rs[i]) == 1) && iszero(rs[i][1][1])
                rs[i] = typeof(rs[i])()
            end
        end

        if scale_rates && !isempty(sr)
            scalerates!(sr, rs)
        end
        new(sr, rs, ns, pmapper, rescale_rates_on_update)
    end
    function MassActionJump{Nothing, Vector{S},
            Vector{U}, V}(::Nothing, rs_in::Vector{S},
            ns::Vector{U}, pmapper::V,
            scale_rates::Bool,
            useiszero::Bool,
            nocopy::Bool,
            rescale_rates_on_update::Bool = scale_rates) where {S <: AbstractVector,
            U <: AbstractVector, V}
        rs = nocopy ? rs_in : copy(rs_in)
        for i in eachindex(rs)
            if useiszero && (length(rs[i]) == 1) && iszero(rs[i][1][1])
                rs[i] = typeof(rs[i])()
            end
        end
        new(nothing, rs, ns, pmapper, rescale_rates_on_update)
    end
    function MassActionJump{T, S, U, V}(rate::T, rs_in::S, ns::U, pmapper::V,
            scale_rates::Bool, useiszero::Bool,
            nocopy::Bool,
            rescale_rates_on_update::Bool = scale_rates) where {T <: Number, S, U, V}
        rs = rs_in
        if useiszero && (length(rs) == 1) && iszero(rs[1][1])
            rs = typeof(rs)()
        end
        sr = scale_rates ? scalerate(rate, rs) : rate
        new(sr, rs, ns, pmapper, rescale_rates_on_update)
    end
    function MassActionJump{Nothing, S, U, V}(::Nothing, rs_in::S, ns::U, pmapper::V,
            scale_rates::Bool, useiszero::Bool,
            nocopy::Bool,
            rescale_rates_on_update::Bool = scale_rates) where {S, U, V}
        rs = rs_in
        if useiszero && (length(rs) == 1) && iszero(rs[1][1])
            rs = typeof(rs)()
        end
        new(nothing, rs, ns, pmapper, rescale_rates_on_update)
    end
end
function MassActionJump(usr::T, rs::S, ns::U, pmapper::V; scale_rates = true,
        useiszero = true, nocopy = false,
        rescale_rates_on_update = scale_rates) where {T, S, U, V}
    MassActionJump{T, S, U, V}(usr, rs, ns, pmapper, scale_rates, useiszero, nocopy,
        rescale_rates_on_update)
end
function MassActionJump(usr::T, rs, ns; scale_rates = true, useiszero = true,
        nocopy = false, rescale_rates_on_update = scale_rates) where {T <: AbstractVector}
    MassActionJump(usr, rs, ns, nothing; scale_rates, useiszero, nocopy,
        rescale_rates_on_update)
end
function MassActionJump(usr::T, rs, ns; scale_rates = true, useiszero = true,
        nocopy = false, rescale_rates_on_update = scale_rates) where {T <: Number}
    MassActionJump(usr, rs, ns, nothing; scale_rates, useiszero, nocopy,
        rescale_rates_on_update)
end

# with parameter indices or mapping, multiple jump case
function MassActionJump(rs, ns; param_idxs = nothing, param_mapper = nothing,
        scale_rates = true, useiszero = true, nocopy = false,
        rescale_rates_on_update = scale_rates)
    if param_mapper === nothing
        (param_idxs === nothing) &&
            error("If no parameter indices are given via param_idxs, an explicit parameter mapping must be passed in via param_mapper.")
        pmapper = MassActionJumpParamMapper(param_idxs)
    else
        (param_idxs !== nothing) &&
            error("Only one of param_idxs and param_mapper should be passed.")
        pmapper = param_mapper
    end

    MassActionJump(nothing, nocopy ? rs : copy(rs), ns, pmapper; scale_rates, useiszero,
        nocopy = true, rescale_rates_on_update)
end

using_params(maj::MassActionJump{T, S, U, Nothing}) where {T, S, U} = false
using_params(maj::MassActionJump) = true
using_params(maj::Nothing) = false
@inline get_num_majumps(maj::MassActionJump) = length(maj.net_stoch)
@inline get_num_majumps(maj::Nothing) = 0

struct MassActionJumpParamMapper{U}
    param_idxs::U
end

# create the initial parameter vector for use in a MassActionJump
# Note these are unscaled
function (ratemap::MassActionJumpParamMapper{U})(params) where {U <: AbstractArray}
    [params[pidx] for pidx in ratemap.param_idxs]
end

# Note this is unscaled
function (ratemap::MassActionJumpParamMapper{U})(params) where {U <: Int}
    params[ratemap.param_idxs]
end

# update a maj with parameter vectors
function (ratemap::MassActionJumpParamMapper{U})(maj::MassActionJump, newparams;
        scale_rates,
        kwargs...) where {U <: AbstractArray}
    for i in 1:get_num_majumps(maj)
        maj.scaled_rates[i] = newparams[ratemap.param_idxs[i]]
    end
    scale_rates && scalerates!(maj.scaled_rates, maj.reactant_stoch)
    nothing
end

function to_collection(ratemap::MassActionJumpParamMapper{Int})
    MassActionJumpParamMapper([ratemap.param_idxs])
end

function Base.merge!(pmap1::MassActionJumpParamMapper{U},
        pmap2::MassActionJumpParamMapper{U}) where {U <: AbstractVector}
    append!(pmap1.param_idxs, pmap2.param_idxs)
end

function Base.merge!(pmap1::MassActionJumpParamMapper{U},
        pmap2::MassActionJumpParamMapper{V}) where {U <: AbstractVector,
        V <: Int}
    push!(pmap1.param_idxs, pmap2.param_idxs)
end

function Base.merge(pmap1::MassActionJumpParamMapper{Int},
        pmap2::MassActionJumpParamMapper{Int})
    MassActionJumpParamMapper([pmap1.param_idxs, pmap2.param_idxs])
end

"""
update_parameters!(maj::MassActionJump, newparams; scale_rates=maj.rescale_rates_on_update)

Updates the passed in MassActionJump with the parameter values in `newparams`.

Notes:

  - Requires the jump to have been constructed with a user-passed `param_idxs` or `param_mapper`.
  - `scale_rates` defaults to `maj.rescale_rates_on_update`, which itself defaults to the
    `scale_rates` value used when constructing the jump. When `true`, the parameter
    representing the jump rate will be scaled by an appropriate combinatoric factor, i.e.
    for 3A --> B at rate k it will scale k --> k/3!.
"""
function update_parameters!(maj::MassActionJump, newparams; scale_rates = maj.rescale_rates_on_update, kwargs...)
    (maj.param_mapper === nothing) &&
        error("MassActionJumps must be constructed with param_idxs or a param_mapper to be updateable.")
    maj.param_mapper(maj, newparams; scale_rates, kwargs)
end

"""
$(TYPEDEF)

Defines a collection of jumps that should collectively be included in a simulation.

## Fields

$(FIELDS)

## Examples
Here we construct two jumps, store them in a `JumpSet`, and then simulate the resulting
process.
```julia
using JumpProcesses, OrdinaryDiffEq

rate1(u,p,t) = p[1]
affect1!(integrator) = (integrator.u[1] += 1)
crj = ConstantRateJump(rate1, affect1!)

rate2(u,p,t) = (t/(1+t))*p[2]*u[1]
affect2!(integrator) = (integrator.u[1] -= 1)
vrj = VariableRateJump(rate2, affect2!)

jset = JumpSet(crj, vrj)

f!(du,u,p,t) = (du .= 0)
u0 = [0.0]
p = (20.0, 2.0)
tspan = (0.0, 200.0)
oprob = ODEProblem(f!, u0, tspan, p)
jprob = JumpProblem(oprob, Direct(), jset)
sol = solve(jprob, Tsit5())
```
"""
struct JumpSet{T1, T2, T3, T4} <: AbstractJump
    """Collection of [`VariableRateJump`](@ref)s"""
    variable_jumps::T1
    """Collection of [`ConstantRateJump`](@ref)s"""
    constant_jumps::T2
    """Collection of [`RegularJump`](@ref)s"""
    regular_jump::T3
    """Collection of [`MassActionJump`](@ref)s"""
    massaction_jump::T4
end
function JumpSet(vj, cj, rj, maj::MassActionJump{S, T, U, V}) where {S <: Number, T, U, V}
    JumpSet(vj, cj, rj, check_majump_type(maj))
end

JumpSet(jump::ConstantRateJump) = JumpSet((), (jump,), nothing, nothing)
JumpSet(jump::VariableRateJump) = JumpSet((jump,), (), nothing, nothing)
JumpSet(jump::RegularJump) = JumpSet((), (), jump, nothing)
JumpSet(jump::AbstractMassActionJump) = JumpSet((), (), nothing, jump)
function JumpSet(; variable_jumps = (), constant_jumps = (),
        regular_jumps = nothing, massaction_jumps = nothing)
    JumpSet(variable_jumps, constant_jumps, regular_jumps, massaction_jumps)
end
JumpSet(jb::Nothing) = JumpSet()

# For Varargs, use recursion to make it type-stable
function JumpSet(jumps::AbstractJump...)
    JumpSet(split_jumps((), (), nothing, nothing, jumps...)...)
end

# handle vector of mass action jumps
function JumpSet(vjs, cjs, rj, majv::Vector{T}) where {T <: MassActionJump}
    if isempty(majv)
        error("JumpSets do not accept empty mass action jump collections; use \"nothing\" instead.")
    end

    sr_val = majv[1].rescale_rates_on_update
    if !all(m -> m.rescale_rates_on_update == sr_val, majv)
        error("Cannot merge MassActionJumps with different rescale_rates_on_update settings.")
    end
    maj = setup_majump_to_merge(majv[1].scaled_rates, majv[1].reactant_stoch,
        majv[1].net_stoch, majv[1].param_mapper, sr_val)
    for i in 2:length(majv)
        massaction_jump_combine(maj, majv[i])
    end

    JumpSet(vjs, cjs, rj, maj)
end

@inline get_num_majumps(jset::JumpSet) = get_num_majumps(jset.massaction_jump)
@inline num_majumps(jset::JumpSet) = get_num_majumps(jset)

@inline function num_crjs(jset::JumpSet)
    (jset.constant_jumps !== nothing) ? length(jset.constant_jumps) : 0
end

@inline function num_vrjs(jset::JumpSet)
    (jset.variable_jumps !== nothing) ? length(jset.variable_jumps) : 0
end

@inline function num_bndvrjs(jset::JumpSet)
    (jset.variable_jumps !== nothing) ? count(isbounded, jset.variable_jumps) : 0
end

@inline function num_continvrjs(jset::JumpSet)
    (jset.variable_jumps !== nothing) ? count(!isbounded, jset.variable_jumps) : 0
end

num_jumps(jset::JumpSet) = num_majumps(jset) + num_crjs(jset) + num_vrjs(jset)
num_discretejumps(jset::JumpSet) = num_majumps(jset) + num_crjs(jset) + num_bndvrjs(jset)
num_cdiscretejumps(jset::JumpSet) = num_majumps(jset) + num_crjs(jset)

@inline split_jumps(vj, cj, rj, maj) = vj, cj, rj, maj
@inline function split_jumps(vj, cj, rj, maj, v::VariableRateJump, args...)
    split_jumps((vj..., v), cj, rj, maj, args...)
end
@inline function split_jumps(vj, cj, rj, maj, c::ConstantRateJump, args...)
    split_jumps(vj, (cj..., c), rj, maj, args...)
end
@inline function split_jumps(vj, cj, rj, maj, c::RegularJump, args...)
    split_jumps(vj, cj, regular_jump_combine(rj, c), maj, args...)
end
@inline function split_jumps(vj, cj, rj, maj, c::MassActionJump, args...)
    split_jumps(vj, cj, rj, massaction_jump_combine(maj, c), args...)
end
@inline function split_jumps(vj, cj, rj, maj, j::JumpSet, args...)
    split_jumps((vj..., j.variable_jumps...),
        (cj..., j.constant_jumps...),
        regular_jump_combine(rj, j.regular_jump),
        massaction_jump_combine(maj, j.massaction_jump), args...)
end

regular_jump_combine(rj1::RegularJump, rj2::Nothing) = rj1
regular_jump_combine(rj1::Nothing, rj2::RegularJump) = rj2
regular_jump_combine(rj1::Nothing, rj2::Nothing) = rj1
function regular_jump_combine(rj1::RegularJump, rj2::RegularJump)
    error("Only one regular jump is allowed in a JumpSet")
end

# functionality to merge two mass action jumps together
function check_majump_type(maj::MassActionJump{S, T, U, V}) where {S <: Number, T, U, V}
    setup_majump_to_merge(maj.scaled_rates, maj.reactant_stoch, maj.net_stoch,
        maj.param_mapper, maj.rescale_rates_on_update)
end
function check_majump_type(maj::MassActionJump{Nothing, T, U, V}) where {T, U, V}
    setup_majump_to_merge(maj.scaled_rates, maj.reactant_stoch, maj.net_stoch,
        maj.param_mapper, maj.rescale_rates_on_update)
end

# if given containers of rates and stoichiometry directly create a jump
function setup_majump_to_merge(sr::T, rs::AbstractVector{S}, ns::AbstractVector{U}, pmapper,
        rescale_rates_on_update::Bool) where {T <: AbstractVector, S <: AbstractArray,
        U <: AbstractArray}
    MassActionJump(sr, rs, ns, pmapper; scale_rates = false, rescale_rates_on_update)
end

# if just given the data for one jump (and not in a container) wrap in a vector
function setup_majump_to_merge(sr::S, rs::T, ns::U, pmapper,
        rescale_rates_on_update::Bool) where {S <: Number, T <: AbstractArray,
        U <: AbstractArray}
    MassActionJump([sr], [rs], [ns],
        (pmapper === nothing) ? pmapper : to_collection(pmapper);
        scale_rates = false, rescale_rates_on_update)
end

# if no rate field setup yet
function setup_majump_to_merge(::Nothing, rs::T, ns::U, pmapper,
        rescale_rates_on_update::Bool) where {T <: AbstractArray, U <: AbstractArray}
    MassActionJump(nothing, [rs], [ns],
        (pmapper === nothing) ? pmapper : to_collection(pmapper);
        scale_rates = false, rescale_rates_on_update)
end

# when given a collection of reactions to add to maj
function majump_merge!(maj::MassActionJump{U, <:AbstractVector{V}, <:AbstractVector{W}, X},
        sr::U, rs::AbstractVector{V}, ns::AbstractVector{W},
        param_mapper) where {U <: Union{AbstractVector, Nothing},
        V <: AbstractVector, W <: AbstractVector, X}
    (U <: AbstractVector) && append!(maj.scaled_rates, sr)
    append!(maj.reactant_stoch, rs)
    append!(maj.net_stoch, ns)
    if maj.param_mapper === nothing
        (param_mapper === nothing) ||
            error("Error, trying to merge a MassActionJump with a parameter mapping to one without a parameter mapping.")
    else
        merge!(maj.param_mapper, param_mapper)
    end
    maj
end

# when given a single jump's worth of data to add to maj
function majump_merge!(maj::MassActionJump{U, V, W, X}, sr::T, rs::S1, ns::S2,
        param_mapper) where {T <: Union{Number, Nothing},
        S1 <: AbstractArray, S2 <: AbstractArray,
        U <: Union{AbstractVector{T}, Nothing},
        V <: AbstractVector{S1},
        W <: AbstractVector{S2}, X}
    (T <: Number) && push!(maj.scaled_rates, sr)
    push!(maj.reactant_stoch, rs)
    push!(maj.net_stoch, ns)
    if maj.param_mapper === nothing
        (param_mapper === nothing) ||
            error("Error, trying to merge a MassActionJump with a parameter mapping to one without a parameter mapping.")
    else
        merge!(maj.param_mapper, param_mapper)
    end

    maj
end

# when maj only stores a single jump's worth of data (and not in a collection)
# create a new jump with the merged data stored in vectors
function majump_merge!(maj::MassActionJump{T, S, U, V}, sr::T, rs::S, ns::U,
        param_mapper::V) where {T <: Union{Number, Nothing},
        S <: AbstractArray{<:Pair},
        U <: AbstractArray{<:Pair}, V}
    rates = (T <: Nothing) ? nothing : [maj.scaled_rates, sr]
    if maj.param_mapper === nothing
        (param_mapper === nothing) ||
            error("Error, trying to merge a MassActionJump with a parameter mapping to one without a parameter mapping.")
        return MassActionJump(rates, [maj.reactant_stoch, rs], [maj.net_stoch, ns],
            param_mapper; scale_rates = false,
            rescale_rates_on_update = maj.rescale_rates_on_update)
    else
        return MassActionJump(rates, [maj.reactant_stoch, rs], [maj.net_stoch, ns],
            merge(maj.param_mapper, param_mapper); scale_rates = false,
            rescale_rates_on_update = maj.rescale_rates_on_update)
    end
end

massaction_jump_combine(maj1::MassActionJump, maj2::Nothing) = maj1
massaction_jump_combine(maj1::Nothing, maj2::MassActionJump) = maj2
massaction_jump_combine(maj1::Nothing, maj2::Nothing) = maj1
function massaction_jump_combine(maj1::MassActionJump, maj2::MassActionJump)
    (maj1.rescale_rates_on_update == maj2.rescale_rates_on_update) ||
        error("Cannot merge MassActionJumps with different rescale_rates_on_update settings.")
    majump_merge!(maj1, maj2.scaled_rates, maj2.reactant_stoch, maj2.net_stoch,
        maj2.param_mapper)
end

##### helper methods for unpacking rates and affects! from constant jumps #####
function get_jump_info_tuples(jumps)
    if (jumps !== nothing) && !isempty(jumps)
        rates = ((c.rate for c in jumps)...,)
        affects! = ((c.affect! for c in jumps)...,)
    else
        rates = ()
        affects! = ()
    end

    rates, affects!
end

function get_jump_info_fwrappers(u, p, t, jumps)
    RateWrapper = FunctionWrappers.FunctionWrapper{typeof(t),
        Tuple{typeof(u), typeof(p), typeof(t)}}

    if (jumps !== nothing) && !isempty(jumps)
        rates = [RateWrapper(c.rate) for c in jumps]
        affects! = Any[(x -> (c.affect!(x); nothing)) for c in jumps]
    else
        rates = Vector{RateWrapper}()
        affects! = Any[]
    end

    rates, affects!
end

using JumpProcesses, DiffEqBase, OrdinaryDiffEq, OrdinaryDiffEqFunctionMap, StochasticDiffEq, Statistics
using Test
using StableRNGs
rng = StableRNG(12345)

rate = (u, p, t) -> 1.0 * u[1]
affect! = function (integrator)
    integrator.u[1] = 1.0
end
jump1 = ConstantRateJump(rate, affect!)

prob = DiscreteProblem([10], (0.0, 50.0))
prob_control = DiscreteProblem([10], (0.0, 50.0))

jump_prob = JumpProblem(prob, Direct(), jump1; rng = rng)
jump_prob_control = JumpProblem(prob_control, Direct(), jump1; rng = rng)

coupling_map = [(1, 1)]
coupled_prob = SplitCoupledJumpProblem(
    jump_prob, jump_prob_control, Direct(), coupling_map;
    rng = rng)

@time sol = solve(coupled_prob, FunctionMap())
@time solve(jump_prob, FunctionMap())
@test [s[1] - s[2] for s in sol.u] == zeros(length(sol.t)) # coupling two copies of the same process should give zero

rate = (u, p, t) -> 1.0
affect! = function (integrator)
    integrator.u[1] = 1.0
end
jump1 = ConstantRateJump(rate, affect!)
rate = (u, p, t) -> 2.0
jump2 = ConstantRateJump(rate, affect!)

f = function (du, u, p, t)
    du[1] = u[1]
end
g = function (du, u, p, t)
    du[1] = 0.1
end

# Jump ODE to jump ODE
prob = ODEProblem(f, [1.0], (0.0, 1.0))
prob_control = ODEProblem(f, [1.0], (0.0, 1.0))
jump_prob = JumpProblem(prob, Direct(), jump1; rng = rng)
jump_prob_control = JumpProblem(prob_control, Direct(), jump2; rng = rng)
coupled_prob = SplitCoupledJumpProblem(
    jump_prob, jump_prob_control, Direct(), coupling_map;
    rng = rng)
sol = solve(coupled_prob, Tsit5())
@test mean([abs(s[1] - s[2]) for s in sol.u]) <= 5.0

# Jump SDE to Jump SDE
prob = SDEProblem(f, g, [1.0], (0.0, 1.0))
prob_control = SDEProblem(f, g, [1.0], (0.0, 1.0))
jump_prob = JumpProblem(prob, Direct(), jump1; rng = rng)
jump_prob_control = JumpProblem(prob_control, Direct(), jump1; rng = rng)
coupled_prob = SplitCoupledJumpProblem(
    jump_prob, jump_prob_control, Direct(), coupling_map;
    rng = rng)
sol = solve(coupled_prob, SRIW1())
@test mean([abs(s[1] - s[2]) for s in sol.u]) <= 5.0

# Jump SDE to Jump ODE
prob = ODEProblem(f, [1.0], (0.0, 1.0))
prob_control = SDEProblem(f, g, [1.0], (0.0, 1.0))
jump_prob = JumpProblem(prob, Direct(), jump1; rng = rng)
jump_prob_control = JumpProblem(prob_control, Direct(), jump1; rng = rng)
coupled_prob = SplitCoupledJumpProblem(
    jump_prob, jump_prob_control, Direct(), coupling_map;
    rng = rng)
sol = solve(coupled_prob, SRIW1())
@test mean([abs(s[1] - s[2]) for s in sol.u]) <= 5.0

# Jump SDE to Discrete
rate = (u, p, t) -> 1.0
affect! = function (integrator)
    integrator.u[1] += 1.0
end
prob = DiscreteProblem([1.0], (0.0, 1.0))
prob_control = SDEProblem(f, g, [1.0], (0.0, 1.0))
jump_prob = JumpProblem(prob, Direct(), jump1; rng = rng)
jump_prob_control = JumpProblem(prob_control, Direct(), jump1; rng = rng)
coupled_prob = SplitCoupledJumpProblem(
    jump_prob, jump_prob_control, Direct(), coupling_map;
    rng = rng)
sol = solve(coupled_prob, SRIW1())

# test mass action jumps coupled to ODE
# 0 -> A (stochasic) and A -> 0 (ODE)
rate = [100.0]
react_stoch = [Vector{Pair{Int, Int}}()]
net_stoch = [[1 => 1]]
majumps = MassActionJump(rate, react_stoch, net_stoch)
f = function (du, u, p, t)
    du[1] = -1.0 * u[1]
end
odeprob = ODEProblem(f, [10.0], (0.0, 10.0))
jump_prob = JumpProblem(odeprob, Direct(), majumps, save_positions = (false, false);
    rng = rng)
Nsims = 8000
Amean = 0.0
for i in 1:Nsims
    global Amean
    local sol = solve(jump_prob, Tsit5(), saveat = 10.0)
    Amean += sol[1, end]
end
Amean /= Nsims
actmean = 100.0 + (10.0 - 100.0) * exp(-1.0 * 10.0)
#println(abs(Amean-actmean)/actmean)
@test abs(actmean - Amean) < 0.02 * actmean

using DiffEqBase, JumpProcesses, OrdinaryDiffEq, StochasticDiffEq, Test
using Random, LinearSolve, Statistics
using StableRNGs, ADTypes
rng = StableRNG(12345)

a = ExtendedJumpArray(rand(rng, 3), rand(rng, 2))
b = ExtendedJumpArray(rand(rng, 3), rand(rng, 2))

a .= b

@test a.u == b.u
@test a.jump_u == b.jump_u
@test a == b

c = rand(rng, 5)
d = 2.0

a .+ d
a .= b .+ d
a .+ c .+ d
a .= b .+ c .+ d

rate = (u, p, t) -> u[1]
affect! = (integrator) -> (integrator.u[1] = integrator.u[1] / 2)
jump = VariableRateJump(rate, affect!)
jump2 = deepcopy(jump)

f = function (du, u, p, t)
    du[1] = u[1]
end

prob = ODEProblem(f, [0.2], (0.0, 10.0))
jump_prob = JumpProblem(prob, jump, jump2; vr_aggregator = VR_FRM(), rng)
integrator = init(jump_prob, Tsit5())
sol = solve(jump_prob, Tsit5())
sol = solve(jump_prob, Rosenbrock23(autodiff = AutoFiniteDiff()))
sol = solve(jump_prob, Rosenbrock23())

jump_prob_gill = JumpProblem(prob, jump, jump2; vr_aggregator = VR_Direct(), rng)
integrator = init(jump_prob_gill, Tsit5())
sol_gill = solve(jump_prob_gill, Tsit5())
sol_gill = solve(jump_prob, Rosenbrock23(autodiff = AutoFiniteDiff()))
sol_gill = solve(jump_prob, Rosenbrock23())
@test maximum([sol.u[i][2] for i in 1:length(sol.u)]) <= 1e-12
@test maximum([sol.u[i][3] for i in 1:length(sol.u)]) <= 1e-12

g = function (du, u, p, t)
    du[1] = u[1]
end
prob = SDEProblem(f, g, [0.2], (0.0, 10.0))
jump_prob = JumpProblem(prob, jump, jump2; vr_aggregator = VR_FRM(), rng = rng)
sol = solve(jump_prob, SRIW1())
jump_prob_gill = JumpProblem(prob, jump, jump2; vr_aggregator = VR_Direct(), rng = rng)
sol_gill = solve(jump_prob_gill, SRIW1())
@test maximum([sol.u[i][2] for i in 1:length(sol.u)]) <= 1e-12
@test maximum([sol.u[i][3] for i in 1:length(sol.u)]) <= 1e-12

function ff(du, u, p, t)
    if p == 0
        du .= 1.01u
    else
        du .= 2.01u
    end
end
function gg(du, u, p, t)
    du[1, 1] = 0.3u[1]
    du[1, 2] = 0.6u[1]
    du[2, 1] = 1.2u[1]
    du[2, 2] = 0.2u[2]
end
rate_switch(u, p, t) = u[1] * 1.0
function affect_switch!(integrator)
    integrator.p = 1
end
jump_switch = VariableRateJump(rate_switch, affect_switch!)
prob = SDEProblem(ff, gg, ones(2), (0.0, 1.0), 0, noise_rate_prototype = zeros(2, 2))
jump_prob = JumpProblem(prob, jump_switch; vr_aggregator = VR_FRM(), rng)
jump_prob_gill = JumpProblem(prob, jump_switch; vr_aggregator = VR_Direct(), rng)
sol = solve(jump_prob, SRA1(), dt = 1.0)
sol_gill = solve(jump_prob_gill, SRA1(), dt = 1.0)

## Some integration tests

function f2(du, u, p, t)
    du[1] = u[1]
end
prob = ODEProblem(f2, [0.2], (0.0, 10.0))
rate2(u, p, t) = 2
affect2!(integrator) = (integrator.u[1] = integrator.u[1] / 2)
jump = ConstantRateJump(rate2, affect2!)
jump_prob = JumpProblem(prob, jump; vr_aggregator = VR_FRM(), rng)
jump_prob_gill = JumpProblem(prob, jump; vr_aggregator = VR_Direct(), rng)
sol = solve(jump_prob, Tsit5())
sol_gill = solve(jump_prob_gill, Tsit5())
sol(4.0)
sol.u[4]

rate2b(u, p, t) = u[1]
affect2b!(integrator) = (integrator.u[1] = integrator.u[1] / 2)
jump = VariableRateJump(rate2b, affect2b!)
jump2 = deepcopy(jump)
jump_prob = JumpProblem(prob, jump, jump2; vr_aggregator = VR_FRM(), rng)
jump_prob_gill = JumpProblem(prob, jump, jump2; vr_aggregator = VR_Direct(), rng)
sol = solve(jump_prob, Tsit5())
sol_gill = solve(jump_prob_gill, Tsit5())
sol(4.0)
sol.u[4]

function g2(du, u, p, t)
    du[1] = u[1]
end
prob = SDEProblem(f2, g2, [0.2], (0.0, 10.0))
jump_prob = JumpProblem(prob, jump, jump2; vr_aggregator = VR_FRM(), rng)
jump_prob_gill = JumpProblem(prob, jump, jump2; vr_aggregator = VR_Direct(), rng)
sol = solve(jump_prob, SRIW1())
sol_gill = solve(jump_prob_gill, SRIW1())
sol(4.0)
sol.u[4]

function f3(du, u, p, t)
    du .= u
end
prob = ODEProblem(f3, [1.0 2.0; 3.0 4.0], (0.0, 1.0))
rate3(u, p, t) = u[1] + u[2]
function affect3!(integrator)
    (integrator.u[1] = 0.25;
        integrator.u[2] = 0.5;
        integrator.u[3] = 0.75;
        integrator.u[4] = 1)
end
jump = VariableRateJump(rate3, affect3!)
jump_prob = JumpProblem(prob, jump; vr_aggregator = VR_FRM(), rng)
jump_prob_gill = JumpProblem(prob, jump; vr_aggregator = VR_Direct(), rng)
sol = solve(jump_prob, Tsit5())
sol_gill = solve(jump_prob_gill, Tsit5())

# test for https://discourse.julialang.org/t/differentialequations-jl-package-variable-rate-jumps-with-complex-variables/80366/2
function f4(dx, x, p, t)
    dx[1] = x[1]
end
rate4(x, p, t) = t
function affect4!(integrator)
    integrator.u[1] = integrator.u[1] * 0.5
end
jump = VariableRateJump(rate4, affect4!)
x₀ = 1.0 + 0.0im
Δt = (0.0, 6.0)
prob = ODEProblem(f4, [x₀], Δt)
jump_prob = JumpProblem(prob, jump; vr_aggregator = VR_FRM(), rng)
jump_prob_gill = JumpProblem(prob, jump; vr_aggregator = VR_Direct(), rng)
sol = solve(jump_prob, Tsit5())
sol_gill = solve(jump_prob_gill, Tsit5())

# Out of place test
drift(x, p, t) = p * x
rate2c(x, p, t) = 3 * max(0.0, x[1])
affect!2(integrator) = (integrator.u ./= 2; nothing)
x0 = rand(2)
prob = ODEProblem(drift, x0, (0.0, 10.0), 2.0)
jump = VariableRateJump(rate2c, affect!2)
jump_prob = JumpProblem(prob, Direct(), jump; vr_aggregator = VR_FRM(), rng)

# test to check lack of dependency graphs is caught in Coevolve for systems with non-maj
# jumps
let
    maj_rate = [1.0]
    react_stoich_ = [Vector{Pair{Int, Int}}()]
    net_stoich_ = [[1 => 1]]
    mass_action_jump_ = MassActionJump(maj_rate, react_stoich_, net_stoich_;
        scale_rates = false)

    affect! = function (integrator)
        integrator.u[1] -= 1
    end
    cs_rate1(u, p, t) = 0.2 * u[1]
    constant_rate_jump = ConstantRateJump(cs_rate1, affect!)
    jumpset_ = JumpSet((), (constant_rate_jump,), nothing, mass_action_jump_)

    for alg in (Coevolve(),)
        u0 = [0]
        tspan = (0.0, 30.0)
        dprob_ = DiscreteProblem(u0, tspan)
        @test_throws ErrorException JumpProblem(dprob_, alg, jumpset_,
            save_positions = (false, false))

        vrj = VariableRateJump(cs_rate1, affect!; urate = ((u, p, t) -> 1.0),
            rateinterval = ((u, p, t) -> 1.0))
        @test_throws ErrorException JumpProblem(dprob_, alg, mass_action_jump_, vrj;
            save_positions = (false, false))
    end
end

# Test that rate, urate and lrate do not get called past tstop
# https://github.com/SciML/JumpProcesses.jl/issues/330
let
    function test_rate(u, p, t)
        if t > 1.0
            error("test_rate does not handle t > 1.0")
        else
            return 0.1
        end
    end
    test_affect!(integrator) = (integrator.u[1] += 1)
    function test_lrate(u, p, t)
        if t > 1.0
            error("test_lrate does not handle t > 1.0")
        else
            return 0.05
        end
    end
    function test_urate(u, p, t)
        if t > 1.0
            error("test_urate does not handle t > 1.0")
        else
            return 0.2
        end
    end

    test_jump = VariableRateJump(test_rate, test_affect!; urate = test_urate,
        rateinterval = (u, p, t) -> 1.0)

    dprob = DiscreteProblem([0], (0.0, 1.0), nothing)
    jprob = JumpProblem(dprob, Coevolve(), test_jump; dep_graph = [[1]])

    @test_nowarn for i in 1:50
        solve(jprob, SSAStepper())
    end
end

# test u0 resets correctly
let
    b = 2.0
    d = 1.0
    n0 = 1
    tspan = (0.0, 4.0)
    Nsims = 10
    u0 = [n0]
    p = [b, d]

    function ode_fxn(du, u, p, t)
        du .= 0
        nothing
    end
    b_rate(u, p, t) = (u[1] * p[1])
    function birth!(integrator)
        integrator.u[1] += 1
        nothing
    end
    b_jump = VariableRateJump(b_rate, birth!)

    d_rate(u, p, t) = (u[1] * p[2])
    function death!(integrator)
        integrator.u[1] -= 1
        nothing
    end
    d_jump = VariableRateJump(d_rate, death!)

    ode_prob = ODEProblem(ode_fxn, u0, tspan, p)
    sjm_prob = JumpProblem(ode_prob, b_jump, d_jump; vr_aggregator = VR_FRM(), rng)
    # After callback initialize, integrator.u.jump_u should have unique thresholds
    # that differ between sequential solves (RNG advances each time).
    jump_u_old = zeros(length(sjm_prob.prob.u0.jump_u))
    for i in 1:Nsims
        integrator = init(sjm_prob, Tsit5(); saveat = tspan[2])
        @test allunique(integrator.u.jump_u)
        @test integrator.u.jump_u != jump_u_old
        jump_u_old .= integrator.u.jump_u
        solve!(integrator)
    end
end

# accuracy test based on 
# https://github.com/SciML/JumpProcesses.jl/issues/320
# note that even with the seeded StableRNG this test is not 
# deterministic for some reason.
function getmean(Nsims, prob, alg, tsave, seed)
    umean = zeros(length(tsave))
    integrator = init(prob, alg; saveat = tsave, seed)
    solve!(integrator)
    for j in eachindex(umean)
        umean[j] += integrator.sol.u[j][1]
    end
    for i in 2:Nsims
        reinit!(integrator)
        solve!(integrator)
        for j in eachindex(umean)
            umean[j] += integrator.sol.u[j][1]
        end
    end
    umean ./= Nsims
    return umean
end

let
    seed = 12345
    rng = StableRNG(seed)
    b = 2.0
    d = 1.0
    n0 = 1.0
    tspan = (0.0, 4.0)
    Nsims = 10000
    n(t) = n0 * exp((b - d) * t)
    u0 = [n0]
    p = [b, d]

    function ode_fxn(du, u, p, t)
        du .= 0
        nothing
    end

    b_rate(u, p, t) = (u[1] * p[1])
    function birth!(integrator)
        integrator.u[1] += 1
        nothing
    end
    b_jump = VariableRateJump(b_rate, birth!; save_positions = (false, false))

    d_rate(u, p, t) = (u[1] * p[2])
    function death!(integrator)
        integrator.u[1] -= 1
        nothing
    end
    d_jump = VariableRateJump(d_rate, death!; save_positions = (false, false))

    ode_prob = ODEProblem(ode_fxn, u0, tspan, p)
    tsave = range(tspan[1], tspan[2]; step = 0.1)
    for vr_aggregator in (VR_Direct(), VR_DirectFW(), VR_FRM())
        sjm_prob = JumpProblem(ode_prob, b_jump, d_jump; vr_aggregator, rng)

        for alg in (Tsit5(), Rodas5P(linsolve = QRFactorization()))
            umean = getmean(Nsims, sjm_prob, alg, tsave, seed)
            @test all(abs.(umean .- n.(tsave)) .< 0.05 * n.(tsave))
            seed += Nsims
        end
    end
end

# Correctness test based on 
# VR_Direct and VR_FRM
# Function to run ensemble and compute statistics
function run_ensemble(prob, alg, jumps...; vr_aggregator = VR_FRM(), Nsims = 8000)
    rng = StableRNG(12345)
    jump_prob = JumpProblem(prob, Direct(), jumps...; vr_aggregator, rng)
    total = 0.0
    for i in 1:Nsims
        sol = solve(jump_prob, alg; save_everystep = false)
        total += sol.u[end][1]
    end
    return total / Nsims
end

# Test 1: Simple ODE with two variable rate jumps
let
    rate = (u, p, t) -> u[1]
    affect! = (integrator) -> (integrator.u[1] = integrator.u[1] / 2)
    jump = VariableRateJump(rate, affect!; save_positions = (false, false))
    jump2 = deepcopy(jump)

    f = (du, u, p, t) -> (du[1] = u[1])
    prob = ODEProblem(f, [0.2], (0.0, 10.0))

    mean_vrfr = run_ensemble(prob, Tsit5(), jump, jump2)
    mean_vrcb = run_ensemble(prob, Tsit5(), jump, jump2; vr_aggregator = VR_Direct())
    mean_vrcbfw = run_ensemble(prob, Tsit5(), jump, jump2; vr_aggregator = VR_DirectFW())

    @test isapprox(mean_vrfr, mean_vrcb, rtol = 0.05)
    @test isapprox(mean_vrcb, mean_vrcbfw, rtol = 0.05)
end

# Test 2: SDE with two variable rate jumps
let
    f = (du, u, p, t) -> (du[1] = -u[1] / 10.0)
    g = (du, u, p, t) -> (du[1] = -u[1] / 10.0)
    rate = (u, p, t) -> u[1] / 10.0
    affect! = (integrator) -> (integrator.u[1] = integrator.u[1] + 1)
    jump = VariableRateJump(rate, affect!; save_positions = (false, false))
    jump2 = deepcopy(jump)

    prob = SDEProblem(f, g, [10.0], (0.0, 10.0))

    mean_vrfr = run_ensemble(prob, SRIW1(), jump, jump2)
    mean_vrcb = run_ensemble(prob, SRIW1(), jump, jump2; vr_aggregator = VR_Direct())
    mean_vrcbfw = run_ensemble(prob, SRIW1(), jump, jump2; vr_aggregator = VR_DirectFW())

    @test isapprox(mean_vrfr, mean_vrcb, rtol = 0.05)
    @test isapprox(mean_vrcb, mean_vrcbfw, rtol = 0.05)
end

# Test 3: ODE with analytical solution
let
    λ = 2.0
    f = (du, u, p, t) -> (du[1] = -u[1]; nothing)
    rate = (u, p, t) -> λ
    affect! = (integrator) -> (integrator.u[1] += 1; nothing)
    jump = VariableRateJump(rate, affect!; save_positions = (false, false))

    prob = ODEProblem(f, [0.2], (0.0, 10.0))

    mean_vrfr = run_ensemble(prob, Tsit5(), jump)
    mean_vrcb = run_ensemble(prob, Tsit5(), jump; vr_aggregator = VR_Direct())
    mean_vrcbfw = run_ensemble(prob, Tsit5(), jump; vr_aggregator = VR_DirectFW())

    t = 10.0
    u0 = 0.2
    analytical_mean = u0 * exp(-t) + λ*(1 - exp(-t))

    @test isapprox(mean_vrfr, analytical_mean, rtol = 0.05)
    @test isapprox(mean_vrfr, mean_vrcb, rtol = 0.05)
    @test isapprox(mean_vrcb, mean_vrcbfw, rtol = 0.05)
end

# Test 4: No. of Jumps
let
    f(du, u, p, t) = (du[1] = 0.0; nothing)

    # Define birth jump: ∅ → X
    birth_rate(u, p, t) = 10.0
    function birth_affect!(integrator)
        integrator.u[1] += 1
        integrator.p[3] += 1
        nothing
    end
    birth_jump = VariableRateJump(birth_rate, birth_affect!; save_positions = (
        false, false))

    # Define death jump: X → ∅
    death_rate(u, p, t) = 0.5 * u[1]
    function death_affect!(integrator)
        integrator.u[1] -= 1
        integrator.p[3] += 1
        nothing
    end
    death_jump = VariableRateJump(death_rate, death_affect!; save_positions = (
        false, false))

    Nsims = 100
    results = Dict()
    u0 = [1.0]
    tspan = (0.0, 10.0)
    for vr_aggregator in (VR_FRM(), VR_Direct(), VR_DirectFW())
        jump_counts = zeros(Int, Nsims)
        p = [0.0, 0.0, 0]
        prob = ODEProblem(f, u0, tspan, p)
        jump_prob = JumpProblem(prob, Direct(), birth_jump, death_jump; vr_aggregator, rng)

        for i in 1:Nsims
            sol = solve(jump_prob, Tsit5(); save_everystep = false)
            jump_counts[i] = jump_prob.prob.p[3]
            jump_prob.prob.p[3] = 0
        end

        results[vr_aggregator] = (mean_jumps = mean(jump_counts), jump_counts = jump_counts)
        @test sum(jump_counts) > 1000
    end

    mean_jumps_vrfr = results[VR_FRM()].mean_jumps
    mean_jumps_vrcb = results[VR_Direct()].mean_jumps
    mean_jumps_vrcbfw = results[VR_DirectFW()].mean_jumps

    @test isapprox(mean_jumps_vrfr, mean_jumps_vrcb, rtol = 0.1)
    @test isapprox(mean_jumps_vrcb, mean_jumps_vrcbfw, rtol = 0.1)
end

# Test combining MassActionJump with VariableRateJump for all aggregators
# This tests the fix for https://github.com/SciML/JumpProcesses.jl/issues/545
# where RSSA/RSSACR aggregators would fail with ExtendedJumpArray due to
# update_u_brackets! iterating over the full array instead of just species
let
    rng = StableRNG(12345)

    function f!(du, u, p, t)
        du .= 0
    end

    # VariableRateJump (rate depends on time)
    vrj_rate(u, p, t) = p[1] * (1 + sin(t)) * u[1]
    vrj_affect!(integrator) = (integrator.u[1] -= 1; integrator.u[2] += 1)
    vrj = VariableRateJump(vrj_rate, vrj_affect!)

    # MassActionJump: X2 -> X1 with rate k2
    maj = MassActionJump([0.5], [[2 => 1]], [[1 => 1, 2 => -1]])

    u0 = [10.0, 5.0]
    tspan = (0.0, 1.0)
    p = [0.1]
    prob = ODEProblem(f!, u0, tspan, p)

    # Test all aggregators that support MassActionJump
    # Note: Coevolve requires dependency graphs for non-bounded VRJs so we skip it here
    aggregators = [
        Direct(),
        FRM(),
        NRM(),
        SortingDirect(),
        DirectCR(),
        RDirect(),
        RSSA(),
        RSSACR()
    ]

    for agg in aggregators
        local jprob = JumpProblem(prob, agg, maj, vrj; rng)
        local sol = solve(jprob, Tsit5())
        @test SciMLBase.successful_retcode(sol)
        # Verify conservation: total population should be conserved
        @test sol.u[end][1] + sol.u[end][2] ≈ u0[1] + u0[2]
    end
end

# Test with ConstantRateJump + VariableRateJump (no MassActionJump)
let
    rng = StableRNG(12345)

    function f!(du, u, p, t)
        du .= 0
    end

    # VariableRateJump
    vrj_rate(u, p, t) = 0.1 * (1 + sin(t)) * u[1]
    vrj_affect!(integrator) = (integrator.u[1] -= 1; integrator.u[2] += 1)
    vrj = VariableRateJump(vrj_rate, vrj_affect!)

    # ConstantRateJump: X2 -> X1
    crj_rate(u, p, t) = 0.5 * u[2]
    crj_affect!(integrator) = (integrator.u[1] += 1; integrator.u[2] -= 1)
    crj = ConstantRateJump(crj_rate, crj_affect!)

    u0 = [10.0, 5.0]
    tspan = (0.0, 1.0)
    prob = ODEProblem(f!, u0, tspan)

    # Test with Direct aggregator (most common case)
    jprob = JumpProblem(prob, Direct(), crj, vrj; rng)
    sol = solve(jprob, Tsit5())
    @test SciMLBase.successful_retcode(sol)
    @test sol.u[end][1] + sol.u[end][2] ≈ u0[1] + u0[2]
end

# Test with multiple VariableRateJumps + MassActionJump
let
    rng = StableRNG(12345)

    function f!(du, u, p, t)
        du .= 0
    end

    # Two VariableRateJumps
    vrj1_rate(u, p, t) = 0.1 * u[1]
    vrj1_affect!(integrator) = (integrator.u[1] -= 1; integrator.u[2] += 1)
    vrj1 = VariableRateJump(vrj1_rate, vrj1_affect!)

    vrj2_rate(u, p, t) = 0.05 * u[2]
    vrj2_affect!(integrator) = (integrator.u[2] -= 1; integrator.u[1] += 1)
    vrj2 = VariableRateJump(vrj2_rate, vrj2_affect!)

    # MassActionJump
    maj = MassActionJump([0.2], [[1 => 1]], [[1 => -1, 2 => 1]])

    u0 = [20.0, 10.0]
    tspan = (0.0, 2.0)
    prob = ODEProblem(f!, u0, tspan)

    # Test RSSA and RSSACR specifically (the aggregators that had the bug)
    for agg in [RSSA(), RSSACR()]
        local jprob = JumpProblem(prob, agg, maj, vrj1, vrj2; rng)
        local sol = solve(jprob, Tsit5())
        @test SciMLBase.successful_retcode(sol)
        @test sol.u[end][1] + sol.u[end][2] ≈ u0[1] + u0[2]
    end
end

# Regression for https://github.com/SciML/JumpProcesses.jl/issues/592
# VR_FRM + SDEProblem with `noise_rate_prototype` + adaptive non-diagonal SDE
# solver: ExtendedJumpArray's `mul!` needs to zero `c.jump_u` when the noise
# matrix only addresses the original state, otherwise stale scratchpad values
# from the adaptive error estimate blow up `jump_u` and the VRJ callbacks
# never fire.
let
    rng = StableRNG(592)

    mutable struct Issue592Params
        λ::Float64
        μ::Float64
        mode::Symbol
    end
    p = Issue592Params(0.3, 0.5, :CLE)

    function f!(du, u, p, t)
        du[1] = (p.mode === :CLE) ? (p.λ - p.μ) * u[1] : 0.0
        nothing
    end
    function g!(G, u, p, t)
        if p.mode === :CLE
            x = max(u[1], 0.0)
            G[1, 1] = sqrt(p.λ * x)
            G[1, 2] = -sqrt(p.μ * x)
        else
            G .= 0.0
        end
        nothing
    end

    rate_birth(u, p, t) = (p.mode === :SSA) ? p.λ * u[1] : 0.0
    rate_death(u, p, t) = (p.mode === :SSA) ? p.μ * u[1] : 0.0
    birth_affect!(integ) = (integ.u[1] += 1.0)
    death_affect!(integ) = (integ.u[1] -= 1.0)
    birth = VariableRateJump(rate_birth, birth_affect!)
    death = VariableRateJump(rate_death, death_affect!)

    switch_cond(u, t, integ) = (integ.p.mode === :CLE) ? u[1] - 95.0 : 1.0
    function switch_affect!(integ)
        integ.u[1] = max(round(integ.u[1]), 0.0)
        integ.p.mode = :SSA
        u_modified!(integ, true)
        reset_aggregated_jumps!(integ)
    end
    switch_cb = ContinuousCallback(switch_cond, switch_affect!)

    u0 = [150.0]
    tspan = (0.0, 10.0)
    sde_prob = SDEProblem(f!, g!, u0, tspan, p; noise_rate_prototype = zeros(1, 2))
    jprob = JumpProblem(sde_prob, Direct(), birth, death; vr_aggregator = VR_FRM(), rng)

    sol = solve(jprob, LambaEM(); callback = switch_cb, adaptive = true)
    @test SciMLBase.successful_retcode(sol)
    @test sol.t[end] == tspan[2]
    # The bug drove `jump_u` past ±1e15 within a few steps; with the fix it
    # stays bounded near its initial -randexp() values.
    @test all(isfinite, sol.u[end].jump_u)
    @test maximum(abs, sol.u[end].jump_u) < 1e6
    # SSA jumps must actually fire after the mode switch — without the fix u
    # gets pinned at the switch threshold (95) forever.
    @test sol.u[end].u[1] != 95.0
end

function isinplace_jump(p, rj)
    if p isa DiscreteProblem && p.f === DiffEqBase.DISCRETE_INPLACE_DEFAULT &&
       rj !== nothing
        # Just a default discrete problem f, so don't use it for iip
        DiffEqBase.isinplace(rj)
    else
        DiffEqBase.isinplace(p)
    end
end

"""
$(TYPEDEF)

Defines a collection of jump processes to associate with another problem type.

  - [Documentation Page](https://docs.sciml.ai/JumpProcesses/stable/jump_types/)
  - [Tutorial
    Page](https://docs.sciml.ai/JumpProcesses/stable/tutorials/discrete_stochastic_example/)
  - [FAQ
    Page](https://docs.sciml.ai/JumpProcesses/stable/tutorials/discrete_stochastic_example/#FAQ)

### Constructors

`JumpProblem`s can be constructed by first building another problem type to which the jumps
will be associated. For example, to  simulate a collection of jump processes for which the
transition rates are constant *between* jumps (called [`ConstantRateJump`](@ref)s or
[`MassActionJump`](@ref)s), we must first construct a
[`DiscreteProblem`](https://docs.sciml.ai/DiffEqDocs/stable/types/discrete_types/)

```julia
prob = DiscreteProblem(u0, p, tspan)
```

where `u0` is the initial condition, `p` the parameters and `tspan` the time span. If we
wanted to have the jumps coupled with a system of ODEs, or have transition rates with
explicit time dependence, we would use an `ODEProblem` instead that defines the ODE portion
of the dynamics.

Given `prob` we define the jumps via

  - `JumpProblem(prob, aggregator::AbstractAggregatorAlgorithm, jumps::JumpSet ; kwargs...)`
  - `JumpProblem(prob, aggregator::AbstractAggregatorAlgorithm, jumps...; kwargs...)`

Here `aggregator` specifies the underlying algorithm for calculating next jump times and
types, for example [`Direct`](@ref). The collection of different `AbstractJump` types can
then be passed within a single [`JumpSet`](@ref) or as subsequent sequential arguments.

### Fields

$(FIELDS)

## Keyword Arguments

  - `rng`, the random number generator to use. Defaults to Julia's built-in generator.
  - `save_positions=(true,true)` when including variable rates and `(false,true)` for constant
    rates, specifies whether to save the system's state (before, after) the jump occurs.
  - `spatial_system`, for spatial problems the underlying spatial structure.
  - `hopping_constants`, for spatial problems the spatial transition rate coefficients.
  - `use_vrj_bounds = true`, set to false to disable handling bounded `VariableRateJump`s with
    a supporting aggregator (such as `Coevolve`). They will then be handled via the continuous
    integration interface, and treated like general `VariableRateJump`s.
  - `vr_aggregator`, indicates the aggregator to use for sampling variable rate jumps. Current
    default is `VR_FRM`.

Please see the [tutorial
page](https://docs.sciml.ai/JumpProcesses/stable/tutorials/discrete_stochastic_example/) in
the DifferentialEquations.jl [docs](https://docs.sciml.ai/JumpProcesses/stable/) for usage
examples and commonly asked questions.
"""
mutable struct JumpProblem{iip, P, A, C, J <: Union{Nothing, AbstractJumpAggregator}, J1, 
        J2, J3, J4, R, K} <: DiffEqBase.AbstractJumpProblem{P, J}
    """The type of problem to couple the jumps to. For a pure jump process use `DiscreteProblem`, to couple to ODEs, `ODEProblem`, etc."""
    prob::P
    """The aggregator algorithm that determines the next jump times and types for `ConstantRateJump`s and `MassActionJump`s. Examples include `Direct`."""
    aggregator::A
    """The underlying state data associated with the chosen aggregator."""
    discrete_jump_aggregation::J
    """`CallBackSet` with the underlying `ConstantRate` and `VariableRate` jumps."""
    jump_callback::C
    """The `ConstantRateJump`s."""
    constant_jumps::J1
    """The `VariableRateJump`s."""
    variable_jumps::J2
    """The `RegularJump`s."""
    regular_jump::J3
    """The `MassActionJump`s."""
    massaction_jump::J4
    """The random number generator to use."""
    rng::R
    """kwargs to pass on to solve call."""
    kwargs::K
end
function JumpProblem(p::P, a::A, dj::J, jc::C, cj::J1, vj::J2, rj::J3, mj::J4,
        rng::R, kwargs::K) where {P, A, J, C, J1, J2, J3, J4, R, K}
    iip = isinplace_jump(p, rj)
    JumpProblem{iip, P, A, C, J, J1, J2, J3, J4, R, K}(p, a, dj, jc, cj, vj, rj, mj, 
        rng, kwargs)
end

######## remaking ######

# for a problem where prob.u0 is an ExtendedJumpArray, create an ExtendedJumpArray that 
# aliases and resets prob.u0.jump_u while having newu0 as the new u component.
function remake_extended_u0(prob, newu0, rng)
    jump_u = prob.u0.jump_u
    ttype = eltype(prob.tspan)
    @. jump_u = -randexp(rng, ttype)
    ExtendedJumpArray(newu0, jump_u)
end

Base.@pure remaker_of(prob::T) where {T <: JumpProblem} = DiffEqBase.parameterless_type(T)
function DiffEqBase.remake(jprob::JumpProblem; u0 = missing, p = missing,
        interpret_symbolicmap = true, use_defaults = false, kwargs...)
    T = remaker_of(jprob)

    errmesg = """
    JumpProblems can currently only be remade with new u0, p, tspan or prob fields. To change other fields create a new JumpProblem. Feel free to open an issue on JumpProcesses to discuss further.
    """
    !issubset(keys(kwargs), (:tspan, :prob)) && error(errmesg)

    if :prob ∉ keys(kwargs)
        # Update u0 when we are wrapping via ExtendedJumpArrays. If the user passes an
        # ExtendedJumpArray we assume they properly initialized it
        prob = jprob.prob
        if (prob.u0 isa ExtendedJumpArray) && (u0 !== missing)
            if u0 isa ExtendedJumpArray
                # User provided ExtendedJumpArray directly - use as-is (current behavior)
                # This gives users full control over jump_u values
                final_u0 = u0
            else
                # Resolve symbolic maps if needed (handles [:X => 3.0], [sys.X => 3.0], Dict, etc.)
                resolved_u0, _ = SciMLBase.updated_u0_p(prob, u0, missing; interpret_symbolicmap, use_defaults)

                # Extract state values and wrap with fresh jump_u (resampled)
                # This handles both:
                #   - symbolic maps (resolved_u0 is ExtendedJumpArray with updated u)
                #   - numeric arrays (resolved_u0 is Vector{Float64})
                state_vals = resolved_u0 isa ExtendedJumpArray ? resolved_u0.u : resolved_u0

                # Validate type compatibility
                if typeof(state_vals) != typeof(prob.u0.u)
                    error("Passed in u0 is incompatible with current u0 which has type: $(typeof(prob.u0.u)).")
                end

                final_u0 = remake_extended_u0(prob, state_vals, jprob.rng)
            end
            newprob = DiffEqBase.remake(prob; u0 = final_u0, p, interpret_symbolicmap, use_defaults, kwargs...)
        else
            newprob = DiffEqBase.remake(prob; u0, p, interpret_symbolicmap, use_defaults, kwargs...)
        end

        # if the parameters were changed we must remake the MassActionJump too
        if (p !== missing) && using_params(jprob.massaction_jump)
            update_parameters!(jprob.massaction_jump, newprob.p; kwargs...)
        end
    else
        ((u0 !== missing) || (p !== missing) || (:tspan ∈ keys(kwargs))) &&
            error("If remaking a JumpProblem you can not pass both prob and any of u0, p, or tspan.")
        newprob = kwargs[:prob]

        # when passing a new wrapped problem directly we require u0 has the correct type
        (typeof(newprob.u0) == typeof(jprob.prob.u0)) ||
            error("The new u0 within the passed prob does not have the same type as the existing u0. Please pass a u0 of type $(typeof(jprob.prob.u0)).")

        # we can't know if p was changed, so we must remake the MassActionJump
        if using_params(jprob.massaction_jump)
            update_parameters!(jprob.massaction_jump, newprob.p; kwargs...)
        end
    end

    T(newprob, jprob.aggregator, jprob.discrete_jump_aggregation, jprob.jump_callback,
        jprob.constant_jumps, jprob.variable_jumps, jprob.regular_jump, 
        jprob.massaction_jump, jprob.rng, jprob.kwargs)
end

# for updating parameters in JumpProblems to update MassActionJumps
function SII.finalize_parameters_hook!(prob::JumpProblem, p)
    if using_params(prob.massaction_jump)
        update_parameters!(prob.massaction_jump, SII.parameter_values(prob))
    end
    nothing
end

DiffEqBase.isinplace(::JumpProblem{iip}) where {iip} = iip
JumpProblem(prob::JumpProblem) = prob

function JumpProblem(prob, jumps::ConstantRateJump; kwargs...)
    JumpProblem(prob, JumpSet(jumps); kwargs...)
end
function JumpProblem(prob, jumps::VariableRateJump; kwargs...)
    JumpProblem(prob, JumpSet(jumps); kwargs...)
end
function JumpProblem(prob, jumps::RegularJump; kwargs...)
    JumpProblem(prob, JumpSet(jumps); kwargs...)
end
function JumpProblem(prob, jumps::MassActionJump; kwargs...)
    JumpProblem(prob, JumpSet(jumps); kwargs...)
end
function JumpProblem(prob, jumps::AbstractJump...; kwargs...)
    JumpProblem(prob, JumpSet(jumps...); kwargs...)
end

function JumpProblem(prob, aggregator::AbstractAggregatorAlgorithm,
        jumps::ConstantRateJump; kwargs...)
    JumpProblem(prob, aggregator, JumpSet(jumps); kwargs...)
end
function JumpProblem(prob, aggregator::AbstractAggregatorAlgorithm,
        jumps::VariableRateJump; kwargs...)
    JumpProblem(prob, aggregator, JumpSet(jumps); kwargs...)
end
function JumpProblem(prob, aggregator::AbstractAggregatorAlgorithm, jumps::RegularJump;
        kwargs...)
    JumpProblem(prob, aggregator, JumpSet(jumps); kwargs...)
end
function JumpProblem(prob, aggregator::AbstractAggregatorAlgorithm,
        jumps::AbstractMassActionJump; kwargs...)
    JumpProblem(prob, aggregator, JumpSet(jumps); kwargs...)
end
function JumpProblem(prob, aggregator::AbstractAggregatorAlgorithm, jumps::AbstractJump...;
        kwargs...)
    JumpProblem(prob, aggregator, JumpSet(jumps...); kwargs...)
end
function JumpProblem(prob, jumps::JumpSet; vartojumps_map = nothing,
        jumptovars_map = nothing, dep_graph = nothing,
        spatial_system = nothing, hopping_constants = nothing, kwargs...)
    ps = (; vartojumps_map, jumptovars_map, dep_graph, spatial_system, hopping_constants)
    aggtype = select_aggregator(jumps; ps...)
    return JumpProblem(prob, aggtype(), jumps; ps..., kwargs...)
end

# this makes it easier to test the aggregator selection
function JumpProblem(prob, aggregator::NullAggregator, jumps::JumpSet; kwargs...)
    JumpProblem(prob, jumps; kwargs...)
end

make_kwarg(; kwargs...) = kwargs

function JumpProblem(prob, aggregator::AbstractAggregatorAlgorithm, jumps::JumpSet;
        vr_aggregator::VariableRateAggregator = VR_FRM(),
        save_positions = prob isa DiffEqBase.AbstractDiscreteProblem ?
                         (false, true) : (true, true),
        rng = DEFAULT_RNG, scale_rates = true, useiszero = true,
        spatial_system = nothing, hopping_constants = nothing,
        callback = nothing, tstops = nothing, use_vrj_bounds = true, kwargs...)

    # initialize the MassActionJump rate constants with the user parameters
    if using_params(jumps.massaction_jump)
        rates = jumps.massaction_jump.param_mapper(prob.p)
        maj = MassActionJump(rates, jumps.massaction_jump.reactant_stoch,
            jumps.massaction_jump.net_stoch,
            jumps.massaction_jump.param_mapper; scale_rates = scale_rates,
            useiszero = useiszero,
            nocopy = true)
    else
        maj = jumps.massaction_jump
    end

    ## Spatial jumps handling
    if spatial_system !== nothing && hopping_constants !== nothing
        (num_crjs(jumps) == num_vrjs(jumps) == 0) ||
            error("Spatial aggregators only support MassActionJumps currently.")

        if is_spatial(aggregator)
            kwargs = merge((; hopping_constants, spatial_system), kwargs)
        else
            prob, maj = flatten(maj, prob, spatial_system, hopping_constants; kwargs...)
        end
    end

    ndiscjumps = get_num_majumps(maj) + num_crjs(jumps)
    crjs = jumps.constant_jumps

    # separate bounded variable rate jumps *if* the aggregator can use them
    if use_vrj_bounds && supports_variablerates(aggregator) && (num_bndvrjs(jumps) > 0)
        bvrjs = filter(isbounded, jumps.variable_jumps)
        cvrjs = filter(!isbounded, jumps.variable_jumps)
        kwargs = merge((; variable_jumps = bvrjs), kwargs)
        ndiscjumps += length(bvrjs)
    else
        bvrjs = nothing
        cvrjs = jumps.variable_jumps
    end

    t, end_time, u = prob.tspan[1], prob.tspan[2], prob.u0

    # handle majs, crjs, and bounded vrjs
    if (ndiscjumps == 0) && !is_spatial(aggregator)
        disc_agg = nothing
        constant_jump_callback = CallbackSet()
    else
        disc_agg = aggregate(aggregator, u, prob.p, t, end_time, crjs, maj,
            save_positions, rng; kwargs...)
        constant_jump_callback = DiscreteCallback(disc_agg)
    end

    # handle any remaining vrjs
    if length(cvrjs) > 0
        # Handle variable rate jumps based on vr_aggregator
        new_prob, variable_jump_callback = configure_jump_problem(prob, vr_aggregator, 
            jumps, cvrjs; rng)
    else
        new_prob = prob
        variable_jump_callback = CallbackSet()
        cvrjs = JumpSet().variable_jumps
    end

    jump_cbs = CallbackSet(constant_jump_callback, variable_jump_callback)
    iip = isinplace_jump(prob, jumps.regular_jump)
    solkwargs = tstops === nothing ? make_kwarg(; callback) : make_kwarg(; callback, tstops)

    JumpProblem{iip, typeof(new_prob), typeof(aggregator), typeof(jump_cbs),
        typeof(disc_agg), typeof(crjs), typeof(cvrjs), typeof(jumps.regular_jump),
        typeof(maj), typeof(rng), typeof(solkwargs)}(new_prob, aggregator, disc_agg,
        jump_cbs, crjs, cvrjs, jumps.regular_jump, maj, rng, solkwargs)
end

# Special dispatch for PureLeaping aggregator - bypasses all aggregation
function JumpProblem(prob, aggregator::PureLeaping, jumps::JumpSet;
        save_positions = prob isa DiffEqBase.AbstractDiscreteProblem ?
                         (false, true) : (true, true),
        rng = DEFAULT_RNG, scale_rates = true, useiszero = true,
        spatial_system = nothing, hopping_constants = nothing,
        callback = nothing, tstops = nothing, kwargs...)

    # Validate no spatial systems (not currently supported)
    (spatial_system !== nothing || hopping_constants !== nothing) &&
        error("PureLeaping does not currently support spatial problems.")

    # Initialize the MassActionJump rate constants with the user parameters
    if using_params(jumps.massaction_jump)
        rates = jumps.massaction_jump.param_mapper(prob.p)
        maj = MassActionJump(rates, jumps.massaction_jump.reactant_stoch,
            jumps.massaction_jump.net_stoch,
            jumps.massaction_jump.param_mapper; scale_rates = scale_rates,
            useiszero = useiszero,
            nocopy = true)
    else
        maj = jumps.massaction_jump
    end

    # For PureLeaping, all jumps are handled by the tau-leaping solver
    # No discrete jump aggregation or variable rate callbacks are created
    disc_agg = nothing
    jump_cbs = CallbackSet()
    
    # Store all jump types for access by tau-leaping solver
    crjs = jumps.constant_jumps
    vrjs = jumps.variable_jumps
    
    iip = isinplace_jump(prob, jumps.regular_jump)
    solkwargs = tstops === nothing ? make_kwarg(; callback) : make_kwarg(; callback, tstops)

    JumpProblem{iip, typeof(prob), typeof(aggregator), typeof(jump_cbs),
        typeof(disc_agg), typeof(crjs), typeof(vrjs), typeof(jumps.regular_jump),
        typeof(maj), typeof(rng), typeof(solkwargs)}(prob, aggregator, disc_agg,
        jump_cbs, crjs, vrjs, jumps.regular_jump, maj, rng, solkwargs)
end

aggregator(jp::JumpProblem{iip, P, A}) where {iip, P, A} = A

@inline function extend_tstops!(tstops, jp::JumpProblem) 
    !(jp.jump_callback.discrete_callbacks isa Tuple{}) &&
        push!(tstops, jp.jump_callback.discrete_callbacks[1].condition.next_jump_time)
end

### Displays
num_constant_rate_jumps(aggregator::AbstractSSAJumpAggregator) = length(aggregator.rates)

function Base.summary(io::IO, prob::JumpProblem)
    type_color, no_color = SciMLBase.get_colorizers(io)
    print(io,
        type_color, nameof(typeof(prob)),
        no_color, " with problem ",
        type_color, nameof(typeof(prob.prob)),
        no_color, " with aggregator ",
        type_color, typeof(prob.aggregator))
end
function Base.show(io::IO, mime::MIME"text/plain", A::JumpProblem)
    summary(io, A)
    println(io)
    println(io, "Number of jumps with discrete aggregation: ",
        A.discrete_jump_aggregation === nothing ? 0 :
        num_constant_rate_jumps(A.discrete_jump_aggregation))
    println(io, "Number of jumps with continuous aggregation: ", length(A.variable_jumps))
    nmajs = (A.massaction_jump !== nothing) ? get_num_majumps(A.massaction_jump) : 0
    println(io, "Number of mass action jumps: ", nmajs)
    if A.regular_jump !== nothing
        println(io, "Have a regular jump")
    end
end

using JumpProcesses, OrdinaryDiffEq, Statistics
using Test
using StableRNGs
rng = StableRNG(12345)

function reset_history!(h; start_time = nothing)
    @inbounds for i in 1:length(h)
        h[i] = eltype(h)[]
    end
    nothing
end

function empirical_rate(sol)
    return (sol(sol.t[end]) - sol(sol.t[1])) / (sol.t[end] - sol.t[1])
end

function hawkes_rate(i::Int, g, h)
    function rate(u, p, t)
        λ, α, β = p
        x = zero(typeof(t))
        for j in g[i]
            for _t in reverse(h[j])
                λij = α * exp(-β * (t - _t))
                if λij ≈ 0
                    break
                end
                x += λij
            end
        end
        return λ + x
    end
    return rate
end

function hawkes_jump(i::Int, g, h; uselrate = true)
    rate = hawkes_rate(i, g, h)
    urate = rate
    if uselrate
        lrate(u, p, t) = p[1]
        rateinterval = (
            u, p, t) -> begin
            _lrate = lrate(u, p, t)
            _urate = urate(u, p, t)
            return _urate == _lrate ? typemax(t) : 1 / (2 * _urate)
        end
    else
        lrate = nothing
        rateinterval = (u, p, t) -> begin
            _urate = urate(u, p, t)
            return 1 / (2 * _urate)
        end
    end
    function affect!(integrator)
        push!(h[i], integrator.t)
        integrator.u[i] += 1
    end
    return VariableRateJump(rate, affect!; lrate, urate, rateinterval)
end

function hawkes_jump(u, g, h; uselrate = true)
    return [hawkes_jump(i, g, h; uselrate) for i in 1:length(u)]
end

function hawkes_problem(p, agg::Coevolve; u = [0.0], tspan = (0.0, 50.0),
        save_positions = (false, true), g = [[1]], h = [[]], uselrate = true, kwargs...)
    dprob = DiscreteProblem(u, tspan, p)
    jumps = hawkes_jump(u, g, h; uselrate)
    jprob = JumpProblem(dprob, agg, jumps...; dep_graph = g, save_positions, rng)
    return jprob
end

function f!(du, u, p, t)
    du .= 0
    nothing
end

function hawkes_problem(p, agg; u = [0.0], tspan = (0.0, 50.0),
        save_positions = (false, true), g = [[1]], h = [[]], vr_aggregator = VR_FRM(), kwargs...)
    oprob = ODEProblem(f!, u, tspan, p)
    jumps = hawkes_jump(u, g, h)
    jprob = JumpProblem(oprob, agg, jumps...; vr_aggregator, save_positions, rng)
    return jprob
end

function expected_stats_hawkes_problem(p, tspan)
    T = tspan[end] - tspan[1]
    λ, α, β = p
    γ = β - α
    κ = β / γ
    Eλ = λ * κ
    # Equation 21
    # J. Da Fonseca and R. Zaatour,
    # “Hawkes Process: Fast Calibration, Application to Trade Clustering and Diffusive Limit.”
    # Rochester, NY, Aug. 04, 2013. doi: 10.2139/ssrn.2294112.
    Varλ = (Eλ * (T * κ^2 + (1 - κ^2) * (1 - exp(-T * γ)) / γ)) / (T^2)
    return Eλ, Varλ
end

u0 = [0.0]
p = (0.5, 0.5, 2.0)
tspan = (0.0, 200.0)
g = [[1]]
h = [Float64[]]

Eλ, Varλ = expected_stats_hawkes_problem(p, tspan)

algs = (Direct(), Coevolve(), Coevolve())
uselrate = zeros(Bool, length(algs))
uselrate[3] = true
Nsims = 250

for (i, alg) in enumerate(algs)
    jump_prob = hawkes_problem(p, alg; u = u0, tspan, g, h, uselrate = uselrate[i])
    if alg isa Coevolve
        stepper = SSAStepper()
    else
        stepper = Tsit5()
    end
    sols = Vector{ODESolution}(undef, Nsims)
    for n in 1:Nsims
        reset_history!(h)
        sols[n] = solve(jump_prob, stepper)
    end

    if alg isa Coevolve
        λs = permutedims(mapreduce((sol) -> empirical_rate(sol), hcat, sols))
    else
        cols = length(u0)
        λs = permutedims(mapreduce((sol) -> empirical_rate(sol), hcat, sols))[:, 1:cols]
    end
    @test isapprox(mean(λs), Eλ; atol = 0.01)
    @test isapprox(var(λs), Varλ; atol = 0.001)
end

# test stepping Coevolve with continuous integrator and bounded jumps
let alg = Coevolve()
    for vr_aggregator in (VR_FRM(), VR_Direct(), VR_DirectFW())
        oprob = ODEProblem(f!, u0, tspan, p)
        jumps = hawkes_jump(u0, g, h)
        jprob = JumpProblem(oprob, alg, jumps...; vr_aggregator, dep_graph = g, rng)
        @test ((jprob.variable_jumps === nothing) || isempty(jprob.variable_jumps))
        sols = Vector{ODESolution}(undef, Nsims)
        for n in 1:Nsims
            reset_history!(h)
            sols[n] = solve(jprob, Tsit5())
        end
        λs = permutedims(mapreduce((sol) -> empirical_rate(sol), hcat, sols))
        @test isapprox(mean(λs), Eλ; atol = 0.01)
        @test isapprox(var(λs), Varλ; atol = 0.001)
    end
end

# test disabling bounded jumps and using continuous integrator
Nsims = 500
let alg = Coevolve()
    for vr_aggregator in (VR_FRM(), VR_Direct(), VR_DirectFW())
        oprob = ODEProblem(f!, u0, tspan, p)
        jumps = hawkes_jump(u0, g, h)
        jprob = JumpProblem(oprob, alg, jumps...; vr_aggregator, dep_graph = g, rng, use_vrj_bounds = false)
        @test length(jprob.variable_jumps) == 1
        sols = Vector{ODESolution}(undef, Nsims)
        for n in 1:Nsims
            reset_history!(h)
            sols[n] = solve(jprob, Tsit5())
        end

        cols = length(u0)
        if vr_aggregator isa VR_FRM
            λs = permutedims(mapreduce((sol) -> empirical_rate(sol), hcat, sols))[:, 1:cols]
        else
            λs = permutedims(mapreduce((sol) -> empirical_rate(sol), hcat, sols))
        end
        @test isapprox(mean(λs), Eλ; atol = 0.01)
        @test isapprox(var(λs), Varλ; atol = 0.001)
    end
end

using JumpProcesses, Graphs, Test, Random, StableRNGs
const JP = JumpProcesses

# Functions to test
# HopRates(hop_constants, spatial_system)
# update_hop_rates!(hop_rates::AbstractHopRates, species::AbstractArray, u, site, spatial_system)
# total_site_hop_rate(hop_rates::AbstractHopRates, site)
# reset!(hop_rates::AbstractHopRates)
# sample_hop_at_site(hop_rates::AbstractHopRates, site, rng, spatial_system)

function test_reset(hop_rates, num_nodes)
    JP.reset!(hop_rates)
    for site in 1:num_nodes
        @test JP.total_site_hop_rate(hop_rates, site) == 0.0
    end
end

function normalized(distribution::Dict)
    d = copy(distribution)
    s = sum(values(d))
    for key in keys(d)
        d[key] /= s
    end
    return d
end

normalized(distribution) = distribution / sum(distribution)

function statistical_test(hop_rates, spec_propensities, target_propensities::Dict,
        num_species, u, site, g, rng, rel_tol)
    spec_probs = normalized(spec_propensities)
    target_probs = normalized(target_propensities)
    JP.update_hop_rates!(hop_rates, 1:num_species, u, site, g)
    @test JP.total_site_hop_rate(hop_rates, site) == sum(spec_propensities)
    spec_dict = Dict{Int, Int}()
    site_dict = Dict{Int, Int}()
    for _ in 1:num_samples
        spec, target = JP.sample_hop_at_site(hop_rates, site, rng, g)
        spec_dict[spec] = get(spec_dict, spec, 0) + 1
        site_dict[target] = get(site_dict, target, 0) + 1
    end
    for species in 1:num_species
        @test abs(spec_dict[species]) / num_samples - spec_probs[species] < rel_tol
    end
    for target in JP.neighbors(g, site)
        @test abs(site_dict[target]) / num_samples - target_probs[target] < rel_tol
    end
end

io = IOBuffer()
rng = StableRNG(12345)
rel_tol = 0.05
num_samples = 10^4
dims = (3, 2)
g = CartesianGridRej(dims)
num_nodes = JP.num_sites(g)
num_species = 2
u = ones(Int, num_species, num_nodes)

# Tests for HopRatesGraphDs
hop_constants = [1.0, 3.0] # species
hop_rates = JP.HopRates(hop_constants, g)
@test hop_rates isa JP.HopRatesGraphDs
show(io, "text/plain", hop_rates)
for site in 1:num_nodes
    spec_propensities = hop_constants * JP.outdegree(g, site)
    target_propensities = Dict{Int, Float64}()
    for (i, target) in enumerate(JP.neighbors(g, site))
        target_propensities[target] = 1.0
    end
    statistical_test(hop_rates, spec_propensities, target_propensities, num_species, u,
        site, g, rng, rel_tol)
end
test_reset(hop_rates, num_nodes)

# Tests for HopRatesGraphDsi
hop_constants = [2.0 1.0 1.0 1.0 1.0 1.0; 6.0 3.0 3.0 3.0 3.0 3.0] # [species, site]
hop_rates = JP.HopRates(hop_constants, g)
@test hop_rates isa JP.HopRatesGraphDsi
show(io, "text/plain", hop_rates)
for site in 1:num_nodes
    spec_propensities = hop_constants[:, site] * JP.outdegree(g, site)
    target_propensities = Dict{Int, Float64}()
    for (i, target) in enumerate(JP.neighbors(g, site))
        target_propensities[target] = 1.0
    end
    statistical_test(hop_rates, spec_propensities, target_propensities, num_species, u,
        site, g, rng, rel_tol)
end
test_reset(hop_rates, num_nodes)

# Tests for HopRatesGraphDsij
hop_constants = Matrix{Vector{Float64}}(undef, num_species, num_nodes) # [species, site][target_site]
hop_constants[1, :] = [
    [2.0, 4.0],
    [1.0, 2.0, 4.0],
    [1.0, 2.0],
    [1.0, 2.0],
    [1.0, 2.0, 4.0],
    [1.0, 2.0]
]
hop_constants[2, :] = [
    [3.0, 12.0],
    [3.0, 6.0, 12.0],
    [3.0, 6.0],
    [3.0, 6.0],
    [3.0, 6.0, 12.0],
    [3.0, 6.0]
]
hop_rates_structs = [
    JP.HopRatesGraphDsij(hop_constants),
    JP.HopRates(hop_constants, g)
]
@test hop_rates_structs[2] isa JP.HopRatesGridDsij
for hop_rates in hop_rates_structs
    show(io, "text/plain", hop_rates)
    for site in 1:num_nodes
        spec_propensities = [sum(hop_constants[species, site]) for species in 1:num_species]
        target_propensities = Dict{Int, Float64}()
        for (i, target) in enumerate(JP.neighbors(g, site))
            target_propensities[target] = sum([hop_constants[species, site][i]
                                               for species in 1:num_species])
        end
        statistical_test(hop_rates, spec_propensities, target_propensities, num_species, u, site, g, rng, rel_tol)
    end
end
test_reset(hop_rates, num_nodes)

# Tests for HopRatesGraphDsLij
species_hop_constants = [1.0, 3.0] #species
site_hop_constants = [
    [2.0, 4.0],
    [1.0, 2.0, 4.0],
    [1.0, 2.0],
    [1.0, 2.0],
    [1.0, 2.0, 4.0],
    [1.0, 2.0]
] #[site][target_site]
hop_rates_structs = [
    JP.HopRatesGraphDsLij(species_hop_constants, site_hop_constants),
    JP.HopRates((species_hop_constants => site_hop_constants), g)
]
@test hop_rates_structs[2] isa JP.HopRatesGridDsLij
for hop_rates in hop_rates_structs
    show(io, "text/plain", hop_rates)
    for site in 1:num_nodes
        spec_propensities = [species_hop_constants[species] * sum(site_hop_constants[site])
                             for species in 1:num_species]
        target_propensities = Dict{Int, Float64}()
        for (i, target) in enumerate(JP.neighbors(g, site))
            target_propensities[target] = sum([species_hop_constants[species] *
                                               site_hop_constants[site][i]
                                               for species in 1:num_species])
        end
        statistical_test(hop_rates, spec_propensities, target_propensities, num_species, u, site, g, rng, rel_tol)
    end
end
test_reset(hop_rates, num_nodes)

# Tests for HopRatesGraphDsiLij
species_hop_constants = [2.0 1.0 1.0 1.0 1.0 1.0; 6.0 3.0 3.0 3.0 3.0 3.0] #[species, site]
site_hop_constants = [
    [2.0, 4.0],
    [1.0, 2.0, 4.0],
    [1.0, 2.0],
    [1.0, 2.0],
    [1.0, 2.0, 4.0],
    [1.0, 2.0]
] #[site][target_site]
hop_rates_structs = [
    JP.HopRatesGraphDsiLij(species_hop_constants, site_hop_constants),
    JP.HopRates((species_hop_constants => site_hop_constants), g)
]
@test hop_rates_structs[2] isa JP.HopRatesGridDsiLij
for hop_rates in hop_rates_structs
    show(io, "text/plain", hop_rates)
    for site in 1:num_nodes
        spec_propensities = [species_hop_constants[species, site] * sum(site_hop_constants[site]) for species in 1:num_species]
        target_propensities = Dict{Int, Float64}()
        for (i, target) in enumerate(JP.neighbors(g, site))
            target_propensities[target] = sum([species_hop_constants[species, site] *
                                               site_hop_constants[site][i]
                                               for species in 1:num_species])
        end
        statistical_test(hop_rates, spec_propensities, target_propensities, num_species, u, site, g, rng, rel_tol)
    end
end
test_reset(hop_rates, num_nodes)

@test String(take!(io)) !== nothing

"""
    reset_aggregated_jumps!(integrator, uprev = nothing; update_jump_params=true)

Reset the state of jump processes and associated solvers following a change
in parameters or such.

Notes

  - `update_jump_params=true` will recalculate the rates stored within any
    MassActionJump that was built from the parameter vector. If the parameter
    vector is unchanged, this can safely be set to false to improve performance.
"""
function reset_aggregated_jumps!(integrator, uprev = nothing; update_jump_params = true,
        kwargs...)
    reset_aggregated_jumps!(integrator, uprev, integrator.opts.callback,
        update_jump_params = update_jump_params, kwargs...)
    nothing
end

function reset_aggregated_jumps!(integrator, uprev, callback::Nothing;
        update_jump_params = true, kwargs...)
    nothing
end

function reset_aggregated_jumps!(integrator, uprev, callback::CallbackSet;
        update_jump_params = true, kwargs...)
    if !isempty(callback.discrete_callbacks)
        reset_aggregated_jumps!(integrator, uprev, callback.discrete_callbacks...,
            update_jump_params = update_jump_params, kwargs...)
    end
    nothing
end

function reset_aggregated_jumps!(integrator, uprev, cb::DiscreteCallback, cbs...;
        update_jump_params = true, kwargs...)
    if cb.condition isa AbstractSSAJumpAggregator
        maj = cb.condition.ma_jumps
        update_jump_params && using_params(maj) &&
            update_parameters!(cb.condition.ma_jumps, integrator.p; kwargs...)
        cb.condition(cb, integrator.u, integrator.t, integrator)
    end
    reset_aggregated_jumps!(integrator, uprev, cbs...;
        update_jump_params = update_jump_params, kwargs...)
    nothing
end

function reset_aggregated_jumps!(integrator, uprev, cb::DiscreteCallback;
        update_jump_params = true, kwargs...)
    if cb.condition isa AbstractSSAJumpAggregator
        maj = cb.condition.ma_jumps
        update_jump_params && using_params(maj) &&
            update_parameters!(cb.condition.ma_jumps, integrator.p; kwargs...)
        cb.condition(cb, integrator.u, integrator.t, integrator)
    end
    nothing
end

"""
An aggregator interface for SSA-like algorithms.

### Required Fields

  - `next_jump`          # the next jump to execute
  - `prev_jump`          # the previous jump that was executed
  - `next_jump_time`     # the time of the next jump
  - `end_time`           # the time to stop a simulation
  - `cur_rates`          # vector of current propensity values
  - `sum_rate`           # sum of current propensity values
  - `ma_jumps`           # any MassActionJumps for the system (scalar form)
  - `rates`              # vector of rate functions for ConstantRateJumps
  - `affects!`           # vector of affect functions for ConstantRateJumps
  - `save_positions`     # tuple for whether to save the jumps before and/or after event
  - `rng`                # random number generator

### Optional fields:

  - `dep_gr`             # dependency graph, dep_gr[i] = indices of reactions that should be updated when rx i occurs.
"""
abstract type AbstractSSAJumpAggregator{T, S, F1, F2, RNG} <: AbstractJumpAggregator end

function DiscreteCallback(c::AbstractSSAJumpAggregator)
    DiscreteCallback(c, c, initialize = c, save_positions = c.save_positions)
end

########### The following routines are templates for all SSAs ###########
########### Generally they should not need to be overloaded.  ###########

## Users will normally define (see direct.jl for examples):
# aggregate
# initialize!
# execute_jumps!
# generate_jumps!

@inline function makewrapper(::Type{T}, aff) where {T}
    # rewrap existing wrappers
    if aff isa FunctionWrappers.FunctionWrapper
        T(aff.obj[])
    elseif aff isa Function
        T(aff)
    else
        error("Invalid type of affect function, $(typeof(aff)), expected a Function or FunctionWrapper.")
    end
end

@inline function concretize_affects!(p::AbstractSSAJumpAggregator,
        ::I) where {I <: SciMLBase.DEIntegrator}
    if (p.affects! isa Vector) &&
       !(p.affects! isa Vector{FunctionWrappers.FunctionWrapper{Nothing, Tuple{I}}})
        AffectWrapper = FunctionWrappers.FunctionWrapper{Nothing, Tuple{I}}
        p.affects! = AffectWrapper[makewrapper(AffectWrapper, aff) for aff in p.affects!]
    end
    nothing
end

@inline function concretize_affects!(p::AbstractSSAJumpAggregator{T, S, F1, F2},
        ::I) where {T, S, F1, F2 <: Tuple, I <: SciMLBase.DEIntegrator}
    nothing
end

# setting up a new simulation
function (p::AbstractSSAJumpAggregator)(dj, u, t, integrator) # initialize
    concretize_affects!(p, integrator)
    initialize!(p, integrator, u, integrator.p, t)
    register_next_jump_time!(integrator, p, integrator.t)
    u_modified!(integrator, false)
    nothing
end

# condition for jump to occur
@inline function (p::AbstractSSAJumpAggregator)(u, t, integrator)
    p.next_jump_time == t
end

# executing jump at the next jump time
function (p::AbstractSSAJumpAggregator)(integrator::I) where {I <: SciMLBase.DEIntegrator}
    affects! = p.affects!
    if affects! isa Vector{FunctionWrappers.FunctionWrapper{Nothing, Tuple{I}}}
        execute_jumps!(p, integrator, integrator.u, integrator.p, integrator.t, affects!)
    else
        error("Error, invalid affects! type. Expected a vector of function wrappers and got $(typeof(affects!))")
    end
    generate_jumps!(p, integrator, integrator.u, integrator.p, integrator.t)
    register_next_jump_time!(integrator, p, integrator.t)
    nothing
end

function (p::AbstractSSAJumpAggregator{
        T, S, F1, F2})(integrator::SciMLBase.DEIntegrator) where
        {T, S, F1, F2 <: Union{Tuple, Nothing}}
    execute_jumps!(p, integrator, integrator.u, integrator.p, integrator.t, p.affects!)
    generate_jumps!(p, integrator, integrator.u, integrator.p, integrator.t)
    register_next_jump_time!(integrator, p, integrator.t)
    nothing
end

############################## Generic Routines ###############################

"""
    register_next_jump_time!(integrator, p::AbstractSSAJumpAggregator, t)

Adds a `tstop` to the integrator at the next jump time.
"""
@inline function register_next_jump_time!(integrator, p::AbstractSSAJumpAggregator, t)
    if p.next_jump_time < p.end_time
        add_tstop!(integrator, p.next_jump_time)
    end
    nothing
end

"""
    build_jump_aggregation(jump_agg_type, u, p, t, end_time, ma_jumps, rates,
                           affects!, save_positions, rng; kwargs...)

Helper routine for setting up standard fields of SSA jump aggregations.
"""
function build_jump_aggregation(jump_agg_type, u, p, t, end_time, ma_jumps, rates,
        affects!, save_positions, rng; kwargs...)

    # mass action jumps
    majumps = ma_jumps
    if majumps === nothing
        majumps = MassActionJump(Vector{typeof(t)}(),
            Vector{Vector{Pair{Int, eltype(u)}}}(),
            Vector{Vector{Pair{Int, eltype(u)}}}())
    end

    # current jump rates, allows mass action rates and constant jumps
    cur_rates = Vector{typeof(t)}(undef, get_num_majumps(majumps) + length(rates))

    sum_rate = zero(typeof(t))
    next_jump = 0
    next_jump_time = typemax(typeof(t))
    jump_agg_type(next_jump, next_jump_time, end_time, cur_rates, sum_rate,
        majumps, rates, affects!, save_positions, rng; kwargs...)
end

"""
    fill_rates_and_sum!(p::AbstractSSAJumpAggregator, u, params, t)

Reevaluate all rates and their sum.
"""
function fill_rates_and_sum!(p::AbstractSSAJumpAggregator, u, params, t)
    sum_rate = zero(typeof(p.sum_rate))

    # mass action jumps
    majumps = p.ma_jumps
    cur_rates = p.cur_rates
    @inbounds for i in 1:get_num_majumps(majumps)
        cur_rates[i] = evalrxrate(u, i, majumps)
        sum_rate += cur_rates[i]
    end

    # constant rates
    rates = p.rates
    idx = get_num_majumps(majumps) + 1
    @inbounds for rate in rates
        cur_rates[idx] = rate(u, params, t)
        sum_rate += cur_rates[idx]
        idx += 1
    end

    p.sum_rate = sum_rate
    nothing
end

"""
    calculate_jump_rate(ma_jumps, rates, u, params, t, rx)

Recalculate the rate for the jump with index `rx`.
"""
@inline function calculate_jump_rate(ma_jumps, num_majumps, rates, u, params, t, rx)
    if rx <= num_majumps
        return evalrxrate(u, rx, ma_jumps)
    else
        @inbounds return rates[rx - num_majumps](u, params, t)
    end
end

"""
    update_dependent_rates!(p::AbstractSSAJumpAggregator, u, params, t)

Recalculate jump rates for jumps that depend on the just executed jump.

Notes:

  - Intended for methods that have a dependency graph, i.e. define `p.dep_gr`.
"""
function update_dependent_rates!(p::AbstractSSAJumpAggregator, u, params, t)
    @inbounds dep_rxs = p.dep_gr[p.next_jump]
    cur_rates = p.cur_rates
    sum_rate = p.sum_rate
    num_majumps = get_num_majumps(p.ma_jumps)
    @inbounds for rx in dep_rxs
        sum_rate -= cur_rates[rx]
        @inbounds cur_rates[rx] = calculate_jump_rate(p.ma_jumps, num_majumps, p.rates, u,
            params, t, rx)
        sum_rate += cur_rates[rx]
    end

    p.sum_rate = sum_rate
    nothing
end

"""
    update_state!(p::AbstractSSAJumpAggregator, integrator, u)

Execute `p.next_jump`.
"""
@inline function update_state!(p::AbstractSSAJumpAggregator, integrator, u, affects!)
    (; ma_jumps, next_jump) = p
    num_ma_rates = get_num_majumps(ma_jumps)
    if next_jump <= num_ma_rates # is next jump a mass action jump
        if u isa SVector
            integrator.u = executerx(u, next_jump, ma_jumps)
        else
            @inbounds executerx!(u, next_jump, ma_jumps)
        end
    else
        idx = next_jump - num_ma_rates
        @inbounds affects![idx](integrator)
    end

    # save jump that was just executed
    p.prev_jump = next_jump
    return integrator.u
end

@generated function update_state!(p::AbstractSSAJumpAggregator, integrator, u,
        affects!::T) where {T <: Tuple}
    quote
        (; ma_jumps, next_jump) = p
        num_ma_rates = get_num_majumps(ma_jumps)
        if next_jump <= num_ma_rates # is next jump a mass action jump
            if u isa SVector
                integrator.u = executerx(u, next_jump, ma_jumps)
            else
                @inbounds executerx!(u, next_jump, ma_jumps)
            end
        else
            idx = next_jump - num_ma_rates
            Base.Cartesian.@nif $(fieldcount(T)) i->(i == idx) i->(@inbounds affects![i](integrator)) i->(@inbounds affects![fieldcount(T)](integrator))
        end

        # save jump that was just executed
        p.prev_jump = next_jump
        return integrator.u
    end
end

"""
    nomorejumps!(p, sum_rate) :: Bool

Check if the total rate is zero, and if it is, make the next jump time Inf.
"""
@inline function nomorejumps!(p, sum_rate)::Bool
    if sum_rate < eps(typeof(sum_rate))
        p.next_jump = zero(p.next_jump)
        p.next_jump_time = convert(typeof(sum_rate), Inf)
        return true
    end
    return false
end

"""
    linear_search(iterator, r)

Perform linear search for `r` over iterator. Output index j s.t. sum(array[1:j-1])
< r <= sum(array[1:j]), where array=collect(iterator)

Notes:

  - The iterator must have all positive numbers
  - Returns index zero if the search is unsuccessful. Assumes this corresponds to
    the case of an infinite next reaction time and so the jump index does not
    matter.
"""
@inline function linear_search(iterator, r)
    jidx = 0
    idx = 1
    for element in iterator
        r -= element
        if r < zero(r)
            jidx = idx
            break
        end
        idx += 1
    end
    return jidx
end

"""
    rejectrx(ma_jumps, rates, cur_rate_high, cur_rate_low, rng, u, jidx, params, t)

Perform rejection sampling test (used in RSSA methods).
"""
@inline function rejectrx(
        ma_jumps, num_majumps, rates, cur_rate_high, cur_rate_low, rng, u,
        jidx, params, t)
    # rejection test
    @inbounds r2 = rand(rng) * cur_rate_high[jidx]
    @inbounds crlow = cur_rate_low[jidx]

    if crlow > zero(crlow) && r2 <= crlow
        return false
    else
        # calculate actual propensity, split up for type stability
        crate = calculate_jump_rate(ma_jumps, num_majumps, rates, u, params, t, jidx)
        if crate > zero(crate) && r2 <= crate
            return false
        end
    end
    return true
end

using Test, JumpProcesses, DiffEqBase, OrdinaryDiffEq, SciMLBase, LinearAlgebra, LinearSolve
using FastBroadcast
using StableRNGs

rng = StableRNG(123)

# Check that the new broadcast norm gives the same result as the old one
rand_array = ExtendedJumpArray{Float64, 1, Vector{Float64}, Vector{Float64}}(rand(rng, 5),
    rand(rng, 2))
old_norm = Base.FastMath.sqrt_fast(DiffEqBase.UNITLESS_ABS2(rand_array) /
                                   max(DiffEqBase.recursive_length(rand_array), 1))
new_norm = DiffEqBase.ODE_DEFAULT_NORM(rand_array, 0.0)
@test old_norm ≈ new_norm

# Check for an ExtendedJumpArray where the types differ (Float64/Int64)
rand_array = ExtendedJumpArray{Float64, 1, Vector{Float64}, Vector{Int64}}(rand(rng, 5),
    rand(rng, 1:1000,
        2))
old_norm = Base.FastMath.sqrt_fast(DiffEqBase.UNITLESS_ABS2(rand_array) /
                                   max(DiffEqBase.recursive_length(rand_array), 1))
new_norm = DiffEqBase.ODE_DEFAULT_NORM(rand_array, 0.0)
@test old_norm ≈ new_norm

# Check that we no longer allocate. Run inside function so @allocated works properly
norm_check_alloc(jump_array, t) = @allocated DiffEqBase.ODE_DEFAULT_NORM(jump_array, t)
norm_check_alloc(rand_array, 0.0);
@test 0 == norm_check_alloc(rand_array, 0.0)

## Broadcasting
bc_eja_1 = ExtendedJumpArray(rand(rng, 10), rand(rng, 2))
bc_eja_2 = ExtendedJumpArray(rand(rng, 10), rand(rng, 2))
bc_out = ExtendedJumpArray(zeros(10), zeros(2))

# Test that broadcasting gives the same output as non-broadcasted math
@test bc_eja_1 + bc_eja_2 ≈ bc_eja_1 .+ bc_eja_2
@test 3.14 * bc_eja_1 + 2.7 * bc_eja_2 ≈ 3.14 .* bc_eja_1 .+ 2.7 .* bc_eja_2

# Test that non-allocating (copyto!) gives the same result, both w/ and w/o the dot macro
bc_out .= 3.14 .* bc_eja_1 + 2.7 .* bc_eja_2
@test bc_out ≈ 3.14 * bc_eja_1 + 2.7 * bc_eja_2
@. bc_out = 3.14 * bc_eja_1 + 2.7 * bc_eja_2
@test bc_out ≈ 3.14 * bc_eja_1 + 2.7 * bc_eja_2

# Test that mismatched arrays cannot be broadcasted
bc_mismatch = ExtendedJumpArray(rand(rng, 8), rand(rng, 4))
@test_throws DimensionMismatch bc_mismatch+bc_eja_1
@test_throws DimensionMismatch bc_mismatch .+ bc_eja_1

# Test that datatype mixing persists through broadcasting
bc_dtype_1 = ExtendedJumpArray(rand(rng, 10), rand(rng, 1:10, 2))
bc_dtype_2 = ExtendedJumpArray(rand(rng, 10), rand(rng, 1:10, 2))
result = bc_dtype_1 + bc_dtype_2 * 2
@test eltype(result.jump_u) == Int64
out_result = ExtendedJumpArray(zeros(10), zeros(2))
out_result .= bc_dtype_1 .+ bc_dtype_2 .* 2
@test eltype(result.jump_u) == Int64
@test out_result ≈ result

# Test that fast broadcasting also gives the correct results
@.. bc_out = 3.14 * bc_eja_1 + 2.7 * bc_eja_2
@test bc_out ≈ 3.14 * bc_eja_1 + 2.7 * bc_eja_2

# Test both the in-place and allocating problems (https://github.com/SciML/JumpProcesses.jl/issues/321)
# to check that an ExtendedJumpArray is not getting downgraded into a Vector
oop_test_rate(u, p, t) = exp(t)
function oop_test_affect!(integrator)
    integrator.u[1] += 1
    nothing
end
oop_test_jump = VariableRateJump(oop_test_rate, oop_test_affect!)

# Test in-place
u₀ = [0.0]
inplace_prob = ODEProblem((du, u, p, t) -> (du .= 0), u₀, (0.0, 2.0), nothing)
jump_prob = JumpProblem(inplace_prob, Direct(), oop_test_jump; vr_aggregator = VR_FRM())
sol = solve(jump_prob, Tsit5())
@test sol.retcode == ReturnCode.Success
sol.u

# Test out-of-place
u₀ = [0.0]
oop_prob = ODEProblem((u, p, t) -> [0.0], u₀, (0.0, 2.0), nothing) # only difference is use of OOP ode function
jump_prob = JumpProblem(oop_prob, Direct(), oop_test_jump)
sol = solve(jump_prob, Tsit5())
@test sol.retcode == ReturnCode.Success

# Test saveat https://github.com/SciML/JumpProcesses.jl/issues/179 and https://github.com/SciML/JumpProcesses.jl/issues/322
let
    f(du, u, p, t) = (du[1] = u[1]; nothing)
    prob = ODEProblem(f, [0.2], (0.0, 10.0))
    rate(u, p, t) = u[1]
    affect!(integrator) = (integrator.u.u[1] = integrator.u.u[1] / 2; nothing)
    jump = VariableRateJump(rate, affect!)
    jump_prob = JumpProblem(prob, Direct(), jump; vr_aggregator = VR_FRM())
    sol = solve(jump_prob, Tsit5(); saveat = 0.5)
    times = range(0.0, 10.0; step = 0.5)
    @test issubset(times, sol.t)
end

# Test for u0 promotion https://github.com/SciML/JumpProcesses.jl/issues/275
let
    p = (λ = 2.0, μ = 1.5)

    deathrate(u, p, t) = p.μ * u[1]
    deathaffect!(integrator) = (integrator.u[1] -= 1; integrator.u[2] += 1)
    deathvrj = VariableRateJump(deathrate, deathaffect!)

    rate1(u, p, t) = p.λ * (sin(pi * t / 2) + 1)
    affect1!(integrator) = (integrator.u[1] += 1)
    vrj = VariableRateJump(rate1, affect1!)

    function f!(du, u, p, t)
        du .= 0
        nothing
    end
    u₀ = [0, 0]
    oprob = ODEProblem(f!, u₀, (0.0, 10.0), p)
    jprob = JumpProblem(oprob, Direct(), vrj, deathvrj; vr_aggregator = VR_FRM())
    sol = solve(jprob, Tsit5())
    @test eltype(sol.u) <: ExtendedJumpArray{Float64, 1, Vector{Float64}, Vector{Float64}}
    @test SciMLBase.plottable_indices(sol.u[1]) == 1:length(u₀)
end

# Regression for https://github.com/SciML/JumpProcesses.jl/issues/592:
# mul!(c::ExtendedJumpArray, A, u) must clear c.jump_u when A only addresses
# the c.u portion. Otherwise stale scratchpad values pollute the jump-rate
# integral state in adaptive SDE solvers.
let rng = StableRNG(592)
    c = ExtendedJumpArray(rand(rng, 3), [1.0, 2.0, -3.0])   # pre-populated jump_u
    A = rand(rng, 3, 4)                                      # noise-rate-prototype-sized
    u = rand(rng, 4)
    expected_u = A * u
    mul!(c, A, u)
    @test c.u ≈ expected_u
    @test all(iszero, c.jump_u)                              # jump_u zeroed
end

# Full-state matrix case still scatters into both halves.
let rng = StableRNG(593)
    c = ExtendedJumpArray(zeros(3), [9.0, 9.0, 9.0])
    A = rand(rng, 6, 4)
    u = rand(rng, 4)
    full = A * u
    mul!(c, A, u)
    @test c.u ≈ full[1:3]
    @test c.jump_u ≈ full[4:6]
end

# Test ldiv! and lmul! for stiff solver support
let rng = StableRNG(456)
    u = rand(rng, 3)
    jump_u = rand(rng, 2)
    flat = [u; jump_u]

    # ldiv! with LU should modify eja in place and match plain vector result
    eja = ExtendedJumpArray(copy(u), copy(jump_u))
    A = rand(rng, 5, 5) + 5I
    F = lu(A)
    expected = F \ flat
    ldiv!(F, eja)
    @test vcat(eja.u, eja.jump_u) ≈ expected

    # lmul! with Q from QR
    eja2 = ExtendedJumpArray(copy(u), copy(jump_u))
    Q = qr(rand(rng, 5, 5)).Q
    expected_q = Q * flat
    lmul!(Q, eja2)
    @test vcat(eja2.u, eja2.jump_u) ≈ expected_q

    # lmul! with AdjointQ from QR (the actual CI failure case)
    eja3 = ExtendedJumpArray(copy(u), copy(jump_u))
    expected_qt = Q' * flat
    lmul!(Q', eja3)
    @test vcat(eja3.u, eja3.jump_u) ≈ expected_qt
end

# Integration test: stiff solver with QRFactorization and ExtendedJumpArray
let
    f!(du, u, p, t) = (du .= 0; nothing)
    rate(u, p, t) = 0.5
    affect!(integrator) = (integrator.u[1] += 1; nothing)
    vrj = VariableRateJump(rate, affect!)
    oprob = ODEProblem(f!, [0.0], (0.0, 1.0))
    jprob = JumpProblem(oprob, Direct(), vrj; vr_aggregator = VR_FRM(),
        rng = StableRNG(789))
    sol = solve(jprob, Rodas5P(linsolve = QRFactorization()))
    @test sol.retcode == ReturnCode.Success
end

# calculates the mean from N stochastic A->B reactions at different rates
# this really tests different ways of constructing the jump problems
using DiffEqBase, JumpProcesses, Statistics
using Test
using StableRNGs
rng = StableRNG(12345)

# using BenchmarkTools
# dobenchmark = true

doprint = false
dotest = true
Nrxs = 16
Nsims = 8000
tf = 0.1
baserate = 0.1
A0 = 100
exactmean = (t, ratevec) -> A0 * exp(-sum(ratevec) * t)
SSAalgs = (JumpProcesses.JUMP_AGGREGATORS..., JumpProcesses.NullAggregator())
SSAs_to_exclude = (DirectFW(), FRM(), FRMFW())

vartojumps_map = [collect(1:Nrxs), []]
jumptovars_map = [[1, 2] for i in 1:Nrxs]
namedpars = (; vartojumps_map, jumptovars_map)
rates = ones(Float64, Nrxs) * baserate;
cumsum!(rates, rates)
exactmeanval = exactmean(tf, rates)

function runSSAs(jump_prob)
    Asamp = zeros(Int, Nsims)
    for i in 1:Nsims
        sol = solve(jump_prob, SSAStepper())
        Asamp[i] = sol[1, end]
    end
    mean(Asamp)
end

# uses constant jumps as a tuple within a JumpSet
function A_to_B_tuple(N, method)
    # jump reactions
    jumpvec = []
    for i in 1:N
        ratefunc = (u, p, t) -> rates[i] * u[1]
        affect! = function (integrator)
            integrator.u[1] -= 1
            integrator.u[2] += 1
        end
        push!(jumpvec, ConstantRateJump(ratefunc, affect!))
    end

    # convert jumpvec to tuple to send to JumpProblem...
    jumps = ((jump for jump in jumpvec)...,)
    jset = JumpSet((), jumps, nothing, nothing)
    prob = DiscreteProblem([A0, 0], (0.0, tf))
    jump_prob = JumpProblem(prob, method, jset; save_positions = (false, false), rng,
        namedpars...)

    jump_prob
end

# uses constant jumps as a vector within a JumpSet
function A_to_B_vec(N, method)
    # jump reactions
    jumps = Vector{ConstantRateJump}()
    for i in 1:N
        ratefunc = (u, p, t) -> rates[i] * u[1]
        affect! = function (integrator)
            integrator.u[1] -= 1
            integrator.u[2] += 1
        end
        push!(jumps, ConstantRateJump(ratefunc, affect!))
    end

    # convert jumpvec to tuple to send to JumpProblem...
    jset = JumpSet((), jumps, nothing, nothing)
    prob = DiscreteProblem([A0, 0], (0.0, tf))
    jump_prob = JumpProblem(prob, method, jset; save_positions = (false, false), rng,
        namedpars...)

    jump_prob
end

# uses a single mass action jump to represent all reactions
function A_to_B_ma(N, method)
    reactstoch = Vector{Vector{Pair{Int, Int}}}()
    netstoch = Vector{Vector{Pair{Int, Int}}}()
    for i in 1:N
        push!(reactstoch, [1 => 1])
        push!(netstoch, [1 => -1, 2 => 1])
    end

    majumps = MassActionJump(rates, reactstoch, netstoch)
    jset = JumpSet((), (), nothing, majumps)
    prob = DiscreteProblem([A0, 0], (0.0, tf))
    jump_prob = JumpProblem(prob, method, jset; save_positions = (false, false), rng,
        namedpars...)

    jump_prob
end

# uses one mass action jump to represent half the reactions and a vector
# of constant jumps for the other half. Stores them in a JumpSet
function A_to_B_hybrid(N, method)
    # half reactions are treated as mass action and half as constant jumps
    switchidx = (N // 2).num

    # mass action reactions
    reactstoch = Vector{Vector{Pair{Int, Int}}}()
    netstoch = Vector{Vector{Pair{Int, Int}}}()
    for i in 1:switchidx
        push!(reactstoch, [1 => 1])
        push!(netstoch, [1 => -1, 2 => 1])
    end

    # jump reactions
    jumps = Vector{ConstantRateJump}()
    for i in (switchidx + 1):N
        ratefunc = (u, p, t) -> rates[i] * u[1]
        affect! = function (integrator)
            integrator.u[1] -= 1
            integrator.u[2] += 1
        end
        push!(jumps, ConstantRateJump(ratefunc, affect!))
    end

    majumps = MassActionJump(rates[1:switchidx], reactstoch, netstoch)
    jset = JumpSet((), jumps, nothing, majumps)
    prob = DiscreteProblem([A0, 0], (0.0, tf))
    jump_prob = JumpProblem(prob, method, jset; save_positions = (false, false), rng,
        namedpars...)

    jump_prob
end

# uses a mass action jump to represent half the reactions and a vector
# of constant jumps for the other half. Passes them to JumpProblem as a splatted tuple
function A_to_B_hybrid_nojset(N, method)
    # half reactions are treated as mass action and half as constant jumps
    switchidx = (N // 2).num

    # mass action reactions
    reactstoch = Vector{Vector{Pair{Int, Int}}}()
    netstoch = Vector{Vector{Pair{Int, Int}}}()
    for i in 1:switchidx
        push!(reactstoch, [1 => 1])
        push!(netstoch, [1 => -1, 2 => 1])
    end

    # jump reactions
    jumpvec = Vector{ConstantRateJump}()
    for i in (switchidx + 1):N
        ratefunc = (u, p, t) -> rates[i] * u[1]
        affect! = function (integrator)
            integrator.u[1] -= 1
            integrator.u[2] += 1
        end
        push!(jumpvec, ConstantRateJump(ratefunc, affect!))
    end
    constjumps = (jump for jump in jumpvec)
    majumps = MassActionJump(rates[1:switchidx], reactstoch, netstoch)
    jumps = (constjumps..., majumps)
    prob = DiscreteProblem([A0, 0], (0.0, tf))
    jump_prob = JumpProblem(prob, method, jumps...; save_positions = (false, false),
        rng, namedpars...)

    jump_prob
end

# uses a vector of mass action jumps of vectors to represent half the reactions and a vector
# of constant jumps for the other half. Passes them to JumpProblem as a JumpSet
function A_to_B_hybrid_vecs(N, method)
    # half reactions are treated as mass action and half as constant jumps
    switchidx = (N // 2).num

    # mass action reactions
    majumps = Vector{MassActionJump}()
    for i in 1:switchidx
        push!(majumps, MassActionJump([rates[i]], [[1 => 1]], [[1 => -1, 2 => 1]]))
    end

    # jump reactions
    jumpvec = Vector{ConstantRateJump}()
    for i in (switchidx + 1):N
        ratefunc = (u, p, t) -> rates[i] * u[1]
        affect! = function (integrator)
            integrator.u[1] -= 1
            integrator.u[2] += 1
        end
        push!(jumpvec, ConstantRateJump(ratefunc, affect!))
    end
    jset = JumpSet((), jumpvec, nothing, majumps)
    prob = DiscreteProblem([A0, 0], (0.0, tf))
    jump_prob = JumpProblem(prob, method, jset; save_positions = (false, false), rng,
        namedpars...)

    jump_prob
end

# uses a vector of scalar mass action jumps to represent half the reactions and a vector
# of constant jumps for the other half. Passes them to JumpProblem as a JumpSet
function A_to_B_hybrid_vecs_scalars(N, method)
    # half reactions are treated as mass action and half as constant jumps
    switchidx = (N // 2).num

    # mass action reactions
    majumps = Vector{MassActionJump}()
    for i in 1:switchidx
        push!(majumps, MassActionJump(rates[i], [1 => 1], [1 => -1, 2 => 1]))
    end

    # jump reactions
    jumpvec = Vector{ConstantRateJump}()
    for i in (switchidx + 1):N
        ratefunc = (u, p, t) -> rates[i] * u[1]
        affect! = function (integrator)
            integrator.u[1] -= 1
            integrator.u[2] += 1
        end
        push!(jumpvec, ConstantRateJump(ratefunc, affect!))
    end
    jset = JumpSet((), jumpvec, nothing, majumps)
    prob = DiscreteProblem([A0, 0], (0.0, tf))
    jump_prob = JumpProblem(prob, method, jset; save_positions = (false, false), rng,
        namedpars...)

    jump_prob
end

# uses a vector of scalar mass action jumps to represent half the reactions and a vector
# of constant jumps for the other half. Passes them to JumpProblem as a single splatted tuple.
function A_to_B_hybrid_tups_scalars(N, method)
    # half reactions are treated as mass action and half as constant jumps
    switchidx = (N // 2).num

    # mass action reactions
    majumpsv = Vector{MassActionJump}()
    for i in 1:switchidx
        push!(majumpsv, MassActionJump(rates[i], [1 => 1], [1 => -1, 2 => 1]))
    end

    # jump reactions
    jumpvec = Vector{ConstantRateJump}()
    for i in (switchidx + 1):N
        ratefunc = (u, p, t) -> rates[i] * u[1]
        affect! = function (integrator)
            integrator.u[1] -= 1
            integrator.u[2] += 1
        end
        push!(jumpvec, ConstantRateJump(ratefunc, affect!))
    end

    jumps = ((maj for maj in majumpsv)..., (jump for jump in jumpvec)...)
    prob = DiscreteProblem([A0, 0], (0.0, tf))
    jump_prob = JumpProblem(prob, method, jumps...; save_positions = (false, false),
        rng, namedpars...)

    jump_prob
end

# uses a mass action jump to represent half the reactions and a tuple
# of constant jumps for the other half. Passes them to JumpProblem as a JumpSet.
function A_to_B_hybrid_tups(N, method)
    # half reactions are treated as mass action and half as constant jumps
    switchidx = (N // 2).num

    # mass action reactions
    majumps = Vector{MassActionJump}()
    for i in 1:switchidx
        push!(majumps, MassActionJump([rates[i]], [[1 => 1]], [[1 => -1, 2 => 1]]))
    end

    # jump reactions
    jumpvec = Vector{ConstantRateJump}()
    for i in (switchidx + 1):N
        ratefunc = (u, p, t) -> rates[i] * u[1]
        affect! = function (integrator)
            integrator.u[1] -= 1
            integrator.u[2] += 1
        end
        push!(jumpvec, ConstantRateJump(ratefunc, affect!))
    end
    jumps = ((jump for jump in jumpvec)...,)
    jset = JumpSet((), jumps, nothing, majumps)
    prob = DiscreteProblem([A0, 0], (0.0, tf))
    jump_prob = JumpProblem(prob, method, jset; save_positions = (false, false), rng,
        namedpars...)

    jump_prob
end

jump_prob_gens = [A_to_B_tuple, A_to_B_vec, A_to_B_ma, A_to_B_hybrid, A_to_B_hybrid_nojset,
    A_to_B_hybrid_vecs, A_to_B_hybrid_vecs_scalars, A_to_B_hybrid_tups,
    A_to_B_hybrid_tups_scalars]
#jump_prob_gens = [A_to_B_tuple, A_to_B_ma, A_to_B_hybrid, A_to_B_hybrid_vecs, A_to_B_hybrid_vecs_scalars,A_to_B_hybrid_tups_scalars]

for method in SSAalgs

    # skip methods that use regular dep graphs
    (needs_depgraph(method) || (method in SSAs_to_exclude)) && continue

    for jump_prob_gen in jump_prob_gens
        local jump_prob = jump_prob_gen(Nrxs, method)
        meanval = runSSAs(jump_prob)
        if doprint
            println("Method: ", method, ", Jump input types: ", jump_prob_gen,
                ", sample mean = ", meanval, ", actual mean = ", exactmeanval)
        end
        @test abs(meanval - exactmeanval) < 1.0
    end
end

# for dependency graph methods just test with mass action jumps
jump_prob_gens = [A_to_B_ma]
for method in SSAalgs
    # skip methods that don't use a normal dep graph
    (!needs_depgraph(method) || method in SSAs_to_exclude) && continue

    for jump_prob_gen in jump_prob_gens
        local jump_prob = jump_prob_gen(Nrxs, method)
        meanval = runSSAs(jump_prob)
        if doprint
            println("Method: ", method, ", Jump input types: ", jump_prob_gen,
                ", sample mean = ", meanval, ", actual mean = ", exactmeanval)
        end
        @test abs(meanval - exactmeanval) < 1.0
    end
end

using JumpProcesses, DiffEqBase, Graphs

"""
prob.u0 must be a Matrix with prob.u0[i,j] being the number of species i at site j
"""
function flatten(ma_jump, prob::DiscreteProblem, spatial_system, hopping_constants;
        kwargs...)
    tspan = prob.tspan
    u0 = prob.u0
    if ma_jump === nothing
        ma_jump = MassActionJump(Vector{typeof(tspan[1])}(),
            Vector{Vector{Pair{Int, eltype(u0)}}}(),
            Vector{Vector{Pair{Int, eltype(u0)}}}())
    end
    netstoch = ma_jump.net_stoch
    reactstoch = ma_jump.reactant_stoch
    rx_rates = if isa(ma_jump, MassActionJump)
        ma_jump.scaled_rates
    elseif isa(ma_jump, SpatialMassActionJump)
        num_nodes = num_sites(spatial_system)
        if isnothing(ma_jump.uniform_rates) && isnothing(ma_jump.spatial_rates)
            zeros(0, num_nodes)
        elseif isnothing(ma_jump.uniform_rates)
            ma_jump.spatial_rates
        elseif isnothing(ma_jump.spatial_rates)
            reshape(repeat(ma_jump.uniform_rates, num_nodes),
                length(ma_jump.uniform_rates), num_nodes)
        else
            @assert size(ma_jump.spatial_rates, 2) == num_nodes
            cat(dims = 1,
                reshape(repeat(ma_jump.uniform_rates, num_nodes),
                    length(ma_jump.uniform_rates), num_nodes),
                ma_jump.spatial_rates)
        end
    else
        error("flatten: unsupported jump type $(typeof(ma_jump))")
    end
    flatten(netstoch, reactstoch, rx_rates, spatial_system, u0, tspan, hopping_constants;
        scale_rates = false, kwargs...)
end

"""
if hopping_constants is a matrix, assume hopping_constants[i,j] is the hopping constant of species i from site j to any neighbor
"""
function flatten(netstoch::AbstractArray, reactstoch::AbstractArray,
        rx_rates::AbstractArray, spatial_system, u0::Matrix{Int}, tspan,
        hopping_constants::Matrix{F}; kwargs...) where {F <: Number}
    @assert size(hopping_constants) == size(u0)
    hop_constants = Matrix{Vector{F}}(undef, size(hopping_constants))
    for ci in CartesianIndices(hop_constants)
        (species, site) = Tuple(ci)
        hop_constants[ci] = hopping_constants[species, site] * ones(outdegree(spatial_system, site))
    end
    flatten(netstoch, reactstoch, rx_rates, spatial_system, u0, tspan, hop_constants;
        kwargs...)
end

"""
if reaction rates is a vector, assume reaction rates are equal across sites
"""
function flatten(netstoch::AbstractArray, reactstoch::AbstractArray, rx_rates::Vector,
        spatial_system, u0::Matrix{Int}, tspan,
        hopping_constants::Matrix{Vector{F}}; kwargs...) where {F <: Number}
    num_nodes = num_sites(spatial_system)
    rates = reshape(repeat(rx_rates, num_nodes), length(rx_rates), num_nodes)
    flatten(netstoch, reactstoch, rates, spatial_system, u0, tspan, hopping_constants;
        kwargs...)
end

"""
"flatten" the spatial jump problem. Return flattened DiscreteProblem and MassActionJump.
"""
function flatten(netstoch::Vector{R}, reactstoch::Vector{R}, rx_rates::Matrix{F},
        spatial_system, u0::Matrix{Int}, tspan,
        hopping_constants::Matrix{Vector{F}}; scale_rates = true,
        kwargs...) where {R, F <: Number}
    num_species = size(u0, 1)
    num_nodes = num_sites(spatial_system)
    num_rxs = length(reactstoch)
    @assert size(hopping_constants) == size(u0)
    @assert size(u0, 2) == size(rx_rates, 2) == num_nodes
    @assert length(netstoch) == length(reactstoch) == size(rx_rates, 1) == num_rxs
    spec_CI = CartesianIndices((num_species, num_nodes))
    spec_LI = LinearIndices((num_species, num_nodes))

    sum_outdegrees = sum(outdegree(spatial_system, site) for site in 1:num_nodes)
    num_jumps = num_species * sum_outdegrees + num_nodes * num_rxs
    total_netstoch = R[]
    sizehint!(total_netstoch, num_jumps)
    total_reactstoch = R[]
    sizehint!(total_reactstoch, num_jumps)
    total_rates = F[]
    sizehint!(total_rates, num_jumps)

    #hops
    # assuming hopping_constants isa Matrix{Vector} where hopping_constants[species, src][index] is the hop const of species from src to neighbor at index in neighbors(spatial_system, src)
    for src in 1:num_nodes
        for species in 1:num_species
            hopping_const = hopping_constants[species, src]
            for (i, dst) in enumerate(neighbors(spatial_system, src))
                dst_idx = spec_LI[spec_CI[species, dst]]
                src_idx = spec_LI[spec_CI[species, src]]
                push!(total_netstoch, [dst_idx => 1, src_idx => -1])
                push!(total_reactstoch, [src_idx => 1])
                push!(total_rates, hopping_const[i])
            end
        end
    end

    #reactions
    for site in 1:num_nodes
        for rx in 1:num_rxs
            nstoch = map(p -> Pair(spec_LI[spec_CI[p[1], site]], p[2]), netstoch[rx]) # transform into new indices
            rstoch = map(p -> Pair(spec_LI[spec_CI[p[1], site]], p[2]), reactstoch[rx])
            push!(total_netstoch, nstoch)
            push!(total_reactstoch, rstoch)
        end
    end
    append!(total_rates, vec(rx_rates)) # assuming rx_rates isa Matrix where rx_rates[rx, site] is the rate of rx at site

    # put everything together
    ma_jump = MassActionJump(total_rates, total_reactstoch, total_netstoch; nocopy = true,
        scale_rates = scale_rates)
    flattened_u0 = vec(u0)
    prob = DiscreteProblem(flattened_u0, tspan, total_rates)
    prob, ma_jump
end

using JumpProcesses, Test, Random, StableRNGs
const JP = JumpProcesses

# Functions to test:
# num_rxs
# reset!
# total_site_rx_rate
# update_rx_rates!
# sample_rx_at_site

# Dummy integrator to test update_rx_rates!
struct DummyIntegrator{U, P, T}
    u::U # state
    p::P # parameters
    t::T # time
end

io = IOBuffer()
# setup of A + B <--> C
rel_tol = 0.05
num_samples = 10^4
num_nodes = 27
num_species = 3
reactstoch = [[1 => 1, 2 => 1], [3 => 1]]
netstoch = [[1 => -1, 2 => -1, 3 => 1], [1 => 1, 2 => 1, 3 => -1]]
rates = [0.1, 1.0]
num_rxs = length(rates)
ma_jumps = MassActionJump(rates, reactstoch, netstoch)
spatial_ma_jumps = SpatialMassActionJump(rates, reactstoch, netstoch)
u = ones(Int, num_species, num_nodes)
integrator = DummyIntegrator(u, nothing, nothing)
rng = StableRNG(12345)

# Tests for RxRates
rx_rates_list = [JP.RxRates(num_nodes, ma_jumps), JP.RxRates(num_nodes, spatial_ma_jumps)]
for rx_rates in rx_rates_list
    @test JP.num_rxs(rx_rates) == length(rates)
    show(io, "text/plain", rx_rates)
    for site in 1:num_nodes
        JP.update_rx_rates!(rx_rates, 1:num_rxs, integrator, site)
        @test JP.total_site_rx_rate(rx_rates, site) == 1.1
        rx_props = [JP.evalrxrate(u[:, site], rx, ma_jumps) for rx in 1:num_rxs]
        rx_probs = rx_props / sum(rx_props)
        d = Dict{Int, Int}()
        for i in 1:num_samples
            rx = JP.sample_rx_at_site(rx_rates, site, rng)
            rx in keys(d) ? d[rx] += 1 : d[rx] = 1
        end
        for (k, v) in d
            @test abs(v / num_samples - rx_probs[k]) < rel_tol
        end
    end
    JP.reset!(rx_rates)
    for site in 1:num_nodes
        @test JP.total_site_rx_rate(rx_rates, site) == 0.0
    end
end

using JumpProcesses, DiffEqBase
using Test, LinearAlgebra
using StableRNGs
rng = StableRNG(12345)

Nsims = 1e4

# ABC model A + B <--> C
reactstoch = [
    [1 => 1, 2 => 1],
    [3 => 1]
]
netstoch = [
    [1 => -1, 2 => -1, 3 => 1],
    [1 => 1, 2 => 1, 3 => -1]
]
rates = [0.1, 1.0]
u0 = [500, 500, 0]
tspan = (0.0, 5.0)
prob = DiscreteProblem(u0, tspan, rates)
majumps = MassActionJump(rates, reactstoch, netstoch)

function getmean(jprob, Nsims)
    Amean = 0
    for i in 1:Nsims
        sol = solve(jprob, SSAStepper())
        Amean += sol[1, end]
    end
    Amean /= Nsims
    Amean
end

function mastereqmean(u, rates)
    α = u[1]
    β = u[2]
    γ = u[3]
    d₊ = [rates[1] * (a + 1) * (β - α + a + 1) for a in 0:(α - 1)]
    d₋ = [rates[2] * (γ + α - a + 1) for a in 1:α]
    d = [-rates[1] * a * (β - α + a) - rates[2] * (γ + α - a) for a in 0:α]
    L = diagm(-1 => d₋, 0 => d, 1 => d₊)
    P_a = nullspace(L)
    P_a ./= sum(P_a)
    P_a .= abs.(P_a)
    sum((a - 1) * p for (a, p) in enumerate(P_a))
end
mastereq_mean = mastereqmean(u0, rates)

algs = (JumpProcesses.JUMP_AGGREGATORS..., JumpProcesses.NullAggregator())
relative_tolerance = 0.01
for alg in algs
    local jprob = JumpProblem(prob, alg, majumps, save_positions = (false, false),
        rng = rng)
    local Amean = getmean(jprob, Nsims)
    @test abs(Amean - mastereq_mean) / mastereq_mean < relative_tolerance
end

"""
Dynamic table data structure to store and update priorities

Implementation
Stores ids that identify the priorities. Each group stores a range of priority ids.
The basic design assumes a lower-most group of "zero" priorities, and a second
group storing all non-zero priorities that are < a `minpriority`. All other groups
store priorities within consecutive ranges. The `minpriority` is taken fixed at creation,
but the `maxpriority` will increase dynamically based on inserted / updated priorities.
The ranges are assumed to be powers of two:
   bin 1 = {0},
   bin 2 = (0,`minpriority`),
   bin 3 = [`minpriority`,`2*minpriority`)...
in N = [`.5*maxpriority`,`maxpriority`)
*Assumes* the `priortogid` function that maps priorities to groups maps the upper end of
the interval to the next group. i.e. maxpriority -> N+1
"""

"""
One group (i.e. bin) of priority ids within the table
"""
mutable struct PriorityGroup{T, W <: AbstractVector}
    "(strict) upper bound for priorities in this group"
    maxpriority::T

    "number of priority ids"
    numpids::Int

    "priority ids associated with group"
    pids::W
end
PriorityGroup{U}(maxpriority::T) where {T, U} = PriorityGroup(maxpriority, 0, Vector{U}())

@inline function insert!(pg::PriorityGroup, pid)
    (; numpids, pids) = pg

    if numpids == length(pids)
        push!(pids, pid)
    else
        @inbounds pids[numpids + 1] = pid
    end

    # return the position of insertion
    pg.numpids += 1
end

@inline function remove!(pg::PriorityGroup, pididx)
    (; numpids, pids) = pg

    @inbounds lastpid = pids[numpids]

    # simply swap the last id with the one to remove
    @inbounds pids[pididx] = lastpid
    pg.numpids -= 1

    # return the pid that was swapped to pididx
    lastpid
end

@inline function ids(pg::PriorityGroup)
    pg.pids[1:(pg.numpids)]
end

function Base.show(io::IO, pg::PriorityGroup)
    println(io, "  ", summary(pg))
    println(io, "  maxpriority = ", pg.maxpriority)
    println(io, "  numpids = ", pg.numpids)
    println(io, "  pids = ", ids(pg))
end

"""
Table to store the groups.
"""
abstract type AbstractPriorityTable end

mutable struct PriorityTable{F, S, T, U <: Function} <: AbstractPriorityTable
    "non-zero values below this are binned together, static"
    minpriority::F

    "values above this cause new groups to be added"
    maxpriority::F

    "bins storing priority ids within a given range"
    groups::Vector{PriorityGroup{F, Vector{S}}}

    "stores the sums of the priorities within each group"
    gsums::Vector{F}

    "stores the sum of the group sums"
    gsum::F

    "maps priority id to group and idx within the group"
    pidtogroup::Vector{Tuple{T, T}}

    "mapping from priority value to group id that stores it"
    priortogid::U
end

"""
Setup table from a vector of priorities. The id
of a priority is its position within this vector.
"""
function PriorityTable(priortogid::Function, priorities::AbstractVector, minpriority,
        maxpriority)
    numgroups = priortogid(maxpriority)
    numgroups -= one(typeof(numgroups))
    pidtype = typeof(numgroups)
    ptype = eltype(priorities)
    groups = Vector{PriorityGroup{ptype, Vector{pidtype}}}()
    pidtogroup = Vector{Tuple{Int, Int}}(undef, length(priorities))
    gsum = zero(ptype)
    gsums = zeros(ptype, numgroups)

    # create the groups, {0}, (0,minpriority), [minpriority,2*minpriority)...
    push!(groups, PriorityGroup{pidtype}(zero(ptype)))
    gmaxprior = minpriority
    for i in 2:numgroups
        push!(groups, PriorityGroup{pidtype}(gmaxprior))
        gmaxprior *= 2
    end
    #@assert 2*maxpriority <= gmaxprior "gmaxprior = $gmaxprior, maxpriority=$maxpriority"
    gmaxprior = groups[end].maxpriority

    pt = PriorityTable(minpriority, gmaxprior, groups, gsums, gsum, pidtogroup, priortogid)

    # insert priority ids into the groups
    for (pid, priority) in enumerate(priorities)
        insert!(pt, pid, priority)
    end

    pt
end

########################## ACCESSORS ##########################
@inline function numgroups(pt::PriorityTable)
    length(pt.groups)
end

@inline function numpriorities(pt::PriorityTable)
    length(pt.pidtogroup)
end

@inline function groupsum(pt::PriorityTable)
    pt.gsum
end

"""
Adds extra groups to the table to accommodate a new maxpriority.
"""
function padtable!(pt::PriorityTable, pid, priority)
    (; maxpriority, groups, gsums) = pt
    pidtype = typeof(pid)

    while priority >= maxpriority
        maxpriority *= 2
        push!(groups, PriorityGroup{pidtype}(maxpriority))
        push!(gsums, zero(eltype(gsums)))
    end
    pt.maxpriority = maxpriority
    nothing
end

# assumes pid is at most 1 greater than last priority (id) currently in table
# i.e. pid = length(pidtogroup) + 1
function insert!(pt::PriorityTable, pid, priority)
    (; maxpriority, groups, gsums, pidtogroup, priortogid) = pt

    # find group for new priority
    gid = priortogid(priority)

    # add new (empty) groups if priority is too big
    if priority >= maxpriority
        padtable!(pt, pid, priority)
        #@assert (gid == length(groups))
    end

    # update table and priority's group
    pt.gsum += priority
    @inbounds gsums[gid] += priority
    @inbounds pididx = insert!(groups[gid], pid)

    if pid <= length(pidtogroup)
        @inbounds pidtogroup[pid] = (gid, pididx)
    else
        #@assert pid == length(pidtogroup) + 1
        push!(pidtogroup, (gid, pididx))
    end

    nothing
end

function update!(pt::PriorityTable, pid, oldpriority, newpriority)
    (; maxpriority, groups, gsums, pidtogroup, priortogid) = pt

    oldgid = priortogid(oldpriority)
    newgid = priortogid(newpriority)

    # expand the table if necessary
    if newpriority >= maxpriority
        padtable!(pt, pid, newpriority)
    end

    # update the global priority sum
    pdiff = newpriority - oldpriority
    pt.gsum += pdiff

    if oldgid == newgid
        # update the group priority too
        @inbounds gsums[newgid] += pdiff
    else
        @inbounds begin
            # location in oldgid of pid to move
            pididx = pidtogroup[pid][2]

            # remove pid from old group
            movedpid = remove!(groups[oldgid], pididx)

            # update position in group of the pid that swapped places with the removed one
            pidtogroup[movedpid] = (oldgid, pididx)

            # insert the updated pid back and store it's new position in the group
            pididx = insert!(groups[newgid], pid)
            pidtogroup[pid] = (newgid, pididx)

            # update sums, special case if group empty to avoid FP error in running sums
            grpsz = groups[oldgid].numpids
            gsums[oldgid] = (grpsz == zero(grpsz)) ? zero(oldpriority) :
                            gsums[oldgid] - oldpriority
            gsums[newgid] += newpriority
        end
    end
    nothing
end

function reset!(pt::PriorityTable{F, S, T, U}) where {F, S, T, U}
    (; groups, gsums, pidtogroup) = pt
    pt.gsum = zero(F)
    fill!(gsums, zero(F))
    fill!(pidtogroup, (zero(T), zero(T)))
    for group in groups
        group.numpids = zero(T)
    end
end

function Base.show(io::IO, pt::PriorityTable)
    println(io, summary(pt))
    println(io, "(minpriority,maxpriority) = ", (pt.minpriority, pt.maxpriority))
    println(io, "sum of priorities = ", pt.gsum)
    println(io, "num of groups = ", length(pt.groups))
    println(io, "pidtogroup = ", pt.pidtogroup)
    for (i, group) in enumerate(pt.groups)
        if group.numpids > 0
            println(io, "group = ", i, ", group sum = ", pt.gsums[i])
            Base.show(io, group)
        end
    end
end

#############################
### routines for DirectCR ###
#############################

# map priority (i.e. jump rate) to integer
# add two as 0. -> 1 and  priority < minpriority ==> pid -> 2
@inline function priortogid(priority, mingid)
    (priority <= eps(typeof(priority))) && return 1
    gid = exponent(priority) + 1
    (gid <= mingid) && return 2
    return gid - mingid + 2
end

@inline function sample(pg::PriorityGroup, priorities, rng = DEFAULT_RNG)
    (; maxpriority, numpids, pids) = pg

    pididx = 0
    pid = zero(eltype(pids))

    @inbounds while true

        # pick a random element
        r = rand(rng) * numpids
        pididx = trunc(Int, r)
        pid = pids[pididx + 1]

        # acceptance test
        ((r - pididx) * maxpriority < priorities[pid]) && break
    end

    pid
end

function sample(pt::PriorityTable, priorities, rng = DEFAULT_RNG)
    (; groups, gsum, gsums) = pt

    # return id zero if total priority is zero
    (gsum < eps(typeof(gsum))) && return zero(eltype(groups[1].pids))

    # sample a group, search from end (largest priorities)
    # NOTE, THIS ASSUMES THE FIRST PRIORITY IS ZERO!!!
    # gid = length(gsums)
    # @inbounds r = rand(rng) * gsum - gsums[gid]
    # while r > zero(r)
    #     gid -= one(gid)
    #     iszero(gid) && return gid   # if no result found return zero
    #     @inbounds r -= gsums[gid]
    # end
    gid = 0
    r = rand(rng) * gsum
    @inbounds for i in length(gsums):-1:1
        r -= gsums[i]
        if r <= zero(r)
            gid = i
            break
        end
    end
    iszero(gid) && return gid

    # sample element within the group
    @inbounds sample(groups[gid], priorities, rng)
end

##########################
### Routines for CCNRM ###
##########################

struct TimeGrouper{T <: Number}
    mintime::T
    binwidth::T
end

@inline function (t::TimeGrouper{T})(time::T) where {T}
    return floor(Int, (time - t.mintime) / t.binwidth) + 1
end

mutable struct PriorityTimeTable{T, F <: Int}
    groups::Vector{PriorityGroup{T, Vector{F}}}
    pidtogroup::Vector{Tuple{F, F}}
    times::Vector{T}
    timegrouper::TimeGrouper{T}
    minbin::F
    steps::F # TODO: For adaptive rebuilding. 
    maxtime::T
    binwidthconst::F
    numbinsconst::F
end

# Construct the time table with the default optimal bin width and number of bins. 
# DEFAULT NUMBINS: 20 * √length(times)
# DEFAULT BINWIDTH: 16 / sum(propensities)
function PriorityTimeTable(
        times::AbstractVector, mintime, timestep; binwidthconst = 16, numbinsconst = 20)
    binwidth = binwidthconst * timestep
    numbins = floor(Int64, numbinsconst * sqrt(length(times)))
    maxtime = mintime + numbins * binwidth

    pidtype = typeof(numbins)
    ptype = eltype(times)
    groups = Vector{PriorityGroup{ptype, Vector{pidtype}}}()
    pidtogroup = Vector{Tuple{Int, Int}}(undef, length(times))

    ttgdata = TimeGrouper{ptype}(mintime, binwidth)
    # Create the groups, [t_min, t_min + τ), [t_min + τ, t_min + 2τ)...
    for i in 1:numbins
        push!(groups, PriorityGroup{pidtype}(mintime + i * binwidth))
    end

    ptt = PriorityTimeTable(
        groups, pidtogroup, times, ttgdata, zero(pidtype),
        zero(pidtype), maxtime, binwidthconst, numbinsconst)
    # Insert priority ids into the groups
    for (pid, time) in enumerate(times)
        if time > maxtime
            pidtogroup[pid] = (0, 0)
            continue
        end
        insert!(ptt, pid, time)
    end

    ptt.minbin = findfirst(g -> g.numpids > (0), groups)
    ptt.minbin === nothing && (ptt.minbin = 0)
    ptt
end

# Rebuild the table when there are no more reaction times within the current
# time window. 
function rebuild!(ptt::PriorityTimeTable{T, F}, mintime, timestep) where {T, F}
    (; pidtogroup, groups, times, binwidthconst) = ptt
    fill!(pidtogroup, (zero(F), zero(F)))

    numbins = length(groups)
    binwidth = binwidthconst * timestep
    ptt.maxtime = mintime + numbins * binwidth
    ptt.timegrouper = TimeGrouper(mintime, binwidth)

    groupmaxtime = mintime
    for group in groups
        group.numpids = zero(F)
        groupmaxtime += binwidth
        group.maxpriority = groupmaxtime
    end

    # Reinsert the times into the groups. 
    for (id, time) in enumerate(times)
        time > ptt.maxtime && continue
        insert!(ptt, id, time)
    end
    ptt.minbin = findfirst(g -> g.numpids > (0), groups)
    ptt.minbin === nothing && (ptt.minbin = 0)
    ptt.steps = 0

    return nothing
end

# Get the reaction with the earliest timestep.
function getfirst(ptt::PriorityTimeTable)
    (; groups, times, minbin) = ptt
    minbin == 0 && return (0, 0)

    while groups[minbin].numpids == 0
        minbin += 1
        if minbin > length(groups)
            return (0, 0)
        end
    end

    ptt.minbin = minbin
    ptt.steps += 1
    min_time = typemax(eltype(times))
    min_idx = 0
    @inbounds for i in 1:(groups[minbin].numpids)
        pid = groups[minbin].pids[i]
        times[pid] < min_time && begin
            min_time = times[pid]
            min_idx = pid
        end
    end

    return min_idx, min_time
end

function insert!(ptt::PriorityTimeTable, pid, time)
    (; timegrouper, pidtogroup, groups) = ptt
    gid = timegrouper(time)
    @inbounds pididx = insert!(groups[gid], pid)
    @inbounds pidtogroup[pid] = (gid, pididx)

    return nothing
end

# Update the priority table when a reaction time gets updated. We only shift
# between bins if the new time is within the current time window; otherwise
# we remove the reaction and wait until rebuild. 
function update!(ptt::PriorityTimeTable{T, F}, pid, oldtime, newtime) where {T, F}
    (; times, timegrouper, maxtime, pidtogroup, groups) = ptt

    times[pid] = newtime
    if oldtime >= maxtime
        # If a reaction comes back into the time window, insert it. 
        newtime < maxtime ? insert!(ptt, pid, newtime) : return nothing
    elseif newtime >= maxtime
        # If the new time lands outside of current window, remove it.
        @inbounds begin
            gid, pidx = pidtogroup[pid]
            movedpid = remove!(groups[gid], pidx)
            pidtogroup[movedpid] = (gid, pidx)
            pidtogroup[pid] = (zero(F), zero(F))
        end
    else
        # Move bins if the reaction was already inside. 
        oldgid = timegrouper(oldtime)
        newgid = timegrouper(newtime)
        oldgid == newgid && return nothing
        @inbounds begin
            pidx = pidtogroup[pid][2]
            movedpid = remove!(groups[oldgid], pidx)
            pidtogroup[movedpid] = (oldgid, pidx)
            newpidx = insert!(groups[newgid], pid)
            pidtogroup[pid] = (newgid, newpidx)
        end
    end
    return nothing
end

const AVecOrNothing = Union{AbstractVector, Nothing}
const AMatOrNothing = Union{AbstractMatrix, Nothing}

struct SpatialMassActionJump{A <: AVecOrNothing, B <: AMatOrNothing, S, U, V} <:
       AbstractMassActionJump
    uniform_rates::A # reactions that are uniform in space
    spatial_rates::B # reactions whose rate depends on the site
    reactant_stoch::S
    net_stoch::U
    param_mapper::V

    """
    uniform rates go first in ordering
    """
    function SpatialMassActionJump{A, B, S, U, V}(uniform_rates::A, spatial_rates::B,
            reactant_stoch::S, net_stoch::U,
            param_mapper::V, scale_rates::Bool,
            useiszero::Bool,
            nocopy::Bool) where {A <: AVecOrNothing,
            B <: AMatOrNothing,
            S, U, V}
        uniform_rates = (nocopy || isnothing(uniform_rates)) ? uniform_rates :
                        copy(uniform_rates)
        spatial_rates = (nocopy || isnothing(spatial_rates)) ? spatial_rates :
                        copy(spatial_rates)
        reactant_stoch = nocopy ? reactant_stoch : copy(reactant_stoch)
        for i in eachindex(reactant_stoch)
            if useiszero && (length(reactant_stoch[i]) == 1) &&
               iszero(reactant_stoch[i][1][1])
                reactant_stoch[i] = typeof(reactant_stoch[i])()
            end
        end
        num_unif_rates = isnothing(uniform_rates) ? 0 : length(uniform_rates)
        if scale_rates && num_unif_rates > 0
            scalerates!(uniform_rates, reactant_stoch)
        end
        if scale_rates && !isnothing(spatial_rates) && !isempty(spatial_rates)
            scalerates!(spatial_rates, reactant_stoch[(num_unif_rates + 1):end])
        end
        new(uniform_rates, spatial_rates, reactant_stoch, net_stoch, param_mapper)
    end
end

################ Constructors ##################

function SpatialMassActionJump(urates::A, srates::B, rs::S, ns::U, pmapper::V;
        scale_rates = true, useiszero = true,
        nocopy = false) where {A <: AVecOrNothing,
        B <: AMatOrNothing, S, U, V}
    SpatialMassActionJump{A, B, S, U, V}(urates, srates, rs, ns, pmapper, scale_rates,
        useiszero, nocopy)
end
function SpatialMassActionJump(urates::A, srates::B, rs, ns; scale_rates = true,
        useiszero = true,
        nocopy = false) where {A <: AVecOrNothing,
        B <: AMatOrNothing}
    SpatialMassActionJump(urates, srates, rs, ns, nothing; scale_rates = scale_rates,
        useiszero = useiszero, nocopy = nocopy)
end

function SpatialMassActionJump(srates::B, rs, ns, pmapper; scale_rates = true,
        useiszero = true,
        nocopy = false) where {B <: AMatOrNothing}
    SpatialMassActionJump(nothing, srates, rs, ns, pmapper; scale_rates = scale_rates,
        useiszero = useiszero, nocopy = nocopy)
end
function SpatialMassActionJump(srates::B, rs, ns; scale_rates = true, useiszero = true,
        nocopy = false) where {B <: AMatOrNothing}
    SpatialMassActionJump(nothing, srates, rs, ns, nothing; scale_rates = scale_rates,
        useiszero = useiszero, nocopy = nocopy)
end

function SpatialMassActionJump(urates::A, rs, ns, pmapper; scale_rates = true,
        useiszero = true,
        nocopy = false) where {A <: AVecOrNothing}
    SpatialMassActionJump(urates, nothing, rs, ns, pmapper; scale_rates = scale_rates,
        useiszero = useiszero, nocopy = nocopy)
end
function SpatialMassActionJump(urates::A, rs, ns; scale_rates = true, useiszero = true,
        nocopy = false) where {A <: AVecOrNothing}
    SpatialMassActionJump(urates, nothing, rs, ns, nothing; scale_rates = scale_rates,
        useiszero = useiszero, nocopy = nocopy)
end

# scale_rates defaults to false since ma_jumps.scaled_rates are already scaled;
# passing true would double-scale.
function SpatialMassActionJump(ma_jumps::MassActionJump{T, S, U, V}; scale_rates = false,
        useiszero = true, nocopy = false) where {T, S, U, V}
    SpatialMassActionJump(ma_jumps.scaled_rates, ma_jumps.reactant_stoch,
        ma_jumps.net_stoch, ma_jumps.param_mapper;
        scale_rates = scale_rates, useiszero = useiszero, nocopy = nocopy)
end

##############################################

function get_num_majumps(smaj::SpatialMassActionJump{
        Nothing, Nothing, S, U, V}) where
        {S, U, V}
    0
end
function get_num_majumps(smaj::SpatialMassActionJump{
        Nothing, B, S, U, V}) where
        {B, S, U, V}
    size(smaj.spatial_rates, 1)
end
function get_num_majumps(smaj::SpatialMassActionJump{
        A, Nothing, S, U, V}) where
        {A, S, U, V}
    length(smaj.uniform_rates)
end
function get_num_majumps(smaj::SpatialMassActionJump{
        A, B, S, U, V}) where
        {A <: AbstractVector, B <: AbstractMatrix, S, U, V}
    length(smaj.uniform_rates) + size(smaj.spatial_rates, 1)
end
using_params(smaj::SpatialMassActionJump) = false

function rate_at_site(rx, site,
        smaj::SpatialMassActionJump{Nothing, B, S, U, V}) where {B, S, U, V}
    smaj.spatial_rates[rx, site]
end
function rate_at_site(rx, site,
        smaj::SpatialMassActionJump{A, Nothing, S, U, V}) where {A, S, U, V}
    smaj.uniform_rates[rx]
end
function rate_at_site(rx, site,
        smaj::SpatialMassActionJump{A, B, S, U, V}) where
        {A <: AbstractVector, B <: AbstractMatrix, S, U, V}
    num_unif_rxs = length(smaj.uniform_rates)
    rx <= num_unif_rxs ? smaj.uniform_rates[rx] :
    smaj.spatial_rates[rx - num_unif_rxs, site]
end

function evalrxrate(speciesmat::AbstractMatrix{T}, rxidx::S, majump::SpatialMassActionJump,
        site::Int) where {T, S}
    val = one(T)
    @inbounds for specstoch in majump.reactant_stoch[rxidx]
        specpop = speciesmat[specstoch[1], site]
        val *= specpop
        @inbounds for k in 2:specstoch[2]
            specpop -= one(specpop)
            val *= specpop
        end
    end
    @inbounds return val * rate_at_site(rxidx, site, majump)
end

"""
Direct with rejection sampling
"""

mutable struct RDirectJumpAggregation{T, S, F1, F2, RNG, DEPGR} <:
               AbstractSSAJumpAggregator{T, S, F1, F2, RNG}
    next_jump::Int
    prev_jump::Int
    next_jump_time::T
    end_time::T
    cur_rates::Vector{T}
    sum_rate::T
    ma_jumps::S
    rates::F1
    affects!::F2
    save_positions::Tuple{Bool, Bool}
    rng::RNG
    dep_gr::DEPGR
    max_rate::T
    counter::Int
    counter_threshold::Any
end

function RDirectJumpAggregation(nj::Int, njt::T, et::T, crs::Vector{T}, sr::T, maj::S,
        rs::F1, affs!::F2, sps::Tuple{Bool, Bool}, rng::RNG;
        num_specs, counter_threshold = length(crs),
        dep_graph = nothing,
        kwargs...) where {T, S, F1, F2, RNG}
    # a dependency graph is needed and must be provided if there are constant rate jumps
    if dep_graph === nothing
        if (get_num_majumps(maj) == 0) || !isempty(rs)
            error("To use ConstantRateJumps with the Rejection Direct (RDirect) algorithm a dependency graph must be supplied.")
        else
            dg = make_dependency_graph(num_specs, maj)
        end
    else
        dg = dep_graph

        # make sure each jump depends on itself
        add_self_dependencies!(dg)
    end

    max_rate = maximum(crs)
    affecttype = F2 <: Tuple ? F2 : Any
    return RDirectJumpAggregation{T, S, F1, affecttype, RNG, typeof(dg)}(nj, nj, njt, et,
        crs, sr, maj, rs,
        affs!, sps, rng,
        dg, max_rate, 0,
        counter_threshold)
end

############################# Required Functions #############################

# creating the JumpAggregation structure (tuple-based constant jumps)
function aggregate(aggregator::RDirect, u, p, t, end_time, constant_jumps,
        ma_jumps, save_positions, rng; kwargs...)

    # handle constant jumps using function wrappers
    rates, affects! = get_jump_info_fwrappers(u, p, t, constant_jumps)

    build_jump_aggregation(RDirectJumpAggregation, u, p, t, end_time, ma_jumps,
        rates, affects!, save_positions, rng; num_specs = length(u),
        kwargs...)
end

# set up a new simulation and calculate the first jump / jump time
function initialize!(p::RDirectJumpAggregation, integrator, u, params, t)
    p.end_time = integrator.sol.prob.tspan[2]
    fill_rates_and_sum!(p, u, params, t)
    p.max_rate = maximum(p.cur_rates)
    generate_jumps!(p, integrator, u, params, t)
    nothing
end

"""
execute one jump, changing the system state and updating rates
"""
function execute_jumps!(p::RDirectJumpAggregation, integrator, u, params, t, affects!)
    # execute jump
    u = update_state!(p, integrator, u, affects!)

    # update rates
    update_dependent_rates!(p, u, params, t)
    nothing
end

"""
calculate the next jump / jump time
"""
function generate_jumps!(p::RDirectJumpAggregation, integrator, u, params, t)
    # if no more events possible there is nothing to do
    sum_rate = p.sum_rate
    if nomorejumps!(p, sum_rate)
        return nothing
    end
    (; rng, cur_rates, max_rate) = p

    num_rxs = length(cur_rates)
    counter = 0
    rx = trunc(Int, rand(rng) * num_rxs) + 1
    @inbounds while cur_rates[rx] < rand(rng) * max_rate
        rx = trunc(Int, rand(rng) * num_rxs) + 1
        counter += 1
    end

    p.counter = counter
    p.next_jump = rx
    p.next_jump_time = t + randexp(p.rng) / sum_rate
    nothing
end

######################## SSA specific helper routines #########################
function update_dependent_rates!(p::RDirectJumpAggregation, u, params, t)
    @inbounds dep_rxs = p.dep_gr[p.next_jump]
    (; ma_jumps, rates, cur_rates, sum_rate) = p
    num_majumps = get_num_majumps(ma_jumps)
    max_rate_increased = false
    @inbounds for rx in dep_rxs
        @inbounds new_rate = calculate_jump_rate(
            ma_jumps, num_majumps, rates, u, params, t,
            rx)
        sum_rate += new_rate - cur_rates[rx]
        if new_rate > p.max_rate
            p.max_rate = new_rate
            max_rate_increased = true
        end
        cur_rates[rx] = new_rate
    end
    if !max_rate_increased && p.counter > p.counter_threshold
        p.max_rate = maximum(p.cur_rates)
    end

    p.sum_rate = sum_rate
    nothing
end

using Documenter, JumpProcesses

# Force PNG backend for plots to reduce file size
ENV["GKSwstype"] = "100"  # Force GR to use PNG
using Plots

docpath = Base.source_dir()
assetpath = joinpath(docpath, "src", "assets")
cp(joinpath(docpath, "Manifest.toml"), joinpath(assetpath, "Manifest.toml"), force = true)
cp(joinpath(docpath, "Project.toml"), joinpath(assetpath, "Project.toml"), force = true)

include("pages.jl")

mathengine = MathJax3(Dict(:loader => Dict("load" => ["[tex]/require", "[tex]/mathtools"]), :tex => Dict("inlineMath" => [["\$", "\$"], ["\\(", "\\)"]],
        "packages" => [
            "base",
            "ams",
            "autoload",
            "mathtools",
            "require"
        ])))

makedocs(sitename = "JumpProcesses.jl", authors = "Chris Rackauckas", modules = [JumpProcesses],
    clean = true, doctest = false, linkcheck = true, warnonly = [:missing_docs],
    format = Documenter.HTML(; assets = ["assets/favicon.ico"],
        canonical = "https://docs.sciml.ai/JumpProcesses/",
        prettyurls = (get(ENV, "CI", nothing) == "true"),
        mathengine,
        edit_link = "master",
        repolink = "https://github.com/SciML/JumpProcesses.jl"),
    pages = pages)

deploydocs(repo = "github.com/SciML/JumpProcesses.jl.git"; push_preview = true)

"""
A file with structs and functions for setting up and using the topology of the spatial system (e.g. a graph or a Cartesian grid)
"""

################### Graph ########################
num_sites(graph::AbstractGraph) = Graphs.nv(graph)
# neighbors(graph::AbstractGraph, site) = Graphs.neighbors(graph, site)
# outdegree(graph::AbstractGraph, site) = Graphs.outdegree(graph, site)
rand_nbr(rng, graph::AbstractGraph, site) = rand(rng, neighbors(graph, site))
nth_nbr(graph::AbstractGraph, site, n) = @inbounds neighbors(graph, site)[n]

################### CartesianGrid ########################
const offsets_1D = [CartesianIndex(-1), CartesianIndex(1)]
const offsets_2D = [
    CartesianIndex(0, -1),
    CartesianIndex(-1, 0),
    CartesianIndex(1, 0),
    CartesianIndex(0, 1)
]
const offsets_3D = [
    CartesianIndex(0, 0, -1),
    CartesianIndex(0, -1, 0),
    CartesianIndex(-1, 0, 0),
    CartesianIndex(1, 0, 0),
    CartesianIndex(0, 1, 0),
    CartesianIndex(0, 0, 1)
]

"""
    potential_offsets(dimension::Int)

NOTE: dimension is assumed to be 1, 2, or 3
"""
function potential_offsets(dimension::Int)
    if dimension == 1
        return offsets_1D
    elseif dimension == 2
        return offsets_2D
    else # else dimension == 3
        return offsets_3D
    end
end

dimension(grid) = length(grid.dims)
num_sites(grid) = prod(grid.dims)
outdegree(grid, site) = grid.nums_neighbors[site]

"""
    nth_potential_nbr(grid, site, n)

return nth Cartesian neighbor ignoring boundaries
"""
nth_potential_nbr(grid, site, n) = grid.LI[grid.offsets[n] + grid.CI[site]]

"""
    nth_nbr(grid, site, n)

return the nth neighbor of site in grid, in ascending order
"""
function nth_nbr(grid, site, n)
    CI = grid.CI
    offsets = grid.offsets
    @inbounds I = CI[site]
    @inbounds for off in offsets
        nb = I + off
        if nb in CI
            n -= 1
            @inbounds n == 0 && return grid.LI[nb]
        end
    end
end

"""
    neighbors(grid, site)

return an iterator over neighbors of site in ascending order. Do not use in hot loops
"""
function neighbors(grid, site)
    CI = grid.CI
    LI = grid.LI
    I = CI[site]
    Iterators.map(off -> LI[off + I], Iterators.filter(off -> off + I in CI, grid.offsets))
end

"""
given a vector of hopping constants of length num_neighbors(grid, site), form the vector of size 2*(dimension of grid) with zeros at indices where the neighbor is out of bounds. Store it in to_pad
"""
function pad_hop_vec!(to_pad::AbstractVector, grid, site, hop_vec::AbstractVector)
    CI = grid.CI
    I = CI[site]
    nbr_counter = 1
    @inbounds for (i, off) in enumerate(grid.offsets)
        if I + off in CI
            to_pad[i] = hop_vec[nbr_counter]
            nbr_counter += 1
        else
            to_pad[i] = zero(eltype(to_pad))
        end
    end
    to_pad
end

CartesianGrid(dims) = CartesianGridRej(dims) # use CartesianGridRej by default

# neighbor sampling is rejection-based
struct CartesianGridRej{N, T}
    "dimensions (side lengths) of the grid"
    dims::NTuple{N, Int}

    "number of neighbor for each site"
    nums_neighbors::Vector{Int8}
    CI::CartesianIndices{N, T}
    LI::LinearIndices{N, T}

    "offsets, e.g. [-1, 1] for 1D"
    offsets::Vector{CartesianIndex{N}}
end

"""
    CartesianGridRej(dims::Tuple)

initialize CartesianGridRej
"""
function CartesianGridRej(dims::Tuple)
    dim = length(dims)
    CI = CartesianIndices(dims)
    LI = LinearIndices(dims)
    offsets = potential_offsets(dim)
    nums_neighbors = Int8[count(x -> x + CI[site] in CI, offsets) for site in 1:prod(dims)]
    CartesianGridRej(dims, nums_neighbors, CI, LI, offsets)
end
CartesianGridRej(dims) = CartesianGridRej(Tuple(dims))
function CartesianGridRej(dimension, linear_size::Int)
    CartesianGridRej([linear_size for i in 1:dimension])
end
function rand_nbr(rng, grid::CartesianGridRej, site::Int)
    CI = grid.CI
    offsets = grid.offsets
    @inbounds I = CI[site]
    while true
        @inbounds nb = rand(rng, offsets) + I
        @inbounds nb in CI && return grid.LI[nb]
    end
end

function Base.show(io::IO, ::MIME"text/plain",
        grid::CartesianGridRej)
    println(io, "A Cartesian grid with dimensions $(grid.dims)")
end

# Implementation of the Next Subvolume Method

############################ NSM ###################################
#NOTE state vector u is a matrix. u[i,j] is species i, site j
#NOTE hopping_constants is a matrix. hopping_constants[i,j] is species i, site j
mutable struct NSMJumpAggregation{T, S, F1, F2, RNG, J, RX, HOP, DEPGR, VJMAP, JVMAP,
    PQ, SS} <:
               AbstractSSAJumpAggregator{T, S, F1, F2, RNG}
    next_jump::SpatialJump{J} #some structure to identify the next event: reaction or hop
    prev_jump::SpatialJump{J} #some structure to identify the previous event: reaction or hop
    next_jump_time::T
    end_time::T
    rx_rates::RX
    hop_rates::HOP
    rates::F1 # legacy, not used
    affects!::F2 # legacy, not used
    save_positions::Tuple{Bool, Bool}
    rng::RNG
    dep_gr::DEPGR #dep graph is same for each site
    vartojumps_map::VJMAP #vartojumps_map is same for each site
    jumptovars_map::JVMAP #jumptovars_map is same for each site
    pq::PQ
    spatial_system::SS
    numspecies::Int #number of species
end

function NSMJumpAggregation(
        nj::SpatialJump{J}, njt::T, et::T, rx_rates::RX, hop_rates::HOP,
        sps::Tuple{Bool, Bool},
        rng::RNG, spatial_system::SS; num_specs,
        vartojumps_map = nothing, jumptovars_map = nothing,
        dep_graph = nothing, kwargs...) where {J, T, RX, HOP, RNG, SS}

    # a dependency graph is needed
    if dep_graph === nothing
        dg = make_dependency_graph(num_specs, rx_rates.ma_jumps)
    else
        dg = dep_graph
        # make sure each jump depends on itself
        add_self_dependencies!(dg)
    end

    # a species-to-reactions graph is needed
    if vartojumps_map === nothing
        vtoj_map = var_to_jumps_map(num_specs, rx_rates.ma_jumps)
    else
        vtoj_map = vartojumps_map
    end

    if jumptovars_map === nothing
        jtov_map = jump_to_vars_map(rx_rates.ma_jumps)
    else
        jtov_map = jumptovars_map
    end

    pq = MutableBinaryMinHeap{T}()

    NSMJumpAggregation{T, Nothing, Nothing, Nothing, RNG, J, RX, HOP, typeof(dg),
        typeof(vtoj_map), typeof(jtov_map), typeof(pq), SS}(nj, nj, njt, et,
        rx_rates,
        hop_rates,
        nothing,
        nothing,
        sps, rng, dg,
        vtoj_map,
        jtov_map,
        pq,
        spatial_system,
        num_specs)
end

############################# Required Functions ##############################
# creating the JumpAggregation structure (function wrapper-based constant jumps)
function aggregate(aggregator::NSM, starting_state, p, t, end_time, constant_jumps,
        ma_jumps, save_positions, rng; hopping_constants, spatial_system,
        kwargs...)
    num_species = size(starting_state, 1)
    majumps = ma_jumps
    if majumps === nothing
        majumps = MassActionJump(Vector{typeof(end_time)}(),
            Vector{Vector{Pair{Int, Int}}}(),
            Vector{Vector{Pair{Int, Int}}}())
    end

    next_jump = SpatialJump{Int}(typemax(Int), typemax(Int), typemax(Int)) #a placeholder
    next_jump_time = typemax(typeof(end_time))
    rx_rates = RxRates(num_sites(spatial_system), majumps)
    hop_rates = HopRates(hopping_constants, spatial_system)

    NSMJumpAggregation(next_jump, next_jump_time, end_time, rx_rates, hop_rates,
        save_positions, rng, spatial_system; num_specs = num_species,
        kwargs...)
end

# set up a new simulation and calculate the first jump / jump time
function initialize!(p::NSMJumpAggregation, integrator, u, params, t)
    p.end_time = integrator.sol.prob.tspan[2]
    fill_rates_and_get_times!(p, integrator, t)
    generate_jumps!(p, integrator, params, u, t)
    nothing
end

# calculate the next jump / jump time
function generate_jumps!(p::NSMJumpAggregation, integrator, params, u, t)
    p.next_jump_time, site = top_with_handle(p.pq)
    p.next_jump_time >= p.end_time && return nothing
    p.next_jump = sample_jump_direct(p, site)
    nothing
end

# execute one jump, changing the system state
function execute_jumps!(p::NSMJumpAggregation, integrator, u, params, t, affects!)
    # execute jump
    update_state!(p, integrator)

    # update current jump rates and times
    update_dependent_rates_and_firing_times!(p, integrator, t)
    nothing
end

######################## SSA specific helper routines ########################
"""
    fill_rates_and_get_times!(aggregation::NSMJumpAggregation, u, t)

reset all structs, reevaluate all rates, recalculate tentative site firing times, and reinit the priority queue
"""
function fill_rates_and_get_times!(aggregation::NSMJumpAggregation, integrator, t)
    (; spatial_system, rx_rates, hop_rates, rng) = aggregation
    u = integrator.u

    reset!(rx_rates)
    reset!(hop_rates)

    rxs = 1:num_rxs(rx_rates)
    species = 1:(aggregation.numspecies)
    num_nodes = num_sites(spatial_system)

    pqdata = Vector{typeof(t)}(undef, num_nodes)
    @inbounds for site in 1:num_nodes
        update_rx_rates!(rx_rates, rxs, integrator, site)
        update_hop_rates!(hop_rates, species, u, site, spatial_system)
        pqdata[site] = t + randexp(rng) / (total_site_rate(rx_rates, hop_rates, site))
    end

    aggregation.pq = MutableBinaryMinHeap(pqdata)
    nothing
end

"""
    update_dependent_rates_and_firing_times!(p, integrator, t)

recalculate jump rates for jumps that depend on the just executed jump (p.prev_jump)
"""
function update_dependent_rates_and_firing_times!(p::NSMJumpAggregation, integrator, t)
    u = integrator.u
    jump = p.prev_jump
    if is_hop(p, jump)
        source_site = jump.src
        target_site = jump.dst
        update_rates_after_hop!(p, integrator, source_site, target_site, jump.jidx)
        update_site_time!(p, source_site, t)
        update_site_time!(p, target_site, t)
    else
        site = jump.src
        update_rates_after_reaction!(p, integrator, site, reaction_id_from_jump(p, jump))
        update_site_time!(p, site, t)
    end
    nothing
end

"""
    update_site_time!(p::NSMJumpAggregation, site, t)

update the time of site in the priority queue
"""
function update_site_time!(p::NSMJumpAggregation, site, t)
    site_rate = (total_site_rate(p.rx_rates, p.hop_rates, site))
    if site_rate > zero(typeof(site_rate))
        update!(p.pq, site, t + randexp(p.rng) / site_rate)
    else
        update!(p.pq, site, typemax(t))
    end
    nothing
end

"""
    num_constant_rate_jumps(aggregator::NSMJumpAggregation)

number of constant rate jumps
"""
num_constant_rate_jumps(aggregator::NSMJumpAggregation) = 0

using DiffEqBase, JumpProcesses, DataStructures
using Test, Statistics

using StableRNGs
rng = StableRNG(12345)

# using Plots; plotlyjs()
doplot = false

# using BenchmarkTools
# dobenchmark = false

dotestmean = true
doprintmeans = false

# SSAs to test
SSAalgs = (JumpProcesses.JUMP_AGGREGATORS..., JumpProcesses.NullAggregator())

Nsims = 32000
tf = 0.01
u0 = [200, 100, 150]
expected_avg = 84.876015624999994
reltol = 0.01

# MODEL SETUP

# using DiffEqBiological
# rs = @reaction_network dtype begin
#     k1, 2A --> B
#     k2, B --> 2A
#     k3, A + B --> C
#     k4, C --> A + B
#     k5, 3C --> 3A
# end k1 k2 k3 k4

# model using mass action jumps
# ids: A = 1, B = 2, C = 3
reactstoch = [
    [1 => 2],
    [2 => 1],
    [1 => 1, 2 => 1],
    [3 => 1],
    [3 => 3]
]
netstoch = [
    [1 => -2, 2 => 1],
    [1 => 2, 2 => -1],
    [1 => -1, 2 => -1, 3 => 1],
    [1 => 1, 2 => 1, 3 => -1],
    [1 => 3, 3 => -3]
]
rates = [1.0, 2.0, 0.5, 0.75, 0.25]
spec_to_dep_jumps = [[1, 3], [2, 3], [4, 5]]
jump_to_dep_specs = [[1, 2], [1, 2], [1, 2, 3], [1, 2, 3], [1, 3]]
majumps = MassActionJump(rates, reactstoch, netstoch)

# average number of proteins in a simulation
function runSSAs(jump_prob; use_stepper = true)
    Psamp = zeros(Int, Nsims)
    for i in 1:Nsims
        sol = use_stepper ? solve(jump_prob, SSAStepper()) : solve(jump_prob)
        Psamp[i] = sol[1, end]
    end
    mean(Psamp)
end

# TESTING:
prob = DiscreteProblem(u0, (0.0, tf), rates)

# plotting one full trajectory
if doplot
    for alg in SSAalgs
        local jump_prob = JumpProblem(prob, alg, majumps,
            vartojumps_map = spec_to_dep_jumps,
            jumptovars_map = jump_to_dep_specs, rng = rng)
        local sol = solve(jump_prob, SSAStepper())
        local plothand = plot(sol, seriestype = :steppost, reuse = false)
        display(plothand)
    end
end

# test the means
if dotestmean
    for (i, alg) in enumerate(SSAalgs)
        local jump_prob = JumpProblem(prob, alg, majumps, save_positions = (false, false),
            vartojumps_map = spec_to_dep_jumps,
            jumptovars_map = jump_to_dep_specs, rng = rng)
        means = runSSAs(jump_prob)
        relerr = abs(means - expected_avg) / expected_avg
        doprintmeans && println("Mean from method: ", typeof(alg), " is = ", means,
            ", rel err = ", relerr)
        @test abs(means - expected_avg) < reltol * expected_avg

        # test not specifying SSAStepper
        means = runSSAs(jump_prob; use_stepper = false)
        relerr = abs(means - expected_avg) / expected_avg
        @test abs(means - expected_avg) < reltol * expected_avg
    end
end

# add a test for passing MassActionJumps individually (tests combining)
if dotestmean
    majump_vec = Vector{MassActionJump{Float64, Vector{Pair{Int, Int}}}}()
    for i in 1:length(rates)
        push!(majump_vec, MassActionJump(rates[i], reactstoch[i], netstoch[i]))
    end
    jset = JumpSet((), (), nothing, majump_vec)
    jump_prob = JumpProblem(prob, Direct(), jset, save_positions = (false, false),
        vartojumps_map = spec_to_dep_jumps,
        jumptovars_map = jump_to_dep_specs, rng = rng)
    meanval = runSSAs(jump_prob)
    relerr = abs(meanval - expected_avg) / expected_avg
    if doprintmeans
        println("Using individual MassActionJumps; Mean from method: ", typeof(Direct()),
            " is = ", meanval, ", rel err = ", relerr)
    end
    @test abs(meanval - expected_avg) < reltol * expected_avg
end

using JumpProcesses, DiffEqBase
using Test, LinearAlgebra, Statistics
using KernelAbstractions, Adapt, CUDA
using StableRNGs
rng = StableRNG(12345)

Nsims = 100_000

# SIR model with influx
let
    β = 0.1 / 1000.0
    ν = 0.01
    influx_rate = 1.0
    p = (β, ν, influx_rate)

    regular_rate = (out, u, p, t) -> begin
        out[1] = p[1] * u[1] * u[2]  # β*S*I (infection)
        out[2] = p[2] * u[2]         # ν*I (recovery)
        out[3] = p[3]                # influx_rate
    end

    regular_c = (dc, u, p, t, counts, mark) -> begin
        dc .= 0.0
        dc[1] = -counts[1] + counts[3]  # S: -infection + influx
        dc[2] = counts[1] - counts[2]   # I: +infection - recovery
        dc[3] = counts[2]               # R: +recovery
    end

    u0 = [999.0, 10.0, 0.0]  # S, I, R
    tspan = (0.0, 250.0)

    prob_disc = DiscreteProblem(u0, tspan, p)
    rj = RegularJump(regular_rate, regular_c, 3)
    jump_prob = JumpProblem(prob_disc, PureLeaping(), rj)

    sol = solve(EnsembleProblem(jump_prob), SimpleTauLeaping(),
        EnsembleGPUKernel(CUDABackend()); trajectories = Nsims, dt = 1.0)
    mean_kernel = mean(sol.u[i][1, end] for i in 1:Nsims)

    sol = solve(EnsembleProblem(jump_prob), SimpleTauLeaping(),
        EnsembleSerial(); trajectories = Nsims, dt = 1.0)
    mean_serial = mean(sol.u[i][1, end] for i in 1:Nsims)

    @test isapprox(mean_kernel, mean_serial, rtol = 0.05)
end

# SEIR model with exposed compartment
let
    β = 0.3 / 1000.0
    σ = 0.2
    ν = 0.01
    p = (β, σ, ν)

    regular_rate = (out, u, p, t) -> begin
        out[1] = p[1] * u[1] * u[3]  # β*S*I (infection)
        out[2] = p[2] * u[2]         # σ*E (progression)
        out[3] = p[3] * u[3]         # ν*I (recovery)
    end

    regular_c = (dc, u, p, t, counts, mark) -> begin
        dc .= 0.0
        dc[1] = -counts[1]           # S: -infection
        dc[2] = counts[1] - counts[2] # E: +infection - progression
        dc[3] = counts[2] - counts[3] # I: +progression - recovery
        dc[4] = counts[3]            # R: +recovery
    end

    # Initial state
    u0 = [999.0, 0.0, 10.0, 0.0]  # S, E, I, R
    tspan = (0.0, 250.0)

    # Create JumpProblem
    prob_disc = DiscreteProblem(u0, tspan, p)
    rj = RegularJump(regular_rate, regular_c, 3)
    jump_prob = JumpProblem(prob_disc, PureLeaping(), rj; rng = StableRNG(12345))

    sol = solve(EnsembleProblem(jump_prob), SimpleTauLeaping(),
        EnsembleGPUKernel(CUDABackend()); trajectories = Nsims, dt = 1.0)
    mean_kernel = mean(sol.u[i][end, end] for i in 1:Nsims)

    sol = solve(EnsembleProblem(jump_prob), SimpleTauLeaping(),
        EnsembleSerial(); trajectories = Nsims, dt = 1.0)
    mean_serial = mean(sol.u[i][end, end] for i in 1:Nsims)

    @test isapprox(mean_kernel, mean_serial, rtol = 0.05)
end

# Tests for topology.jl
using JumpProcesses, Graphs, Test, Random, StableRNGs
const JP = JumpProcesses

# Functions to test:
# num_sites(grid)
# neighbors(grid, site)
# outdegree(grid, site)
# rand_nbr(rng, grid, site)
# nth_nbr(grid, site, n)

io = IOBuffer()
rng = StableRNG(12345)
dims = (4, 3, 2)
sites = 1:prod(dims)
num_samples = 10^5
rel_tol = 0.01
grids = [
    JP.CartesianGridRej(dims),
    Graphs.grid(dims)
]
for grid in grids
    show(io, "text/plain", grid)
    @test String(take!(io)) !== nothing
    @test JP.num_sites(grid) == prod(dims)
    @test JP.outdegree(grid, 1) == 3
    @test JP.outdegree(grid, 4) == 3
    @test JP.outdegree(grid, 17) == 4
    @test JP.outdegree(grid, 21) == 3
    @test JP.outdegree(grid, 6) == 5
    for site in sites
        @test [JP.nth_nbr(grid, site, n) for n in 1:outdegree(grid, site)] ==
              collect(neighbors(grid, site))
        d = Dict{Int, Int}()
        for i in 1:num_samples
            nb = JP.rand_nbr(rng, grid, site)
            nb in keys(d) ? d[nb] += 1 : d[nb] = 1
        end
        for val in values(d)
            @test abs(val / num_samples - 1 / JP.outdegree(grid, site)) < rel_tol
        end
    end
end

function DiffEqBase.__solve(jump_prob::DiffEqBase.AbstractJumpProblem{P},
        alg::DiffEqBase.AbstractDEAlgorithm;
        merge_callbacks = true, kwargs...) where {P}
    # Merge jump_prob.kwargs with passed kwargs
    kwargs = DiffEqBase.merge_problem_kwargs(jump_prob; merge_callbacks, kwargs...)

    integrator = __jump_init(jump_prob, alg; kwargs...)
    solve!(integrator)
    integrator.sol
end

#Ambiguity Fix
function DiffEqBase.__solve(jump_prob::DiffEqBase.AbstractJumpProblem{P},
        alg::Union{SciMLBase.AbstractRODEAlgorithm, SciMLBase.AbstractSDEAlgorithm};
        merge_callbacks = true, kwargs...) where {P}
    # Merge jump_prob.kwargs with passed kwargs
    kwargs = DiffEqBase.merge_problem_kwargs(jump_prob; merge_callbacks, kwargs...)

    integrator = __jump_init(jump_prob, alg; kwargs...)
    solve!(integrator)
    integrator.sol
end

# if passed a JumpProblem over a DiscreteProblem, and no aggregator is selected use
# SSAStepper
function DiffEqBase.__solve(jump_prob::DiffEqBase.AbstractJumpProblem{P};
        kwargs...) where {P <: DiscreteProblem}
    DiffEqBase.__solve(jump_prob, SSAStepper(); kwargs...)
end

function DiffEqBase.__solve(jump_prob::DiffEqBase.AbstractJumpProblem; kwargs...)
    error("Auto-solver selection is currently only implemented for JumpProblems defined over DiscreteProblems. Please explicitly specify a solver algorithm in calling solve.")
end

function DiffEqBase.__init(_jump_prob::DiffEqBase.AbstractJumpProblem{P},
        alg::DiffEqBase.AbstractDEAlgorithm; merge_callbacks = true, kwargs...) where {P}
    # Merge jump_prob.kwargs with passed kwargs
    kwargs = DiffEqBase.merge_problem_kwargs(_jump_prob; merge_callbacks, kwargs...)

    __jump_init(_jump_prob, alg; kwargs...)
end 

function __jump_init(_jump_prob::DiffEqBase.AbstractJumpProblem{P}, alg;
        callback = nothing, seed = nothing,
        alias_jump = Threads.threadid() == 1,
        kwargs...) where {P}
    if alias_jump
        jump_prob = _jump_prob
        reset_jump_problem!(jump_prob, seed)
    else
        jump_prob = resetted_jump_problem(_jump_prob, seed)
    end

    # DDEProblems do not have a recompile_flag argument
    if jump_prob.prob isa DiffEqBase.AbstractDDEProblem
        # callback comes after jump consistent with SSAStepper
        integrator = init(jump_prob.prob, alg;
            callback = CallbackSet(jump_prob.jump_callback, callback),
            kwargs...)
    else
        # callback comes after jump consistent with SSAStepper
        integrator = init(jump_prob.prob, alg;
            callback = CallbackSet(jump_prob.jump_callback, callback),
            kwargs...)
    end
end

# Derive an independent seed from the caller's seed. When a caller (e.g. StochasticDiffEq)
# passes the same seed used for its noise process, we must produce a distinct seed for the
# jump aggregator's RNG. We cannot assume the JumpProblem's stored RNG is any particular
# type, so we pass the seed through `hash` (to decorrelate from the input) and then through
# a Xoshiro draw (to ensure strong mixing regardless of the target RNG's seeding quality).
const _JUMP_SEED_SALT = 0x4a756d7050726f63  # "JumPProc" in ASCII
_derive_jump_seed(seed) = rand(Random.Xoshiro(hash(seed, _JUMP_SEED_SALT)), UInt64)

function resetted_jump_problem(_jump_prob, seed)
    jump_prob = deepcopy(_jump_prob)
    if seed !== nothing && !isempty(jump_prob.jump_callback.discrete_callbacks)
        rng = jump_prob.jump_callback.discrete_callbacks[1].condition.rng
        Random.seed!(rng, _derive_jump_seed(seed))
    end
    jump_prob
end

function reset_jump_problem!(jump_prob, seed)
    if seed !== nothing && !isempty(jump_prob.jump_callback.discrete_callbacks)
        Random.seed!(jump_prob.jump_callback.discrete_callbacks[1].condition.rng,
            _derive_jump_seed(seed))
    end
end

using JumpProcesses, DiffEqBase
using Test
using LinearAlgebra
using Graphs
using StableRNGs
rng = StableRNG(12345)

function get_mean_sol(jump_prob, Nsims, saveat)
    sol = solve(jump_prob, SSAStepper(), saveat = saveat).u
    for i in 1:(Nsims - 1)
        sol += solve(jump_prob, SSAStepper(), saveat = saveat).u
    end
    sol / Nsims
end

# assume sites are labeled from 1 to num_sites(spatial_system)
function discrete_laplacian_from_spatial_system(spatial_system, hopping_rate)
    sites = 1:num_sites(spatial_system)
    laplacian = zeros(length(sites), length(sites))
    for site in sites
        laplacian[site, site] = -outdegree(spatial_system, site)
        for nb in neighbors(spatial_system, site)
            laplacian[site, nb] = 1
        end
    end
    laplacian .*= hopping_rate
    laplacian
end

# problem setup
majumps = JumpSet(nothing)
tf = 0.5
u0 = [100]
num_species = 1

domain_size = 1.0 #μ-meter
linear_size = 5
diffusivity = 0.1
dim = 2
dims = Tuple([linear_size for i in 1:dim])
num_nodes = prod(dims)

# Starting state setup
starting_state = zeros(Int, length(u0), num_nodes)
center_node = trunc(Int, (num_nodes + 1) / 2)
starting_state[:, center_node] = copy(u0)
tspan = (0.0, tf)
prob = DiscreteProblem(starting_state, tspan)

hopping_rate = diffusivity * (linear_size / domain_size)^2
hopping_constants = [hopping_rate for i in starting_state]

# analytic solution
lap = discrete_laplacian_from_spatial_system(Graphs.grid(dims), hopping_rate)
evals, B = eigen(lap) # lap == B*diagm(evals)*B'
Bt = B'
analytic_solution(t) = B * diagm(ℯ .^ (t * evals)) * Bt * reshape(prob.u0, num_nodes, 1)

num_time_points = 10
Nsims = 10000
rel_tol = 0.02
times = 0.0:(tf / num_time_points):tf

algs = [NSM(), DirectCRDirect()]
grids = [CartesianGridRej(dims), Graphs.grid(dims)]
jump_problems = JumpProblem[JumpProblem(prob, algs[2], majumps,
                                hopping_constants = hopping_constants,
                                spatial_system = grid,
                                save_positions = (false, false), rng = rng)
                            for grid in grids]
sizehint!(jump_problems, 15 + length(jump_problems))

# flattenned jump prob
push!(jump_problems,
    JumpProblem(prob, NRM(), majumps, hopping_constants = hopping_constants,
        spatial_system = grids[1], save_positions = (false, false), rng = rng))

# hop rates of form D_s
hop_constants = [hopping_rate]
for alg in algs
    push!(jump_problems,
        JumpProblem(prob, alg, majumps, hopping_constants = hop_constants,
            spatial_system = grids[1], save_positions = (false, false), rng = rng))
    push!(jump_problems,
        JumpProblem(prob, alg, majumps, hopping_constants = hop_constants,
            spatial_system = grids[end], save_positions = (false, false), rng = rng))
end

# hop rates of form L_{s,i,j}
hop_constants = Matrix{Vector{Float64}}(undef, size(hopping_constants))
for ci in CartesianIndices(hop_constants)
    (species, site) = Tuple(ci)
    hop_constants[ci] = repeat([hopping_constants[species, site]],
        outdegree(grids[1], site))
end
for alg in algs
    push!(jump_problems,
        JumpProblem(prob, alg, majumps, hopping_constants = hop_constants,
            spatial_system = grids[1], save_positions = (false, false), rng = rng))
    push!(jump_problems,
        JumpProblem(prob, alg, majumps, hopping_constants = hop_constants,
            spatial_system = grids[end], save_positions = (false, false), rng = rng))
end

# hop rates of form D_s * L_{i,j}
species_hop_constants = [hopping_rate]
site_hop_constants = Vector{Vector{Float64}}(undef, num_nodes)
for site in 1:num_nodes
    site_hop_constants[site] = repeat([1.0], JumpProcesses.outdegree(grids[1], site))
end
for alg in algs
    push!(jump_problems,
        JumpProblem(prob, alg, majumps,
            hopping_constants = Pair(species_hop_constants, site_hop_constants),
            spatial_system = grids[1], save_positions = (false, false), rng = rng))
    push!(jump_problems,
        JumpProblem(prob, alg, majumps,
            hopping_constants = Pair(species_hop_constants, site_hop_constants),
            spatial_system = grids[end], save_positions = (false, false), rng = rng))
end

# hop rates of form D_{s,i} * L_{i,j}
species_hop_constants = hopping_rate * ones(1, num_nodes)
site_hop_constants = Vector{Vector{Float64}}(undef, num_nodes)
for site in 1:num_nodes
    site_hop_constants[site] = repeat([1.0], JumpProcesses.outdegree(grids[1], site))
end
for alg in algs
    push!(jump_problems,
        JumpProblem(prob, alg, majumps,
            hopping_constants = Pair(species_hop_constants, site_hop_constants),
            spatial_system = grids[1], save_positions = (false, false), rng = rng))
    push!(jump_problems,
        JumpProblem(prob, alg, majumps,
            hopping_constants = Pair(species_hop_constants, site_hop_constants),
            spatial_system = grids[end], save_positions = (false, false), rng = rng))
end

# testing
for (j, spatial_jump_prob) in enumerate(jump_problems)
    mean_sol = get_mean_sol(spatial_jump_prob, Nsims, tf / num_time_points)
    for (i, t) in enumerate(times)
        local diff = analytic_solution(t) - reshape(mean_sol[i], num_nodes, 1)
        @test abs(sum(diff[1:center_node]) / sum(analytic_solution(t)[1:center_node])) <
              rel_tol
    end
end

# testing non-uniform hopping rates. Only hopping up or left.
dims = (2, 2)
num_nodes = prod(dims)
grid = Graphs.grid(dims)
hopping_constants = Matrix{Vector{Float64}}(undef, 1, num_nodes)
for ci in CartesianIndices(hopping_constants)
    (species, site) = Tuple(ci)
    hopping_constants[species, site] = zeros(outdegree(grid, site))
    for (n, nb) in enumerate(neighbors(grid, site))
        if nb < site
            hopping_constants[species, site][n] = 10.0
        end
    end
end
starting_state = 25 * ones(Int, length(u0), num_nodes)
tspan = (0.0, 10.0)
prob = DiscreteProblem(starting_state, tspan)

jp = JumpProblem(prob, NSM(), majumps, hopping_constants = hopping_constants,
    spatial_system = grid, save_positions = (false, false), rng = rng)
sol = solve(jp, SSAStepper())

@test sol.u[end][1, 1] == sum(sol.u[end])

mutable struct FRMJumpAggregation{T, S, F1, F2, RNG} <:
               AbstractSSAJumpAggregator{T, S, F1, F2, RNG}
    next_jump::Int
    prev_jump::Int
    next_jump_time::T
    end_time::T
    cur_rates::Vector{T}
    sum_rate::T
    ma_jumps::S
    rates::F1
    affects!::F2
    save_positions::Tuple{Bool, Bool}
    rng::RNG
end
function FRMJumpAggregation(nj::Int, njt::T, et::T, crs::Vector{T}, sr::T, maj::S, rs::F1,
        affs!::F2, sps::Tuple{Bool, Bool}, rng::RNG;
        kwargs...) where {T, S, F1, F2, RNG}
    affecttype = F2 <: Tuple ? F2 : Any
    FRMJumpAggregation{T, S, F1, affecttype, RNG}(nj, nj, njt, et, crs, sr, maj, rs,
        affs!, sps, rng)
end

############################# Required Functions #############################

# creating the JumpAggregation structure (tuple-based constant jumps)
function aggregate(aggregator::FRM, u, p, t, end_time, constant_jumps,
        ma_jumps, save_positions, rng; kwargs...)

    # handle constant jumps using tuples
    rates, affects! = get_jump_info_tuples(constant_jumps)

    build_jump_aggregation(
        FRMJumpAggregation, u, p, t, end_time, ma_jumps, rates, affects!,
        save_positions, rng; kwargs...)
end

# creating the JumpAggregation structure (function wrapper-based constant jumps)
function aggregate(aggregator::FRMFW, u, p, t, end_time, constant_jumps,
        ma_jumps, save_positions, rng; kwargs...)

    # handle constant jumps using function wrappers
    rates, affects! = get_jump_info_fwrappers(u, p, t, constant_jumps)

    build_jump_aggregation(
        FRMJumpAggregation, u, p, t, end_time, ma_jumps, rates, affects!,
        save_positions, rng; kwargs...)
end

# set up a new simulation and calculate the first jump / jump time
function initialize!(p::FRMJumpAggregation, integrator, u, params, t)
    p.end_time = integrator.sol.prob.tspan[2]
    generate_jumps!(p, integrator, u, params, t)
    nothing
end

# execute one jump, changing the system state
@inline function execute_jumps!(p::FRMJumpAggregation, integrator, u, params, t, affects!)
    # execute jump
    update_state!(p, integrator, u, affects!)
    nothing
end

# calculate the next jump / jump time
function generate_jumps!(p::FRMJumpAggregation, integrator, u, params, t)
    nextmaj, ttnmaj = next_ma_jump(p, u, params, t)
    nextcrj, ttncrj = next_constant_rate_jump(p, u, params, t)

    # execute reaction with minimal time
    if ttnmaj < ttncrj
        p.next_jump = nextmaj
        p.next_jump_time = t + ttnmaj
    else
        p.next_jump = nextcrj
        p.next_jump_time = t + ttncrj
    end
    nothing
end

######################## SSA specific helper routines ########################

# mass action jumps
function next_ma_jump(p::FRMJumpAggregation, u, params, t)
    ttnj = typemax(typeof(t))
    nextrx = zero(Int)
    majumps = p.ma_jumps
    @inbounds for i in 1:get_num_majumps(majumps)
        p.cur_rates[i] = evalrxrate(u, i, majumps)
        dt = randexp(p.rng) / p.cur_rates[i]
        if dt < ttnj
            ttnj = dt
            nextrx = i
        end
    end
    nextrx, ttnj
end

# tuple-based constant jumps
function next_constant_rate_jump(p::FRMJumpAggregation{T, S, F1, F2, RNG}, u, params,
        t) where {T, S, F1 <: Tuple, F2 <: Tuple, RNG}
    ttnj = typemax(typeof(t))
    nextrx = zero(Int)
    if !isempty(p.rates)
        idx = get_num_majumps(p.ma_jumps) + 1
        fill_cur_rates(u, params, t, p.cur_rates, idx, p.rates...)
        @inbounds for i in idx:length(p.cur_rates)
            dt = randexp(p.rng) / p.cur_rates[i]
            if dt < ttnj
                ttnj = dt
                nextrx = i
            end
        end
    end
    nextrx, ttnj
end

# function wrapper-based constant jumps
function next_constant_rate_jump(p::FRMJumpAggregation{T, S, F1}, u, params,
        t) where {T, S, F1 <: AbstractArray}
    ttnj = typemax(typeof(t))
    nextrx = zero(Int)
    if !isempty(p.rates)
        idx = get_num_majumps(p.ma_jumps) + 1
        @inbounds for i in 1:length(p.rates)
            p.cur_rates[idx] = p.rates[i](u, params, t)
            dt = randexp(p.rng) / p.cur_rates[idx]
            if dt < ttnj
                ttnj = dt
                nextrx = idx
            end
            idx += 1
        end
    end
    nextrx, ttnj
end

###############################################################################
# Stochiometry for a given reaction is a vector of pairs mapping species id to
# stochiometric coefficient.
###############################################################################

@inline function evalrxrate(speciesvec::AbstractVector{T}, rxidx,
        majump::MassActionJump{U})::R where {T <: Integer, R, U <: AbstractVector{R}}
    val = one(T)
    @inbounds for specstoch in majump.reactant_stoch[rxidx]
        specpop = speciesvec[specstoch[1]]
        val *= specpop
        @inbounds for k in 2:specstoch[2]
            specpop -= one(specpop)
            val *= specpop
        end
    end

    @inbounds return val * majump.scaled_rates[rxidx]
end

@inline function evalrxrate(speciesvec::AbstractVector{T}, rxidx,
        majump::MassActionJump{U})::R where {T <: Real, R, U <: AbstractVector{R}}
    val = one(T)
    @inbounds for specstoch in majump.reactant_stoch[rxidx]
        specpop = speciesvec[specstoch[1]]
        val *= specpop
        @inbounds for k in 2:specstoch[2]
            specpop -= one(specpop)
            val *= specpop
        end
        # we need to check the smallest rate law term is positive
        # i.e. for an order k reaction: x - k + 1 > 0 
        (specpop <= 0) && return zero(R)
    end

    @inbounds return val * majump.scaled_rates[rxidx]
end

@inline function executerx!(speciesvec::AbstractVector{T}, rxidx::S,
        majump::M) where {T, S, M <: AbstractMassActionJump}
    @inbounds net_stoch = majump.net_stoch[rxidx]
    @inbounds for specstoch in net_stoch
        speciesvec[specstoch[1]] += specstoch[2]
    end
    nothing
end

@inline function executerx(speciesvec::SVector{T}, rxidx::S,
        majump::M) where {T, S, M <: AbstractMassActionJump}
    @inbounds net_stoch = majump.net_stoch[rxidx]
    @inbounds for specstoch in net_stoch
        speciesvec = setindex(speciesvec, speciesvec[specstoch[1]] + specstoch[2],
            specstoch[1])
    end
    speciesvec

    #=
    map(net_stoch) do stoch
        @inbounds speciesvec[stoch[1]] + stoch[2]
    end
    =#
end

function scalerates!(unscaled_rates::AbstractVector{U},
        stochmat::AbstractVector{V}) where {U, S, T, W <: Pair{S, T},
        V <: AbstractVector{W}}
    @inbounds for i in eachindex(unscaled_rates)
        coef = one(T)
        @inbounds for specstoch in stochmat[i]
            coef *= factorial(specstoch[2])
        end
        unscaled_rates[i] /= coef
    end
    nothing
end

function scalerates!(unscaled_rates::AbstractMatrix{U},
        stochmat::AbstractVector{V}) where {U, S, T, W <: Pair{S, T},
        V <: AbstractVector{W}}
    @inbounds for i in size(unscaled_rates, 1)
        coef = one(T)
        @inbounds for specstoch in stochmat[i]
            coef *= factorial(specstoch[2])
        end
        unscaled_rates[i, :] /= coef
    end
    nothing
end

function scalerate(unscaled_rate::U,
        stochmat::AbstractVector{Pair{S, T}}) where {U <: Number, S, T}
    coef = one(T)
    @inbounds for specstoch in stochmat
        coef *= factorial(specstoch[2])
    end
    unscaled_rate /= coef
end

###############################################################################
# dependency graph when MassActionJump uses pairs to represent (species,stoich)
###############################################################################

# map from species to reactions depending on that species
# uses a Vector instead of a Set as the latter requires isEqual,
# and by using an underlying Dict can be slower for small numbers
# of dependencies
function var_to_jumps_map(numspec, ma_jumps::AbstractMassActionJump)
    numrxs = get_num_majumps(ma_jumps)

    # map from a species to reactions that depend on it
    spec_to_dep_rxs = [Vector{Int}() for n in 1:numspec]
    for rx in 1:numrxs
        for (spec, stoch) in ma_jumps.reactant_stoch[rx]
            push!(spec_to_dep_rxs[spec], rx)
        end
    end

    foreach(s -> unique!(sort!(s)), spec_to_dep_rxs)
    spec_to_dep_rxs
end

"""
make a map from reactions to dependent species
"""
function jump_to_vars_map(majumps)
    [[s for (s, c) in majumps.net_stoch[i]] for i in 1:get_num_majumps(majumps)]
end

# dependency graph is a map from a reaction to a vector of reactions
# that should depend on species it changes
function make_dependency_graph(numspec, ma_jumps::AbstractMassActionJump)
    numrxs = get_num_majumps(ma_jumps)
    spec_to_dep_rxs = var_to_jumps_map(numspec, ma_jumps)

    # create map from rx to reactions depending on it
    dep_graph = [Vector{Int}() for n in 1:numrxs]
    for rx in 1:numrxs

        # rx changes spec, hence rxs depending on spec depend on rx
        for (spec, stoch) in ma_jumps.net_stoch[rx]
            for dependent_rx in spec_to_dep_rxs[spec]
                push!(dep_graph[rx], dependent_rx)
            end
        end
    end

    add_self_dependencies!(dep_graph, dosort = false)
    foreach(deps -> unique!(sort!(deps)), dep_graph)
    dep_graph
end

# update dependency graph to make sure jumps depend on themselves
function add_self_dependencies!(dg; dosort = true)
    for (i, jump_deps) in enumerate(dg)
        if !any(y -> isequal(y, i), jump_deps)
            push!(jump_deps, i)
            dosort && sort!(jump_deps)
        end
    end
end

"""
A file with structs and functions for sampling reactions and updating reaction rates in spatial SSAs
"""

### spatial rx rates ###
struct RxRates{F, M}
    "rx_rates[i,j] is rate of reaction i at site j"
    rates::Matrix{F}

    "rx_rates_sum[j] is sum of reaction rates at site j"
    sum_rates::Vector{F}

    "AbstractMassActionJump"
    ma_jumps::M
end

"""
    RxRates(num_sites::Int, ma_jumps::M) where {M}

initializes RxRates with zero rates
"""
function RxRates(num_sites::Int, ma_jumps::M) where {M}
    numrxjumps = get_num_majumps(ma_jumps)
    rates = zeros(Float64, numrxjumps, num_sites)
    RxRates{Float64, M}(rates, vec(sum(rates, dims = 1)), ma_jumps)
end

num_rxs(rx_rates::RxRates) = get_num_majumps(rx_rates.ma_jumps)

"""
    reset!(rx_rates::RxRates)

make all rates zero
"""
function reset!(rx_rates::RxRates)
    fill!(rx_rates.rates, zero(eltype(rx_rates.rates)))
    fill!(rx_rates.sum_rates, zero(eltype(rx_rates.sum_rates)))
    nothing
end

"""
    total_site_rx_rate(rx_rates::RxRates, site)

return total reaction rate at site
"""
function total_site_rx_rate(rx_rates::RxRates, site)
    @inbounds rx_rates.sum_rates[site]
end

"""
    update_rx_rates!(rx_rates, rxs, u, site)

update rates of all reactions in rxs at site
"""
function update_rx_rates!(rx_rates::RxRates, rxs, u::AbstractMatrix, integrator,
        site)
    ma_jumps = rx_rates.ma_jumps
    @inbounds for rx in rxs
        rate = eval_massaction_rate(u, rx, ma_jumps, site)
        set_rx_rate_at_site!(rx_rates, site, rx, rate)
    end
end

function update_rx_rates!(rx_rates::RxRates, rxs, integrator,
        site)
    u = integrator.u
    update_rx_rates!(rx_rates, rxs, u, integrator, site)
end

"""
    sample_rx_at_site(rx_rates::RxRates, site, rng)

sample a reaction at site, return reaction index
"""
function sample_rx_at_site(rx_rates::RxRates, site, rng)
    linear_search((@view rx_rates.rates[:, site]),
        rand(rng) * total_site_rx_rate(rx_rates, site))
end

# helper functions
function set_rx_rate_at_site!(rx_rates::RxRates, site, rx, rate)
    @inbounds old_rate = rx_rates.rates[rx, site]
    @inbounds rx_rates.rates[rx, site] = rate
    @inbounds rx_rates.sum_rates[site] += rate - old_rate
    old_rate
end

function Base.show(io::IO, ::MIME"text/plain", rx_rates::RxRates)
    num_rxs, num_sites = size(rx_rates.rates)
    println(io, "RxRates with $num_rxs reactions and $num_sites sites")
end

function eval_massaction_rate(u, rx, ma_jumps::M, site) where {M <: SpatialMassActionJump}
    evalrxrate(u, rx, ma_jumps, site)
end
function eval_massaction_rate(u, rx, ma_jumps::M, site) where {M <: MassActionJump}
    evalrxrate((@view u[:, site]), rx, ma_jumps)
end

#! format: off
using JumpProcesses, SafeTestsets, Pkg

const GROUP = get(ENV, "GROUP", "All")

function activate_gpu_env()
    Pkg.activate("gpu")
    Pkg.develop(PackageSpec(path = dirname(@__DIR__)))
    Pkg.instantiate()
end

@time begin
    if GROUP == "QA"
        @time @safetestset "QA Tests" begin include("qa.jl") end
    end
    
    if GROUP == "All" || GROUP == "InterfaceI"
        @time @safetestset "Constant Rate Tests" begin include("constant_rate.jl") end
        @time @safetestset "Variable Rate Tests" begin include("variable_rate.jl") end
        @time @safetestset "ExtendedJumpArray Tests" begin include("extended_jump_array.jl") end
        @time @safetestset "FunctionWrapper Tests" begin include("functionwrappers.jl") end
        @time @safetestset "Monte Carlo Tests" begin include("monte_carlo_test.jl") end
        @time @safetestset "Split Coupled Tests" begin include("splitcoupled.jl") end
        @time @safetestset "SSA Tests" begin include("ssa_tests.jl") end
        @time @safetestset "Tau Leaping Tests" begin include("regular_jumps.jl") end
        @time @safetestset "Simple SSA Callback Test" begin include("ssa_callback_test.jl") end
        @time @safetestset "SIR Discrete Callback Test" begin include("sir_model.jl") end
        @time @safetestset "Callback Merging Tests" begin include("callbacks.jl") end
        @time @safetestset "Linear Reaction SSA Test" begin include("linearreaction_test.jl") end
        @time @safetestset "Mass Action Jump Tests; Gene Expr Model" begin include("geneexpr_test.jl") end
        @time @safetestset "Mass Action Jump Tests; Nonlinear Rx Model" begin include("bimolerx_test.jl") end
        @time @safetestset "Mass Action Jump Tests; Special Cases" begin include("degenerate_rx_cases.jl") end
        @time @safetestset "Mass Action Jump Tests; Floating Point Inputs" begin include("fp_unknowns.jl") end
        @time @safetestset "scale_rates Field Tests" begin include("scale_rates_field_test.jl") end
        @time @safetestset "Direct allocations test" begin include("allocations.jl") end
        @time @safetestset "Bracketing Tests" begin include("bracketing.jl") end
        @time @safetestset "Composition-Rejection Table Tests" begin include("table_test.jl") end
        @time @safetestset "Extinction test" begin include("extinction_test.jl") end
    end
    if GROUP == "All" || GROUP == "InterfaceII"
        @time @safetestset "Saveat Regression test" begin include("saveat_regression.jl") end
        @time @safetestset "Save_positions test" begin include("save_positions.jl") end
        @time @safetestset "Ensemble Uniqueness test" begin include("ensemble_uniqueness.jl") end
        @time @safetestset "Thread Safety test" begin include("thread_safety.jl") end
        @time @safetestset "Ensemble Problem Tests" begin include("ensemble_problems.jl") end
        @time @safetestset "A + B <--> C" begin include("reversible_binding.jl") end
        @time @safetestset "Remake tests" begin include("remake_test.jl") end
        @time @safetestset "ExtendedJumpArray remake tests" begin include("extended_jump_array_remake.jl") end
        @time @safetestset "Symbol based problem indexing" begin include("jprob_symbol_indexing.jl") end
        @time @safetestset "Long time accuracy test" begin include("longtimes_test.jl") end
        @time @safetestset "Hawkes process" begin include("hawkes_test.jl") end
        @time @safetestset "Reaction rates" begin include("spatial/reaction_rates.jl") end
        @time @safetestset "Hop rates" begin include("spatial/hop_rates.jl") end
        @time @safetestset "Topology" begin include("spatial/topology.jl") end
        @time @safetestset "Spatial bracketing Tests" begin include("spatial/bracketing.jl") end
        @time @safetestset "Spatial A + B <--> C" begin include("spatial/ABC.jl") end
        @time @safetestset "Spatially Varying Reaction Rates" begin include("spatial/spatial_majump.jl") end
        @time @safetestset "Pure diffusion" begin include("spatial/diffusion.jl") end
    end

    if GROUP == "CUDA"
        activate_gpu_env()
        @time @safetestset "GPU Tau Leaping test" begin include("gpu/regular_jumps.jl") end
    end

    if GROUP == "Correctness"
        activate_gpu_env()
    end
end

using OrdinaryDiffEq, OrdinaryDiffEqFunctionMap, JumpProcesses, Test
using StableRNGs, Random

j1 = ConstantRateJump((u, p, t) -> 10, (integrator) -> integrator.u[1] += 1)
j2 = ConstantRateJump((u, p, t) -> 1u[1], (integrator) -> integrator.u[1] -= 1)
u0 = [0]

dprob = DiscreteProblem(u0, (0.0, 100.0))

# For EnsembleProblems, use prob_func to create a new JumpProblem with unique RNG per trajectory.
# This ensures different trajectories while maintaining reproducibility.
# Generate seeds from a seeded RNG for reproducibility of ensemble results.
function make_seeded_prob_func(dprob, aggregator, jumps, base_rng)
    return function prob_func(prob, ctx)
        seed = rand(base_rng, UInt64)
        JumpProblem(dprob, aggregator, jumps...; rng = StableRNG(seed))
    end
end

# Test with FunctionMap - use prob_func to create JumpProblems with unique RNGs
rng1 = StableRNG(12345)
jump_prob = JumpProblem(dprob, Direct(), j1, j2; rng = rng1)
ensemble_rng = StableRNG(99999)  # separate RNG for generating trajectory seeds
ensemble_prob = EnsembleProblem(jump_prob;
    prob_func = make_seeded_prob_func(dprob, Direct(), (j1, j2), ensemble_rng))
sol = solve(ensemble_prob, FunctionMap(), trajectories = 3)
@test Array(sol.u[1]) !== Array(sol.u[2])
@test Array(sol.u[1]) !== Array(sol.u[3])
@test Array(sol.u[2]) !== Array(sol.u[3])
@test eltype(sol.u[1].u[1]) == Int

# Test with SSAStepper - use prob_func to create JumpProblems with unique RNGs
rng2 = StableRNG(12345)
jump_prob = JumpProblem(dprob, Direct(), j1, j2; rng = rng2)
ensemble_rng2 = StableRNG(99999)  # separate RNG for generating trajectory seeds
ensemble_prob2 = EnsembleProblem(jump_prob;
    prob_func = make_seeded_prob_func(dprob, Direct(), (j1, j2), ensemble_rng2))
sol = solve(ensemble_prob2, SSAStepper(), trajectories = 3)
@test Array(sol.u[1]) !== Array(sol.u[2])
@test Array(sol.u[1]) !== Array(sol.u[3])
@test Array(sol.u[2]) !== Array(sol.u[3])
@test eltype(sol.u[1].u[1]) == Int

"""
$(TYPEDEF)

An abstract type for aggregators that manage the simulation of `VariableRateJump`s in jump processes.

## Notes

  - In hybrid ODE/SDE systems with general `VariableRateJump`s, `integrator.u` may be an
    `ExtendedJumpArray` for some aggregators.
"""
abstract type VariableRateAggregator end

################################### VR_FRM ####################################

"""
$(TYPEDEF)

A concrete `VariableRateAggregator` implementing a first-reaction method variant for
simulating `VariableRateJump`s. `VR_FRM` (Variable Rate First Reaction Method with
Ordinary Differential Equation) uses a user-selected ODE solver to handle integrating each
jump's intensity / propensity. A callback is also used for each jump to determine when its
integrated intensity reaches a level corresponding to a firing time, and to then execute the
affect associated with the jump at that time.

## Examples

Simulating a birth-death process with `VR_FRM`:

```julia
using JumpProcesses, OrdinaryDiffEq
u0 = [1.0]           # Initial population  
p = [10.0, 0.5]      # [birth rate, death rate]  
tspan = (0.0, 10.0)

# Birth jump: ∅ → X  
birth_rate(u, p, t) = p[1]
birth_affect!(integrator) = (integrator.u[1] += 1; nothing)
birth_jump = VariableRateJump(birth_rate, birth_affect!)

# Death jump: X → ∅  
death_rate(u, p, t) = p[2] * u[1]
death_affect!(integrator) = (integrator.u[1] -= 1; nothing)
death_jump = VariableRateJump(death_rate, death_affect!)

# Problem setup  
oprob = ODEProblem((du, u, p, t) -> du .= 0, u0, tspan, p)
jprob = JumpProblem(oprob, birth_jump, death_jump; vr_aggregator = VR_FRM())
sol = solve(jprob, Tsit5())
```

## Notes

  - Specify `VR_FRM` in a `JumpProblem` via the `vr_aggregator` keyword argument to select
    its use for handling `VariableRateJump`s.
  - While robust, it may be less performant than `VR_Direct` due to its integration of each
    individual jump's intensity, and use of one continuous callback per jump to handle
    detection of jump times and implementation of state changes from that jump.
"""
struct VR_FRM <: VariableRateAggregator end

function configure_jump_problem(prob, vr_aggregator::VR_FRM, jumps, cvrjs;
        rng = DEFAULT_RNG)
    new_prob = extend_problem(prob, cvrjs; rng)
    variable_jump_callback = build_variable_callback(CallbackSet(), 0, cvrjs...; rng)
    return new_prob, variable_jump_callback
end

# extends prob.u0 to an ExtendedJumpArray with Njumps integrated intensity values,
# of type prob.tspan
function extend_u0(prob, Njumps, rng)
    ttype = eltype(prob.tspan)
    u0 = ExtendedJumpArray(prob.u0, [-randexp(rng, ttype) for i in 1:Njumps])
    return u0
end

function extend_problem(prob::DiffEqBase.AbstractDiscreteProblem, jumps; rng = DEFAULT_RNG)
    error("General `VariableRateJump`s require a continuous problem, like an ODE/SDE/DDE/DAE problem. To use a `DiscreteProblem` bounded `VariableRateJump`s must be used. See the JumpProcesses docs.")
end

function extend_problem(prob::DiffEqBase.AbstractODEProblem, jumps; rng = DEFAULT_RNG)
    _f = SciMLBase.unwrapped_f(prob.f)

    if isinplace(prob)
        jump_f = let _f = _f
            function (du::ExtendedJumpArray, u::ExtendedJumpArray, p, t)
                _f(du.u, u.u, p, t)
                update_jumps!(du, u, p, t, length(u.u), jumps...)
            end
        end
    else
        jump_f = let _f = _f
            function (u::ExtendedJumpArray, p, t)
                du = ExtendedJumpArray(_f(u.u, p, t), u.jump_u)
                update_jumps!(du, u, p, t, length(u.u), jumps...)
                return du
            end
        end
    end

    u0 = extend_u0(prob, length(jumps), rng)
    f = ODEFunction{isinplace(prob)}(jump_f; sys = prob.f.sys,
        observed = prob.f.observed)
    remake(prob; f, u0)
end

function extend_problem(prob::DiffEqBase.AbstractSDEProblem, jumps; rng = DEFAULT_RNG)
    _f = SciMLBase.unwrapped_f(prob.f)

    if isinplace(prob)
        jump_f = let _f = _f
            function (du::ExtendedJumpArray, u::ExtendedJumpArray, p, t)
                _f(du.u, u.u, p, t)
                update_jumps!(du, u, p, t, length(u.u), jumps...)
            end
        end
    else
        jump_f = let _f = _f
            function (u::ExtendedJumpArray, p, t)
                du = ExtendedJumpArray(_f(u.u, p, t), u.jump_u)
                update_jumps!(du, u, p, t, length(u.u), jumps...)
                return du
            end
        end
    end

    if prob.noise_rate_prototype === nothing
        jump_g = function (du, u, p, t)
            prob.g(du.u, u.u, p, t)
        end
    else
        jump_g = function (du, u, p, t)
            prob.g(du, u.u, p, t)
        end
    end

    u0 = extend_u0(prob, length(jumps), rng)
    f = SDEFunction{isinplace(prob)}(jump_f, jump_g; sys = prob.f.sys,
        observed = prob.f.observed)
    remake(prob; f, g = jump_g, u0)
end

function extend_problem(prob::DiffEqBase.AbstractDDEProblem, jumps; rng = DEFAULT_RNG)
    _f = SciMLBase.unwrapped_f(prob.f)

    if isinplace(prob)
        jump_f = let _f = _f
            function (du::ExtendedJumpArray, u::ExtendedJumpArray, h, p, t)
                _f(du.u, u.u, h, p, t)
                update_jumps!(du, u, p, t, length(u.u), jumps...)
            end
        end
    else
        jump_f = let _f = _f
            function (u::ExtendedJumpArray, h, p, t)
                du = ExtendedJumpArray(_f(u.u, h, p, t), u.jump_u)
                update_jumps!(du, u, p, t, length(u.u), jumps...)
                return du
            end
        end
    end

    u0 = extend_u0(prob, length(jumps), rng)
    f = DDEFunction{isinplace(prob)}(jump_f; sys = prob.f.sys,
        observed = prob.f.observed)
    remake(prob; f, u0)
end

# Not sure if the DAE one is correct: Should be a residual of sorts
function extend_problem(prob::DiffEqBase.AbstractDAEProblem, jumps; rng = DEFAULT_RNG)
    _f = SciMLBase.unwrapped_f(prob.f)

    if isinplace(prob)
        jump_f = let _f = _f
            function (out, du::ExtendedJumpArray, u::ExtendedJumpArray, h, p, t)
                _f(out, du.u, u.u, h, p, t)
                update_jumps!(out, u, p, t, length(u.u), jumps...)
            end
        end
    else
        jump_f = let _f = _f
            function (du, u::ExtendedJumpArray, h, p, t)
                out = ExtendedJumpArray(_f(du.u, u.u, h, p, t), u.jump_u)
                update_jumps!(du, u, p, t, length(u.u), jumps...)
                return du
            end
        end
    end

    u0 = extend_u0(prob, length(jumps), rng)
    f = DAEFunction{isinplace(prob)}(jump_f, sys = prob.f.sys,
        observed = prob.f.observed)
    remake(prob; f, u0)
end

struct VR_FRMEventCallback{F, RNG}
    idx::Int
    affect!::F
    rng::RNG
end

# condition: (u, t, integrator)
@inline (c::VR_FRMEventCallback)(u, t, integrator) = u.jump_u[c.idx]

# affect: (integrator)
function (c::VR_FRMEventCallback)(integrator)
    c.affect!(integrator)
    integrator.u.jump_u[c.idx] = -randexp(c.rng, typeof(integrator.t))
    nothing
end

# initialize: (cb, u, t, integrator)
function (c::VR_FRMEventCallback)(cb, u, t, integrator)
    integrator.u.jump_u[c.idx] = -randexp(c.rng, typeof(integrator.t))
    u_modified!(integrator, true)
    nothing
end

function wrap_jump_in_callback(idx, jump; rng = DEFAULT_RNG)
    cb_functor = VR_FRMEventCallback(idx, jump.affect!, rng)
    ContinuousCallback(cb_functor, cb_functor;
        initialize = cb_functor,
        idxs = jump.idxs,
        rootfind = jump.rootfind,
        interp_points = jump.interp_points,
        save_positions = jump.save_positions,
        abstol = jump.abstol,
        reltol = jump.reltol)
end

function build_variable_callback(cb, idx, jump, jumps...; rng = DEFAULT_RNG)
    idx += 1
    new_cb = wrap_jump_in_callback(idx, jump; rng)
    build_variable_callback(CallbackSet(cb, new_cb), idx, jumps...; rng = DEFAULT_RNG)
end

function build_variable_callback(cb, idx, jump; rng = DEFAULT_RNG)
    idx += 1
    CallbackSet(cb, wrap_jump_in_callback(idx, jump; rng))
end

@inline function update_jumps!(du, u, p, t, idx, jump)
    idx += 1
    du[idx] = jump.rate(u.u, p, t)
end

@inline function update_jumps!(du, u, p, t, idx, jump, jumps...)
    idx += 1
    du[idx] = jump.rate(u.u, p, t)
    update_jumps!(du, u, p, t, idx, jumps...)
end

################################### VR_Direct and VR_DirectFW ####################################

"""
$(TYPEDEF)

A concrete `VariableRateAggregator` implementing a direct method-based approach for
simulating `VariableRateJump`s. `VR_Direct` (Variable Rate Direct Callback) efficiently
samples jump times using one continuous callback to integrate the total intensity /
propensity for all `VariableRateJump`s, sample when the next jump occurs, and then sample
which jump occurs at this time.  `VR_DirectFW` a separate FunctionWrapper mode, which
wraps things in FunctionWrappers in cases with large numbers of jumps

## Examples

Simulating a birth-death process with `VR_Direct` (default) and VR_DirectFW:

```julia
using JumpProcesses, OrdinaryDiffEq
u0 = [1.0]           # Initial population  
p = [10.0, 0.5]      # [birth rate, death rate coefficient]  
tspan = (0.0, 10.0)

# Birth jump: ∅ → X  
birth_rate(u, p, t) = p[1]
birth_affect!(integrator) = (integrator.u[1] += 1; nothing)
birth_jump = VariableRateJump(birth_rate, birth_affect!)

# Death jump: X → ∅  
death_rate(u, p, t) = p[2] * u[1]
death_affect!(integrator) = (integrator.u[1] -= 1; nothing)
death_jump = VariableRateJump(death_rate, death_affect!)

# Problem setup  
oprob = ODEProblem((du, u, p, t) -> du .= 0, u0, tspan, p)
jprob = JumpProblem(oprob, birth_jump, death_jump; vr_aggregator = VR_Direct())
sol = solve(jprob, Tsit5())

jprob = JumpProblem(oprob, birth_jump, death_jump; vr_aggregator = VR_DirectFW())
sol = solve(jprob, Tsit5())
```

## Notes

  - `VR_Direct` and `VR_DirectFW` are expected to generally be more performant than `VR_FRM`.
"""
struct VR_Direct <: VariableRateAggregator end
struct VR_DirectFW <: VariableRateAggregator end

mutable struct VR_DirectEventCache{T, RNG, F1, F2}
    prev_time::T
    prev_threshold::T
    current_time::T
    current_threshold::T
    total_rate::T
    rng::RNG
    rate_funcs::F1
    affect_funcs::F2
    cum_rate_sum::Vector{T}
end

function VR_DirectEventCache(
        jumps::JumpSet, ::VR_Direct, prob, ::Type{T}; rng = DEFAULT_RNG) where {T}
    initial_threshold = randexp(rng, T)
    vjumps = jumps.variable_jumps

    # handle vjumps using tuples
    rate_funcs, affect_funcs = get_jump_info_tuples(vjumps)

    cum_rate_sum = Vector{T}(undef, length(vjumps))

    VR_DirectEventCache{T, typeof(rng), typeof(rate_funcs), typeof(affect_funcs)}(zero(T),
        initial_threshold, zero(T), initial_threshold, zero(T), rng, rate_funcs,
        affect_funcs, cum_rate_sum)
end

function VR_DirectEventCache(
        jumps::JumpSet, ::VR_DirectFW, prob, ::Type{T}; rng = DEFAULT_RNG) where {T}
    initial_threshold = randexp(rng, T)
    vjumps = jumps.variable_jumps

    t, u = prob.tspan[1], prob.u0

    # handle vjumps using tuples
    rate_funcs, affect_funcs = get_jump_info_fwrappers(u, prob.p, t, vjumps)

    cum_rate_sum = Vector{T}(undef, length(vjumps))

    VR_DirectEventCache{T, typeof(rng), typeof(rate_funcs), Any}(zero(T),
        initial_threshold, zero(T), initial_threshold, zero(T), rng, rate_funcs,
        affect_funcs, cum_rate_sum)
end

# Initialization function for VR_DirectEventCache
function initialize_vr_direct_cache!(cache::VR_DirectEventCache, u, t, integrator)
    cache.prev_time = zero(integrator.t)
    cache.current_time = zero(integrator.t)
    cache.prev_threshold = randexp(cache.rng, eltype(integrator.t))
    cache.current_threshold = cache.prev_threshold
    cache.total_rate = zero(integrator.t)
    cache.cum_rate_sum .= 0
    nothing
end

@inline function concretize_vr_direct_affects!(cache::VR_DirectEventCache,
        ::I) where {I <: SciMLBase.DEIntegrator}
    if (cache.affect_funcs isa Vector) &&
       !(cache.affect_funcs isa Vector{FunctionWrappers.FunctionWrapper{Nothing, Tuple{I}}})
        AffectWrapper = FunctionWrappers.FunctionWrapper{Nothing, Tuple{I}}
        cache.affect_funcs = AffectWrapper[makewrapper(AffectWrapper, aff)
                                           for aff in cache.affect_funcs]
    end
    nothing
end

@inline function concretize_vr_direct_affects!(cache::VR_DirectEventCache{T, RNG, F1, F2},
        ::I) where {T, RNG, F1, F2 <: Tuple, I <: SciMLBase.DEIntegrator}
    nothing
end

# Wrapper for initialize to match ContinuousCallback signature
function initialize_vr_direct_wrapper(cb::ContinuousCallback, u, t, integrator)
    concretize_vr_direct_affects!(cb.condition, integrator)
    initialize_vr_direct_cache!(cb.condition, u, t, integrator)
    u_modified!(integrator, false)
    nothing
end

# Merge callback parameters across all jumps for VR_Direct
function build_variable_integcallback(cache::VR_DirectEventCache, jumps)
    save_positions = (false, false)
    abstol = jumps[1].abstol
    reltol = jumps[1].reltol

    for jump in jumps
        save_positions = save_positions .|| jump.save_positions
        abstol = min(abstol, jump.abstol)
        reltol = min(reltol, jump.reltol)
    end

    return ContinuousCallback(cache, cache; initialize = initialize_vr_direct_wrapper,
        save_positions, abstol, reltol)
end

function configure_jump_problem(prob, ::VR_Direct, jumps, cvrjs; rng = DEFAULT_RNG)
    new_prob = prob
    cache = VR_DirectEventCache(jumps, VR_Direct(), prob, eltype(prob.tspan); rng)
    variable_jump_callback = build_variable_integcallback(cache, cvrjs)
    return new_prob, variable_jump_callback
end

function configure_jump_problem(prob, ::VR_DirectFW, jumps, cvrjs; rng = DEFAULT_RNG)
    new_prob = prob
    cache = VR_DirectEventCache(jumps, VR_DirectFW(), prob, eltype(prob.tspan); rng)
    variable_jump_callback = build_variable_integcallback(cache, cvrjs)
    return new_prob, variable_jump_callback
end

# recursively evaluate the cumulative sum of the rates for type stability
@inline function cumsum_rates!(cum_rate_sum, u, p, t, rates::Tuple)
    cur_sum = zero(eltype(cum_rate_sum))
    cumsum_rates!(cum_rate_sum, u, p, t, 1, cur_sum, rates...)
end

# loop-based version for Vector rate_funcs (avoids dynamic splatting)
@inline function cumsum_rates!(cum_rate_sum, u, p, t, rates::AbstractVector)
    cur_sum = zero(eltype(cum_rate_sum))
    @inbounds for (idx, rate) in enumerate(rates)
        cur_sum += rate(u, p, t)
        cum_rate_sum[idx] = cur_sum
    end
    return cur_sum
end

@inline function cumsum_rates!(cum_rate_sum, u, p, t, idx, cur_sum, rate, rates...)
    new_sum = cur_sum + rate(u, p, t)
    @inbounds cum_rate_sum[idx] = new_sum
    idx += 1
    cumsum_rates!(cum_rate_sum, u, p, t, idx, new_sum, rates...)
end

@inline function cumsum_rates!(cum_rate_sum, u, p, t, idx, cur_sum, rate)
    @inbounds cum_rate_sum[idx] = cur_sum + rate(u, p, t)
end

function total_variable_rate(
        cache::VR_DirectEventCache{
            T, RNG, F1, F2}, u, p, t) where {T, RNG, F1, F2}
    (; cum_rate_sum, rate_funcs) = cache
    sum_rate = cumsum_rates!(cum_rate_sum, u, p, t, rate_funcs)
    return sum_rate
end

# how many quadrature points to use (i.e. determines the degree of the quadrature rule)
const NUM_GAUSS_QUAD_NODES = 4

# Condition functor defined directly on the cache
function (cache::VR_DirectEventCache)(u, t, integrator)
    if integrator.t < cache.current_time
        error("integrator.t < cache.current_time. $(integrator.t) < $(cache.current_time). This is not supported in the `VR_Direct` handling")
    end

    if integrator.t != cache.current_time
        cache.prev_time = cache.current_time
        cache.prev_threshold = cache.current_threshold
        cache.current_time = integrator.t
    end

    dt = t - cache.prev_time
    if dt == 0
        return cache.prev_threshold
    end

    p = integrator.p
    rate_increment = zero(t)
    gps = _GAUSS_POINTS
    weights = _GAUSS_WEIGHTS
    tmid = (t + cache.prev_time) / 2
    halfdt = dt / 2
    u_τ = first(SciMLBase.get_tmp_cache(integrator))
    for (i, τᵢ) in enumerate(gps)
        τ = halfdt * τᵢ + tmid
        integrator(u_τ, τ)
        total_variable_rate_τ = total_variable_rate(cache, u_τ, p, τ)
        rate_increment += weights[i] * total_variable_rate_τ
    end
    rate_increment *= halfdt

    cache.current_threshold = cache.prev_threshold - rate_increment
    return cache.current_threshold
end

@generated function execute_affect!(cache::VR_DirectEventCache{T, RNG, F1, F2},
        integrator::I, idx) where {T, RNG, F1, F2 <: Tuple, I <: SciMLBase.DEIntegrator}
    quote
        (; affect_funcs) = cache
        Base.Cartesian.@nif $(fieldcount(F2)) i -> (i == idx) i -> (@inbounds affect_funcs[i](integrator)) i -> (@inbounds affect_funcs[fieldcount(F2)](integrator))
    end
end

@inline function execute_affect!(cache::VR_DirectEventCache,
        integrator::I, idx) where {I <: SciMLBase.DEIntegrator}
    (; affect_funcs) = cache
    if affect_funcs isa Vector{FunctionWrappers.FunctionWrapper{Nothing, Tuple{I}}}
        @inbounds affect_funcs[idx](integrator)
    else
        error("Error, invalid affect_funcs type. Expected a vector of function wrappers and got $(typeof(affect_funcs))")
    end
end

# Affect functor defined directly on the cache
function (cache::VR_DirectEventCache)(integrator)
    (; t, u, p) = integrator
    total_variable_rate_sum = total_variable_rate(cache, u, p, t)
    if total_variable_rate_sum <= 0
        cache.total_rate = 0
        return nothing
    end
    cache.total_rate = total_variable_rate_sum

    rng = cache.rng
    r = rand(rng) * total_variable_rate_sum
    @inbounds jump_idx = searchsortedfirst(cache.cum_rate_sum, r)
    execute_affect!(cache, integrator, jump_idx)

    cache.prev_time = t
    cache.current_threshold = randexp(rng)
    cache.prev_threshold = cache.current_threshold
    cache.current_time = t
    return nothing
end

# site chosen with DirectCR, rx or hop chosen with Direct

############################ DirectCRDirect ###################################
const MINJUMPRATE = 2.0^exponent(1e-12)

#NOTE state vector u is a matrix. u[i,j] is species i, site j
#NOTE hopping_constants is a matrix. hopping_constants[i,j] is species i, site j
mutable struct DirectCRDirectJumpAggregation{T, S, F1, F2, RNG, J, RX, HOP, DEPGR,
    VJMAP, JVMAP, SS, U <: PriorityTable,
    W <: Function} <:
               AbstractSSAJumpAggregator{T, S, F1, F2, RNG}
    next_jump::SpatialJump{J} #some structure to identify the next event: reaction or hop
    prev_jump::SpatialJump{J} #some structure to identify the previous event: reaction or hop
    next_jump_time::T
    end_time::T
    rx_rates::RX
    hop_rates::HOP
    site_rates::Vector{T}
    rates::F1 # legacy, not used
    affects!::F2 # legacy, not used
    save_positions::Tuple{Bool, Bool}
    rng::RNG
    dep_gr::DEPGR #dep graph is same for each site
    vartojumps_map::VJMAP #vartojumps_map is same for each site
    jumptovars_map::JVMAP #jumptovars_map is same for each site
    spatial_system::SS
    numspecies::Int #number of species
    rt::U
    ratetogroup::W
end

function DirectCRDirectJumpAggregation(nj::SpatialJump{J}, njt::T, et::T, rx_rates::RX,
        hop_rates::HOP, site_rates::Vector{T},
        sps::Tuple{Bool, Bool}, rng::RNG, spatial_system::SS;
        num_specs, minrate = convert(T, MINJUMPRATE),
        vartojumps_map = nothing, jumptovars_map = nothing,
        dep_graph = nothing,
        kwargs...) where {J, T, RX, HOP, RNG, SS}

    # a dependency graph is needed
    if dep_graph === nothing
        dg = make_dependency_graph(num_specs, rx_rates.ma_jumps)
    else
        dg = dep_graph
        # make sure each jump depends on itself
        add_self_dependencies!(dg)
    end

    # a species-to-reactions graph is needed
    if vartojumps_map === nothing
        vtoj_map = var_to_jumps_map(num_specs, rx_rates.ma_jumps)
    else
        vtoj_map = vartojumps_map
    end

    if jumptovars_map === nothing
        jtov_map = jump_to_vars_map(rx_rates.ma_jumps)
    else
        jtov_map = jumptovars_map
    end

    # mapping from jump rate to group id
    minexponent = exponent(minrate)

    # use the largest power of two that is <= the passed in minrate
    minrate = 2.0^minexponent
    ratetogroup = rate -> priortogid(rate, minexponent)

    # construct an empty initial priority table -- we'll reset this in init
    rt = PriorityTable(ratetogroup, zeros(T, 1), minrate, 2 * minrate)

    DirectCRDirectJumpAggregation{T, Nothing, Nothing, Nothing, RNG, J, RX, HOP,
        typeof(dg), typeof(vtoj_map),
        typeof(jtov_map), SS, typeof(rt),
        typeof(ratetogroup)}(nj, nj, njt, et, rx_rates, hop_rates,
        site_rates, nothing, nothing, sps,
        rng, dg, vtoj_map,
        jtov_map, spatial_system, num_specs,
        rt, ratetogroup)
end

############################# Required Functions ##############################
# creating the JumpAggregation structure (function wrapper-based constant jumps)
function aggregate(aggregator::DirectCRDirect, starting_state, p, t, end_time,
        constant_jumps, ma_jumps, save_positions, rng; hopping_constants,
        spatial_system, kwargs...)
    num_species = size(starting_state, 1)
    majumps = ma_jumps
    if majumps === nothing
        majumps = MassActionJump(Vector{typeof(end_time)}(),
            Vector{Vector{Pair{Int, Int}}}(),
            Vector{Vector{Pair{Int, Int}}}())
    end

    next_jump = SpatialJump{Int}(typemax(Int), typemax(Int), typemax(Int)) #a placeholder
    next_jump_time = typemax(typeof(end_time))
    rx_rates = RxRates(num_sites(spatial_system), majumps)
    hop_rates = HopRates(hopping_constants, spatial_system)
    site_rates = zeros(typeof(end_time), num_sites(spatial_system))

    DirectCRDirectJumpAggregation(next_jump, next_jump_time, end_time, rx_rates, hop_rates,
        site_rates, save_positions, rng, spatial_system;
        num_specs = num_species, kwargs...)
end

# set up a new simulation and calculate the first jump / jump time
function initialize!(p::DirectCRDirectJumpAggregation, integrator, u, params, t)
    p.end_time = integrator.sol.prob.tspan[2]
    fill_rates_and_get_times!(p, integrator, t)
    generate_jumps!(p, integrator, params, u, t)
    nothing
end

# calculate the next jump / jump time
function generate_jumps!(p::DirectCRDirectJumpAggregation, integrator, params, u, t)
    p.next_jump_time = t + randexp(p.rng) / p.rt.gsum
    p.next_jump_time >= p.end_time && return nothing
    site = sample(p.rt, p.site_rates, p.rng)
    p.next_jump = sample_jump_direct(p, site)
    nothing
end

# execute one jump, changing the system state
function execute_jumps!(p::DirectCRDirectJumpAggregation, integrator, u, params, t,
        affects!)
    # execute jump
    update_state!(p, integrator)

    # update current jump rates and times
    update_dependent_rates_and_firing_times!(p, integrator, t)
    nothing
end

######################## SSA specific helper routines ########################
"""
    fill_rates_and_get_times!(aggregation::DirectCRDirectJumpAggregation, u, t)

reset all structs, reevaluate all rates, repopulate the priority table
"""
function fill_rates_and_get_times!(
        aggregation::DirectCRDirectJumpAggregation, integrator, t)
    (; spatial_system, rx_rates, hop_rates, site_rates, rt) = aggregation
    u = integrator.u

    reset!(rx_rates)
    reset!(hop_rates)
    site_rates .= zero(typeof(t))

    rxs = 1:num_rxs(rx_rates)
    species = 1:(aggregation.numspecies)

    for site in 1:num_sites(spatial_system)
        update_rx_rates!(rx_rates, rxs, integrator, site)
        update_hop_rates!(hop_rates, species, u, site, spatial_system)
        site_rates[site] = total_site_rate(rx_rates, hop_rates, site)
    end
    # setup PriorityTable
    reset!(rt)
    for (pid, priority) in enumerate(site_rates)
        insert!(rt, pid, priority)
    end
    nothing
end

"""
    update_dependent_rates_and_firing_times!(p, integrator, t)

recalculate jump rates for jumps that depend on the just executed jump (p.prev_jump)
"""
function update_dependent_rates_and_firing_times!(
        p::DirectCRDirectJumpAggregation, integrator, t)
    u = integrator.u
    site_rates = p.site_rates
    jump = p.prev_jump
    if is_hop(p, jump)
        source_site = jump.src
        target_site = jump.dst
        update_rates_after_hop!(p, integrator, source_site, target_site, jump.jidx)

        # update site rates
        oldrate = site_rates[source_site]
        site_rates[source_site] = total_site_rate(p.rx_rates, p.hop_rates, source_site)
        update!(p.rt, source_site, oldrate, site_rates[source_site])

        oldrate = site_rates[target_site]
        p.site_rates[target_site] = total_site_rate(p.rx_rates, p.hop_rates, target_site)
        update!(p.rt, target_site, oldrate, site_rates[target_site])
    else
        site = jump.src
        update_rates_after_reaction!(p, integrator, site, reaction_id_from_jump(p, jump))

        # update site rates
        oldrate = site_rates[site]
        site_rates[site] = total_site_rate(p.rx_rates, p.hop_rates, site)
        update!(p.rt, site, oldrate, site_rates[site])
    end
end

"""
    num_constant_rate_jumps(aggregator::DirectCRDirectJumpAggregation)

number of constant rate jumps
"""
num_constant_rate_jumps(aggregator::DirectCRDirectJumpAggregation) = 0

"""
David F. Anderson, Masanori Koyama; An asymptotic relationship between coupling
methods for stochastically modeled population processes. IMA J Numer Anal 2015;
35 (4): 1757-1778. doi: 10.1093/imanum/dru044
"""
function SplitCoupledJumpProblem(prob::DiffEqBase.AbstractJumpProblem,
        prob_control::DiffEqBase.AbstractJumpProblem,
        aggregator::AbstractAggregatorAlgorithm,
        coupling_map::Vector{Tuple{Int, Int}}; kwargs...)
    JumpProblem(cat_problems(prob.prob, prob_control.prob), aggregator,
        build_split_jumps(prob, prob_control, coupling_map)...; kwargs...)
end

# make new problem by joining initial_data
function cat_problems(prob::DiscreteProblem, prob_control::DiscreteProblem)
    u0_coupled = CoupledArray(prob.u0, prob_control.u0, true)
    DiscreteProblem(u0_coupled, prob.tspan, prob.p)
end

function cat_problems(prob::DiffEqBase.AbstractODEProblem,
        prob_control::DiffEqBase.AbstractODEProblem)
    l = length(prob.u0) # add l_c = length(prob_control.u0)

    _f = SciMLBase.unwrapped_f(prob.f)
    _f_control = SciMLBase.unwrapped_f(prob_control.f)

    new_f = function (du, u, p, t)
        _f(@view(du[1:l]), u.u, p, t)
        _f_control(@view(du[(l + 1):(2 * l)]), u.u_control, p, t)
    end
    u0_coupled = CoupledArray(prob.u0, prob_control.u0, true)
    ODEProblem(new_f, u0_coupled, prob.tspan, prob.p)
end

function cat_problems(prob::DiscreteProblem, prob_control::DiffEqBase.AbstractODEProblem)
    l = length(prob.u0) # add l_c = length(prob_control.u0)
    if !(prob.f isa typeof(DiffEqBase.DISCRETE_INPLACE_DEFAULT))
        @warn("Coupling to DiscreteProblem with nontrivial f. Note that, unless scale_by_time=true, the meaning of f will change when using an ODE/SDE/DDE/DAE solver.")
    end

    _f = SciMLBase.unwrapped_f(prob.f)
    _f_control = SciMLBase.unwrapped_f(prob_control.f)

    new_f = function (du, u, p, t)
        _f(@view(du[1:l]), u.u, p, t)
        _f_control(@view(du[(l + 1):(2 * l)]), u.u_control, p, t)
    end
    u0_coupled = CoupledArray(prob.u0, prob_control.u0, true)
    ODEProblem(new_f, u0_coupled, prob.tspan, prob.p)
end

function cat_problems(prob::DiffEqBase.AbstractSDEProblem,
        prob_control::DiffEqBase.AbstractSDEProblem)
    l = length(prob.u0)
    new_f = function (du, u, p, t)
        prob.f(@view(du[1:l]), u.u, p, t)
        prob_control.f(@view(du[(l + 1):(2 * l)]), u.u_control, p, t)
    end
    new_g = function (du, u, p, t)
        prob.g(@view(du[1:l]), u.u, p, t)
        prob_control.g(@view(du[(l + 1):(2 * l)]), u.u_control, p, t)
    end
    u0_coupled = CoupledArray(prob.u0, prob_control.u0, true)
    SDEProblem(new_f, new_g, u0_coupled, prob.tspan, prob.p)
end

function cat_problems(prob::DiffEqBase.AbstractSDEProblem,
        prob_control::DiffEqBase.AbstractODEProblem)
    l = length(prob.u0)

    _f = SciMLBase.unwrapped_f(prob.f)
    _f_control = SciMLBase.unwrapped_f(prob_control.f)

    new_f = function (du, u, p, t)
        _f(@view(du[1:l]), u.u, p, t)
        _f_control(@view(du[(l + 1):(2 * l)]), u.u_control, p, t)
    end
    new_g = function (du, u, p, t)
        prob.g(@view(du[1:l]), u.u, p, t)
        for i in (l + 1):(2 * l)
            du[i] = 0.0
        end
    end
    u0_coupled = CoupledArray(prob.u0, prob_control.u0, true)
    SDEProblem(new_f, new_g, u0_coupled, prob.tspan, prob.p)
end

function cat_problems(prob::DiffEqBase.AbstractSDEProblem, prob_control::DiscreteProblem)
    l = length(prob.u0)
    if !(prob_control.f isa typeof(DiffEqBase.DISCRETE_INPLACE_DEFAULT))
        @warn("Coupling to DiscreteProblem with nontrivial f. Note that, unless scale_by_time=true, the meaning of f will change when using an ODE/SDE/DDE/DAE solver.")
    end
    new_f = function (du, u, p, t)
        prob.f(@view(du[1:l]), u.u, p, t)
        prob_control.f(@view(du[(l + 1):(2 * l)]), u.u_control, p, t)
    end
    new_g = function (du, u, p, t)
        prob.g(@view(du[1:l]), u.u, p, t)
        for i in (l + 1):(2 * l)
            du[i] = 0.0
        end
    end
    u0_coupled = CoupledArray(prob.u0, prob_control.u0, true)
    SDEProblem(new_f, new_g, u0_coupled, prob.tspan)
end

function cat_problems(prob_control::DiffEqBase.AbstractODEProblem, prob::DiscreteProblem)
    cat_problems(prob, prob_control)
end
function cat_problems(prob_control::DiscreteProblem, prob::DiffEqBase.AbstractSDEProblem)
    cat_problems(prob, prob_control)
end
function cat_problems(prob_control::DiffEqBase.AbstractODEProblem,
        prob::DiffEqBase.AbstractSDEProblem)
    cat_problems(prob, prob_control)
end

# this only depends on the jumps in prob, not prob.prob
function build_split_jumps(prob::DiffEqBase.AbstractJumpProblem,
        prob_control::DiffEqBase.AbstractJumpProblem,
        coupling_map::Vector{Tuple{Int, Int}})
    num_jumps = length(prob.discrete_jump_aggregation.rates)
    num_jumps_control = length(prob_control.discrete_jump_aggregation.rates)
    jumps = []
    # overallocates, will fix later
    uncoupled = deleteat!(Vector(1:num_jumps), [c[1] for c in coupling_map])
    uncoupled_control = deleteat!(Vector(1:num_jumps_control), [c[2] for c in coupling_map])
    for c in uncoupled   # make uncoupled jumps in prob
        new_rate = prob.discrete_jump_aggregation.rates[c]
        new_affect! = prob.discrete_jump_aggregation.affects![c]
        push!(jumps, ConstantRateJump(new_rate, new_affect!))
    end
    for c in uncoupled_control  # make uncoupled jumps in prob_control
        rate = prob_control.discrete_jump_aggregation.rates[c]
        new_rate = (u, p, t) -> rate(u.u_control, p, t)
        affect! = prob_control.discrete_jump_aggregation.affects![c]
        new_affect! = function (integrator)
            flip_u!(integrator.u)
            affect!(integrator)
            flip_u!(integrator.u)
        end
        push!(jumps, ConstantRateJump(new_rate, new_affect!))
    end

    for c in coupling_map # make coupled jumps. 3 new jumps for each old one
        rate = prob.discrete_jump_aggregation.rates[c[1]]
        rate_control = prob_control.discrete_jump_aggregation.rates[c[2]]
        affect! = prob.discrete_jump_aggregation.affects![c[1]]
        affect_control! = prob_control.discrete_jump_aggregation.affects![c[2]]
        # shared jump
        new_affect! = function (integrator)
            affect!(integrator)
            flip_u!(integrator.u)
            affect_control!(integrator)
            flip_u!(integrator.u)
        end
        new_rate = (u, p, t) -> min(rate(u.u, p, t), rate_control(u.u_control, p, t))
        push!(jumps, ConstantRateJump(new_rate, new_affect!))
        # only prob
        new_affect! = affect!
        new_rate = (u, p, t) -> rate(u.u, p, t) -
                  min(rate(u.u, p, t), rate_control(u.u_control, p, t))
        push!(jumps, ConstantRateJump(new_rate, new_affect!))
        # only prob_control
        new_affect! = function (integrator)
            flip_u!(integrator.u)
            affect!(integrator)
            flip_u!(integrator.u)
        end
        new_rate = (u, p, t) -> rate_control(u.u_control, p, t) -
                  min(rate(u.u, p, t), rate_control(u.u_control, p, t))
        push!(jumps, ConstantRateJump(new_rate, new_affect!))
    end
    jumps
end

"""
A file with structs and functions for sampling hops and updating hopping rates
"""

# TODO to simplify the design can do two things:
# 1. make an abstract type HopRatesGridOptim (grid-optimized) and dispatch on it. Or maybe dispatch on the type of hop_const_cumulative_sums instead (Array{F} vs Array{Vector{F}})
# 2. make an abstract type HopRatesGraphDsi, which has hop rates uniform wrt neighbors, and treat things not of that type as having hop_const_cumulative_sums field
# 3. Use traits

### spatial hop rates ###
abstract type AbstractHopRates end

function HopRates(hopping_constants::Vector{F}, spatial_system) where {F <: Number}
    HopRatesGraphDs(hopping_constants, num_sites(spatial_system))
end
function HopRates(hopping_constants::Vector{F},
        grid::CartesianGridRej) where {F <: Number}
    HopRatesGraphDs(hopping_constants, num_sites(grid))
end

function HopRates(hopping_constants::Matrix{F}, spatial_system) where {F <: Number}
    HopRatesGraphDsi(hopping_constants)
end
function HopRates(hopping_constants::Matrix{F},
        grid::CartesianGridRej) where {F <: Number}
    HopRatesGraphDsi(hopping_constants)
end

function HopRates(hopping_constants::Matrix{Vector{F}}, spatial_system) where {F <: Number}
    HopRatesGraphDsij(hopping_constants)
end
function HopRates(hopping_constants::Matrix{Vector{F}},
        grid::CartesianGridRej) where {F <: Number}
    HopRatesGridDsij(hopping_constants, grid)
end

function HopRates(p::Pair{SpecHop, SiteHop},
        spatial_system) where {F <: Number, SpecHop <: Vector{F},
        SiteHop <: Vector{Vector{F}}}
    HopRatesGraphDsLij(p...)
end
function HopRates(p::Pair{SpecHop, SiteHop},
        grid::CartesianGridRej) where
        {F <: Number, SpecHop <: Vector{F}, SiteHop <: Vector{Vector{F}}}
    HopRatesGridDsLij(p..., grid)
end

function HopRates(p::Pair{SpecHop, SiteHop},
        spatial_system) where {F <: Number, SpecHop <: Matrix{F},
        SiteHop <: Vector{Vector{F}}}
    HopRatesGraphDsiLij(p...)
end
function HopRates(p::Pair{SpecHop, SiteHop},
        grid::CartesianGridRej) where
        {SpecHop <: Matrix{F}, SiteHop <: Vector{Vector{F}}} where {F <: Number}
    HopRatesGridDsiLij(p..., grid)
end

"""
    update_hop_rates!(hop_rates::AbstractHopRates, species::AbstractArray, u, site, spatial_system)

update rates of all specs in species at site
"""
function update_hop_rates!(hop_rates::AbstractHopRates, species::AbstractArray, u, site,
        spatial_system)
    @inbounds for spec in species
        update_hop_rate!(hop_rates, spec, u, site, spatial_system)
    end
end

"""
    update_hop_rate!(hop_rates::HopRatesGraphDsi, species, u, site, spatial_system)

update rates of single species at site
"""
function update_hop_rate!(hop_rates::AbstractHopRates, species, u, site, spatial_system)
    rates = hop_rates.rates
    @inbounds old_rate = rates[species, site]
    @inbounds rates[species, site] = evalhoprate(hop_rates, u, species, site,
        spatial_system)
    @inbounds hop_rates.sum_rates[site] += rates[species, site] - old_rate
    old_rate
end

"""
    total_site_hop_rate(hop_rates::AbstractHopRates, site)

return total hopping rate out of site
"""
total_site_hop_rate(hop_rates::AbstractHopRates, site) = @inbounds hop_rates.sum_rates[site]

"""
    reset!(hop_rates::AbstractHopRates)

make all rates zero
"""
function reset!(hop_rates::AbstractHopRates)
    hop_rates.rates .= zero(eltype(hop_rates.rates))
    hop_rates.sum_rates .= zero(eltype(hop_rates.sum_rates))
    nothing
end

"""
    sample_species(hop_rates::AbstractHopRates, site, rng)

sample species to hop from site
"""
function sample_species(hop_rates::AbstractHopRates, site, rng)
    @inbounds linear_search((@view hop_rates.rates[:, site]),
        rand(rng) * total_site_hop_rate(hop_rates, site))
end

"""
    sample_hop_at_site(hop_rates::AbstractHopRates, site, rng, spatial_system)

sample a reaction at site, return (species, target_site)
"""
function sample_hop_at_site(hop_rates::AbstractHopRates, site, rng, spatial_system)
    species = sample_species(hop_rates, site, rng)
    return species, sample_target_site(hop_rates, site, species, rng, spatial_system)
end

############## hopping rates of form D_s ################

struct HopRatesGraphDs{F} <: AbstractHopRates
    "hopping_constants[i] is the hop constant of species i"
    hopping_constants::Vector{F}

    "rates[i,j] is total hopping rate of species i at site j"
    rates::Matrix{F}

    "sum_rates[j] is the sum of hopping rates at site j"
    sum_rates::Vector{F}
end

function Base.show(io::IO, ::MIME"text/plain", hop_rates::HopRatesGraphDs)
    num_specs, num_sites = size(hop_rates.rates)
    println(io,
        "HopRates with $num_specs species and $num_sites sites. \nHopping constants of form D_{s} where s is species.")
end

"""
    HopRatesGraphDs(hopping_constants::Vector{F}, num_nodes) where F <: Number

initializes HopRatesGraphDs with zero rates
"""
function HopRatesGraphDs(hopping_constants::Vector{F}, num_nodes) where {F <: Number}
    rates = zeros(F, length(hopping_constants), num_nodes)
    HopRatesGraphDs{F}(hopping_constants, rates, zeros(F, size(rates, 2)))
end

function sample_target_site(hop_rates::HopRatesGraphDs, site, species, rng, spatial_system)
    rand_nbr(rng, spatial_system, site)
end

"""
return hopping rate of species at site
"""
function evalhoprate(hop_rates::HopRatesGraphDs, u, species, site, spatial_system)
    @inbounds u[species, site] * hop_rates.hopping_constants[species] * outdegree(spatial_system, site)
end

############## hopping rates of form D_{s,i} ################
struct HopRatesGraphDsi{F} <: AbstractHopRates
    "hopping_constants[i,j] is the hop constant of species i at site j"
    hopping_constants::Matrix{F}

    "rates[i,j] is total hopping rate of species i at site j"
    rates::Matrix{F}

    "sum_rates[j] is the sum of hopping rates at site j"
    sum_rates::Vector{F}
end

function Base.show(io::IO, ::MIME"text/plain", hop_rates::HopRatesGraphDsi)
    num_specs, num_sites = size(hop_rates.rates)
    println(io,
        "HopRates with $num_specs species and $num_sites sites. \nHopping constants of form D_{s,i} where s is species, and i is source.")
end

"""
    HopRatesGraphDsi(hopping_constants::Matrix{F}) where F <: Number

initializes HopRatesGraphDsi with zero rates
"""
function HopRatesGraphDsi(hopping_constants::Matrix{F}) where {F <: Number}
    rates = zeros(F, size(hopping_constants))
    HopRatesGraphDsi{F}(hopping_constants, rates, zeros(F, size(rates, 2)))
end

function sample_target_site(hop_rates::HopRatesGraphDsi, site, species, rng, spatial_system)
    rand_nbr(rng, spatial_system, site)
end

"""
return hopping rate of species at site
"""
function evalhoprate(hop_rates::HopRatesGraphDsi, u, species, site, spatial_system)
    @inbounds u[species, site] * hop_rates.hopping_constants[species, site] * outdegree(spatial_system, site)
end

############## hopping rates of form D_{s,i,j} ################
struct HopRatesGraphDsij{F} <: AbstractHopRates
    "hop_const_cumulative_sums[s,i] is the vector of cumulative sums of hopping constants of species s at site i"
    hop_const_cumulative_sums::Matrix{Vector{F}}

    "rates[s,i] is the total hopping rate of species s at site i"
    rates::Matrix{F}

    "sum_rates[i] is the total hopping rate out of site i"
    sum_rates::Vector{F}
end

function Base.show(io::IO, ::MIME"text/plain", hop_rates::HopRatesGraphDsij)
    num_specs, num_sites = size(hop_rates.rates)
    println(io,
        "HopRates with $num_specs species and $num_sites sites. \nHopping constants of form D_{s,i,j} where s is species, i is source and j is destination.")
end

"""
    HopRatesGraphDsij(hopping_constants::Matrix{Vector{F}}) where F <: Number

initializes HopRates with zero rates
"""
function HopRatesGraphDsij(hopping_constants::Matrix{Vector{F}};
        do_cumsum = true) where {F <: Number}
    do_cumsum && (hopping_constants = map(cumsum, hopping_constants))
    rates = zeros(F, size(hopping_constants))
    sum_rates = zeros(F, size(rates, 2))
    HopRatesGraphDsij{F}(hopping_constants, rates, sum_rates)
end

function sample_target_site(hop_rates::HopRatesGraphDsij, site, species, rng,
        spatial_system)
    @inbounds cum_hop_consts = hop_rates.hop_const_cumulative_sums[species, site]
    @inbounds n = searchsortedfirst(cum_hop_consts, rand(rng) * cum_hop_consts[end])
    return nth_nbr(spatial_system, site, n)
end

function evalhoprate(hop_rates::HopRatesGraphDsij, u, species, site, spatial_system)
    @inbounds u[species, site] * hop_rates.hop_const_cumulative_sums[species, site][end]
end

#################  hopping rates of form L_{s,i,j} optimized for cartesian grid  ######################
"""
Analogue of HopRatesGraphDsij, optimized for CartesianGrid
"""
struct HopRatesGridDsij{F} <: AbstractHopRates
    "hop_const_cumulative_sums[:,s,i] is the vector of cumulative sums of hopping constants of species s at site i. Out-of-bounds neighbors are treated as having zero propensity."
    hop_const_cumulative_sums::Array{F, 3}

    "rates[s,i] is the total hopping rate of species s at site i"
    rates::Matrix{F}

    "sum_rates[i] is the total hopping rate out of site i"
    sum_rates::Vector{F}
end

function Base.show(io::IO, ::MIME"text/plain", hop_rates::HopRatesGridDsij)
    num_specs, num_sites = size(hop_rates.rates)
    println(io,
        "HopRates with $num_specs species and $num_sites sites, optimized for CartesianGrid. \nHopping constants of form L_{s,i,j} where s is species, i is source and j is destination.")
end

"""
    HopRatesGridDsij(hopping_constants::Matrix{Vector{F}}) where F <: Number

initializes HopRates with zero rates
"""
function HopRatesGridDsij(hopping_constants::Array{F, 3};
        do_cumsum = true) where {F <: Number}
    do_cumsum && (hopping_constants = mapslices(cumsum, hopping_constants, dims = 1))
    rates = zeros(F, size(hopping_constants)[2:3])
    sum_rates = zeros(F, size(rates, 2))
    HopRatesGridDsij{F}(hopping_constants, rates, sum_rates)
end

function HopRatesGridDsij(hopping_constants::Matrix{Vector{F}}, grid) where {F <: Number}
    new_hopping_constants = Array{F, 3}(undef, 2 * dimension(grid),
        size(hopping_constants)...)
    for ci in CartesianIndices(hopping_constants)
        species, site = Tuple(ci)
        nb_constants = @view new_hopping_constants[:, species, site]
        pad_hop_vec!(nb_constants, grid, site, hopping_constants[ci])
        cumsum!(nb_constants, nb_constants)
    end
    HopRatesGridDsij(new_hopping_constants, do_cumsum = false)
end

function sample_target_site(hop_rates::HopRatesGridDsij, site, species, rng, grid)
    @inbounds cum_hop_consts = @view hop_rates.hop_const_cumulative_sums[:, species, site]
    @inbounds n = searchsortedfirst(cum_hop_consts, rand(rng) * cum_hop_consts[end])
    return nth_potential_nbr(grid, site, n)
end

function evalhoprate(hop_rates::HopRatesGridDsij, u, species, site, spatial_system)
    @inbounds u[species, site] * hop_rates.hop_const_cumulative_sums[end, species, site]
end

############## hopping rates of form D_s * L_{i,j} ################
struct HopRatesGraphDsLij{F} <: AbstractHopRates
    "hopping constants of species -- D_s"
    species_hop_constants::Vector{F}

    "nbs_cumulative[i] is the vector of cumulative sums of hopping constants from site i to its neighbors"
    hop_const_cumulative_sums::Vector{Vector{F}}

    "rates[s,i] is the total hopping rate of species s at site i"
    rates::Matrix{F}

    "sum_rates[i] is the total hopping rate out of site i"
    sum_rates::Vector{F}
end

function Base.show(io::IO, ::MIME"text/plain", hop_rates::HopRatesGraphDsLij)
    num_specs,
    num_sites = length(hop_rates.species_hop_constants),
    length(hop_rates.hop_const_cumulative_sums)
    println(io,
        "HopRates with $num_specs species and $num_sites sites. \nHopping constants of form D_s * L_{i,j} where s is species, i is source and j is destination.")
end

"""
    HopRatesGraphDsLij(species_hop_constants::Vector{F}, site_hop_constants::Vector{Vector{F}}) where F <: Number

initializes HopRates with zero rates
"""
function HopRatesGraphDsLij(species_hop_constants::Vector{F},
        site_hop_constants::Vector{Vector{F}};
        do_cumsum = true) where {F <: Number}
    do_cumsum && (site_hop_constants = map(cumsum, site_hop_constants))
    rates = zeros(F, length(species_hop_constants), length(site_hop_constants))
    sum_rates = zeros(size(rates, 2))
    HopRatesGraphDsLij{F}(species_hop_constants, site_hop_constants, rates, sum_rates)
end

function sample_target_site(hop_rates::HopRatesGraphDsLij, site, species, rng,
        spatial_system)
    @inbounds cum_hop_consts = hop_rates.hop_const_cumulative_sums[site]
    @inbounds n = searchsortedfirst(cum_hop_consts, rand(rng) * cum_hop_consts[end])
    return nth_nbr(spatial_system, site, n)
end

function evalhoprate(hop_rates::HopRatesGraphDsLij, u, species, site, spatial_system)
    @inbounds u[species, site] * hop_rates.species_hop_constants[species] * hop_rates.hop_const_cumulative_sums[site][end]
end

############## hopping rates of form D_s * L_{i,j} optimized for cartesian grid ################
struct HopRatesGridDsLij{F} <: AbstractHopRates
    "hopping constants of species -- D_s"
    species_hop_constants::Vector{F}

    "nbs_cumulative[i] is the vector of cumulative sums of hopping constants from site i to its neighbors"
    hop_const_cumulative_sums::Matrix{F}

    "rates[s,i] is the total hopping rate of species s at site i"
    rates::Matrix{F}

    "sum_rates[i] is the total hopping rate out of site i"
    sum_rates::Vector{F}
end

function Base.show(io::IO, ::MIME"text/plain", hop_rates::HopRatesGridDsLij)
    num_specs,
    num_sites = length(hop_rates.species_hop_constants),
    size(hop_rates.hop_const_cumulative_sums, 2)
    println(io,
        "HopRates with $num_specs species and $num_sites sites, optimized for CartesianGrid. \nHopping constants of form D_s * L_{i,j} where s is species, i is source and j is destination.")
end

function HopRatesGridDsLij(species_hop_constants::Vector{F}, site_hop_constants::Matrix{F};
        do_cumsum = true) where {F <: Number}
    do_cumsum && (site_hop_constants = mapslices(cumsum, site_hop_constants, dims = 1))
    rates = zeros(F, length(species_hop_constants), size(site_hop_constants, 2))
    sum_rates = zeros(size(rates, 2))
    HopRatesGridDsLij{F}(species_hop_constants, site_hop_constants, rates, sum_rates)
end

function HopRatesGridDsLij(species_hop_constants::Vector{F},
        site_hop_constants::Vector{Vector{F}}, grid) where {F <: Number}
    new_hopping_constants = Matrix{F}(undef, 2 * dimension(grid),
        length(site_hop_constants))
    for site in 1:length(site_hop_constants)
        nb_constants = @view new_hopping_constants[:, site]
        pad_hop_vec!(nb_constants, grid, site, site_hop_constants[site])
        cumsum!(nb_constants, nb_constants)
    end
    HopRatesGridDsLij(species_hop_constants, new_hopping_constants, do_cumsum = false)
end

function sample_target_site(hop_rates::HopRatesGridDsLij, site, species, rng, grid)
    @inbounds cum_hop_consts = @view hop_rates.hop_const_cumulative_sums[:, site]
    @inbounds n = searchsortedfirst(cum_hop_consts, rand(rng) * cum_hop_consts[end])
    return nth_potential_nbr(grid, site, n)
end

function evalhoprate(hop_rates::HopRatesGridDsLij, u, species, site, grid)
    @inbounds u[species, site] * hop_rates.species_hop_constants[species] * hop_rates.hop_const_cumulative_sums[end, site]
end

############## hopping rates of form D_{s,i} * L_{i,j} ################
struct HopRatesGraphDsiLij{F} <: AbstractHopRates
    "hopping constants of species -- D_s"
    species_hop_constants::Matrix{F}

    "nbs_cumulative[i] is the vector of cumulative sums of hopping constants from site i to its neighbors"
    hop_const_cumulative_sums::Vector{Vector{F}}

    "rates[s,i] is the total hopping rate of species s at site i"
    rates::Matrix{F}

    "sum_rates[i] is the total hopping rate out of site i"
    sum_rates::Vector{F}
end

function Base.show(io::IO, ::MIME"text/plain", hop_rates::HopRatesGraphDsiLij)
    num_specs, num_sites = size(hop_rates.species_hop_constants)
    println(io,
        "HopRates with $num_specs species and $num_sites sites. \nHopping constants of form D_{s,i} * L_{i,j} where s is species, i is source and j is destination.")
end

function HopRatesGraphDsiLij(species_hop_constants::Matrix{F},
        site_hop_constants::Vector{Vector{F}};
        do_cumsum = true) where {F <: Number}
    @assert size(species_hop_constants, 2) == length(site_hop_constants)
    do_cumsum && (site_hop_constants = map(cumsum, site_hop_constants))
    rates = zeros(F, length(species_hop_constants), length(site_hop_constants))
    sum_rates = zeros(size(rates, 2))
    HopRatesGraphDsiLij{F}(species_hop_constants, site_hop_constants, rates, sum_rates)
end

function sample_target_site(hop_rates::HopRatesGraphDsiLij, site, species, rng,
        spatial_system)
    @inbounds cum_hop_consts = hop_rates.hop_const_cumulative_sums[site]
    @inbounds n = searchsortedfirst(cum_hop_consts, rand(rng) * cum_hop_consts[end])
    return nth_nbr(spatial_system, site, n)
end

function evalhoprate(hop_rates::HopRatesGraphDsiLij, u, species, site, spatial_system)
    @inbounds u[species, site] * hop_rates.species_hop_constants[species, site] * hop_rates.hop_const_cumulative_sums[site][end]
end

############## hopping rates of form D_{s,i} * L_{i,j} optimized for cartesian grid ################
struct HopRatesGridDsiLij{F} <: AbstractHopRates
    "hopping constants of species -- D_s"
    species_hop_constants::Matrix{F}

    "nbs_cumulative[i] is the vector of cumulative sums of hopping constants from site i to its neighbors"
    hop_const_cumulative_sums::Matrix{F}

    "rates[s,i] is the total hopping rate of species s at site i"
    rates::Matrix{F}

    "sum_rates[i] is the total hopping rate out of site i"
    sum_rates::Vector{F}
end

function Base.show(io::IO, ::MIME"text/plain", hop_rates::HopRatesGridDsiLij)
    num_specs,
    num_sites = length(hop_rates.species_hop_constants),
    size(hop_rates.hop_const_cumulative_sums, 2)
    println(io,
        "HopRates with $num_specs species and $num_sites sites, optimized for CartesianGrid. \nHopping constants of form D_{s,i} * L_{i,j} where s is species, i is source and j is destination.")
end

function HopRatesGridDsiLij(
        species_hop_constants::Matrix{F}, site_hop_constants::Matrix{F};
        do_cumsum = true) where {F <: Number}
    @assert size(species_hop_constants, 2) == size(site_hop_constants, 2)
    do_cumsum && (site_hop_constants = mapslices(cumsum, site_hop_constants, dims = 1))
    rates = zeros(F, size(species_hop_constants))
    sum_rates = zeros(size(rates, 2))
    HopRatesGridDsiLij{F}(species_hop_constants, site_hop_constants, rates, sum_rates)
end

function HopRatesGridDsiLij(species_hop_constants::Matrix{F},
        site_hop_constants::Vector{Vector{F}}, grid) where {F <: Number}
    new_hopping_constants = Matrix{F}(undef, 2 * dimension(grid),
        length(site_hop_constants))
    for site in 1:length(site_hop_constants)
        nb_constants = @view new_hopping_constants[:, site]
        pad_hop_vec!(nb_constants, grid, site, site_hop_constants[site])
        cumsum!(nb_constants, nb_constants)
    end
    HopRatesGridDsiLij(species_hop_constants, new_hopping_constants, do_cumsum = false)
end

function sample_target_site(hop_rates::HopRatesGridDsiLij, site, species, rng, grid)
    @inbounds cum_hop_consts = @view hop_rates.hop_const_cumulative_sums[:, site]
    @inbounds n = searchsortedfirst(cum_hop_consts, rand(rng) * cum_hop_consts[end])
    return nth_potential_nbr(grid, site, n)
end

function evalhoprate(hop_rates::HopRatesGridDsiLij, u, species, site, grid)
    @inbounds u[species, site] * hop_rates.species_hop_constants[species, site] * hop_rates.hop_const_cumulative_sums[end, site]
end

using JumpProcesses, DiffEqBase, OrdinaryDiffEq, OrdinaryDiffEqFunctionMap
using Test
using StableRNGs
rng = StableRNG(12345)

rate = (u, p, t) -> (0.1 / 1000.0) * u[1] * u[2]
affect! = function (integrator)
    integrator.u[1] -= 1
    integrator.u[2] += 1
end
jump = ConstantRateJump(rate, affect!)

rate = (u, p, t) -> 0.01u[2]
affect! = function (integrator)
    integrator.u[2] -= 1
    integrator.u[3] += 1
end
jump2 = ConstantRateJump(rate, affect!)

prob = DiscreteProblem([999.0, 1.0, 0.0], (0.0, 250.0))
jump_prob = JumpProblem(prob, Direct(), jump, jump2; rng = rng)
integrator = init(jump_prob, FunctionMap())

condition(u, t, integrator) = t == 100
function purge_affect!(integrator)
    integrator.u[2] ÷= 10
    reset_aggregated_jumps!(integrator)
end
cb = DiscreteCallback(condition, purge_affect!, save_positions = (false, false))
sol = solve(jump_prob, FunctionMap(), callback = cb, tstops = [100])
sol = solve(jump_prob, SSAStepper(), callback = cb, tstops = [100])

# test README example using the auto-solver selection runs
let
    # here we order S = 1, I = 2, and R = 3
    # substrate stoichiometry:
    substoich = [[1 => 1, 2 => 1],    # 1*S + 1*I
        [2 => 1]]                     # 1*I
    # net change by each jump type
    netstoich = [[1 => -1, 2 => 1],   # S -> S-1, I -> I+1
        [2 => -1, 3 => 1]]            # I -> I-1, R -> R+1
    # rate constants for each jump
    p = (0.1 / 1000, 0.01)

    # p[1] is rate for S+I --> 2I, p[2] for I --> R
    pidxs = [1, 2]

    maj = MassActionJump(substoich, netstoich; param_idxs = pidxs)

    u₀ = [999, 1, 0]       #[S(0),I(0),R(0)]
    tspan = (0.0, 250.0)
    dprob = DiscreteProblem(u₀, tspan, p)

    # use the Direct method to simulate
    jprob = JumpProblem(dprob, maj)

    # solve as a pure jump process, i.e. using SSAStepper
    sol = solve(jprob)
end

# Rejection SSA Method (RSSA), implementation following:
# Marchetti, Priami and Thanh - Simulation Algorithms for Computational Systems Biology
# Note, this implementation **assumes** jump rate functions are monotone
# functions of the current population sizes (i.e. u)
# requires vartojumps_map and fluct_rates as JumpProblem keywords

mutable struct RSSAJumpAggregation{T, S, F1, F2, RNG, VJMAP, JVMAP, BD, U} <:
               AbstractSSAJumpAggregator{T, S, F1, F2, RNG}
    next_jump::Int
    prev_jump::Int
    next_jump_time::T
    end_time::T
    cur_rate_low::Vector{T}
    cur_rate_high::Vector{T}
    sum_rate::T
    ma_jumps::S
    rates::F1
    affects!::F2
    save_positions::Tuple{Bool, Bool}
    rng::RNG
    vartojumps_map::VJMAP
    jumptovars_map::JVMAP
    bracket_data::BD
    ulow::U
    uhigh::U
end

function RSSAJumpAggregation(nj::Int, njt::T, et::T, crs::Vector{T}, sr::T,
        maj::S, rs::F1, affs!::F2, sps::Tuple{Bool, Bool},
        rng::RNG; u::U, vartojumps_map = nothing,
        jumptovars_map = nothing,
        bracket_data = nothing, kwargs...) where {T, S, F1, F2, RNG, U}
    # a dependency graph is needed and must be provided if there are constant rate jumps
    if vartojumps_map === nothing
        if (get_num_majumps(maj) == 0) || !isempty(rs)
            error("To use the RSSA algorithm a map from variables to dependent jumps must be supplied.")
        else
            vtoj_map = var_to_jumps_map(length(u), maj)
        end
    else
        vtoj_map = vartojumps_map
    end

    if jumptovars_map === nothing
        if (get_num_majumps(maj) == 0) || !isempty(rs)
            error("To use the RSSA algorithm a map from jumps to dependent variables must be supplied.")
        else
            jtov_map = jump_to_vars_map(maj)
        end
    else
        jtov_map = jumptovars_map
    end

    # vectors to store bracketing intervals for jump rates
    crl_bnds = similar(crs)
    crh_bnds = similar(crs)

    # a bracket data structure is needed for updating species populations
    bd = (bracket_data === nothing) ? BracketData{T, eltype(U)}() : bracket_data

    # current bounds on solution
    ulow = similar(u)
    uhigh = similar(u)

    affecttype = F2 <: Tuple ? F2 : Any
    RSSAJumpAggregation{T, S, F1, affecttype, RNG, typeof(vtoj_map),
        typeof(jtov_map), typeof(bd), U}(nj, nj, njt, et, crl_bnds,
        crh_bnds, sr, maj, rs, affs!, sps,
        rng, vtoj_map, jtov_map, bd, ulow,
        uhigh)
end

############################# Required Functions ##############################

# creating the JumpAggregation structure (function wrapper-based constant jumps)
function aggregate(aggregator::RSSA, u, p, t, end_time, constant_jumps,
        ma_jumps, save_positions, rng; kwargs...)

    # handle constant jumps using function wrappers
    rates, affects! = get_jump_info_fwrappers(u, p, t, constant_jumps)

    build_jump_aggregation(RSSAJumpAggregation, u, p, t, end_time, ma_jumps,
        rates, affects!, save_positions, rng; u = u,
        kwargs...)
end

# set up a new simulation and calculate the first jump / jump time
function initialize!(p::RSSAJumpAggregation, integrator, u, params, t)
    p.end_time = integrator.sol.prob.tspan[2]
    set_bracketing!(p, u, params, t)
    generate_jumps!(p, integrator, u, params, t)
    nothing
end

# execute one jump, changing the system state
function execute_jumps!(p::RSSAJumpAggregation, integrator, u, params, t, affects!)
    # execute jump
    u = update_state!(p, integrator, u, affects!)
    update_rates!(p, u, params, t)
    nothing
end

# calculate the next jump / jump time
function generate_jumps!(p::RSSAJumpAggregation, integrator, u, params, t)
    sum_rate = p.sum_rate
    # if no more events possible there is nothing to do
    if nomorejumps!(p, sum_rate)
        return nothing
    end
    # next jump type
    (; ma_jumps, rates, cur_rate_high, cur_rate_low, rng) = p
    num_majumps = get_num_majumps(ma_jumps)
    rerl = zero(sum_rate)

    r = rand(rng) * sum_rate
    jidx = linear_search(cur_rate_high, r)
    if iszero(jidx)
        p.next_jump_time = Inf
        return nothing
    end
    rerl += randexp(rng)
    @inbounds while rejectrx(ma_jumps, num_majumps, rates, cur_rate_high,
        cur_rate_low, rng, u, jidx, params, t)
        # sample candidate reaction
        r = rand(rng) * sum_rate
        jidx = linear_search(cur_rate_high, r)
        rerl += randexp(rng)
    end
    p.next_jump = jidx

    p.next_jump_time = t + rerl / sum_rate
    nothing
end

# alt erlang sampling above
#rerl = one(sum_rate)
#rerl *= rand(p.rng)
#p.next_jump_time = t + (-one(sum_rate) / sum_rate) * log(rerl)

######################## SSA specific helper routines #########################

"""
Update rates
"""
@inline function update_rates!(p::RSSAJumpAggregation, u::AbstractVector, params, t)
    # update bracketing intervals
    (; ulow, uhigh) = p
    sum_rate = p.sum_rate
    crhigh = p.cur_rate_high

    @inbounds for uidx in p.jumptovars_map[p.next_jump]
        uval = u[uidx]

        # if new u value is outside the bracketing interval
        if uval == zero(uval) || uval < ulow[uidx] || uval > uhigh[uidx]
            # update u bracketing interval
            ulow[uidx], uhigh[uidx] = get_spec_brackets(p.bracket_data, uidx, uval)

            # for each dependent jump, update jump rate brackets
            for jidx in p.vartojumps_map[uidx]
                sum_rate -= crhigh[jidx]
                p.cur_rate_low[jidx], crhigh[jidx] = get_jump_brackets(jidx, p, params, t)
                sum_rate += crhigh[jidx]
            end
        end
    end
    p.sum_rate = sum_rate
end

@inline function update_rates!(p::RSSAJumpAggregation, u::SVector, params, t)
    # update bracketing intervals
    sum_rate = p.sum_rate
    crhigh = p.cur_rate_high

    @inbounds for uidx in p.jumptovars_map[p.next_jump]
        uval = u[uidx]

        # if new u value is outside the bracketing interval
        if uval == zero(uval) || uval < p.ulow[uidx] || uval > p.uhigh[uidx]
            # update u bracketing interval
            ulow, uhigh = get_spec_brackets(p.bracket_data, uidx, uval)
            p.ulow = setindex(p.ulow, ulow, uidx)
            p.uhigh = setindex(p.uhigh, uhigh, uidx)

            # for each dependent jump, update jump rate brackets
            for jidx in p.vartojumps_map[uidx]
                sum_rate -= crhigh[jidx]
                p.cur_rate_low[jidx], crhigh[jidx] = get_jump_brackets(jidx, p, params, t)
                sum_rate += crhigh[jidx]
            end
        end
    end
    p.sum_rate = sum_rate
end

using JumpProcesses, StaticArrays
using Test
using StableRNGs
rng = StableRNG(12345)

reactstoch = [
    [1 => 1]
]

netstoch = [
    [1 => -1]
]

Nsims = 10
rates = [1.0]
dg = [[1]]
majump = MassActionJump(rates, reactstoch, netstoch)
u0 = [100000]
dprob = DiscreteProblem(u0, (0.0, 1e5), rates)
algs = (JumpProcesses.JUMP_AGGREGATORS..., JumpProcesses.NullAggregator())

for n in 1:Nsims
    for ssa in algs
        local jprob = JumpProblem(dprob, ssa, majump, save_positions = (false, false),
            rng = rng)
        local sol = solve(jprob, SSAStepper())
        @test sol[1, end] == 0
        @test sol.t[end] < Inf
    end
end

u0 = SA[10]
dprob = DiscreteProblem(u0, (0.0, 100.0), rates)

for ssa in algs
    local jprob = JumpProblem(dprob, ssa, majump, save_positions = (false, false),
        rng = rng)
    local sol = solve(jprob, SSAStepper(), saveat = 100.0)
    @test sol[1, end] == 0
    @test sol.t[end] < Inf
end

# test callback
Base.@kwdef mutable struct ExtinctionTest
    cnt::Int = 0
end
function (e::ExtinctionTest)(u, t, integrator)
    (e.cnt == 0) && (integrator.cb.affect!.next_jump_time == Inf)
end
function (e::ExtinctionTest)(integrator)
    (saved, savedexactly) = savevalues!(integrator, true)
    @test saved == true
    @test savedexactly == true
    e.cnt += 1
    nothing
end
et = ExtinctionTest()
cb = DiscreteCallback(et, et, save_positions = (false, false))
dprob = DiscreteProblem(u0, (0.0, 1000.0), rates)
jprob = JumpProblem(dprob, Direct(), majump; save_positions = (false, false), rng = rng)
sol = solve(jprob, SSAStepper(), callback = cb, save_end = false)
@test sol.t[end] < 1000.0

# test terminate
function extinction_condition2(u, t, integrator)
    u[1] == 1
end
function extinction_affect!2(integrator)
    (saved, savedexactly) = savevalues!(integrator, true)
    terminate!(integrator)
    nothing
end
cb = DiscreteCallback(extinction_condition2, extinction_affect!2,
    save_positions = (false, false))
dprob = DiscreteProblem(u0, (0.0, 1000.0), rates)
jprob = JumpProblem(dprob, majump; save_positions = (false, false), rng)
sol = solve(jprob; callback = cb, save_end = false)
@test sol[1, end] == 1
@test sol.retcode == ReturnCode.Terminated
@test sol.t[end] < 1000.0

mutable struct DirectJumpAggregation{T, S, F1, F2, RNG} <:
               AbstractSSAJumpAggregator{T, S, F1, F2, RNG}
    next_jump::Int
    prev_jump::Int
    next_jump_time::T
    end_time::T
    cur_rates::Vector{T}
    sum_rate::T
    ma_jumps::S
    rates::F1
    affects!::F2
    save_positions::Tuple{Bool, Bool}
    rng::RNG
end
function DirectJumpAggregation(nj::Int, njt::T, et::T, crs::Vector{T}, sr::T, maj::S,
        rs::F1, affs!::F2, sps::Tuple{Bool, Bool}, rng::RNG;
        kwargs...) where {T, S, F1, F2, RNG}
    affecttype = F2 <: Tuple ? F2 : Any
    DirectJumpAggregation{T, S, F1, affecttype, RNG}(nj, nj, njt, et, crs, sr, maj, rs,
        affs!, sps, rng)
end

############################# Required Functions #############################

# creating the JumpAggregation structure (tuple-based constant jumps)
function aggregate(aggregator::Direct, u, p, t, end_time, constant_jumps,
        ma_jumps, save_positions, rng; kwargs...)

    # handle constant jumps using tuples
    rates, affects! = get_jump_info_tuples(constant_jumps)

    build_jump_aggregation(DirectJumpAggregation, u, p, t, end_time, ma_jumps,
        rates, affects!, save_positions, rng; kwargs...)
end

# creating the JumpAggregation structure (function wrapper-based constant jumps)
function aggregate(aggregator::DirectFW, u, p, t, end_time, constant_jumps,
        ma_jumps, save_positions, rng; kwargs...)

    # handle constant jumps using function wrappers
    rates, affects! = get_jump_info_fwrappers(u, p, t, constant_jumps)

    build_jump_aggregation(DirectJumpAggregation, u, p, t, end_time, ma_jumps,
        rates, affects!, save_positions, rng; kwargs...)
end

# set up a new simulation and calculate the first jump / jump time
function initialize!(p::DirectJumpAggregation, integrator, u, params, t)
    p.end_time = integrator.sol.prob.tspan[2]
    generate_jumps!(p, integrator, u, params, t)
    nothing
end

# execute one jump, changing the system state
@inline function execute_jumps!(p::DirectJumpAggregation, integrator, u, params, t,
        affects!)
    update_state!(p, integrator, u, affects!)
    nothing
end

# calculate the next jump / jump time
function generate_jumps!(p::DirectJumpAggregation, integrator, u, params, t)
    p.sum_rate, ttnj = time_to_next_jump(p, u, params, t)
    p.next_jump_time = add_fast(t, ttnj)
    @inbounds p.next_jump = searchsortedfirst(p.cur_rates, rand(p.rng) * p.sum_rate)
    nothing
end

######################## SSA specific helper routines ########################

# tuple-based constant jumps
function time_to_next_jump(p::DirectJumpAggregation{T, S, F1}, u, params,
        t) where {T, S, F1 <: Tuple}
    prev_rate = zero(t)
    new_rate = zero(t)
    cur_rates = p.cur_rates

    # mass action rates
    majumps = p.ma_jumps
    idx = get_num_majumps(majumps)
    @inbounds for i in 1:idx
        new_rate = evalrxrate(u, i, majumps)
        cur_rates[i] = add_fast(new_rate, prev_rate)
        prev_rate = cur_rates[i]
    end

    # constant jump rates
    rates = p.rates
    if !isempty(rates)
        idx += 1
        fill_cur_rates(u, params, t, cur_rates, idx, rates...)
        @inbounds for i in idx:length(cur_rates)
            cur_rates[i] = add_fast(cur_rates[i], prev_rate)
            prev_rate = cur_rates[i]
        end
    end

    @inbounds sum_rate = cur_rates[end]
    sum_rate, randexp(p.rng) / sum_rate
end

@inline function fill_cur_rates(u, p, t, cur_rates, idx, rate, rates...)
    @inbounds cur_rates[idx] = rate(u, p, t)
    idx += 1
    fill_cur_rates(u, p, t, cur_rates, idx, rates...)
end

@inline function fill_cur_rates(u, p, t, cur_rates, idx, rate)
    @inbounds cur_rates[idx] = rate(u, p, t)
    nothing
end

# function wrapper-based constant jumps
function time_to_next_jump(p::DirectJumpAggregation{T, S, F1}, u, params,
        t) where {T, S, F1 <: AbstractArray}
    prev_rate = zero(t)
    new_rate = zero(t)
    cur_rates = p.cur_rates

    # mass action rates
    majumps = p.ma_jumps
    idx = get_num_majumps(majumps)
    @inbounds for i in 1:idx
        new_rate = evalrxrate(u, i, majumps)
        cur_rates[i] = add_fast(new_rate, prev_rate)
        prev_rate = cur_rates[i]
    end

    # constant jump rates
    idx += 1
    rates = p.rates
    @inbounds for i in 1:length(p.rates)
        new_rate = rates[i](u, params, t)
        cur_rates[idx] = add_fast(new_rate, prev_rate)
        prev_rate = cur_rates[idx]
        idx += 1
    end

    @inbounds sum_rate = cur_rates[end]
    sum_rate, randexp(p.rng) / sum_rate
end

# prepares the problem
using JumpProcesses, Test, SymbolicIndexingInterface
rate1(u, p, t) = p[1]
rate2(u, p, t) = p[2]
affect1!(integ) = (integ.u[1] += 1)
affect2!(integ) = (integ.u[2] += 1)
crj1 = ConstantRateJump(rate1, affect1!)
crj2 = ConstantRateJump(rate2, affect2!)
maj = MassActionJump([[1 => 1], [1 => 1]], [[1 => -1], [1 => -1]]; param_idxs = [1, 2])
g = DiscreteFunction((du, u, p, t) -> nothing;
    sys = SymbolicIndexingInterface.SymbolCache([:a, :b], [:p1, :p2], :t))
dprob = DiscreteProblem(g, [0, 10], (0.0, 10.0), [1.0, 2.0])
jprob = JumpProblem(dprob, Direct(), crj1, crj2, maj)

# test basic querying of u0 and p
@test jprob[:a] == 0
@test jprob[:b] == 10
@test getp(jprob, :p1)(jprob) == 1.0
@test getp(jprob, :p2)(jprob) == 2.0
@test jprob.ps[:p1] == 1.0
@test jprob.ps[:p2] == 2.0

# test updating u0
jprob[:a] = 20
@test jprob[:a] == 20

# test mass action jumps update with parameter mutation in problems
@test jprob.massaction_jump.scaled_rates[1] == 1.0
jprob.ps[:p1] = 3.0
@test jprob.ps[:p1] == 3.0
@test jprob.massaction_jump.scaled_rates[1] == 3.0
p1setter = setp(jprob, [:p1, :p2])
p1setter(jprob, [4.0, 10.0])
@test jprob.ps[:p1] == 4.0
@test jprob.ps[:p2] == 10.0
@test jprob.massaction_jump.scaled_rates == [4.0, 10.0]

# integrator tests
# note that `setu` is not currently supported as `set_u!` is not implemented for SSAStepper
integ = init(jprob, SSAStepper())
@test getu(integ, [:a, :b])(integ) == [20, 10]
integ[[:b, :a]] = [40, 5]
@test getu(integ, [:a, :b])(integ) == [5, 40]
@test getp(integ, :p2)(integ) == 10.0
setp(integ, :p2)(integ, 15.0)
@test getp(integ, :p2)(integ) == 15.0
@test jprob.massaction_jump.scaled_rates[2] == 10.0  # jump rate not updated
reset_aggregated_jumps!(integ)
@test jprob.massaction_jump.scaled_rates[2] == 15.0  # jump rate now updated

# remake tests
dprob = DiscreteProblem(g, [0, 10], (0.0, 10.0), [1.0, 2.0])
jprob = JumpProblem(dprob, Direct(), crj1, crj2, maj)
jprob = remake(jprob; u0 = [:a => -10, :b => 100], p = [:p2 => 3.5, :p1 => 0.5])
@test jprob.prob.u0 == [-10, 100]
@test jprob.prob.p == [0.5, 3.5]
@test jprob.massaction_jump.scaled_rates == [0.5, 3.5]
jprob = remake(jprob; u0 = [:b => 10], p = [:p2 => 4.5])
@test jprob.prob.u0 == [-10, 10]
@test jprob.prob.p == [0.5, 4.5]
@test jprob.massaction_jump.scaled_rates == [0.5, 4.5]

# test updating problems via regular indexing still updates the mass action jump
dprob = DiscreteProblem(g, [0, 10], (0.0, 10.0), [1.0, 2.0])
jprob = JumpProblem(dprob, Direct(), crj1, crj2, maj)
@test jprob.massaction_jump.scaled_rates[1] == 1.0
jprob.ps[1] = 3.0
@test jprob.ps[1] == 3.0
@test jprob.massaction_jump.scaled_rates[1] == 3.0

# test updating integrators via regular indexing
dprob = DiscreteProblem(g, [0, 10], (0.0, 10.0), [1.0, 2.0])
jprob = JumpProblem(dprob, Direct(), crj1, crj2, maj)
integ = init(jprob, SSAStepper())
integ.u .= [40, 5]
@test getu(integ, [1, 2])(integ) == [40, 5]
@test getp(integ, 2)(integ) == 2.0
@test integ.p[2] == 2.0
@test jprob.massaction_jump.scaled_rates[2] == 2.0
setp(integ, 2)(integ, 15.0)
@test integ.p[2] == 15.0
@test getp(integ, 2)(integ) == 15.0
reset_aggregated_jumps!(integ)
@test jprob.massaction_jump.scaled_rates[2] == 15.0  # jump rate now updated

# remake tests for regular indexing
dprob = DiscreteProblem(g, [0, 10], (0.0, 10.0), [1.0, 2.0])
jprob = JumpProblem(dprob, Direct(), crj1, crj2, maj)
jprob = remake(jprob; u0 = [-10, 100], p = [0.5, 3.5])
@test jprob.prob.u0 == [-10, 100]
@test jprob.prob.p == [0.5, 3.5]
@test jprob.massaction_jump.scaled_rates == [0.5, 3.5]
jprob = remake(jprob; u0 = [2 => 10], p = [2 => 4.5])
@test jprob.prob.u0 == [-10, 10]
@test jprob.prob.p == [0.5, 4.5]
@test jprob.massaction_jump.scaled_rates == [0.5, 4.5]

using JumpProcesses, Test, StableRNGs, FunctionWrappers
rng = StableRNG(12345)

# https://github.com/SciML/JumpProcesses.jl/issues/324
let
    rate(u, p, t; debug = true) = 5.0
    function affect!(integrator)
        integrator.u[1] += 1
        nothing
    end
    jump = VariableRateJump(rate, affect!; urate = (u, p, t) -> 10.0,
        rateinterval = (u, p, t) -> 0.1)

    prob = DiscreteProblem([0.0], (0.0, 2.0), [1.0])
    jprob = JumpProblem(prob, Coevolve(), jump; dep_graph = [[1]], rng)
    agg = jprob.discrete_jump_aggregation
    @test agg.affects! isa Vector{Any}

    integ = init(jprob, SSAStepper())
    T = Vector{FunctionWrappers.FunctionWrapper{Nothing, Tuple{typeof(integ)}}}
    @test agg.affects! isa T
    affs = agg.affects!
    sol_c = solve!(integ)

    # check the affects vector is unchanged from a second call
    integ = init(jprob, SSAStepper())
    sol_c = solve!(integ)
    @test affs === agg.affects!

    # check changing the integrator doesn't break things
    terminate_condition(u, t, integrator) = (return u[1] >= 1)
    terminate_affect!(integrator) = terminate!(integrator)
    terminate_cb = DiscreteCallback(terminate_condition, terminate_affect!)
    integ2 = init(jprob, SSAStepper(); callback = terminate_cb)
    T2 = Vector{FunctionWrappers.FunctionWrapper{Nothing, Tuple{typeof(integ2)}}}
    @test T2 !== T
    @test agg.affects! isa T2

    # test the affects! Vector was recreated
    @test affs !== agg.affects!
    affs2 = agg.affects!
    solve!(integ2)

    # check affs2 is unchanged when solving again now
    integ2 = init(jprob, SSAStepper(); callback = terminate_cb)
    solve!(integ2)
    @test affs2 === agg.affects!
end

module JumpProcesses

using Reexport: Reexport, @reexport
@reexport using DiffEqBase

# Explicit imports from standard libraries
using LinearAlgebra: LinearAlgebra, mul!
using Random: Random, randexp, seed!

# Explicit imports from external packages
using DocStringExtensions: DocStringExtensions, FIELDS, TYPEDEF
using DataStructures: DataStructures, MutableBinaryMinHeap, sizehint!, top_with_handle
using PoissonRandom: PoissonRandom, pois_rand
using ArrayInterface: ArrayInterface
using FunctionWrappers: FunctionWrappers
using Graphs: Graphs, AbstractGraph, dst, grid, src
using StaticArrays: StaticArrays, SVector, setindex
using Base.Threads: Threads
using Base.FastMath: add_fast

# Import functions we extend from Base
import Base: size, getindex, setindex!, length, similar, show, merge!, merge

# Import functions we extend from packages
import DiffEqCallbacks: gauss_points, gauss_weights
# Cache gauss quadrature data at module load to avoid type instability from
# non-const gauss_points/gauss_weights globals in DiffEqCallbacks.
const _GAUSS_POINTS = gauss_points[4]
const _GAUSS_WEIGHTS = gauss_weights[4]
import DiffEqBase: DiscreteCallback, init, solve, solve!, initialize!
import SciMLBase: plot_indices
import DataStructures: update!
import Graphs: neighbors, outdegree
import RecursiveArrayTools: recursivecopy!
import SymbolicIndexingInterface as SII

# Import additional types and functions from DiffEqBase and SciMLBase
using DiffEqBase: DiffEqBase, CallbackSet, ContinuousCallback, DAEFunction,
                  DDEFunction, DiscreteProblem, ODEFunction, ODEProblem,
                  ODESolution, ReturnCode, SDEFunction, SDEProblem, add_tstop!,
                  deleteat!, isinplace, remake, savevalues!, step!,
                  u_modified!
using SciMLBase: SciMLBase, DEIntegrator

abstract type AbstractJump end
abstract type AbstractMassActionJump <: AbstractJump end
abstract type AbstractAggregatorAlgorithm end
abstract type AbstractJumpAggregator end
abstract type AbstractSSAIntegrator{Alg, IIP, U, T} <:
              DEIntegrator{Alg, IIP, U, T} end

const DEFAULT_RNG = Random.default_rng()

# thresholds for auto-alg below which the listed alg is used
# see select_aggregator for details
const USE_DIRECT_THRESHOLD = 20
const USE_RSSA_THRESHOLD = 100
const USE_SORTINGDIRECT_THRESHOLD = 200

include("jumps.jl")
export ConstantRateJump, VariableRateJump, RegularJump, MassActionJump, JumpSet

include("massaction_rates.jl")

include("extended_jump_array.jl")
export ExtendedJumpArray

# constant rate aggregators (i.e. SSAs)
include("aggregators/aggregators.jl")
export get_num_majumps, needs_depgraph, needs_vartojumps_map, reset_aggregated_jumps!

include("aggregators/ssajump.jl")

include("aggregators/direct.jl")
export Direct, DirectFW

include("aggregators/frm.jl")
export FRM, FRMFW

include("aggregators/sortingdirect.jl")
export SortingDirect

include("aggregators/nrm.jl")
export NRM

include("aggregators/bracketing.jl")
export BracketData

include("aggregators/rssa.jl")
export RSSA

include("aggregators/prioritytable.jl")

include("aggregators/directcr.jl")
export DirectCR

include("aggregators/rssacr.jl")
export RSSACR

include("aggregators/rdirect.jl")
export RDirect

include("aggregators/coevolve.jl")
export Coevolve

include("aggregators/ccnrm.jl")
export CCNRM

include("aggregators/aggregated_api.jl")

# variable rate aggregators (i.e. SSAs)
include("variable_rate.jl")
export VariableRateAggregator, VR_FRM, VR_Direct, VR_DirectFW

"""
Aggregator to indicate that individual jumps should also be handled via the leaping
algorithm that is passed to solve.
"""
struct PureLeaping <: AbstractAggregatorAlgorithm end
export PureLeaping

# core problem and timestepping
include("problem.jl")
export JumpProblem, SplitCoupledJumpProblem

include("solve.jl")
export init, solve, solve!

include("SSA_stepper.jl")
export SSAStepper

# leaping: 
include("simple_regular_solve.jl")
export SimpleTauLeaping, SimpleExplicitTauLeaping, EnsembleGPUKernel

# spatial:
include("spatial/spatial_massaction_jump.jl")
export SpatialMassActionJump

include("spatial/topology.jl")
export CartesianGrid, CartesianGridRej, outdegree, num_sites, neighbors

include("spatial/hop_rates.jl")
include("spatial/reaction_rates.jl")
include("spatial/flatten.jl")
include("spatial/utils.jl")
include("spatial/bracketing.jl")
include("spatial/nsm.jl")
export NSM

include("spatial/directcrdirect.jl")
export DirectCRDirect

# coupling
include("coupled_array.jl")
include("coupling.jl")

end # module

################## Spatial bracketing ##################

# struct to store brackets like (ulow, uhigh), (rx_rates_low, rx_rates_high), (hop_rates_low, hop_rates_high), (site_rates_low, site_rates_high)
struct LowHigh{T}
    low::T
    high::T

    LowHigh(low::T, high::T) where {T} = new{T}(deepcopy(low), deepcopy(high))
    LowHigh(pair::Tuple{T, T}) where {T} = new{T}(pair[1], pair[2])
    LowHigh(low_and_high::T) where {T} = new{T}(low_and_high, deepcopy(low_and_high))
end

function Base.show(io::IO, ::MIME"text/plain", low_high::LowHigh)
    println(io, "Low: \n $(low_high.low)")
    println(io, "High: \n $(low_high.high)")
end

@inline function update_u_brackets!(u_low_high::LowHigh, bracket_data, u::AbstractMatrix)
    @inbounds for (i, uval) in enumerate(u)
        u_low_high[i] = LowHigh(get_spec_brackets(bracket_data, i, uval))
    end
    nothing
end

### convenience functions for LowHigh ###
function setindex!(low_high::LowHigh, val::LowHigh, i)
    low_high.low[i] = val.low
    low_high.high[i] = val.high
    val
end

function getindex(low_high::LowHigh, i)
    return LowHigh(low_high.low[i], low_high.high[i])
end

function total_site_rate(rx_rates::LowHigh, hop_rates::LowHigh, site)
    return LowHigh(
        total_site_rate(rx_rates.low, hop_rates.low, site),
        total_site_rate(rx_rates.high, hop_rates.high, site))
end

function update_rx_rates!(rx_rates::LowHigh, rxs, u_low_high, integrator, site)
    update_rx_rates!(rx_rates.low, rxs, u_low_high.low, integrator, site)
    update_rx_rates!(rx_rates.high, rxs, u_low_high.high, integrator, site)
end

function update_hop_rates!(hop_rates::LowHigh, species, u_low_high, site, spatial_system)
    update_hop_rates!(hop_rates.low, species, u_low_high.low, site, spatial_system)
    update_hop_rates!(hop_rates.high, species, u_low_high.high, site, spatial_system)
end

using DiffEqBase, Test
using JumpProcesses, OrdinaryDiffEq
using StableRNGs
rng = StableRNG(12345)

sr = [1.0, 2.0, 50.0]
maj = MassActionJump(sr, [[1 => 1], [1 => 1], [0 => 1]], [[1 => 1], [1 => -1], [1 => 1]])
params = (1.0, 2.0, 50.0)
tspan = (0.0, 4.0)
u0 = [5]
dprob = DiscreteProblem(u0, tspan, params)
jprob = JumpProblem(dprob, Direct(), maj; rng = rng)
solve(EnsembleProblem(jprob), SSAStepper(), EnsembleThreads(); trajectories = 10)
solve(EnsembleProblem(jprob; safetycopy = true), SSAStepper(), EnsembleThreads();
    trajectories = 10)

# test for https://github.com/SciML/JumpProcesses.jl/issues/472
let
    function f!(du, u, p, t)
        du[1] = -u[1]
        nothing
    end
    u_0 = [1.0]
    ode_prob = ODEProblem(f!, u_0, (0.0, 10))
    vrj = VariableRateJump((u, p, t) -> 1.0, integrator -> nothing)

    for agg in (VR_FRM(), VR_Direct(), VR_DirectFW())
        jump_prob = JumpProblem(ode_prob, Direct(), vrj; vr_aggregator = agg)
        prob_func(prob, ctx) = deepcopy(prob)
        prob = EnsembleProblem(jump_prob, prob_func = prob_func)
        sol = solve(prob, Tsit5(), EnsembleThreads(), trajectories = 400,
            save_everystep = false)
        firstrx_time = [sol.u[i].t[findfirst(>(sol.u[i].t[1]), sol.u[i].t)] for i in 1:length(sol.u)]
        @test allunique(firstrx_time)
    end
end

# Tests for JumpProblem remake with VariableRateJumps (ExtendedJumpArray case)
# This tests the fix for symbolic u0 with ExtendedJumpArray

using JumpProcesses, OrdinaryDiffEq, Test, SymbolicIndexingInterface
using StableRNGs

@testset "remake JumpProblem with VariableRateJumps (ExtendedJumpArray)" begin
    rng = StableRNG(12345)

    # Setup: Create an ODEProblem with SymbolCache for symbolic indexing
    f(du, u, p, t) = (du .= 0; nothing)
    g = ODEFunction(f; sys = SymbolCache([:X, :Y], [:k1, :k2], :t))
    oprob = ODEProblem(g, [10.0, 5.0], (0.0, 10.0), [1.0, 2.0])

    # Add a VariableRateJump to trigger ExtendedJumpArray
    vr_rate(u, p, t) = p[1] * u[1]
    vr_affect!(integrator) = (integrator.u[1] -= 1; integrator.u[2] += 1)
    vrj = VariableRateJump(vr_rate, vr_affect!)

    jprob = JumpProblem(oprob, vrj; rng)

    # Verify we have ExtendedJumpArray
    @test jprob.prob.u0 isa ExtendedJumpArray
    @test jprob.prob.u0.u == [10.0, 5.0]

    @testset "remake with numeric Vector{Float64}" begin
        original_jump_u = copy(jprob.prob.u0.jump_u)

        prob2 = remake(jprob; u0 = [20.0, 10.0])
        @test prob2.prob.u0 isa ExtendedJumpArray
        @test prob2.prob.u0.u == [20.0, 10.0]
        # jump_u should be resampled (different from original)
        @test prob2.prob.u0.jump_u != original_jump_u
    end

    @testset "remake with ExtendedJumpArray (no resample)" begin
        # User passes ExtendedJumpArray directly - should preserve jump_u
        new_u0 = deepcopy(jprob.prob.u0)
        new_u0.u[1] = 30.0
        original_jump_u = copy(new_u0.jump_u)

        prob2 = remake(jprob; u0 = new_u0)
        @test prob2.prob.u0 isa ExtendedJumpArray
        @test prob2.prob.u0.u[1] == 30.0
        # jump_u should NOT be resampled - user has full control
        @test prob2.prob.u0.jump_u == original_jump_u
    end

    @testset "remake with Symbol pairs" begin
        original_jump_u = copy(jprob.prob.u0.jump_u)

        # This was the FAILING case - should work after fix
        prob2 = remake(jprob; u0 = [:X => 25.0])
        @test prob2.prob.u0 isa ExtendedJumpArray
        @test prob2.prob.u0.u[1] == 25.0
        # jump_u should be resampled
        @test prob2.prob.u0.jump_u != original_jump_u
    end

    @testset "remake with multiple Symbol pairs" begin
        original_jump_u = copy(jprob.prob.u0.jump_u)

        prob2 = remake(jprob; u0 = [:X => 35.0, :Y => 15.0])
        @test prob2.prob.u0 isa ExtendedJumpArray
        @test prob2.prob.u0.u == [35.0, 15.0]
        # jump_u should be resampled
        @test prob2.prob.u0.jump_u != original_jump_u
    end

    @testset "remake with Dict" begin
        original_jump_u = copy(jprob.prob.u0.jump_u)

        prob2 = remake(jprob; u0 = Dict(:X => 40.0))
        @test prob2.prob.u0 isa ExtendedJumpArray
        @test prob2.prob.u0.u[1] == 40.0
        # jump_u should be resampled
        @test prob2.prob.u0.jump_u != original_jump_u
    end

    @testset "remake with parameters only (u0 unchanged)" begin
        original_u0 = deepcopy(jprob.prob.u0)

        prob2 = remake(jprob; p = [:k1 => 5.0])
        @test prob2.prob.u0 isa ExtendedJumpArray
        # u0 should be unchanged (same reference or equal values)
        @test prob2.prob.u0.u == original_u0.u
        @test prob2.prob.u0.jump_u == original_u0.jump_u
    end

    @testset "remake with both u0 and p" begin
        original_jump_u = copy(jprob.prob.u0.jump_u)

        prob2 = remake(jprob; u0 = [:X => 50.0], p = [:k1 => 3.0])
        @test prob2.prob.u0 isa ExtendedJumpArray
        @test prob2.prob.u0.u[1] == 50.0
        @test prob2.prob.p[1] == 3.0
        # jump_u should be resampled
        @test prob2.prob.u0.jump_u != original_jump_u
    end

    @testset "remake preserves problem solvability" begin
        # Ensure remade problems can actually be solved
        prob2 = remake(jprob; u0 = [5.0, 2.0])
        sol = solve(prob2, Tsit5())
        @test SciMLBase.successful_retcode(sol)

        # With symbolic map (after fix)
        prob3 = remake(jprob; u0 = [:X => 8.0])
        sol3 = solve(prob3, Tsit5())
        @test SciMLBase.successful_retcode(sol3)
    end
end

"""
Composition-Rejection Direct Method (DirectCR), implementation combining
features from the original article:
*A constant-time kinetic Monte Carlo algorithm for simulation of large biochemical reaction networks*,
by A. Slepoy, A.P. Thompson and S.J. Plimpton, J. Chem. Phys, 128, 205101 (2008).
and
*Efficient Formulations for Exact Stochastic Simulation of Chemical Systems*,
by S. Mauch and M. Stalzer, ACM Trans. Comp. Biol. and Bioinf., 8, No. 1, 27-35 (2010).
"""

const MINJUMPRATE = 2.0^exponent(1e-12)

mutable struct DirectCRJumpAggregation{T, S, F1, F2, RNG, DEPGR, U <: PriorityTable,
    W <: Function} <:
               AbstractSSAJumpAggregator{T, S, F1, F2, RNG}
    next_jump::Int
    prev_jump::Int
    next_jump_time::T
    end_time::T
    cur_rates::Vector{T}
    sum_rate::T
    ma_jumps::S
    rates::F1
    affects!::F2
    save_positions::Tuple{Bool, Bool}
    rng::RNG
    dep_gr::DEPGR
    minrate::T
    maxrate::T   # initial maxrate only, table can increase beyond it!
    rt::U
    ratetogroup::W
end

function DirectCRJumpAggregation(nj::Int, njt::T, et::T, crs::Vector{T}, sr::T,
        maj::S, rs::F1, affs!::F2, sps::Tuple{Bool, Bool},
        rng::RNG; num_specs, dep_graph = nothing,
        minrate = convert(T, MINJUMPRATE),
        maxrate = convert(T, Inf),
        kwargs...) where {T, S, F1, F2, RNG}

    # a dependency graph is needed and must be provided if there are constant rate jumps
    if dep_graph === nothing
        if (get_num_majumps(maj) == 0) || !isempty(rs)
            error("To use ConstantRateJumps with the DirectCR algorithm a dependency graph must be supplied.")
        else
            dg = make_dependency_graph(num_specs, maj)
        end
    else
        dg = dep_graph

        # make sure each jump depends on itself
        add_self_dependencies!(dg)
    end

    # mapping from jump rate to group id
    minexponent = exponent(minrate)

    # use the largest power of two that is <= the passed in minrate
    minrate = 2.0^minexponent
    ratetogroup = rate -> priortogid(rate, minexponent)

    # construct an empty initial priority table -- we'll reset this in init
    rt = PriorityTable(ratetogroup, zeros(T, 1), minrate, 2 * minrate)

    affecttype = F2 <: Tuple ? F2 : Any
    DirectCRJumpAggregation{T, S, F1, affecttype, RNG, typeof(dg),
        typeof(rt), typeof(ratetogroup)}(nj, nj, njt, et, crs, sr, maj,
        rs, affs!, sps, rng, dg,
        minrate, maxrate, rt,
        ratetogroup)
end

############################# Required Functions ##############################

# creating the JumpAggregation structure (function wrapper-based constant jumps)
function aggregate(aggregator::DirectCR, u, p, t, end_time, constant_jumps,
        ma_jumps, save_positions, rng; kwargs...)

    # handle constant jumps using function wrappers
    rates, affects! = get_jump_info_fwrappers(u, p, t, constant_jumps)

    build_jump_aggregation(DirectCRJumpAggregation, u, p, t, end_time, ma_jumps,
        rates, affects!, save_positions, rng; num_specs = length(u),
        kwargs...)
end

# set up a new simulation and calculate the first jump / jump time
function initialize!(p::DirectCRJumpAggregation, integrator, u, params, t)
    p.end_time = integrator.sol.prob.tspan[2]

    # initialize rates
    fill_rates_and_sum!(p, u, params, t)

    # setup PriorityTable
    reset!(p.rt)
    for (pid, priority) in enumerate(p.cur_rates)
        insert!(p.rt, pid, priority)
    end

    generate_jumps!(p, integrator, u, params, t)
    nothing
end

# execute one jump, changing the system state
function execute_jumps!(p::DirectCRJumpAggregation, integrator, u, params, t, affects!)
    # execute jump
    u = update_state!(p, integrator, u, affects!)

    # update current jump rates
    update_dependent_rates!(p, u, params, t)
    nothing
end

# calculate the next jump / jump time
function generate_jumps!(p::DirectCRJumpAggregation, integrator, u, params, t)
    p.next_jump_time = t + randexp(p.rng) / p.sum_rate

    if p.next_jump_time < p.end_time
        p.next_jump = sample(p.rt, p.cur_rates, p.rng)
    end
    nothing
end

######################## SSA specific helper routines #########################

# recalculate jump rates for jumps that depend on the just executed jump
# requires dependency graph
function update_dependent_rates!(p::DirectCRJumpAggregation, u, params, t)
    (; cur_rates, rates, ma_jumps, rt) = p
    @inbounds dep_rxs = p.dep_gr[p.next_jump]
    num_majumps = get_num_majumps(ma_jumps)

    @inbounds for rx in dep_rxs
        oldrate = cur_rates[rx]

        # update rate
        cur_rates[rx] = calculate_jump_rate(ma_jumps, num_majumps, rates, u, params, t, rx)

        # update table
        update!(rt, rx, oldrate, cur_rates[rx])
    end

    p.sum_rate = groupsum(rt)
    nothing
end

using DiffEqBase, JumpProcesses, Test, StableRNGs

rng = StableRNG(12345)

# test for https://github.com/SciML/JumpProcesses.jl/issues/177
p = [1.0, 2.0, 50.0]
ns = [[1 => 1], [1 => -1], [1 => 1]]
rs = [[1 => 1], [1 => 1], Pair{Int64, Int64}[]]
maj = MassActionJump(p, rs, ns)
u0 = [5]
tspan = (0.0, 2e6)
dt = tspan[2] / 1000
dprob = DiscreteProblem(u0, tspan, p)
jprob = JumpProblem(dprob, Direct(), maj, save_positions = (false, false), rng = rng)
sol = solve(jprob, SSAStepper(), saveat = tspan[1]:dt:tspan[2])
@test length(unique(sol.u[(end - 10):end][:])) > 1

# Sorting Direct Method, implementation following McCollum et al,
# "The sorting direct method for stochastic simulation of biochemical systems with varying reaction execution behavior"
# Comp. Bio. and Chem., 30, pg. 39-49 (2006).

mutable struct SortingDirectJumpAggregation{T, S, F1, F2, RNG, DEPGR} <:
               AbstractSSAJumpAggregator{T, S, F1, F2, RNG}
    next_jump::Int
    prev_jump::Int
    next_jump_time::T
    end_time::T
    cur_rates::Vector{T}
    sum_rate::T
    ma_jumps::S
    rates::F1
    affects!::F2
    save_positions::Tuple{Bool, Bool}
    rng::RNG
    dep_gr::DEPGR
    jump_search_order::Vector{Int}
    jump_search_idx::Int
end

function SortingDirectJumpAggregation(nj::Int, njt::T, et::T, crs::Vector{T}, sr::T,
        maj::S, rs::F1, affs!::F2, sps::Tuple{Bool, Bool},
        rng::RNG; num_specs, dep_graph = nothing,
        kwargs...) where {T, S, F1, F2, RNG}

    # a dependency graph is needed and must be provided if there are constant rate jumps
    if dep_graph === nothing
        if (get_num_majumps(maj) == 0) || !isempty(rs)
            error("To use ConstantRateJumps with the SortingDirect algorithm a dependency graph must be supplied.")
        else
            dg = make_dependency_graph(num_specs, maj)
        end
    else
        dg = dep_graph

        # make sure each jump depends on itself
        add_self_dependencies!(dg)
    end

    # map jump idx to idx in cur_rates
    jtoidx = collect(1:length(crs))
    affecttype = F2 <: Tuple ? F2 : Any
    SortingDirectJumpAggregation{T, S, F1, affecttype, RNG, typeof(dg)}(nj, nj, njt, et,
        crs, sr, maj, rs,
        affs!, sps, rng,
        dg, jtoidx,
        zero(Int))
end

############################# Required Functions ##############################

# creating the JumpAggregation structure (function wrapper-based constant jumps)
function aggregate(aggregator::SortingDirect, u, p, t, end_time, constant_jumps,
        ma_jumps, save_positions, rng; kwargs...)

    # handle constant jumps using function wrappers
    rates, affects! = get_jump_info_fwrappers(u, p, t, constant_jumps)

    build_jump_aggregation(SortingDirectJumpAggregation, u, p, t, end_time, ma_jumps,
        rates, affects!, save_positions, rng; num_specs = length(u),
        kwargs...)
end

# set up a new simulation and calculate the first jump / jump time
function initialize!(p::SortingDirectJumpAggregation, integrator, u, params, t)
    p.end_time = integrator.sol.prob.tspan[2]
    fill_rates_and_sum!(p, u, params, t)
    generate_jumps!(p, integrator, u, params, t)
    nothing
end

# execute one jump, changing the system state
function execute_jumps!(p::SortingDirectJumpAggregation, integrator, u, params, t, affects!)
    # execute jump
    u = update_state!(p, integrator, u, affects!)

    # update search order
    jso = p.jump_search_order
    jsidx = p.jump_search_idx
    if jsidx != 1
        @inbounds tmp = jso[jsidx]
        @inbounds jso[jsidx] = jso[jsidx - 1]
        @inbounds jso[jsidx - 1] = tmp
    end

    # update current jump rates
    update_dependent_rates!(p, u, params, t)
    nothing
end

# calculate the next jump / jump time
function generate_jumps!(p::SortingDirectJumpAggregation, integrator, u, params, t)
    p.next_jump_time = t + randexp(p.rng) / p.sum_rate

    # search for next jump
    if p.next_jump_time < p.end_time
        cur_rates = p.cur_rates
        numjumps = length(cur_rates)
        jso = p.jump_search_order
        rn = p.sum_rate * rand(p.rng)
        @inbounds for idx in 1:numjumps
            rn -= cur_rates[jso[idx]]
            if rn < zero(rn)
                p.jump_search_idx = idx
                break
            end
        end
        @inbounds p.next_jump = jso[p.jump_search_idx]
    end

    nothing
end

using JumpProcesses, DiffEqBase, OrdinaryDiffEq, OrdinaryDiffEqFunctionMap, Statistics
using Test
using StableRNGs
rng = StableRNG(12345)

rate = (u, p, t) -> u
affect! = function (integrator)
    integrator.u += 1
end
jump = ConstantRateJump(rate, affect!)

rate = (u, p, t) -> 0.5u
affect! = function (integrator)
    integrator.u -= 1
end
jump2 = ConstantRateJump(rate, affect!)

prob = DiscreteProblem(1.0, (0.0, 3.0))
jump_prob = JumpProblem(prob, Direct(), jump; rng = rng)

sol = solve(jump_prob, FunctionMap())

# using Plots; plot(sol)

prob = DiscreteProblem(10.0, (0.0, 3.0))
jump_prob = JumpProblem(prob, Direct(), jump, jump2; rng = rng)

sol = solve(jump_prob, FunctionMap())

# plot(sol)

nums = Int[]
@time for i in 1:10000
    local jump_prob = JumpProblem(prob, Direct(), jump, jump2; rng = rng)
    local sol = solve(jump_prob, FunctionMap())
    push!(nums, sol.u[end])
end

@test mean(nums) - 45 < 1

prob = DiscreteProblem(1.0, (0.0, 3.0))
jump_prob = JumpProblem(prob, Direct(), jump, jump2; rng = rng)

sol = solve(jump_prob, FunctionMap())

nums = Int[]
@time for i in 1:10000
    local jump_prob = JumpProblem(prob, Direct(), jump, jump2; rng = rng)
    local sol = solve(jump_prob, FunctionMap())
    push!(nums, sol.u[2])
end

@test sum(nums .== 0) / 10000 - 0.33 < 0.02

using JumpProcesses, DiffEqBase
using Test, LinearAlgebra, Statistics
using StableRNGs
rng = StableRNG(12345)

Nsims = 1000
t_compare = 0.0:10.0:250.0
npts = length(t_compare)

function compute_mean_at_saves(sol, Nsims, npts, species_idx)
    mean_vals = zeros(npts)
    for i in 1:Nsims
        for j in 1:npts
            mean_vals[j] += sol.u[i].u[j][species_idx]
        end
    end
    mean_vals ./= Nsims
end

# SIR model with influx
@testset "SIR Model Correctness" begin
    β = 0.1 / 1000.0
    ν = 0.01
    influx_rate = 1.0
    p = (β, ν, influx_rate)

    # ConstantRateJump formulation for SSAStepper
    rate1(u, p, t) = p[1] * u[1] * u[2]  # β*S*I (infection)
    rate2(u, p, t) = p[2] * u[2]         # ν*I (recovery)
    rate3(u, p, t) = p[3]                # influx_rate (S influx)
    affect1!(integrator) = (integrator.u[1] -= 1; integrator.u[2] += 1; nothing)
    affect2!(integrator) = (integrator.u[2] -= 1; integrator.u[3] += 1; nothing)
    affect3!(integrator) = (integrator.u[1] += 1; nothing)
    jumps = (ConstantRateJump(rate1, affect1!), ConstantRateJump(rate2, affect2!), ConstantRateJump(rate3, affect3!))

    u0 = [999.0, 10.0, 0.0]  # S, I, R
    tspan = (0.0, 250.0)
    prob_disc = DiscreteProblem(u0, tspan, p)
    jump_prob = JumpProblem(prob_disc, Direct(), jumps...; rng, save_positions = (false, false))

    # Solve with SSAStepper (save only at t_compare times)
    sol_direct = solve(EnsembleProblem(jump_prob), SSAStepper(), EnsembleSerial();
        trajectories = Nsims, saveat = t_compare)

    # RegularJump formulation for SimpleTauLeaping
    regular_rate = (out, u, p, t) -> begin
        out[1] = p[1] * u[1] * u[2]
        out[2] = p[2] * u[2]
        out[3] = p[3]
    end
    regular_c = (dc, u, p, t, counts, mark) -> begin
        dc .= 0
        dc[1] = -counts[1] + counts[3]
        dc[2] = counts[1] - counts[2]
        dc[3] = counts[2]
    end
    rj = RegularJump(regular_rate, regular_c, 3)
    jump_prob_tau = JumpProblem(prob_disc, PureLeaping(), rj; rng)

    # Solve with SimpleTauLeaping (save only at t_compare times)
    sol_simple = solve(EnsembleProblem(jump_prob_tau), SimpleTauLeaping(), EnsembleSerial();
        trajectories = Nsims, dt = 0.1, saveat = t_compare)

    # MassActionJump formulation for SimpleExplicitTauLeaping
    reactant_stoich = [[1 => 1, 2 => 1], [2 => 1], Pair{Int, Int}[]]
    net_stoich = [[1 => -1, 2 => 1], [2 => -1, 3 => 1], [1 => 1]]
    param_idxs = [1, 2, 3]
    maj = MassActionJump(reactant_stoich, net_stoich; param_idxs)
    jump_prob_maj = JumpProblem(prob_disc, PureLeaping(), maj; rng)

    # Solve with SimpleExplicitTauLeaping (save only at t_compare times)
    sol_adaptive = solve(EnsembleProblem(jump_prob_maj), SimpleExplicitTauLeaping(), EnsembleSerial();
        trajectories = Nsims, saveat = t_compare)

    # Compute mean I trajectories via direct indexing (I is index 2 in SIR)
    mean_I_direct = compute_mean_at_saves(sol_direct, Nsims, npts, 2)
    mean_I_simple = compute_mean_at_saves(sol_simple, Nsims, npts, 2)
    mean_I_explicit = compute_mean_at_saves(sol_adaptive, Nsims, npts, 2)

    # Compare full mean trajectories across all saved timepoints
    @test all(isapprox.(mean_I_direct, mean_I_simple, rtol = 0.1))
    @test all(isapprox.(mean_I_direct, mean_I_explicit, rtol = 0.1))
end

# SEIR model with exposed compartment
@testset "SEIR Model Correctness" begin
    β = 0.3 / 1000.0
    σ = 0.2
    ν = 0.01
    p = (β, σ, ν)

    # ConstantRateJump formulation for SSAStepper
    rate1(u, p, t) = p[1] * u[1] * u[3]  # β*S*I (infection)
    rate2(u, p, t) = p[2] * u[2]         # σ*E (progression)
    rate3(u, p, t) = p[3] * u[3]         # ν*I (recovery)
    affect1!(integrator) = (integrator.u[1] -= 1; integrator.u[2] += 1; nothing)
    affect2!(integrator) = (integrator.u[2] -= 1; integrator.u[3] += 1; nothing)
    affect3!(integrator) = (integrator.u[3] -= 1; integrator.u[4] += 1; nothing)
    jumps = (ConstantRateJump(rate1, affect1!), ConstantRateJump(rate2, affect2!), ConstantRateJump(rate3, affect3!))

    u0 = [999.0, 0.0, 10.0, 0.0]  # S, E, I, R
    tspan = (0.0, 250.0)
    prob_disc = DiscreteProblem(u0, tspan, p)
    jump_prob = JumpProblem(prob_disc, Direct(), jumps...; rng, save_positions = (false, false))

    # Solve with SSAStepper (save only at t_compare times)
    sol_direct = solve(EnsembleProblem(jump_prob), SSAStepper(), EnsembleSerial();
        trajectories = Nsims, saveat = t_compare)

    # RegularJump formulation for SimpleTauLeaping
    regular_rate = (out, u, p, t) -> begin
        out[1] = p[1] * u[1] * u[3]
        out[2] = p[2] * u[2]
        out[3] = p[3] * u[3]
    end
    regular_c = (dc, u, p, t, counts, mark) -> begin
        dc .= 0.0
        dc[1] = -counts[1]
        dc[2] = counts[1] - counts[2]
        dc[3] = counts[2] - counts[3]
        dc[4] = counts[3]
    end
    rj = RegularJump(regular_rate, regular_c, 3)
    jump_prob_tau = JumpProblem(prob_disc, PureLeaping(), rj; rng)

    # Solve with SimpleTauLeaping (save only at t_compare times)
    sol_simple = solve(EnsembleProblem(jump_prob_tau), SimpleTauLeaping(), EnsembleSerial();
        trajectories = Nsims, dt = 0.1, saveat = t_compare)

    # MassActionJump formulation for SimpleExplicitTauLeaping
    reactant_stoich = [[1 => 1, 3 => 1], [2 => 1], [3 => 1]]
    net_stoich = [[1 => -1, 2 => 1], [2 => -1, 3 => 1], [3 => -1, 4 => 1]]
    param_idxs = [1, 2, 3]
    maj = MassActionJump(reactant_stoich, net_stoich; param_idxs)
    jump_prob_maj = JumpProblem(prob_disc, PureLeaping(), maj; rng)

    # Solve with SimpleExplicitTauLeaping (save only at t_compare times)
    sol_adaptive = solve(EnsembleProblem(jump_prob_maj), SimpleExplicitTauLeaping(), EnsembleSerial();
        trajectories = Nsims, saveat = t_compare)

    # Compute mean I trajectories via direct indexing (I is index 3 in SEIR)
    mean_I_direct = compute_mean_at_saves(sol_direct, Nsims, npts, 3)
    mean_I_simple = compute_mean_at_saves(sol_simple, Nsims, npts, 3)
    mean_I_explicit = compute_mean_at_saves(sol_adaptive, Nsims, npts, 3)

    # Compare full mean trajectories across all saved timepoints
    @test all(isapprox.(mean_I_direct, mean_I_simple, rtol = 0.1))
    @test all(isapprox.(mean_I_direct, mean_I_explicit, rtol = 0.1))
end

# Test zero-rate case for SimpleExplicitTauLeaping
@testset "Zero Rates Test for SimpleExplicitTauLeaping" begin
    # SIR model: S + I -> 2I, I -> R
    reactant_stoch = [[1=>1, 2=>1], [2=>1], Pair{Int,Int}[]]
    net_stoch = [[1=>-1, 2=>1], [2=>-1, 3=>1], []]
    rates = [0.1/1000, 0.05, 0.0]  # beta/N, gamma, dummy rate for empty reaction
    maj = MassActionJump(rates, reactant_stoch, net_stoch)
    u0 = [0, 0, 0]  # All populations zero
    tspan = (0.0, 250.0)
    prob = DiscreteProblem(u0, tspan)
    jump_prob = JumpProblem(prob, PureLeaping(), maj)

    sol = solve(jump_prob, SimpleExplicitTauLeaping(); dtmin = 0.1, saveat=1.0)

    # Check that solution completes and covers tspan
    @test sol.t[end] ≈ 250.0 atol=1e-6
    # Check that state remains zero
    @test all(u == [0, 0, 0] for u in sol.u)
end

# Test PureLeaping aggregator functionality
@testset "PureLeaping Aggregator Tests" begin
    # Test with MassActionJump
    u0 = [10, 5, 0]
    tspan = (0.0, 10.0)
    p = [0.1, 0.2]
    prob = DiscreteProblem(u0, tspan, p)
    
    # Create MassActionJump
    reactant_stoich = [[1 => 1], [1 => 2]]
    net_stoich = [[1 => -1, 2 => 1], [1 => -2, 3 => 1]]
    rates = [0.1, 0.05]
    maj = MassActionJump(rates, reactant_stoich, net_stoich)
    
    # Test PureLeaping JumpProblem creation
    jp_pure = JumpProblem(prob, PureLeaping(), JumpSet(maj); rng)
    @test jp_pure.aggregator isa PureLeaping
    @test jp_pure.discrete_jump_aggregation === nothing
    @test jp_pure.massaction_jump !== nothing
    @test length(jp_pure.jump_callback.discrete_callbacks) == 0
    
    # Test with ConstantRateJump
    rate(u, p, t) = p[1] * u[1]
    affect!(integrator) = (integrator.u[1] -= 1; integrator.u[3] += 1)
    crj = ConstantRateJump(rate, affect!)
    
    jp_pure_crj = JumpProblem(prob, PureLeaping(), JumpSet(crj); rng)
    @test jp_pure_crj.aggregator isa PureLeaping
    @test jp_pure_crj.discrete_jump_aggregation === nothing
    @test length(jp_pure_crj.constant_jumps) == 1
    
    # Test with VariableRateJump
    vrate(u, p, t) = t * p[1] * u[1]
    vaffect!(integrator) = (integrator.u[1] -= 1; integrator.u[3] += 1)
    vrj = VariableRateJump(vrate, vaffect!)
    
    jp_pure_vrj = JumpProblem(prob, PureLeaping(), JumpSet(vrj); rng)
    @test jp_pure_vrj.aggregator isa PureLeaping
    @test jp_pure_vrj.discrete_jump_aggregation === nothing
    @test length(jp_pure_vrj.variable_jumps) == 1
    
    # Test with RegularJump
    function rj_rate(out, u, p, t)
        out[1] = p[1] * u[1]
    end
    
    rj_dc = zeros(3, 1)
    rj_dc[1, 1] = -1
    rj_dc[3, 1] = 1
    
    function rj_c(du, u, p, t, counts, mark)
        mul!(du, rj_dc, counts)
    end
    
    regj = RegularJump(rj_rate, rj_c, 1)
    
    jp_pure_regj = JumpProblem(prob, PureLeaping(), JumpSet(regj); rng)
    @test jp_pure_regj.aggregator isa PureLeaping
    @test jp_pure_regj.discrete_jump_aggregation === nothing
    @test jp_pure_regj.regular_jump !== nothing
    
    # Test mixed jump types
    mixed_jumps = JumpSet(; massaction_jumps = maj, constant_jumps = (crj,), 
        variable_jumps = (vrj,), regular_jumps = regj)
    jp_pure_mixed = JumpProblem(prob, PureLeaping(), mixed_jumps; rng)
    @test jp_pure_mixed.aggregator isa PureLeaping
    @test jp_pure_mixed.discrete_jump_aggregation === nothing
    @test jp_pure_mixed.massaction_jump !== nothing
    @test length(jp_pure_mixed.constant_jumps) == 1
    @test length(jp_pure_mixed.variable_jumps) == 1
    @test jp_pure_mixed.regular_jump !== nothing
    
    # Test spatial system error
    spatial_sys = CartesianGrid((2, 2))
    hopping_consts = [1.0]
    @test_throws ErrorException JumpProblem(prob, PureLeaping(), JumpSet(maj); rng,
                                          spatial_system = spatial_sys)
    @test_throws ErrorException JumpProblem(prob, PureLeaping(), JumpSet(maj); rng,
                                          hopping_constants = hopping_consts)
    
    # Test MassActionJump with parameter mapping
    maj_params = MassActionJump(reactant_stoich, net_stoich; param_idxs = [1, 2])
    jp_params = JumpProblem(prob, PureLeaping(), JumpSet(maj_params); rng)
    scaled_rates = [p[1], p[2]/2]
    @test jp_params.massaction_jump.scaled_rates == scaled_rates
end

# Test that saveat/save_start/save_end control which times are stored in solutions
@testset "Saving Controls" begin
    # Simple birth process for testing SSAStepper save behavior
    birth_rate(u, p, t) = 1.0
    birth_affect!(integrator) = (integrator.u[1] += 1; nothing)
    crj = ConstantRateJump(birth_rate, birth_affect!)
    u0 = [0.0]
    tspan = (0.0, 10.0)
    prob = DiscreteProblem(u0, tspan)

    # SSAStepper with save_positions=(false,false) + saveat: only saveat times stored
    jp = JumpProblem(prob, Direct(), crj; rng, save_positions = (false, false))
    sol = solve(jp, SSAStepper(); saveat = 1.0)
    @test sol.t == collect(0.0:1.0:10.0)

    # SSAStepper with default save_positions + saveat: jump times stored too
    jp2 = JumpProblem(prob, Direct(), crj; rng)
    sol2 = solve(jp2, SSAStepper(); saveat = 1.0)
    @test length(sol2.t) > length(sol.t)

    # --- SimpleTauLeaping save_start/save_end/saveat tests ---
    regular_rate = (out, u, p, t) -> (out[1] = 1.0)
    regular_c = (dc, u, p, t, counts, mark) -> (dc[1] = counts[1])
    rj = RegularJump(regular_rate, regular_c, 1)
    jp_tau = JumpProblem(prob, PureLeaping(), rj; rng)

    # No saveat: stores every dt step (save_start=true, save_end=true by default)
    sol_tau = solve(jp_tau, SimpleTauLeaping(); dt = 1.0)
    @test sol_tau.t == collect(0.0:1.0:10.0)

    # saveat as Number: defaults save_start=true, save_end=true
    sol = solve(jp_tau, SimpleTauLeaping(); dt = 0.1, saveat = 2.0)
    @test sol.t == collect(0.0:2.0:10.0)

    # saveat as Number + save_start=false
    sol = solve(jp_tau, SimpleTauLeaping(); dt = 0.1, saveat = 2.0, save_start = false)
    @test sol.t == collect(2.0:2.0:10.0)

    # saveat as Number + save_end=false
    sol = solve(jp_tau, SimpleTauLeaping(); dt = 0.1, saveat = 2.0, save_end = false)
    @test sol.t == collect(0.0:2.0:8.0)

    # saveat as Number + save_start=false + save_end=false
    sol = solve(jp_tau, SimpleTauLeaping(); dt = 0.1, saveat = 2.0,
        save_start = false, save_end = false)
    @test sol.t == collect(2.0:2.0:8.0)

    # saveat collection including both endpoints: defaults save_start=true, save_end=true
    sol = solve(jp_tau, SimpleTauLeaping(); dt = 0.1, saveat = [0.0, 5.0, 10.0])
    @test sol.t == [0.0, 5.0, 10.0]

    # saveat collection without endpoints: defaults save_start=false, save_end=false
    sol = solve(jp_tau, SimpleTauLeaping(); dt = 0.1, saveat = [2.0, 5.0, 8.0])
    @test sol.t == [2.0, 5.0, 8.0]

    # saveat collection without endpoints + explicit save_start=true, save_end=true
    sol = solve(jp_tau, SimpleTauLeaping(); dt = 0.1, saveat = [2.0, 5.0, 8.0],
        save_start = true, save_end = true)
    @test sol.t == [0.0, 2.0, 5.0, 8.0, 10.0]

    # saveat collection with endpoints + explicit save_start=false, save_end=false
    sol = solve(jp_tau, SimpleTauLeaping(); dt = 0.1, saveat = [0.0, 5.0, 10.0],
        save_start = false, save_end = false)
    @test sol.t == [5.0]

    # saveat unordered collection: should be sorted automatically
    sol = solve(jp_tau, SimpleTauLeaping(); dt = 0.1, saveat = [10.0, 0.0, 5.0])
    @test sol.t == [0.0, 5.0, 10.0]

    # saveat collection with out-of-range times: filtered out
    sol = solve(jp_tau, SimpleTauLeaping(); dt = 0.1, saveat = [-1.0, 5.0, 20.0])
    @test sol.t == [5.0]

    # --- SimpleExplicitTauLeaping save_start/save_end/saveat tests ---
    u0_decay = [100.0]
    prob_decay = DiscreteProblem(u0_decay, tspan)
    reactant_stoich = [[1 => 1]]
    net_stoich = [[1 => -1]]
    maj = MassActionJump([0.1], reactant_stoich, net_stoich)
    jp_explicit = JumpProblem(prob_decay, PureLeaping(), maj; rng)

    # saveat as Number: defaults save_start=true, save_end=true
    sol = solve(jp_explicit, SimpleExplicitTauLeaping(); saveat = 2.0)
    @test sol.t == collect(0.0:2.0:10.0)

    # saveat as Number + save_start=false + save_end=false
    sol = solve(jp_explicit, SimpleExplicitTauLeaping(); saveat = 2.0,
        save_start = false, save_end = false)
    @test sol.t == collect(2.0:2.0:8.0)

    # saveat collection including endpoints
    sol = solve(jp_explicit, SimpleExplicitTauLeaping(); saveat = [0.0, 5.0, 10.0])
    @test sol.t == [0.0, 5.0, 10.0]

    # saveat collection without endpoints + explicit save_start=true, save_end=true
    sol = solve(jp_explicit, SimpleExplicitTauLeaping(); saveat = [2.0, 8.0],
        save_start = true, save_end = true)
    @test sol.t == [0.0, 2.0, 8.0, 10.0]
end

#! format: off

using JumpProcesses, DiffEqBase, SafeTestsets

@time begin
    @time @safetestset "Reaction rates" begin include("reaction_rates.jl") end
    @time @safetestset "Hop rates" begin include("hop_rates.jl") end
    @time @safetestset "Topology" begin include("topology.jl") end
    @time @safetestset "Bracketing" begin include("bracketing.jl") end
    @time @safetestset "Spatial A + B <--> C" begin include("ABC.jl") end
    @time @safetestset "Pure diffusion" begin include("diffusion.jl") end
    @time @safetestset "Spatially Varying Reaction Rates" begin include("spatial_majump.jl") end
end

using JumpProcesses, DiffEqBase
# using BenchmarkTools
using Test, Graphs
using StableRNGs
rng = StableRNG(12345)

Nsims = 100
reltol = 0.05
non_spatial_mean = [65.7395, 65.7395, 434.2605] #mean of 10,000 simulations

dim = 1
linear_size = 5
dims = Tuple(repeat([linear_size], dim))
num_nodes = prod(dims)
starting_site = trunc(Int, (linear_size^dim + 1) / 2)
u0 = [500, 500, 0]
end_time = 10.0
diffusivity = 1.0

domain_size = 1.0 #μ-meter
mesh_size = domain_size / linear_size
# ABC model A + B <--> C
num_species = 3
reactstoch = [[1 => 1, 2 => 1], [3 => 1]]
netstoch = [[1 => -1, 2 => -1, 3 => 1], [1 => 1, 2 => 1, 3 => -1]]
rates = [0.1 / mesh_size, 1.0]
majumps = MassActionJump(rates, reactstoch, netstoch)

# spatial system setup
hopping_rate = diffusivity * (linear_size / domain_size)^2

# Starting state setup
starting_state = zeros(Int, length(u0), num_nodes)
starting_state[:, starting_site] .= u0

tspan = (0.0, end_time)
prob = DiscreteProblem(starting_state, tspan, rates)
hopping_constants = [hopping_rate for i in starting_state]
# algs = [NSM(), DirectCRDirect()]

function get_mean_end_state(jump_prob, Nsims)
    end_state = zeros(size(jump_prob.prob.u0))
    for i in 1:Nsims
        sol = solve(jump_prob, SSAStepper())
        end_state .+= sol.u[end]
    end
    end_state / Nsims
end

# testing
grids = [CartesianGridRej(dims), Graphs.grid(dims)]
jump_problems = JumpProblem[JumpProblem(prob, NSM(), majumps,
                                hopping_constants = hopping_constants,
                                spatial_system = grid,
                                save_positions = (false, false), rng = rng)
                            for grid in grids]
push!(jump_problems,
    JumpProblem(prob, DirectCRDirect(), majumps, hopping_constants = hopping_constants,
        spatial_system = grids[1], save_positions = (false, false), rng = rng))
# setup flattenned jump prob
push!(jump_problems,
    JumpProblem(prob, NRM(), majumps, hopping_constants = hopping_constants,
        spatial_system = grids[1], save_positions = (false, false), rng = rng))
# test
for spatial_jump_prob in jump_problems
    solution = solve(spatial_jump_prob, SSAStepper())
    mean_end_state = get_mean_end_state(spatial_jump_prob, Nsims)
    mean_end_state = reshape(mean_end_state, num_species, num_nodes)
    diff = sum(mean_end_state, dims = 2) - non_spatial_mean
    for (i, d) in enumerate(diff)
        @test abs(d) < reltol * non_spatial_mean[i]
    end
end

#using non-spatial SSAs to get the mean
# non_spatial_rates = [0.1,1.0]
# reactstoch = [[1 => 1, 2 => 1],[3 => 1]]
# netstoch = [[1 => -1, 2 => -1, 3 => 1],[1 => 1, 2 => 1, 3 => -1]]
# majumps = MassActionJump(non_spatial_rates, reactstoch, netstoch)
# non_spatial_prob = DiscreteProblem(u0,(0.0,end_time), non_spatial_rates)
# jump_prob = JumpProblem(non_spatial_prob, Direct(), majumps)
# non_spatial_mean = get_mean_end_state(jump_prob, 10000)

# testing some special cases that can get missed in more complicated tests
# these are more checks for crashes than accuracy
# tests zeroth order mass action reactions and passing just one mass action reaction
# tests FW and tuple based mix of mass action jump / constant jump

using DiffEqBase, JumpProcesses
using Test
using StableRNGs
rng = StableRNG(12345)

doprint = false
#using Plots; plotlyjs()
doplot = false

methods = (JumpProcesses.JUMP_AGGREGATORS..., JumpProcesses.NullAggregator())

# one reaction case, mass action jump, vector of data
rate = [2.0]
rs = [[0 => 1]]
ns = [[1 => 1]]
jump = MassActionJump(rate, rs, ns)
prob = DiscreteProblem([100], (0.0, 100.0))
jump_prob = JumpProblem(prob, Direct(), jump; rng = rng)
sol = solve(jump_prob, SSAStepper())
if doprint
    println("mass act jump using vectors of data: last val = ", sol[end, end])
end
if doplot
    plothand = plot(sol, lab = "vec, 0=>1")
end
@test sol[end, end] > 200

# one reaction case, mass action jump, data as scalars
rate = 2.0
rs = [0 => 3]                   # stoich power should be ignored
ns = [1 => 1]
jump = MassActionJump(rate, rs, ns)
jump_prob = JumpProblem(prob, Direct(), jump; rng = rng)
sol = solve(jump_prob, SSAStepper())
if doprint
    println("mass act jump using scalar data: last val = ", sol[end, end])
end
if doplot
    plot!(plothand, sol, lab = "scalar, 0=>1")
end
@test sol[end, end] > 200

# one reaction case, mass action jump, vector of empty data
rate = [2.0]
rs = [Vector{Pair{Int, Int}}()]
ns = [[1 => 1]]
jump = MassActionJump(rate, rs, ns)
prob = DiscreteProblem([100], (0.0, 100.0))
jump_prob = JumpProblem(prob, Direct(), jump; rng = rng)
sol = solve(jump_prob, SSAStepper())
if doprint
    println("mass act jump using vector of Pair{Int,Int}: last val = ", sol[end, end])
end
if doplot
    plot!(plothand, sol, lab = "vec, ()")
end
@test sol[end, end] > 200

# one reaction case, mass action jump, data as scalars
rate = 2.0
rs = Vector{Pair{Int, Int}}()
ns = [1 => 1]
jump = MassActionJump(rate, rs, ns)
jump_prob = JumpProblem(prob, Direct(), jump; rng = rng)
sol = solve(jump_prob, SSAStepper())
if doprint
    println("mass act jump using scalar Pair{Int,Int}: last val = ", sol[end, end])
end
if doplot
    plot!(plothand, sol, lab = "scalar, ()")
end
@test sol[end, end] > 200

# mix two rx types
# 0 -> A and A -> 0
rate = 600.0
rs = [0 => 3]                   # stoich power should be ignored
ns = [1 => 1]
jump = MassActionJump(rate, rs, ns)
ratefun = (u, p, t) -> 2.0 * u[1]
affect! = function (integrator)
    integrator.u[1] -= 1
end
jump2 = ConstantRateJump(ratefun, affect!)
if doplot
    plothand2 = plot(reuse = false)
end

dep_graph = [
    [1, 2],
    [1, 2]
]
spec_to_dep_jumps = [[2]]
jump_to_dep_specs = [[1], [1]]
namedpars = (dep_graph = dep_graph, vartojumps_map = spec_to_dep_jumps, jumptovars_map = jump_to_dep_specs)

for method in methods
    local jump_prob = JumpProblem(prob, method, jump, jump2; rng = rng, namedpars...)
    local sol = solve(jump_prob, SSAStepper())

    if doplot
        plot!(plothand2, sol, label = ("A <-> 0, " * string(method)))
    end

    if doprint
        println("Mix of constant and mass action jumps, method = ", typeof(method), ", sol[end] = ", sol[end, end])
    end
    @test sol[end, end] > 200
end

if doplot
    display(plothand)
    display(plothand2)
end

# check MassActionJump with parameters merge together correctly
rs1 = [1 => 1]
rs2 = [2 => 1]
ns1 = [1 => -1, 2 => 1]
ns2 = [1 => 1, 2 => -1]
p = [1.0, 0.0]
maj1 = MassActionJump(rs1, ns1; param_idxs = 1)
maj2 = MassActionJump(rs2, ns2; param_idxs = 2)
js = JumpSet(maj1, maj2)
maj = MassActionJump([rs1, rs2], [ns1, ns2]; param_idxs = [1, 2])
@test all(getfield(maj, fn) == getfield(js.massaction_jump, fn)
for fn in [:scaled_rates, :reactant_stoch, :net_stoch])
@test all(maj.param_mapper.param_idxs .== js.massaction_jump.param_mapper.param_idxs)
maj1 = MassActionJump([rs1], [ns1]; param_idxs = [1])
maj2 = MassActionJump([rs2], [ns2]; param_idxs = [2])
js = JumpSet(maj1, maj2)
@test all(getfield(maj, fn) == getfield(js.massaction_jump, fn)
for fn in [:scaled_rates, :reactant_stoch, :net_stoch])
@test all(maj.param_mapper.param_idxs .== js.massaction_jump.param_mapper.param_idxs)

using JumpProcesses, OrdinaryDiffEq, Test, SciMLBase
using StableRNGs
rng = StableRNG(12345)

# test that we only save when a jump occurs
let
    for alg in (Coevolve(),)
        u0 = [0]
        tspan = (0.0, 30.0)

        dprob = DiscreteProblem(u0, tspan)
        # set the rate to 0, so that no jump ever occurs; but urate is positive so
        # Coevolve will consider many candidates before the end of the simmulation.
        # None of these points should be saved.
        jump = VariableRateJump((u, p, t) -> 0, (integrator) -> integrator.u[1] += 1;
            urate = (u, p, t) -> 1.0, rateinterval = (u, p, t) -> 5.0)
        jumpproblem = JumpProblem(dprob, alg, jump; dep_graph = [[1]],
            save_positions = (false, true), rng)
        sol = solve(jumpproblem, SSAStepper())
        @test sol.t == [0.0, 30.0]

        oprob = ODEProblem((du, u, p, t) -> 0, u0, tspan)
        jump = VariableRateJump((u, p, t) -> 0, (integrator) -> integrator.u[1] += 1;
            urate = (u, p, t) -> 1.0, rateinterval = (u, p, t) -> 5.0)

        for vr_agg in (VR_FRM(), VR_Direct(), VR_DirectFW())
            jumpproblem = JumpProblem(
                oprob, alg, jump; vr_aggregator = vr_agg, dep_graph = [[1]],
                save_positions = (false, true), rng)
            sol = solve(jumpproblem, Tsit5(); save_everystep = false)
            @test sol.t == [0.0, 30.0]
        end
    end
end

# test isdenseplot gives correct values for SSAStepper and non-SSAStepper models
let
    rate(u, p, t) = max(u[1], 0.0)
    affect!(integ) = (integ.u[1] -= 1; nothing)
    crj = ConstantRateJump(rate, affect!)
    u0 = [10.0]
    tspan = (0.0, 10.0)
    dprob = DiscreteProblem(u0, tspan)
    sps = ((true, true), (true, false), (false, true), (false, false))

    # for pure jump problems dense = save_everystep
    vals = (true, true, true, false)
    for (sp, val) in zip(sps, vals)
        jprob = JumpProblem(dprob, Direct(), crj; save_positions = sp, rng)
        sol = solve(jprob, SSAStepper())
        @test SciMLBase.isdenseplot(sol) == val
    end

    # for mixed problems sol.dense currently ignores save_positions
    oprob = ODEProblem((du, u, p, t) -> du[1] = 0.1, u0, tspan)
    for sp in sps
        jprob = JumpProblem(oprob, Direct(), crj; save_positions = sp, rng)
        sol = solve(jprob, Tsit5())
        @test sol.dense == true
        @test SciMLBase.isdenseplot(sol) == true

        sol = solve(jprob, Tsit5(); dense = false)
        @test sol.dense == false
        @test SciMLBase.isdenseplot(sol) == false
    end
end

module JumpProcessesKernelAbstractionsExt

using JumpProcesses, SciMLBase
using KernelAbstractions, Adapt
using StaticArrays
using PoissonRandom, Random

function SciMLBase.__solve(ensembleprob::SciMLBase.AbstractEnsembleProblem,
        alg::SimpleTauLeaping,
        ensemblealg::EnsembleGPUKernel;
        trajectories,
        seed = nothing,
        dt = error("dt is required for SimpleTauLeaping."),
        kwargs...)
    if trajectories == 1
        return SciMLBase.__solve(ensembleprob, alg, EnsembleSerial(); trajectories = 1,
            seed, dt, kwargs...)
    end

    ensemblealg.backend === nothing ? backend = CPU() :
    backend = ensemblealg.backend

    jump_prob = ensembleprob.prob

    # Validate that this is a PureLeaping JumpProblem
    JumpProcesses.validate_pure_leaping_inputs(jump_prob, alg) ||
        error("SimpleTauLeaping can only be used with PureLeaping JumpProblems with only non-RegularJumps.")
    prob = jump_prob.prob

    probs = [remake(jump_prob) for _ in 1:trajectories]

    # Run vectorized solve
    ts,
    us = vectorized_solve(
        probs, jump_prob, SimpleTauLeaping(); backend, trajectories, seed, dt)

    # Convert to CPU for inspection
    _ts = Array(ts)
    _us = Array(us)

    time = @elapsed sol = [begin
                               ts = @view _ts[:, i]
                               us = @view _us[:, :, i]
                               sol_idx = findlast(x -> x != probs[i].prob.tspan[1], ts)
                               if sol_idx === nothing
                                   @error "No solution found" tspan=probs[i].tspan[1] ts
                                   error("Batch solve failed")
                               end
                               @views ensembleprob.output_func(
                                   SciMLBase.build_solution(probs[i].prob,
                                       alg,
                                       ts[1:sol_idx],
                                       [us[j, :] for j in 1:sol_idx],
                                       k = nothing,
                                       stats = nothing,
                                       calculate_error = false,
                                       retcode = sol_idx !=
                                                 length(ts) ?
                                                 ReturnCode.Terminated :
                                                 ReturnCode.Success),
                                   i)[1]
                           end
                           for i in eachindex(probs)]
    return SciMLBase.EnsembleSolution(sol, time, true)
end

# Define an immutable struct to hold trajectory-specific data
struct TrajectoryData{U <: StaticArray, P, T}
    u0::U
    p::P
    tspan::Tuple{T, T}
end

# Define an immutable struct to hold common jump data
struct JumpData{R, C}
    rate::R
    c::C
    numjumps::Int
end

# SimpleTauLeaping kernel
@kernel function simple_tau_leaping_kernel(
        @Const(probs_data), _us, _ts, dt, @Const(rj_data),
        current_u_buf, rate_cache_buf, counts_buf, local_dc_buf,
        seed::UInt64)
    i = @index(Global, Linear)

    # Get thread-local buffers
    @inbounds begin
        current_u = view(current_u_buf, :, i)
        rate_cache = view(rate_cache_buf, :, i)
        counts = view(counts_buf, :, i)
        local_dc = view(local_dc_buf, :, i)
    end

    # Get problem data
    @inbounds prob_data = probs_data[i]
    u0 = prob_data.u0
    p = prob_data.p
    tspan = prob_data.tspan

    # Extract jump data
    rate = rj_data.rate
    num_jumps = rj_data.numjumps
    c = rj_data.c

    # Initialize current_u from u0
    @inbounds for k in 1:length(u0)
        current_u[k] = u0[k]
    end

    n = Int((tspan[2] - tspan[1]) / dt) + 1
    state_dim = length(u0)

    # Get input/output arrays
    ts_view = @inbounds view(_ts, :, i)
    us_view = @inbounds view(_us,:,:,i)

    # Initialize first time step and state
    @inbounds ts_view[1] = tspan[1]
    @inbounds for k in 1:state_dim
        us_view[1, k] = current_u[k]
    end

    # Main loop
    for j in 2:n
        tprev = tspan[1] + (j-2) * dt

        # Compute rates and scale by dt
        rate(rate_cache, current_u, p, tprev)
        rate_cache .*= dt

        # Poisson sampling
        @inbounds for k in 1:num_jumps
            counts[k] = pois_rand(PoissonRandom.PassthroughRNG(), rate_cache[k])
        end

        # Apply changes
        c(local_dc, current_u, p, tprev, counts, nothing)
        current_u .+= local_dc

        # Store results
        @inbounds for k in 1:state_dim
            us_view[j, k] = current_u[k]
        end
        @inbounds ts_view[j] = tspan[1] + (j-1) * dt
    end
end

# Vectorized solve function
function vectorized_solve(probs, prob::JumpProblem, alg::SimpleTauLeaping;
        backend, trajectories, seed, dt, kwargs...)
    # Extract common jump data
    rj = prob.regular_jump
    rj_data = JumpData(rj.rate, rj.c, rj.numjumps)

    # Extract trajectory-specific data without static typing
    probs_data = [TrajectoryData(SA{eltype(p.prob.u0)}[p.prob.u0...], p.prob.p, p.prob.tspan)
                  for p in probs]

    # Adapt to GPU
    probs_data_gpu = adapt(backend, probs_data)
    rj_data_gpu = adapt(backend, rj_data)

    # Extract problem parameters
    state_dim = length(first(probs_data).u0)
    tspan = prob.prob.tspan
    dt = Float64(dt)
    n_steps = Int((tspan[2] - tspan[1]) / dt) + 1
    n_trajectories = length(probs)
    num_jumps = rj_data.numjumps

    # Validate dimensions
    @assert state_dim > 0 "Dimension of state must be positive"
    @assert num_jumps >= 0 "Number of jumps must be positive"

    # Allocate time and state arrays
    ts = allocate(backend, eltype(prob.prob.tspan), (n_steps, n_trajectories))
    us = allocate(backend, eltype(prob.prob.u0), (n_steps, state_dim, n_trajectories))

    # Pre-allocate thread-local buffers
    current_u_buf = allocate(backend, eltype(prob.prob.u0), (state_dim, n_trajectories))
    rate_cache_buf = allocate(backend, eltype(prob.prob.u0), (num_jumps, n_trajectories))
    counts_buf = allocate(backend, eltype(prob.prob.u0), (num_jumps, n_trajectories))
    local_dc_buf = allocate(backend, eltype(prob.prob.u0), (state_dim, n_trajectories))

    # Initialize current_u_buf with u0 values
    @kernel function init_buffers_kernel(@Const(probs_data), current_u_buf)
        i = @index(Global, Linear)
        @inbounds u0 = probs_data[i].u0
        @inbounds for k in 1:length(u0)
            current_u_buf[k, i] = u0[k]
        end
    end
    init_kernel = init_buffers_kernel(backend)
    init_event = init_kernel(probs_data_gpu, current_u_buf; ndrange = n_trajectories)
    KernelAbstractions.synchronize(backend)

    # Seed for Poisson sampling
    seed = seed === nothing ? UInt64(12345) : UInt64(seed);

    # Launch main kernel
    kernel = simple_tau_leaping_kernel(backend)
    main_event = kernel(probs_data_gpu, us, ts, dt, rj_data_gpu,
        current_u_buf, rate_cache_buf, counts_buf, local_dc_buf, seed;
        ndrange = n_trajectories)
    KernelAbstractions.synchronize(backend)

    return ts, us
end

end

using DiffEqBase, JumpProcesses
using Test
const DJ = JumpProcesses

# test data
minpriority = 2.0^exponent(1e-12)
maxpriority = 2.0^exponent(1e12)
priorities = [1e-13, 0.99 * minpriority, minpriority, 1.01e-4, 1e-4, 5.0, 0.0, 1e10]

mingid = exponent(minpriority)   # = -40
ptog = priority -> DJ.priortogid(priority, mingid)
pt = DJ.PriorityTable(ptog, priorities, minpriority, maxpriority)

#display(priorities)
#display(pt)

# test insert
grpcnt = DJ.numgroups(pt)
push!(priorities, maxpriority * 0.99)
DJ.insert!(pt, length(priorities), priorities[end])
@test grpcnt == DJ.numgroups(pt)
@test pt.groups[end].pids[1] == length(priorities)

push!(priorities, maxpriority * 0.99999)
DJ.insert!(pt, length(priorities), priorities[end])
@test grpcnt == DJ.numgroups(pt)
@test pt.groups[end].pids[2] == length(priorities)

numsmall = length(pt.groups[2].pids)
push!(priorities, minpriority * 0.6)
DJ.insert!(pt, length(priorities), priorities[end])
@test grpcnt == DJ.numgroups(pt)
@test pt.groups[2].pids[end] == length(priorities)

push!(priorities, maxpriority)
DJ.insert!(pt, length(priorities), priorities[end])
@test grpcnt == DJ.numgroups(pt) - 1
@test pt.groups[end].pids[1] == length(priorities)

# test updating
DJ.update!(pt, 5, priorities[5], 2 * priorities[5])   # group 29
priorities[5] *= 2
@test pt.groups[29].numpids == 1
@test pt.groups[30].numpids == 1

DJ.update!(pt, 9, priorities[9], maxpriority * 1.01)
priorities[9] = maxpriority * 1.01
@test pt.groups[end].numpids == 2
@test pt.groups[end - 1].numpids == 1

DJ.update!(pt, 10, priorities[10], 0.0)
priorities[10] = 0.0
@test pt.groups[1].numpids == 2

# test sampling
cnt = 0
Nsamps = Int(1e7)
for i in 1:Nsamps
    global cnt
    pid = DJ.sample(pt, priorities)
    (pid == 8) && (cnt += 1)
end
@test abs(cnt // Nsamps - 0.008968535978248484) / 0.008968535978248484 < 0.05

##### PRIORITY TIME TABLE TESTS FOR CCNRM
mintime = 0.0;
maxtime = 100.0;
timestep = 1.5 / 16;
times = [2.0, 8.0, 13.0, 15.0, 74.0]

ptt = DJ.PriorityTimeTable(times, mintime, timestep)
@test DJ.getfirst(ptt) == (1, 2.0)
@test ptt.pidtogroup[5] == (0, 0) # Should not store the last one, outside the window.

# Test update
DJ.update!(ptt, 1, times[1], 10 * times[1]) # 2. -> 20., group 2 to group 14
@test ptt.groups[14].numpids == 1
@test DJ.getfirst(ptt) == (2, 8.0)
# Updating beyond the time window should not change the max priority. 
DJ.update!(ptt, 1, times[1], 70.0) # 20. -> 70.
@test ptt.groups[14].numpids == 0
@test ptt.maxtime == 66.0
@test ptt.pidtogroup[1] == (0, 0)

# Test rebuild
for i in 1:4
    DJ.update!(ptt, i, times[i], times[i] + 66.0)
end
@test DJ.getfirst(ptt) === (0, 0) # No more left.

mintime = 66.0;
timestep = 0.75 / 16;
DJ.rebuild!(ptt, mintime, timestep)
@test ptt.groups[11].numpids == 2 # 73.5-74.25
@test ptt.groups[18].numpids == 1
@test ptt.groups[21].numpids == 1
@test ptt.pidtogroup[1] == (0, 0)

using JumpProcesses, OrdinaryDiffEq, Test

# Reaction: 3X → Y (third-order, factorial(3) = 6)
# reactant_stoch: species 1 consumed with stoichiometry 3
# net_stoch: species 1 loses 3, species 2 gains 1
reactant_stoch = [[1 => 3]]
net_stoch = [[1 => -3, 2 => 1]]

# Custom mapper mimicking MTKBase's JumpSysMajParamMapper.
# The initial rates callable always pre-scales (simulating symbolic expressions that
# already contain the combinatoric factor, e.g. k/3! for 3X → Y).
# The update callable also pre-scales, then conditionally applies scalerates! based on
# scale_rates — matching MTKBase's behavior. This is what makes the test an actual
# regression test: with the old default of scale_rates=true, the second scalerates!
# would double-scale.
struct PreScaledMapper
    param_idxs::Vector{Int}
    reactant_stoch::Vector{Vector{Pair{Int, Int}}}
end
function (m::PreScaledMapper)(params)
    rates = [params[i] for i in m.param_idxs]
    JumpProcesses.scalerates!(rates, m.reactant_stoch)
    rates
end
function (m::PreScaledMapper)(maj::MassActionJump, newparams; scale_rates, kwargs...)
    for i in 1:JumpProcesses.get_num_majumps(maj)
        maj.scaled_rates[i] = newparams[m.param_idxs[i]]
    end
    JumpProcesses.scalerates!(maj.scaled_rates, m.reactant_stoch)
    scale_rates && JumpProcesses.scalerates!(maj.scaled_rates, maj.reactant_stoch)
    nothing
end
JumpProcesses.to_collection(m::PreScaledMapper) = m
function Base.merge!(m1::PreScaledMapper, m2::PreScaledMapper)
    append!(m1.param_idxs, m2.param_idxs)
    append!(m1.reactant_stoch, m2.reactant_stoch)
end

# Test 1: rescale_rates_on_update field is stored correctly
@testset "rescale_rates_on_update field storage" begin
    # Default: scale_rates = true → rescale_rates_on_update = true
    maj = MassActionJump([6.0], reactant_stoch, net_stoch)
    @test maj.rescale_rates_on_update == true
    @test maj.scaled_rates[1] ≈ 1.0  # 6.0 / 3! = 1.0

    # Explicit: scale_rates = false → rescale_rates_on_update = false
    maj = MassActionJump([6.0], reactant_stoch, net_stoch; scale_rates = false)
    @test maj.rescale_rates_on_update == false
    @test maj.scaled_rates[1] ≈ 6.0  # no scaling

    # Parameterized
    maj = MassActionJump(reactant_stoch, net_stoch; param_idxs = [1])
    @test maj.rescale_rates_on_update == true
end

# Test 2: update_parameters! respects stored rescale_rates_on_update
@testset "update_parameters! respects rescale_rates_on_update" begin
    # With param_idxs and scale_rates = true (default) — built-in mapper path
    p = [6.0]
    maj = MassActionJump(reactant_stoch, net_stoch; param_idxs = [1])
    dprob = DiscreteProblem([100, 0], (0.0, 1.0), p)
    jprob = JumpProblem(dprob, Direct(), maj)
    @test jprob.massaction_jump.rescale_rates_on_update == true
    @test jprob.massaction_jump.scaled_rates[1] ≈ 1.0  # 6.0 / 3!

    # update_parameters! should scale (rescale_rates_on_update = true from struct)
    JumpProcesses.update_parameters!(jprob.massaction_jump, [12.0])
    @test jprob.massaction_jump.scaled_rates[1] ≈ 2.0  # 12.0 / 3!
end

# Test 3: Custom pre-scaled mapper with scale_rates = false — the bug reproducer
@testset "Pre-scaled mapper with scale_rates=false (bug reproducer)" begin
    mapper = PreScaledMapper([1], reactant_stoch)
    k = 6.0
    p = [k]

    maj = MassActionJump(reactant_stoch, net_stoch; param_mapper = mapper, scale_rates = false)
    dprob = DiscreteProblem([100, 0], (0.0, 100.0), p)
    jprob = JumpProblem(dprob, Direct(), maj; scale_rates = false)

    expected_scaled = k / factorial(3)  # 1.0
    @test jprob.massaction_jump.scaled_rates[1] ≈ expected_scaled
    @test jprob.massaction_jump.rescale_rates_on_update == false

    # Test reset_aggregated_jumps! does NOT double-scale
    integ = init(jprob, SSAStepper())
    integ.p[1] = 18.0
    reset_aggregated_jumps!(integ)
    new_expected = 18.0 / factorial(3)  # 3.0, NOT 3.0/6 = 0.5
    @test jprob.massaction_jump.scaled_rates[1] ≈ new_expected

    # Test remake does NOT double-scale
    jprob2 = remake(jprob; p = [24.0])
    remake_expected = 24.0 / factorial(3)  # 4.0, NOT 4.0/6 ≈ 0.667
    @test jprob2.massaction_jump.scaled_rates[1] ≈ remake_expected

    # Test remake round-trip
    jprob3 = remake(jprob2; p = [k])
    @test jprob3.massaction_jump.scaled_rates[1] ≈ expected_scaled
end

# Test 4: Callback parameter changes with built-in mapper (rescale_rates_on_update = true)
@testset "Callback with built-in mapper" begin
    p = [6.0]
    maj = MassActionJump(reactant_stoch, net_stoch; param_idxs = [1])
    dprob = DiscreteProblem([100, 0], (0.0, 2000.0), p)
    jprob = JumpProblem(dprob, Direct(), maj; save_positions = (false, false))

    condit(u, t, integrator) = t == 1000.0
    function affect!(integrator)
        integrator.p[1] = 24.0
        reset_aggregated_jumps!(integrator)
    end
    cb = DiscreteCallback(condit, affect!)
    sol = solve(jprob, SSAStepper(); tstops = [1000.0], callback = cb)
    @test jprob.massaction_jump.scaled_rates[1] ≈ 4.0  # 24.0 / 3!
end

# Test 5: rescale_rates_on_update propagated through JumpSet merge and JumpProblem varargs
# Use explicit-rate MAJs since the JumpSet vector merge path doesn't support
# parameterized (Nothing-rated) MAJs.
@testset "rescale_rates_on_update propagated through merge paths" begin
    reactant_stoch2 = [[2 => 3]]
    net_stoch2 = [[2 => -3, 1 => 1]]

    # --- JumpSet merge path ---

    # Two MAJs with matching rescale_rates_on_update = false (rates already scaled)
    maj1 = MassActionJump([1.0], reactant_stoch, net_stoch; scale_rates = false)
    maj2 = MassActionJump([2.0], reactant_stoch2, net_stoch2; scale_rates = false)
    jset = JumpSet(; massaction_jumps = [maj1, maj2])
    @test jset.massaction_jump.rescale_rates_on_update == false

    # Two MAJs with matching rescale_rates_on_update = true (rates get scaled)
    maj3 = MassActionJump([6.0], reactant_stoch, net_stoch)  # scale_rates = true (default)
    maj4 = MassActionJump([12.0], reactant_stoch2, net_stoch2)
    jset2 = JumpSet(; massaction_jumps = [maj3, maj4])
    @test jset2.massaction_jump.rescale_rates_on_update == true

    # Mismatched rescale_rates_on_update via JumpSet — should error
    maj_true = MassActionJump([6.0], reactant_stoch, net_stoch)  # rescale = true
    maj_false = MassActionJump([1.0], reactant_stoch2, net_stoch2; scale_rates = false)  # rescale = false
    @test_throws ErrorException JumpSet(; massaction_jumps = [maj_true, maj_false])

    # --- JumpProblem varargs path (split_jumps → massaction_jump_combine) ---

    dprob = DiscreteProblem([100, 100], (0.0, 1.0), [1.0, 1.0])

    # Two MAJs with matching rescale_rates_on_update = false via JumpProblem varargs
    maj_f1 = MassActionJump([1.0], reactant_stoch, net_stoch; scale_rates = false)
    maj_f2 = MassActionJump([2.0], reactant_stoch2, net_stoch2; scale_rates = false)
    jprob_f = JumpProblem(dprob, Direct(), maj_f1, maj_f2; scale_rates = false)
    @test jprob_f.massaction_jump.rescale_rates_on_update == false

    # Two MAJs with matching rescale_rates_on_update = true via JumpProblem varargs
    maj_t1 = MassActionJump([6.0], reactant_stoch, net_stoch)
    maj_t2 = MassActionJump([12.0], reactant_stoch2, net_stoch2)
    jprob_t = JumpProblem(dprob, Direct(), maj_t1, maj_t2)
    @test jprob_t.massaction_jump.rescale_rates_on_update == true

    # Mismatched rescale_rates_on_update via JumpProblem varargs — should error
    @test_throws ErrorException JumpProblem(dprob, Direct(), maj_true, maj_false)
end

# define new aggregator algorithms here and specify their properties

# Direct type methods

"""
Gillespie's Direct method. `ConstantRateJump` rates and affects are stored in
tuples. Fastest for a small (total) number of `ConstantRateJump`s or
`MassActionJump`s (~10). For larger numbers of possible jumps, use other
methods.

Daniel T. Gillespie, A general method for numerically simulating the stochastic
time evolution of coupled chemical reactions, Journal of Computational Physics,
22 (4), 403–434 (1976). doi:10.1016/0021-9991(76)90041-3.
"""
struct Direct <: AbstractAggregatorAlgorithm end

"""
Gillespie's Direct method. `ConstantRateJump` rates and affects are stored via
`FunctionWrappers`, which is more performant than `Direct` for very large
numbers of `ConstantRateJump`s. However, for such large numbers of jump
different classes of aggregators are usually much more performant (i.e.
`SortingDirect`, `DirectCR`, `RSSA` or `RSSACR`).

Daniel T. Gillespie, A general method for numerically simulating the stochastic
time evolution of coupled chemical reactions, Journal of Computational Physics,
22 (4), 403–434 (1976). doi:10.1016/0021-9991(76)90041-3.
"""
struct DirectFW <: AbstractAggregatorAlgorithm end

"""
The Composition-Rejection Direct method. Performs best relative to other methods
for systems with large numbers of jumps with special structure (for example a
linear chain of reactions, or jumps corresponding to particles hopping on a grid
or graph).

A. Slepoy, A.P. Thompson and S.J. Plimpton, A constant-time kinetic Monte
Carlo algorithm for simulation of large biochemical reaction networks, Journal
of Chemical Physics, 128 (20), 205101 (2008). doi:10.1063/1.2919546.

S. Mauch and M. Stalzer, Efficient formulations for exact stochastic
simulation of chemical systems, ACM Transactions on Computational Biology and
Bioinformatics, 8 (1), 27-35 (2010). doi:10.1109/TCBB.2009.47.
"""
struct DirectCR <: AbstractAggregatorAlgorithm end

"""
The Sorting Direct method. Often the fastest algorithm for smaller to moderate
sized systems (tens of jumps), or systems where a few jumps occur much more
frequently than others.

J. M. McCollum, G. D. Peterson, C. D. Cox, M. L. Simpson and N. F. Samatova, The
sorting direct method for stochastic simulation of biochemical systems with
varying reaction execution behavior, Computational Biology and Chemistry, 30
(1), 39049 (2006). doi:10.1016/j.compbiolchem.2005.10.007.
"""
struct SortingDirect <: AbstractAggregatorAlgorithm end

"""
The Rejection SSA method. One of the best methods for systems with hundreds to
many thousands of jumps (along with `RSSACR`) and sparse dependency graphs.

V. H. Thanh, C. Priami and R. Zunino, Efficient rejection-based simulation of
biochemical reactions with stochastic noise and delays, Journal of Chemical
Physics, 141 (13), 134116 (2014). doi:10.1063/1.4896985

V. H. Thanh, R. Zunino and C. Priami, On the rejection-based algorithm for
simulation and analysis of large-scale reaction networks, Journal of Chemical
Physics, 142 (24), 244106 (2015). doi:10.1063/1.4922923.
"""
struct RSSA <: AbstractAggregatorAlgorithm end

"""
The Rejection SSA Composition-Rejection method. Often the best performer for
systems with tens of thousands of jumps and sparse dependency graphs.

V. H. Thanh, R. Zunino, and C. Priami, Efficient constant-time complexity
algorithm for stochastic simulation of large reaction networks, IEEE/ACM
Transactions on Computational Biology and Bioinformatics, 14 (3), 657-667
(2017). doi:10.1109/TCBB.2016.2530066.
"""
struct RSSACR <: AbstractAggregatorAlgorithm end

"""
A rejection-based direct method.
"""
struct RDirect <: AbstractAggregatorAlgorithm end

# NRM-based methods

"""
Gillespie's First Reaction Method. Should not be used for practical applications
due to slow performance relative to all other methods.

Daniel T. Gillespie, A general method for numerically simulating the stochastic
time evolution of coupled chemical reactions, Journal of Computational Physics,
22 (4), 403–434 (1976). doi:10.1016/0021-9991(76)90041-3.
"""
struct FRM <: AbstractAggregatorAlgorithm end

"""
Gillespie's First Reaction Method with `FunctionWrappers` for handling
`ConstantRateJump`s. Should not be used for practical applications
due to slow performance relative to all other methods.

Daniel T. Gillespie, A general method for numerically simulating the stochastic
time evolution of coupled chemical reactions, Journal of Computational Physics,
22 (4), 403–434 (1976). doi:10.1016/0021-9991(76)90041-3.
"""
struct FRMFW <: AbstractAggregatorAlgorithm end

"""
The Next Reaction Method. Can significantly outperform Direct for systems with
large numbers of jumps and sparse dependency graphs, but is usually slower than
one of `DirectCR`, `RSSA`, or `RSSACR` for such systems.

M. A. Gibson and J. Bruck, Efficient exact stochastic simulation of chemical
systems with many species and many channels, Journal of Physical Chemistry A,
104 (9), 1876-1889 (2000). doi:10.1021/jp993732q.
"""
struct NRM <: AbstractAggregatorAlgorithm end

"""
An improvement of the COEVOLVE algorithm for simulating any compound jump
process that evolves through time. This method handles variable intensity
rates with user-defined bounds and inter-dependent processes. It reduces to
NRM when rates are constant. As opposed to COEVOLVE, this method syncs the
thinning procedure with the stepper which allows it to handle dependencies on
continuous dynamics.

G. A. Zagatti, S. A. Isaacson, C. Rackauckas, V. Ilin, S.-K. Ng and S. Bressan,
Extending JumpProcess.jl for fast point process simulation with time-varying
intensities, arXiv. doi:10.48550/arXiv.2306.06992.

M. Farajtabar, Y. Wang, M. Gomez-Rodriguez, S. Li, H. Zha, and L. Song,
COEVOLVE: a joint point process model for information diffusion and network
evolution, Journal of Machine Learning Research 18(1), 1305–1353 (2017). doi:
10.5555/3122009.3122050.
"""
struct Coevolve <: AbstractAggregatorAlgorithm end

"""
A constant-complexity NRM method. Stores next reaction times in a table with a specified bin width.

Kevin R. Sanft and Hans G. Othmer, Constant-complexity stochastic simulation
algorithm with optimal binning,  Journal of Chemical Physics 143, 074108
(2015). doi: 10.1063/1.4928635.
"""
struct CCNRM <: AbstractAggregatorAlgorithm end

# spatial methods

"""
The Next Subvolume Method for spatial jump process simulations. Usually slower
than `DirectCRDirect`. Uses an indexed priority queue tree structure to
determine where on the grid/graph the next jump occurs, and then the `Direct`
method to determine which jump at the given location occurs.

Elf, Johan and Ehrenberg, M, Spontaneous separation of bi-stable biochemical
systems into spatial domains of opposite phases,Systems Biology, 1(2), 230-236
(2004). doi:10.1049/sb:20045021.
"""
struct NSM <: AbstractAggregatorAlgorithm end

"""
The Direct Composition-Rejection Direct method. Uses the `DirectCR` method to
determine where on the grid/graph a jump occurs, and the `Direct` method to
determine which jump occurs at the sampled location.

Kevin R. Sanft and Hans G. Othmer, Constant-complexity stochastic simulation
algorithm with optimal binning,  Journal of Chemical Physics 143, 074108
(2015). doi: 10.1063/1.4928635.
"""
struct DirectCRDirect <: AbstractAggregatorAlgorithm end

const JUMP_AGGREGATORS = (Direct(), DirectFW(), DirectCR(), SortingDirect(), RSSA(), FRM(),
    FRMFW(), NRM(), RSSACR(), RDirect(), Coevolve(), CCNRM())

# For JumpProblem construction without an aggregator
struct NullAggregator <: AbstractAggregatorAlgorithm end

# true if aggregator requires a jump dependency graph
needs_depgraph(aggregator::AbstractAggregatorAlgorithm) = false
needs_depgraph(aggregator::DirectCR) = true
needs_depgraph(aggregator::SortingDirect) = true
needs_depgraph(aggregator::NRM) = true
needs_depgraph(aggregator::CCNRM) = true
needs_depgraph(aggregator::RDirect) = true
needs_depgraph(aggregator::Coevolve) = true

# true if aggregator requires a map from solution variable to dependent jumps.
# It is implicitly assumed these aggregators also require the reverse map, from
# jumps to variables they update.
needs_vartojumps_map(aggregator::AbstractAggregatorAlgorithm) = false
needs_vartojumps_map(aggregator::RSSA) = true
needs_vartojumps_map(aggregator::RSSACR) = true

# true if aggregator supports variable rates
supports_variablerates(aggregator::AbstractAggregatorAlgorithm) = false
supports_variablerates(aggregator::Coevolve) = true

# true if aggregator supports hops, e.g. diffusion
is_spatial(aggregator::AbstractAggregatorAlgorithm) = false
is_spatial(aggregator::NSM) = true
is_spatial(aggregator::DirectCRDirect) = true

# return the fastest aggregator out of the available ones
function select_aggregator(jumps::JumpSet; vartojumps_map = nothing,
        jumptovars_map = nothing, dep_graph = nothing, spatial_system = nothing,
        hopping_constants = nothing)

    # detect if a spatial SSA should be used
    !isnothing(spatial_system) && !isnothing(hopping_constants) && return DirectCRDirect

    # if variable rate jumps are present, return one of the two SSAs that support them
    if num_vrjs(jumps) > 0
        (num_bndvrjs(jumps) > 0) && return Coevolve
        return Direct
    end

    # if the number of jumps is small, return the Direct
    num_jumps(jumps) < USE_DIRECT_THRESHOLD && return Direct

    # if there are only massaction jumps, we can build the species-jumps dependency graphs
    can_build_dgs = num_crjs(jumps) == 0 && num_vrjs(jumps) == 0
    have_species_to_jumps_dgs = !isnothing(vartojumps_map) && !isnothing(jumptovars_map)

    # if we have the species-jumps dgs or can build them, use a Rejection-based methods
    if can_build_dgs || have_species_to_jumps_dgs
        (num_jumps(jumps) < USE_RSSA_THRESHOLD) && return RSSA
        return RSSACR
    elseif !isnothing(dep_graph)   # if only have a normal dg
        (num_jumps(jumps) < USE_SORTINGDIRECT_THRESHOLD) && return SortingDirect
        return DirectCR
    else
        return Direct
    end
end

"""
Composition-Rejection with Rejection sampling method (RSSA-CR)
"""

const MINJUMPRATE = 2.0^exponent(1e-12)

mutable struct RSSACRJumpAggregation{F, S, F1, F2, RNG, U, VJMAP, JVMAP, BD,
    P <: PriorityTable, W <: Function} <:
               AbstractSSAJumpAggregator{F, S, F1, F2, RNG}
    next_jump::Int
    prev_jump::Int
    next_jump_time::F
    end_time::F
    cur_rate_low::Vector{F}
    cur_rate_high::Vector{F}
    sum_rate::F
    ma_jumps::S
    rates::F1
    affects!::F2
    save_positions::Tuple{Bool, Bool}
    rng::RNG
    vartojumps_map::VJMAP
    jumptovars_map::JVMAP
    bracket_data::BD
    ulow::U
    uhigh::U
    minrate::F
    maxrate::F   # initial maxrate only, table can increase beyond it!
    rt::P #rate table
    ratetogroup::W
end

function RSSACRJumpAggregation(nj::Int, njt::F, et::F, crs::Vector{F}, sum_rate::F, maj::S,
        rs::F1, affs!::F2, sps::Tuple{Bool, Bool}, rng::RNG; u::U,
        vartojumps_map = nothing, jumptovars_map = nothing,
        bracket_data = nothing, minrate = convert(F, MINJUMPRATE),
        maxrate = convert(F, Inf),
        kwargs...) where {F, S, F1, F2, RNG, U}
    # a dependency graph is needed and must be provided if there are constant rate jumps
    if vartojumps_map === nothing
        if (get_num_majumps(maj) == 0) || !isempty(rs)
            error("To use the RSSACR algorithm a map from variables to dependent jumps must be supplied.")
        else
            vtoj_map = var_to_jumps_map(length(u), maj)
        end
    else
        vtoj_map = vartojumps_map
    end

    if jumptovars_map === nothing
        if (get_num_majumps(maj) == 0) || !isempty(rs)
            error("To use the RSSACR algorithm a map from jumps to dependent variables must be supplied.")
        else
            jtov_map = jump_to_vars_map(maj)
        end
    else
        jtov_map = jumptovars_map
    end

    # vectors to store bracketing intervals for jump rates
    crl_bnds = similar(crs)
    crh_bnds = similar(crs)

    # a bracket data structure is needed for updating species populations
    bd = (bracket_data === nothing) ? BracketData{F, eltype(U)}() : bracket_data

    # matrix to store bracketing interval for species and the relative interval width
    # first row is Xlow, second is Xhigh
    ulow = similar(u)
    uhigh = similar(u)

    # mapping from jump rate to group id
    minexponent = exponent(minrate)

    # use the largest power of two that is <= the passed in minrate
    minrate = 2.0^minexponent
    ratetogroup = rate -> priortogid(rate, minexponent)

    # construct an empty initial priority table -- we'll reset this in init
    rt = PriorityTable(ratetogroup, zeros(F, 1), minrate, 2 * minrate)

    affecttype = F2 <: Tuple ? F2 : Any
    RSSACRJumpAggregation{typeof(njt), S, F1, affecttype, RNG, U, typeof(vtoj_map),
        typeof(jtov_map), typeof(bd), typeof(rt),
        typeof(ratetogroup)}(nj, nj, njt, et, crl_bnds, crh_bnds,
        sum_rate, maj, rs, affs!, sps, rng, vtoj_map,
        jtov_map, bd, ulow, uhigh, minrate, maxrate,
        rt, ratetogroup)
end

############################# Required Functions ##############################

# creating the JumpAggregation structure (function wrapper-based constant jumps)
function aggregate(aggregator::RSSACR, u, p, t, end_time, constant_jumps,
        ma_jumps, save_positions, rng; kwargs...)

    # handle constant jumps using function wrappers
    rates, affects! = get_jump_info_fwrappers(u, p, t, constant_jumps)

    build_jump_aggregation(RSSACRJumpAggregation, u, p, t, end_time, ma_jumps,
        rates, affects!, save_positions, rng; u = u, kwargs...)
end

# set up a new simulation and calculate the first jump / jump time
function initialize!(p::RSSACRJumpAggregation, integrator, u, params, t)
    p.end_time = integrator.sol.prob.tspan[2]
    set_bracketing!(p, u, params, t)

    # setup PriorityTable
    reset!(p.rt)
    for (pid, priority) in enumerate(p.cur_rate_high)
        insert!(p.rt, pid, priority)
    end

    generate_jumps!(p, integrator, u, params, t)
    nothing
end

# execute one jump, changing the system state
function execute_jumps!(p::RSSACRJumpAggregation, integrator, u, params, t, affects!)
    # execute jump
    u = update_state!(p, integrator, u, affects!)

    # update rates
    update_dependent_rates!(p, u, params, t)
    nothing
end

# calculate the next jump / jump time
function generate_jumps!(p::RSSACRJumpAggregation, integrator, u, params, t)
    sum_rate = p.sum_rate
    # if no more events possible there is nothing to do
    if nomorejumps!(p, sum_rate)
        return nothing
    end

    (; rt, ma_jumps, rates, cur_rate_high, cur_rate_low, rng) = p
    num_majumps = get_num_majumps(ma_jumps)
    rerl = zero(sum_rate)

    jidx = sample(rt, cur_rate_high, rng)
    if iszero(jidx)
        p.next_jump_time = Inf
        return nothing
    end
    rerl += randexp(rng)
    while rejectrx(ma_jumps, num_majumps, rates, cur_rate_high, cur_rate_low, rng, u, jidx,
        params, t)
        # sample candidate reaction
        jidx = sample(rt, cur_rate_high, rng)
        rerl += randexp(rng)
    end
    p.next_jump = jidx

    # update time to next jump
    p.next_jump_time = t + rerl / sum_rate
    nothing
end

######################## SSA specific helper routines #########################
"""
update bracketing for species that depend on the just executed jump
"""
@inline function update_dependent_rates!(p::RSSACRJumpAggregation, u::AbstractVector,
        params, t)
    # update bracketing intervals
    (; ulow, uhigh) = p
    crhigh = p.cur_rate_high

    @inbounds for uidx in p.jumptovars_map[p.next_jump]
        uval = u[uidx]
        # if new u value is outside the bracketing interval
        if uval == zero(uval) || uval < ulow[uidx] || uval > uhigh[uidx]
            # update u bracketing interval
            ulow[uidx], uhigh[uidx] = get_spec_brackets(p.bracket_data, uidx, uval)

            # for each dependent jump, update jump rate brackets
            for jidx in p.vartojumps_map[uidx]
                oldrate = crhigh[jidx]
                p.cur_rate_low[jidx], crhigh[jidx] = get_jump_brackets(jidx, p, params, t)

                # update the priority table
                update!(p.rt, jidx, oldrate, crhigh[jidx])
            end
        end
    end

    p.sum_rate = groupsum(p.rt)
    nothing
end

@inline function update_dependent_rates!(p::RSSACRJumpAggregation, u::SVector, params, t)
    # update bracketing intervals
    crhigh = p.cur_rate_high

    @inbounds for uidx in p.jumptovars_map[p.next_jump]
        uval = u[uidx]
        # if new u value is outside the bracketing interval
        if uval == zero(uval) || uval < p.ulow[uidx] || uval > p.uhigh[uidx]
            # update u bracketing interval
            ulow, uhigh = get_spec_brackets(p.bracket_data, uidx, uval)
            p.ulow = setindex(p.ulow, ulow, uidx)
            p.uhigh = setindex(p.uhigh, uhigh, uidx)

            # for each dependent jump, update jump rate brackets
            for jidx in p.vartojumps_map[uidx]
                oldrate = crhigh[jidx]
                p.cur_rate_low[jidx], crhigh[jidx] = get_jump_brackets(jidx, p, params, t)

                # update the priority table
                update!(p.rt, jidx, oldrate, crhigh[jidx])
            end
        end
    end

    p.sum_rate = groupsum(p.rt)
    nothing
end

"""
$(TYPEDEF)

Highly efficient integrator for pure jump problems that involve only `ConstantRateJump`s,
`MassActionJump`s, and/or `VariableRateJump`s *with rate bounds*.

## Notes

  - Only works with `JumpProblem`s defined from `DiscreteProblem`s.
  - Only works with collections of `ConstantRateJump`s, `MassActionJump`s, and
    `VariableRateJump`s with rate bounds.
  - Only supports `DiscreteCallback`s for events, which are checked after every step taken by
    `SSAStepper`.
  - Only supports a limited subset of the output controls from the common solver interface,
    specifically `save_start`, `save_end`, and `saveat`.
  - As when using jumps with ODEs and SDEs, saving controls for whether to save each time a
    jump occurs are via the `save_positions` keyword argument to `JumpProblem`. Note that when
    choosing `SSAStepper` as the timestepper, `save_positions = (true,true)`, `(true,false)`,
    or `(false,true)` are all equivalent. `SSAStepper` will save only the post-jump state in
    the solution object in each of these cases. This is because solution objects generated via
    `SSAStepper` use piecewise-constant interpolation, and can therefore exactly reconstruct
    the sampled jump process path with knowing just the post-jump state. That is, `sol(t)`
    for any `0 <= t <= tstop` will give the exact value of the sampled solution path at `t`
    provided at least one component of `save_positions` is `true`.

## Examples

SIR model:

```julia
using JumpProcesses
β = 0.1 / 1000.0;
ν = 0.01;
p = (β, ν)
rate1(u, p, t) = p[1]*u[1]*u[2]  # β*S*I
function affect1!(integrator)
    integrator.u[1] -= 1         # S -> S - 1
    integrator.u[2] += 1         # I -> I + 1
end
jump = ConstantRateJump(rate1, affect1!)

rate2(u, p, t) = p[2]*u[2]      # ν*I
function affect2!(integrator)
    integrator.u[2] -= 1        # I -> I - 1
    integrator.u[3] += 1        # R -> R + 1
end
jump2 = ConstantRateJump(rate2, affect2!)
u₀ = [999, 1, 0]
tspan = (0.0, 250.0)
prob = DiscreteProblem(u₀, tspan, p)
jump_prob = JumpProblem(prob, Direct(), jump, jump2)
sol = solve(jump_prob, SSAStepper())
```

see the
[tutorial](https://docs.sciml.ai/JumpProcesses/stable/tutorials/discrete_stochastic_example/)
for details.
"""
struct SSAStepper <: DiffEqBase.AbstractDEAlgorithm end
SciMLBase.allows_late_binding_tstops(::SSAStepper) = true

"""
$(TYPEDEF)

Solution objects for pure jump problems solved via `SSAStepper`.

## Fields

$(FIELDS)
"""
mutable struct SSAIntegrator{F, uType, tType, tdirType, P, S, CB, SA, OPT, TS} <:
               AbstractSSAIntegrator{SSAStepper, Nothing, uType, tType}
    """The underlying `prob.f` function. Not currently used."""
    f::F
    """The current solution values."""
    u::uType
    """The current solution time."""
    t::tType
    """The previous time a jump occurred."""
    tprev::tType
    """The direction time is changing in (must be positive, indicating time is increasing)"""
    tdir::tdirType
    """The current parameters."""
    p::P
    """The current solution object."""
    sol::S
    i::Int
    """The next jump time."""
    tstop::tType
    """The jump aggregator callback."""
    cb::CB
    """Times to save the solution at."""
    saveat::SA
    """Whether to save every time a jump occurs."""
    save_everystep::Bool
    """Whether to save at the final step."""
    save_end::Bool
    """Index of the next `saveat` time."""
    cur_saveat::Int
    """Tuple storing callbacks."""
    opts::OPT
    """User supplied times to step to, useful with callbacks."""
    tstops::TS
    tstops_idx::Int
    u_modified::Bool
    keep_stepping::Bool          # false if should terminate a simulation
    """If true, will write tstops into the user-passed array"""
    alias_tstops::Bool
    """If true indicates we have already allocated the tstops array"""
    copied_tstops::Bool
end

(integrator::SSAIntegrator)(t) = copy(integrator.u)
(integrator::SSAIntegrator)(out, t) = (out .= integrator.u)

# SciMLBase v3 / DiffEqBase v7 renamed the integrator's `u_modified` field to
# `derivative_discontinuity` and internal callback code now reads/writes the
# field directly (e.g. `integrator.derivative_discontinuity`, not via a
# method). Aliasing here so both names access the same underlying storage —
# v6-era callbacks that look for `:u_modified` and v7-era callbacks that look
# for `:derivative_discontinuity` both keep working without renaming the
# struct field (which would be a breaking ABI change).
@inline function Base.getproperty(integrator::SSAIntegrator, sym::Symbol)
    sym === :derivative_discontinuity && return getfield(integrator, :u_modified)
    sym === :ps && return SII.ParameterIndexingProxy(integrator)
    return getfield(integrator, sym)
end

@inline function Base.setproperty!(integrator::SSAIntegrator, sym::Symbol, val)
    sym === :derivative_discontinuity &&
        return setfield!(integrator, :u_modified, convert(Bool, val))
    return setfield!(integrator, sym, convert(fieldtype(typeof(integrator), sym), val))
end

function Base.propertynames(integrator::SSAIntegrator, private::Bool = false)
    return (fieldnames(SSAIntegrator)..., :derivative_discontinuity)
end

function DiffEqBase.u_modified!(integrator::SSAIntegrator, bool::Bool)
    integrator.u_modified = bool
end

# SciMLBase v3 renamed `u_modified!` to `derivative_discontinuity!` and internal
# callback code now calls the new name. Define the method when available so
# callbacks keep working on v3. Guarded so the file still loads on v2.
@static if isdefined(SciMLBase, :derivative_discontinuity!)
    function SciMLBase.derivative_discontinuity!(integrator::SSAIntegrator, bool::Bool)
        integrator.u_modified = bool
    end
end

function DiffEqBase.__solve(jump_prob::JumpProblem, alg::SSAStepper; kwargs...)
    # init will handle kwargs merging via init_call
    integrator = init(jump_prob, alg; kwargs...)
    solve!(integrator)
    integrator.sol
end

function DiffEqBase.solve!(integrator::SSAIntegrator)
    end_time = integrator.sol.prob.tspan[2]
    while should_continue_solve(integrator) # It stops before adding a tstop over
        step!(integrator)
    end

    # if the user terminated the solve we shouldn't advance in time any more
    if integrator.sol.retcode !== ReturnCode.Terminated
        integrator.t = end_time

        # check callbacks one last time
        if !(integrator.opts.callback.discrete_callbacks isa Tuple{})
            DiffEqBase.apply_discrete_callback!(integrator,
                integrator.opts.callback.discrete_callbacks...)
        end

        if integrator.saveat !== nothing && !isempty(integrator.saveat)
            # Split to help prediction
            while integrator.cur_saveat <= length(integrator.saveat) &&
                integrator.saveat[integrator.cur_saveat] < integrator.t
                push!(integrator.sol.t, integrator.saveat[integrator.cur_saveat])
                push!(integrator.sol.u, copy(integrator.u))
                integrator.cur_saveat += 1
            end
        end

        if integrator.save_end && integrator.sol.t[end] != end_time
            push!(integrator.sol.t, end_time)
            push!(integrator.sol.u, copy(integrator.u))
        end
    end

    DiffEqBase.finalize!(integrator.opts.callback, integrator.u, integrator.t, integrator)
    if integrator.save_end
        SciMLBase.save_final_discretes!(integrator, integrator.opts.callback)
    end

    if integrator.sol.retcode === ReturnCode.Default
        integrator.sol = DiffEqBase.solution_new_retcode(integrator.sol, ReturnCode.Success)
    end
end

"""
    check_continuous_callback_error(callback)

Check if the callback contains any continuous callbacks and throw an informative error.
SSAStepper only supports DiscreteCallbacks for event detection.
"""
function check_continuous_callback_error(callback)
    if callback === nothing
        return nothing
    end

    if callback isa DiffEqBase.ContinuousCallback
        error("SSAStepper does not support continuous callbacks. Only DiscreteCallbacks " *
              "are supported for event detection with SSAStepper. Please use an ODE/SDE " *
              "solver (e.g., Tsit5()) if you need continuous event detection.")
    elseif callback isa DiffEqBase.CallbackSet
        n_continuous = length(callback.continuous_callbacks)
        if n_continuous > 0
            error("SSAStepper does not support continuous callbacks (found $n_continuous " *
                  "continuous callback$(n_continuous > 1 ? "s" : "")). Only DiscreteCallbacks " *
                  "are supported for event detection with SSAStepper. Please use an ODE/SDE " *
                  "solver (e.g., Tsit5()) if you need continuous event detection.")
        end
    end
    return nothing
end

function DiffEqBase.__init(jump_prob::JumpProblem,
        alg::SSAStepper;
        save_start = true,
        save_end = true,
        seed = nothing,
        alias_jump = Threads.threadid() == 1,
        saveat = nothing,
        callback = nothing,
        tstops = nothing,
        numsteps_hint = 100)

    # hack until alias system is in place
    alias_tstops = false

    if !(jump_prob.prob isa DiscreteProblem)
        error("SSAStepper only supports DiscreteProblems.")
    end
    prob = jump_prob.prob

    # Check for continuous callbacks in the jump system
    isempty(jump_prob.jump_callback.continuous_callbacks) ||
        error("SSAStepper does not support continuous callbacks in the jump system. " *
              "Please use an ODE/SDE solver over ODE or SDE problems instead.")

    # Check for continuous callbacks passed via kwargs (from JumpProblem constructor or solve)
    check_continuous_callback_error(callback)
    if alias_jump
        cb = jump_prob.jump_callback.discrete_callbacks[end]
        if seed !== nothing
            Random.seed!(cb.condition.rng, seed)
        end
    else
        cb = deepcopy(jump_prob.jump_callback.discrete_callbacks[end])
        # Only reseed if an explicit seed is provided. This respects the user's RNG choice
        # and enables reproducibility. For EnsembleProblems, use prob_func to set unique seeds
        # for each trajectory if different results are needed.
        if seed !== nothing
            Random.seed!(cb.condition.rng, seed)
        end
    end
    opts = (callback = CallbackSet(callback),)

    if save_start
        t = [prob.tspan[1]]
        u = [copy(prob.u0)]
    else
        t = typeof(prob.tspan[1])[]
        u = typeof(prob.u0)[]
    end
    save_everystep = any(cb.save_positions)

    sol = DiffEqBase.build_solution(prob, alg, t, u, dense = save_everystep,
        calculate_error = false,
        stats = DiffEqBase.Stats(0),
        interp = DiffEqBase.ConstantInterpolation(t, u))

    _saveat = (saveat isa Number) ? (prob.tspan[1]:saveat:prob.tspan[2]) : saveat
    if _saveat !== nothing && !isempty(_saveat) && _saveat[1] == prob.tspan[1]
        cur_saveat = 2
    else
        cur_saveat = 1
    end

    if _saveat !== nothing && !isempty(_saveat)
        sizehint!(u, length(_saveat) + 1)
        sizehint!(t, length(_saveat) + 1)
    elseif save_everystep
        sizehint!(u, numsteps_hint)
        sizehint!(t, numsteps_hint)
    else
        sizehint!(u, save_start + save_end)
        sizehint!(t, save_start + save_end)
    end

    tdir = sign(prob.tspan[2] - prob.tspan[1])
    (tdir <= 0) &&
        error("The time interval to solve over is non-increasing, i.e. tspan[2] <= tspan[1]. This is not allowed for pure jump problem.")

    # Stash callable tstops (e.g. SymbolicTstops); use empty vector for init.
    if tstops === nothing
        alias_tstops = true
        callable_tstops = nothing
        _tstops = eltype(jump_prob.prob.tspan)[]
    elseif tstops isa AbstractArray || tstops isa Tuple || tstops isa Number
        callable_tstops = nothing
        _tstops = tstops
    else
        callable_tstops = tstops
        _tstops = eltype(jump_prob.prob.tspan)[]
    end

    integrator = SSAIntegrator(prob.f, copy(prob.u0), prob.tspan[1], prob.tspan[1], tdir,
        prob.p, sol, 1, prob.tspan[1], cb, _saveat, save_everystep,
        save_end, cur_saveat, opts, _tstops, 1, false, true, alias_tstops, false)
    cb.initialize(cb, integrator.u, prob.tspan[1], integrator)
    DiffEqBase.initialize!(opts.callback, integrator.u, prob.tspan[1], integrator)
    if save_start
        SciMLBase.save_discretes_if_enabled!(integrator, opts.callback; skip_duplicates = true)
    end

    # Evaluate callable tstops now that callbacks are initialized and parameters finalized.
    if callable_tstops !== nothing
        for ts in callable_tstops(SII.parameter_values(integrator), prob.tspan)
            add_tstop!(integrator, ts)
        end
    end

    integrator
end

function DiffEqBase.get_tstops(integrator::SSAIntegrator)
    @view integrator.tstops[(integrator.tstops_idx):end]
end
DiffEqBase.get_tstops_array(integrator::SSAIntegrator) = DiffEqBase.get_tstops(integrator)

# ODE integrators seem to add tf into tstops which SSAIntegrator does not do
# so must account for it here.
function DiffEqBase.get_tstops_max(integrator::SSAIntegrator)
    tstops = DiffEqBase.get_tstops_array(integrator)
    tf = integrator.sol.prob.tspan[2]
    if !isempty(tstops)
        return max(maximum(tstops), tf)
    else
        return tf
    end
end

function DiffEqBase.add_tstop!(integrator::SSAIntegrator, tstop)
    if tstop > integrator.t
        future_tstops = @view integrator.tstops[(integrator.tstops_idx):end]
        insert_index = integrator.tstops_idx + searchsortedfirst(future_tstops, tstop) - 1

        # if not aliasing and have not already copied the user tstops array
        if !integrator.alias_tstops && !integrator.copied_tstops
            integrator.copied_tstops = true
            integrator.tstops = copy(integrator.tstops)
        end

        Base.insert!(integrator.tstops, insert_index, tstop)
    end
    nothing
end

# The Jump aggregators should not register the next jump through add_tstop! for SSAIntegrator
# such that we can achieve maximum performance
@inline function register_next_jump_time!(integrator::SSAIntegrator,
        p::AbstractSSAJumpAggregator, t)
    integrator.tstop = p.next_jump_time
    nothing
end

function DiffEqBase.step!(integrator::SSAIntegrator)
    integrator.tprev = integrator.t
    next_jump_time = integrator.tstop > integrator.t ? integrator.tstop :
                     typemax(integrator.tstop)

    doaffect = false
    if !isempty(integrator.tstops) &&
       integrator.tstops_idx <= length(integrator.tstops) &&
       integrator.tstops[integrator.tstops_idx] < next_jump_time
        integrator.t = integrator.tstops[integrator.tstops_idx]
        integrator.tstops_idx += 1
    else
        integrator.t = integrator.tstop
        doaffect = true # delay effect until after saveat
    end

    @inbounds if integrator.saveat !== nothing && !isempty(integrator.saveat)
        # Split to help prediction
        while integrator.cur_saveat < length(integrator.saveat) &&
            integrator.saveat[integrator.cur_saveat] < integrator.t
            saved = true
            push!(integrator.sol.t, integrator.saveat[integrator.cur_saveat])
            push!(integrator.sol.u, copy(integrator.u))
            integrator.cur_saveat += 1
        end
    end

    # FP error means the new time may equal the old if the next jump time is
    # sufficiently small, hence we add this check to execute jumps until
    # this is no longer true.
    integrator.u_modified = true
    while integrator.t == integrator.tstop
        doaffect && integrator.cb.affect!(integrator)
    end

    jump_modified_u = integrator.u_modified

    if !(integrator.opts.callback.discrete_callbacks isa Tuple{})
        discrete_modified,
        saved_in_cb = DiffEqBase.apply_discrete_callback!(integrator,
            integrator.opts.callback.discrete_callbacks...)
    else
        saved_in_cb = false
    end

    !saved_in_cb && jump_modified_u && savevalues!(integrator)

    nothing
end

function DiffEqBase.savevalues!(integrator::SSAIntegrator, force = false)
    saved, savedexactly = false, false

    # No saveat in here since it would only use previous values,
    # so in the specific case of SSAStepper it's already handled

    if integrator.save_everystep || force
        saved = true
        savedexactly = true
        push!(integrator.sol.t, integrator.t)
        push!(integrator.sol.u, copy(integrator.u))
    end

    saved, savedexactly
end

function should_continue_solve(integrator::SSAIntegrator)
    end_time = integrator.sol.prob.tspan[2]

    # we continue the solve if there is a tstop between now and end_time
    has_tstop = !isempty(integrator.tstops) &&
                integrator.tstops_idx <= length(integrator.tstops) &&
                integrator.tstops[integrator.tstops_idx] < end_time

    # we continue the solve if there will be a jump between now and end_time
    has_jump = integrator.t < integrator.tstop < end_time

    integrator.keep_stepping && (has_jump || has_tstop)
end

function reset_aggregated_jumps!(integrator::SSAIntegrator, uprev = nothing;
        update_jump_params = true, kwargs...)
    reset_aggregated_jumps!(integrator, uprev, integrator.cb;
        update_jump_params, kwargs...)
    nothing
end

function DiffEqBase.terminate!(integrator::SSAIntegrator, retcode = ReturnCode.Terminated)
    integrator.keep_stepping = false
    integrator.sol = DiffEqBase.solution_new_retcode(integrator.sol, retcode)
    nothing
end


function SciMLBase.isdenseplot(sol::ODESolution{
        T, N, uType, uType2, DType, tType, rateType, discType, P,
        SSAStepper}) where {T, N, uType, uType2, DType, tType, rateType, discType, P}
    sol.dense
end

using JumpProcesses, OrdinaryDiffEq, Test
using StableRNGs
rng = StableRNG(12345)

# Test that callbacks passed to JumpProblem constructor work correctly
# This tests the fix for the regression introduced in v9.17.0 (PR #514)

@testset "Callbacks in JumpProblem constructor" begin
    # Simple ODE with a jump
    function f!(du, u, p, t)
        du[1] = -0.5u[1]
    end

    rate(u, p, t) = 0.1
    affect!(integrator) = (integrator.u[1] += 1.0)
    jump = ConstantRateJump(rate, affect!)

    u0 = [5.0]
    tspan = (0.0, 10.0)
    prob = ODEProblem(f!, u0, tspan)

    # Test 1: ContinuousCallback in JumpProblem constructor
    cb_called = Ref(false)
    condition(u, t, integrator) = t - 5.0
    affect_cb!(integrator) = (cb_called[] = true)
    cb = ContinuousCallback(condition, affect_cb!)

    jprob = JumpProblem(prob, Direct(), jump; rng, callback = cb)
    sol = solve(jprob, Tsit5())

    @test cb_called[]
    @test sol.t[end] ≈ 10.0

    # Test 2: DiscreteCallback in JumpProblem constructor
    dcb_called = Ref(0)
    condition_d(u, t, integrator) = t > 2.0  # Fire at every step after t=2
    affect_dcb!(integrator) = (dcb_called[] += 1)
    dcb = DiscreteCallback(condition_d, affect_dcb!)

    jprob = JumpProblem(prob, Direct(), jump; rng, callback = dcb)
    sol = solve(jprob, Tsit5())

    @test dcb_called[] > 0  # Should have fired multiple times

    # Test 3: Terminating callback in JumpProblem constructor
    condition_term(u, t, integrator) = t - 3.0
    affect_term!(integrator) = terminate!(integrator)
    cb_term = ContinuousCallback(condition_term, affect_term!)

    jprob = JumpProblem(prob, Direct(), jump; rng, callback = cb_term)
    sol = solve(jprob, Tsit5())

    @test sol.t[end] ≈ 3.0  # Should terminate at t=3

    # Test 4: State-modifying callback in JumpProblem constructor
    condition_mod(u, t, integrator) = t - 5.0
    affect_mod!(integrator) = (integrator.u[1] *= 2.0)
    cb_mod = ContinuousCallback(condition_mod, affect_mod!)

    jprob = JumpProblem(prob, Direct(), jump; rng, callback = cb_mod)
    sol = solve(jprob, Tsit5())

    # Check that state was modified at t=5
    idx = findfirst(t -> t >= 5.0, sol.t)
    @test idx !== nothing
    # State should have been doubled at this point
end

@testset "Callbacks in both JumpProblem and solve" begin
    # Test that callbacks merge correctly when passed to both

    function f!(du, u, p, t)
        du[1] = -0.5u[1]
    end

    rate(u, p, t) = 0.1
    affect!(integrator) = (integrator.u[1] += 1.0)
    jump = ConstantRateJump(rate, affect!)

    u0 = [5.0]
    tspan = (0.0, 10.0)
    prob = ODEProblem(f!, u0, tspan)

    # Create two callbacks with counters to verify no duplication
    cb1_count = Ref(0)
    condition1(u, t, integrator) = t - 3.0
    affect1!(integrator) = (cb1_count[] += 1)
    cb1 = ContinuousCallback(condition1, affect1!)

    cb2_count = Ref(0)
    condition2(u, t, integrator) = t - 7.0
    affect2!(integrator) = (cb2_count[] += 1)
    cb2 = ContinuousCallback(condition2, affect2!)

    # Test 1: Both callbacks should fire (default merge_callbacks = true)
    cb1_count[] = 0
    cb2_count[] = 0
    jprob = JumpProblem(prob, Direct(), jump; rng, callback = cb1)
    sol = solve(jprob, Tsit5(); callback = cb2)

    @test cb1_count[] > 0
    @test cb2_count[] > 0
    @test sol.t[end] ≈ 10.0

    # Critical test: verify callbacks are not duplicated
    # Continuous callbacks should fire exactly once when crossing the threshold
    @test cb1_count[] == 1  # Should fire exactly once at t=3
    @test cb2_count[] == 1  # Should fire exactly once at t=7

    # Test 2: Only solve callback should fire (merge_callbacks = false)
    cb1_count[] = 0
    cb2_count[] = 0
    jprob = JumpProblem(prob, Direct(), jump; rng, callback = cb1)
    sol = solve(jprob, Tsit5(); callback = cb2, merge_callbacks = false)

    @test cb1_count[] == 0  # Should not fire
    @test cb2_count[] == 1  # Should fire exactly once
    @test sol.t[end] ≈ 10.0
end

@testset "Callbacks with init and solve!" begin
    # Test that callbacks work through the init/solve! pathway

    function f!(du, u, p, t)
        du[1] = -0.5u[1]
    end

    rate(u, p, t) = 0.1
    affect!(integrator) = (integrator.u[1] += 1.0)
    jump = ConstantRateJump(rate, affect!)

    u0 = [5.0]
    tspan = (0.0, 10.0)
    prob = ODEProblem(f!, u0, tspan)

    cb_called = Ref(false)
    condition(u, t, integrator) = t - 5.0
    affect_cb!(integrator) = (cb_called[] = true)
    cb = ContinuousCallback(condition, affect_cb!)

    # Callback in JumpProblem constructor
    jprob = JumpProblem(prob, Direct(), jump; rng, callback = cb)
    integrator = init(jprob, Tsit5())
    solve!(integrator)

    @test cb_called[]
    @test integrator.sol.t[end] ≈ 10.0
end

@testset "Multiple callback types in JumpProblem" begin
    # Test mixing ContinuousCallback and DiscreteCallback

    function f!(du, u, p, t)
        du[1] = -0.5u[1]
    end

    rate(u, p, t) = 0.1
    affect!(integrator) = (integrator.u[1] += 1.0)
    jump = ConstantRateJump(rate, affect!)

    u0 = [5.0]
    tspan = (0.0, 10.0)
    prob = ODEProblem(f!, u0, tspan)

    ccb_called = Ref(false)
    condition_c(u, t, integrator) = t - 5.0
    affect_c!(integrator) = (ccb_called[] = true)
    ccb = ContinuousCallback(condition_c, affect_c!)

    dcb_called = Ref(0)
    condition_d(u, t, integrator) = true
    affect_d!(integrator) = (dcb_called[] += 1)
    dcb = DiscreteCallback(condition_d, affect_d!)

    # Create CallbackSet with both types
    cbset = CallbackSet(ccb, dcb)

    jprob = JumpProblem(prob, Direct(), jump; rng, callback = cbset)
    sol = solve(jprob, Tsit5())

    @test ccb_called[]
    @test dcb_called[] > 0
    @test sol.t[end] ≈ 10.0
end

@testset "Callback with SSAStepper" begin
    # Test that DiscreteCallbacks work with SSAStepper (pure jump systems)
    # SSAStepper only supports DiscreteCallbacks, not ContinuousCallbacks

    # Set up a simple birth process that will definitely increase u[1]
    rate1(u, p, t) = 5.0  # High rate to ensure jumps occur
    affect1!(integrator) = (integrator.u[1] += 1)
    jump1 = ConstantRateJump(rate1, affect1!)

    u0 = [0]
    tspan = (0.0, 10.0)
    dprob = DiscreteProblem(u0, tspan)

    # Test 1: DiscreteCallback in JumpProblem constructor that terminates when u[1] reaches 5
    cb_called = Ref(false)
    condition_term(u, t, integrator) = u[1] >= 5
    affect_term!(integrator) = (cb_called[] = true; terminate!(integrator))
    dcb_term = DiscreteCallback(condition_term, affect_term!)

    jprob = JumpProblem(dprob, Direct(), jump1; rng, callback = dcb_term)
    sol = solve(jprob, SSAStepper())

    @test cb_called[]  # Should have fired
    @test sol.u[end][1] >= 5  # Should have reached threshold
    @test sol.t[end] < 10.0  # Should have terminated early

    # Test 2: DiscreteCallback in solve call
    dcb_counter = Ref(0)
    condition_count(u, t, integrator) = u[1] >= 3
    affect_count!(integrator) = (dcb_counter[] += 1)
    dcb_count = DiscreteCallback(condition_count, affect_count!)

    jprob2 = JumpProblem(dprob, Direct(), jump1; rng)
    sol2 = solve(jprob2, SSAStepper(); callback = dcb_count)

    @test dcb_counter[] > 0  # Should have fired at least once

    # Test 3: DiscreteCallbacks in both JumpProblem and solve (should merge)
    # Use counters to verify callbacks fire the correct number of times (not duplicated)
    cb1_count = Ref(0)
    condition1(u, t, integrator) = u[1] == 3  # Fire exactly once when u[1] == 3
    affect_cb1!(integrator) = (cb1_count[] += 1)
    dcb1 = DiscreteCallback(condition1, affect_cb1!)

    cb2_count = Ref(0)
    condition2(u, t, integrator) = u[1] == 7  # Fire exactly once when u[1] == 7
    affect_cb2!(integrator) = (cb2_count[] += 1)
    dcb2 = DiscreteCallback(condition2, affect_cb2!)

    jprob3 = JumpProblem(dprob, Direct(), jump1; rng, callback = dcb1)
    sol3 = solve(jprob3, SSAStepper(); callback = dcb2)

    @test cb1_count[] > 0  # First callback should fire
    @test cb2_count[] > 0  # Second callback should fire
    @test sol3.u[end][1] >= 7  # Should reach threshold for second callback

    # Critical test: verify callbacks are not duplicated
    # Each callback should fire exactly once per discrete step where u[1] equals the target
    # If duplicated, we'd see exactly 2x the count (each firing twice)
    # Since jumps are discrete +1 increments, we should hit u==3 and u==7 each once
    @test cb1_count[] == 1  # Should fire exactly once
    @test cb2_count[] == 1  # Should fire exactly once

    # Test 4: merge_callbacks = false (solve callback should override)
    cb3_called = Ref(false)
    cb4_called = Ref(false)
    condition3(u, t, integrator) = u[1] >= 2
    affect_cb3!(integrator) = (cb3_called[] = true)
    dcb3 = DiscreteCallback(condition3, affect_cb3!)

    condition4(u, t, integrator) = u[1] >= 4
    affect_cb4!(integrator) = (cb4_called[] = true)
    dcb4 = DiscreteCallback(condition4, affect_cb4!)

    jprob4 = JumpProblem(dprob, Direct(), jump1; rng, callback = dcb3)
    sol4 = solve(jprob4, SSAStepper(); callback = dcb4, merge_callbacks = false)

    @test !cb3_called[]  # First callback should NOT fire
    @test cb4_called[]   # Second callback should fire
end

@testset "Regression test: Catalyst hybrid model callback" begin
    # Simplified version of the Catalyst hybrid_models.jl test that was failing
    # Tests continuous event in a hybrid model

    function f!(du, u, p, t)
        du[1] = p[1] * u[1]  # Simple exponential growth
    end

    rate(u, p, t) = p[2]
    affect!(integrator) = (integrator.u[1] += 1.0)
    jump = ConstantRateJump(rate, affect!)

    u0 = [1.0]
    tspan = (0.0, 1.0)
    p = [1.0, 0.5]  # growth rate, jump rate
    prob = ODEProblem(f!, u0, tspan, p)

    # Continuous callback that terminates at t=0.5
    cb_called = Ref(false)
    condition(u, t, integrator) = t - 0.5
    affect_cb!(integrator) = (cb_called[] = true; terminate!(integrator))
    cb = ContinuousCallback(condition, affect_cb!)

    # This was broken in v9.17.0 - callback wouldn't fire
    jprob = JumpProblem(prob, Direct(), jump; rng, callback = cb)
    sol = solve(jprob, Tsit5())

    @test cb_called[]
    @test sol.t[end] ≈ 0.5  # Should terminate at 0.5, not run to 1.0
    @test abs(sol.u[end][1] - exp(0.5)) < 0.5  # Rough check (jumps add noise)
end

@testset "Mixed callback types: Continuous in JumpProblem, Discrete in solve" begin
    # Test that continuous callbacks in JumpProblem work with discrete callbacks in solve

    function f!(du, u, p, t)
        du[1] = -0.5u[1]
    end

    rate(u, p, t) = 0.1
    affect!(integrator) = (integrator.u[1] += 1.0)
    jump = ConstantRateJump(rate, affect!)

    u0 = [5.0]
    tspan = (0.0, 10.0)
    prob = ODEProblem(f!, u0, tspan)

    # Continuous callback in JumpProblem
    ccb_called = Ref(false)
    condition_c(u, t, integrator) = t - 3.0
    affect_c!(integrator) = (ccb_called[] = true)
    ccb = ContinuousCallback(condition_c, affect_c!)

    # Discrete callback in solve
    dcb_called = Ref(0)
    condition_d(u, t, integrator) = t > 5.0
    affect_d!(integrator) = (dcb_called[] += 1)
    dcb = DiscreteCallback(condition_d, affect_d!)

    jprob = JumpProblem(prob, Direct(), jump; rng, callback = ccb)
    sol = solve(jprob, Tsit5(); callback = dcb)

    @test ccb_called[]  # Continuous callback should fire
    @test dcb_called[] > 0  # Discrete callback should fire multiple times
end

@testset "Mixed callback types: Discrete in JumpProblem, Continuous in solve" begin
    # Test that discrete callbacks in JumpProblem work with continuous callbacks in solve

    function f!(du, u, p, t)
        du[1] = -0.5u[1]
    end

    rate(u, p, t) = 0.1
    affect!(integrator) = (integrator.u[1] += 1.0)
    jump = ConstantRateJump(rate, affect!)

    u0 = [5.0]
    tspan = (0.0, 10.0)
    prob = ODEProblem(f!, u0, tspan)

    # Discrete callback in JumpProblem
    dcb_called = Ref(0)
    condition_d(u, t, integrator) = true
    affect_d!(integrator) = (dcb_called[] += 1)
    dcb = DiscreteCallback(condition_d, affect_d!)

    # Continuous callback in solve
    ccb_called = Ref(false)
    condition_c(u, t, integrator) = t - 7.0
    affect_c!(integrator) = (ccb_called[] = true)
    ccb = ContinuousCallback(condition_c, affect_c!)

    jprob = JumpProblem(prob, Direct(), jump; rng, callback = dcb)
    sol = solve(jprob, Tsit5(); callback = ccb)

    @test dcb_called[] > 0  # Discrete callback should fire
    @test ccb_called[]  # Continuous callback should fire
end

@testset "CallbackSet in JumpProblem, additional callbacks in solve" begin
    # Test that CallbackSet in JumpProblem works with additional callbacks in solve

    function f!(du, u, p, t)
        du[1] = -0.5u[1]
    end

    rate(u, p, t) = 0.1
    affect!(integrator) = (integrator.u[1] += 1.0)
    jump = ConstantRateJump(rate, affect!)

    u0 = [5.0]
    tspan = (0.0, 10.0)
    prob = ODEProblem(f!, u0, tspan)

    # Create a CallbackSet with both continuous and discrete
    cb1_called = Ref(false)
    condition1(u, t, integrator) = t - 2.0
    affect1!(integrator) = (cb1_called[] = true)
    ccb = ContinuousCallback(condition1, affect1!)

    cb2_called = Ref(0)
    condition2(u, t, integrator) = t > 4.0
    affect2!(integrator) = (cb2_called[] += 1)
    dcb = DiscreteCallback(condition2, affect2!)

    cbset = CallbackSet(ccb, dcb)

    # Additional callback in solve
    cb3_called = Ref(false)
    condition3(u, t, integrator) = t - 8.0
    affect3!(integrator) = (cb3_called[] = true)
    ccb2 = ContinuousCallback(condition3, affect3!)

    jprob = JumpProblem(prob, Direct(), jump; rng, callback = cbset)
    sol = solve(jprob, Tsit5(); callback = ccb2)

    @test cb1_called[]  # First continuous callback should fire
    @test cb2_called[] > 0  # Discrete callback should fire
    @test cb3_called[]  # Second continuous callback should fire
end

@testset "SSAStepper continuous callback errors" begin
    # Setup a simple DiscreteProblem for SSAStepper
    rate(u, p, t) = 0.5
    affect_j!(integrator) = (integrator.u[1] += 1)
    jump = ConstantRateJump(rate, affect_j!)

    u0 = [0]
    tspan = (0.0, 10.0)
    dprob = DiscreteProblem(u0, tspan)

    # Test 1: ContinuousCallback passed to JumpProblem constructor should error on solve
    condition(u, t, integrator) = t - 5.0
    affect_cb!(integrator) = nothing
    ccb = ContinuousCallback(condition, affect_cb!)

    jprob_ccb = JumpProblem(dprob, Direct(), jump; rng, callback = ccb)
    @test_throws ErrorException solve(jprob_ccb, SSAStepper())

    # Test 2: ContinuousCallback passed to solve should error
    jprob = JumpProblem(dprob, Direct(), jump; rng)
    @test_throws ErrorException solve(jprob, SSAStepper(); callback = ccb)

    # Test 3: CallbackSet with continuous callbacks passed to JumpProblem should error on solve
    condition_d(u, t, integrator) = true
    affect_dcb!(integrator) = nothing
    dcb = DiscreteCallback(condition_d, affect_dcb!)

    cbset_with_continuous = CallbackSet(ccb, dcb)
    jprob_cbset = JumpProblem(dprob, Direct(), jump; rng, callback = cbset_with_continuous)
    @test_throws ErrorException solve(jprob_cbset, SSAStepper())

    # Test 4: CallbackSet with continuous callbacks passed to solve should error
    @test_throws ErrorException solve(jprob, SSAStepper(); callback = cbset_with_continuous)

    # Test 5: CallbackSet with multiple continuous callbacks should error with correct count
    ccb2 = ContinuousCallback(condition, affect_cb!)
    cbset_multi = CallbackSet(ccb, ccb2, dcb)

    jprob_multi = JumpProblem(dprob, Direct(), jump; rng, callback = cbset_multi)
    err = try
        solve(jprob_multi, SSAStepper())
        nothing
    catch e
        e
    end
    @test err isa ErrorException
    @test occursin("2", err.msg)  # Should mention 2 continuous callbacks
    @test occursin("callbacks", err.msg)  # Plural form

    # Test 6: DiscreteCallbacks should work fine (no error)
    dcb_only = DiscreteCallback(condition_d, affect_dcb!)
    jprob_dcb = JumpProblem(dprob, Direct(), jump; rng, callback = dcb_only)
    sol = solve(jprob_dcb, SSAStepper())
    @test sol.retcode == ReturnCode.Success

    # Test 7: CallbackSet with only discrete callbacks should work
    dcb2 = DiscreteCallback(condition_d, affect_dcb!)
    cbset_discrete = CallbackSet(dcb_only, dcb2)
    jprob_dcb2 = JumpProblem(dprob, Direct(), jump; rng, callback = cbset_discrete)
    sol2 = solve(jprob_dcb2, SSAStepper())
    @test sol2.retcode == ReturnCode.Success

    # Test 8: Error should also be thrown with init
    @test_throws ErrorException init(jprob_ccb, SSAStepper())
    @test_throws ErrorException init(jprob, SSAStepper(); callback = ccb)
end

@testset "SDE + jump callback not duplicated" begin
    # Regression test for PR #567: verify that when using an SDE algorithm with a
    # JumpProblem, the jump callback is added exactly once (not duplicated by both
    # JumpProcesses and StochasticDiffEq). See:
    # https://github.com/SciML/JumpProcesses.jl/pull/567#issuecomment-4092662794
    using StochasticDiffEq

    # SDE: dX = -X dt + 0.1 dW
    f(u, p, t) = -u
    g(u, p, t) = 0.1

    # Constant rate jump
    rate(u, p, t) = 1.0
    affect!(integrator) = (integrator.u += 0.5)
    crj = ConstantRateJump(rate, affect!)

    sde_prob = SDEProblem(f, g, 1.0, (0.0, 1.0))
    jprob = JumpProblem(sde_prob, Direct(), crj; rng)

    integrator = init(jprob, EM(); dt = 0.01)

    # Count discrete callbacks — the jump should appear exactly once.
    # If both JumpProcesses and StochasticDiffEq add it, we'd see duplicates.
    n_discrete = length(integrator.opts.callback.discrete_callbacks)
    @test n_discrete == 1

    # Also test with a VariableRateJump (needs array u0 for ExtendedJumpArray)
    f_vr(du, u, p, t) = (du[1] = -u[1])
    g_vr(du, u, p, t) = (du[1] = 0.1)
    sde_prob_vr = SDEProblem(f_vr, g_vr, [1.0], (0.0, 1.0))

    vrate(u, p, t) = 1.0
    vaffect!(integrator) = (integrator.u[1] += 0.5)
    vrj = VariableRateJump(vrate, vaffect!)

    jprob_vr = JumpProblem(sde_prob_vr, Direct(), vrj; vr_aggregator = VR_FRM(), rng)
    integrator_vr = init(jprob_vr, EM(); dt = 0.01)

    # VariableRateJumps produce continuous callbacks
    n_continuous = length(integrator_vr.opts.callback.continuous_callbacks)
    @test n_continuous == 1
end

using Test, JumpProcesses, StableRNGs

rng = StableRNG(12345)

# test for https://github.com/SciML/JumpProcesses.jl/issues/479
#    A, ∅ --> X
#    1, 2X + Y --> 3X
#    B, X --> Y
#    1, X --> ∅
function test(rng)
    # dep graphs
    dg = [[1, 2, 3, 4],
        [2, 3, 4],
        [2, 3, 4],
        [2, 3, 4]]
    vtoj = [[2, 3, 4],
        [2]]
    jtov = [[1],
        [1, 2],
        [1, 2],
        [1]]

    # reaction as MassActionJump
    sr = [1.0, 0.5, 4.0, 1.0]
    rs = [Pair{Int, Int}[], [1 => 2, 2 => 1], [1 => 1], [1 => 1]]
    ns = [[1 => 1], [1 => 1, 2 => -1], [1 => -1, 2 => 1], [1 => -1]]
    maj = MassActionJump(sr, rs, ns; scale_rates = false)

    Nsims = 10000
    u0 = [1.0, 10.0]
    tspan = (0.0, 50.0)
    dprob = DiscreteProblem(u0, tspan)
    SSAalgs = JumpProcesses.JUMP_AGGREGATORS
    Xmeans = zeros(length(SSAalgs))
    Ymeans = zeros(length(SSAalgs))
    for (j, agg) in enumerate(SSAalgs)
        jprob = JumpProblem(dprob, agg, maj; save_positions = (false, false), rng,
            vartojumps_map = vtoj, jumptovars_map = jtov, dep_graph = dg,
            scale_rates = false)
        for i in 1:Nsims
            sol = solve(jprob, SSAStepper())
            Xmeans[j] += sol[1, end]
            Ymeans[j] += sol[2, end]
        end
    end
    Xmeans ./= Nsims
    Ymeans ./= Nsims
    # for i in 2:length(SSAalgs)
    #     @test abs(Xmeans[i] - Xmeans[1]) < (.1 * Xmeans[1])
    #     @test abs(Ymeans[i] - Ymeans[1]) < (.1 * Ymeans[1])
    # end
end

"""
$(TYPEDEF)

Extended state definition used within integrators when there are
`VariableRateJump`s in a system. For detailed examples and usage information, see
the

  - [Tutorial](https://docs.sciml.ai/JumpProcesses/stable/tutorials/discrete_stochastic_example/)

### Fields

$(FIELDS)

## Examples

```julia
using JumpProcesses, OrdinaryDiffEq
f(du, u, p, t) = du .= 0
rate(u, p, t) = (1+t)*u[1]*u[2]

# suppose we wish to decrease each of the two variables by one
# when a jump occurs
function affect!(integrator)
    # Method 1, direct indexing works like normal
    integrator.u[1] -= 1
    integrator.u[2] -= 1

    # Method 2, if we want to broadcast or use array operations we need
    # to access integrator.u.u which is the actual state object.
    # So equivalently to above we could have said:
    # integrator.u.u .-= 1
end

u0 = [10.0, 10.0]
vrj = VariableRateJump(rate, affect!)
oprob = ODEProblem(f, u0, (0.0, 2.0))
jprob = JumpProblem(oprob, Direct(), vrj)
sol = solve(jprob, Tsit5())
```

## Notes

  - If `ueja isa ExtendedJumpArray` with `ueja.u` of size `N` and `ueja.jump_u` of
    size `num_variableratejumps` then

    ```julia
    # for 1 <= i <= N
    ueja[i] == ueja.u[i]

    # for N < i <= (N+num_variableratejumps)
    ueja[i] == ueja.jump_u[i]
    ```

  - In a system with `VariableRateJump`s all callback, `ConstantRateJump`, and
    `VariableRateJump` `affect!` functions will receive integrators with
    `integrator.u` an `ExtendedJumpArray`.
  - As such, `affect!` functions that wish to modify the state via vector
    operations should use `ueja.u.u` to obtain the aliased state object.
"""
struct ExtendedJumpArray{T3 <: Number, T1, T <: AbstractArray{T3, T1}, T2} <:
       AbstractArray{T3, 1}
    """The current state."""
    u::T
    """The current rate (i.e. hazard, intensity, or propensity) values for the `VariableRateJump`s."""
    jump_u::T2
end

Base.length(A::ExtendedJumpArray) = length(A.u) + length(A.jump_u)
Base.size(A::ExtendedJumpArray) = (length(A),)
@inline function Base.getindex(A::ExtendedJumpArray, i::Int)
    i <= length(A.u) ? A.u[i] : A.jump_u[i - length(A.u)]
end
@inline function Base.getindex(A::ExtendedJumpArray, I::Int...)
    prod(I) <= length(A.u) ? A.u[I...] : A.jump_u[prod(I) - length(A.u)]
end
@inline function Base.getindex(A::ExtendedJumpArray, I::CartesianIndex{1})
    A[I[1]]
end
@inline Base.setindex!(A::ExtendedJumpArray, v, I...) = (A[CartesianIndices(A.u, I...)] = v)
@inline Base.setindex!(A::ExtendedJumpArray, v, I::CartesianIndex{1}) = (A[I[1]] = v)
@inline function Base.setindex!(A::ExtendedJumpArray, v, i::Int)
    i <= length(A.u) ? (A.u[i] = v) : (A.jump_u[i - length(A.u)] = v)
end

Base.IndexStyle(::Type{<:ExtendedJumpArray}) = IndexLinear()
Base.similar(A::ExtendedJumpArray) = ExtendedJumpArray(similar(A.u), similar(A.jump_u))
function Base.similar(A::ExtendedJumpArray, ::Type{S}) where {S}
    ExtendedJumpArray(similar(A.u, S), similar(A.jump_u, S))
end
Base.zero(A::ExtendedJumpArray) = fill!(similar(A), 0)

# Required for non-diagonal noise; also handles full-state matrices from LinearSolve
function LinearAlgebra.mul!(c::ExtendedJumpArray, A::AbstractVecOrMat, u::AbstractVector)
    Nu = length(c.u)
    if size(A, 1) == Nu
        mul!(c.u, A, u)
        # zero c.jump_u so callers (e.g. adaptive SDE step caches that reuse `c`
        # as a scratchpad) do not see stale values as a noise contribution on
        # the jump-rate-integral state
        fill!(c.jump_u, zero(eltype(c.jump_u)))
    elseif size(A, 1) == length(c)
        mul!(c.u, @view(A[1:Nu, :]), u)
        mul!(c.jump_u, @view(A[(Nu + 1):end, :]), u)
    else
        throw(DimensionMismatch("first dimension of A, $(size(A,1)), does not match length of c.u, $Nu, or length of c, $(length(c))"))
    end
end

# Ignore axes
function Base.similar(A::ExtendedJumpArray, ::Type{S},
        axes::Tuple{Base.OneTo{Int}}) where {S}
    ExtendedJumpArray(similar(A.u, S), similar(A.jump_u, S))
end

# plotting
SciMLBase.plottable_indices(u::ExtendedJumpArray) = SciMLBase.plottable_indices(u.u)

# ODE norm to prevent type-unstable fallback
@inline function DiffEqBase.ODE_DEFAULT_NORM(u::ExtendedJumpArray, t)
    Base.FastMath.sqrt_fast(real(sum(abs2, u)) / max(length(u), 1))
end

# Stiff ODE solver
function ArrayInterface.zeromatrix(A::ExtendedJumpArray)
    u = [vec(A.u); vec(A.jump_u)]
    u .* u' .* false
end

# Helper: concatenate fields into a flat vector, apply op, scatter back
function _eja_flat_apply_and_scatter!(op!, A, b::ExtendedJumpArray)
    N = length(b.u)
    tmp = [vec(b.u); vec(b.jump_u)]
    op!(A, tmp)
    copyto!(vec(b.u), 1, tmp, 1, N)
    copyto!(vec(b.jump_u), 1, tmp, N + 1, length(b.jump_u))
    b
end

function LinearAlgebra.ldiv!(A::LinearAlgebra.LU, b::ExtendedJumpArray)
    _eja_flat_apply_and_scatter!(LinearAlgebra.ldiv!, A, b)
end

function LinearAlgebra.lmul!(A::LinearAlgebra.AbstractQ, b::ExtendedJumpArray)
    _eja_flat_apply_and_scatter!(LinearAlgebra.lmul!, A, b)
end

function recursivecopy!(dest::T, src::T) where {T <: ExtendedJumpArray}
    recursivecopy!(dest.u, src.u)
    recursivecopy!(dest.jump_u, src.jump_u)
end
Base.show(io::IO, A::ExtendedJumpArray) = show(io, A.u)
plot_indices(A::ExtendedJumpArray) = eachindex(A.u)

## broadcasting

# The jump array styles stores two sub-styles in the type,
# one for the `u` array and one for the `jump_u` array
struct ExtendedJumpArrayStyle{UStyle <: Broadcast.BroadcastStyle,
    JumpUStyle <: Broadcast.BroadcastStyle} <:
       Broadcast.BroadcastStyle end
# Init style based on type of u/jump_u
function ExtendedJumpArrayStyle(::US, ::JumpUS) where {US, JumpUS}
    ExtendedJumpArrayStyle{US, JumpUS}()
end
function Base.BroadcastStyle(::Type{ExtendedJumpArray{
        T3, T1, UType, JumpUType}}) where {T3,
        T1,
        UType,
        JumpUType
}
    ExtendedJumpArrayStyle(Base.BroadcastStyle(UType), Base.BroadcastStyle(JumpUType))
end

# Combine with other styles by combining individually with u/jump_u styles
function Base.BroadcastStyle(::ExtendedJumpArrayStyle{UStyle, JumpUStyle},
        ::Style) where {UStyle, JumpUStyle,
        Style <: Base.Broadcast.BroadcastStyle}
    ExtendedJumpArrayStyle(Broadcast.result_style(UStyle(), Style()),
        Broadcast.result_style(JumpUStyle(), Style()))
end

# Decay back to the DefaultArrayStyle for higher-order default styles, to support adding to raw vectors as needed
function Base.BroadcastStyle(::ExtendedJumpArrayStyle{UStyle, JumpUStyle},
        ::Broadcast.DefaultArrayStyle{0}) where {UStyle, JumpUStyle}
    ExtendedJumpArrayStyle(UStyle(), JumpUStyle())
end

function Base.BroadcastStyle(::ExtendedJumpArrayStyle{UStyle, JumpUStyle},
        ::Broadcast.DefaultArrayStyle{N}) where {N, UStyle, JumpUStyle}
    Broadcast.DefaultArrayStyle{N}()
end

function Base.Broadcast.BroadcastStyle(::S,
        ::Base.Broadcast.Unknown) where {
        UStyle, JumpUStyle, S <: JumpProcesses.ExtendedJumpArrayStyle{UStyle, JumpUStyle}}
    return throw(ArgumentError("Cannot broadcast JumpProcesses.ExtendedJumpArray with" *
                               " something of type Base.Broadcast.Unknown."),)
end

# Lookup the first ExtendedJumpArray to pick output container size
"""
`A = find_eja(args)` returns the first ExtendedJumpArray among the arguments.
"""
find_eja(bc::Base.Broadcast.Broadcasted) = find_eja(bc.args)
find_eja(args::Tuple) = find_eja(find_eja(args[1]), Base.tail(args))
find_eja(x) = x
find_eja(::Tuple{}) = nothing
find_eja(a::ExtendedJumpArray, rest) = a
find_eja(::Any, rest) = find_eja(rest)

function Base.similar(bc::Broadcast.Broadcasted{ExtendedJumpArrayStyle{US, JumpUS}},
        ::Type{ElType}) where {US, JumpUS, ElType}
    A = find_eja(bc)
    ExtendedJumpArray(similar(A.u, ElType), similar(A.jump_u, ElType))
end

# Helper functions that repack broadcasted functions
@inline function repack(bc::Broadcast.Broadcasted{Style}, i) where {Style}
    Broadcast.Broadcasted{Style}(bc.f, repack_args(i, bc.args))
end
@inline function repack(bc::Broadcast.Broadcasted{ExtendedJumpArrayStyle{US, JumpUS}},
        i::Val{:u}) where {US, JumpUS}
    Broadcast.Broadcasted{US}(bc.f, repack_args(i, bc.args))
end
@inline function repack(bc::Broadcast.Broadcasted{ExtendedJumpArrayStyle{US, JumpUS}},
        i::Val{:jump_u}) where {US, JumpUS}
    Broadcast.Broadcasted{JumpUS}(bc.f, repack_args(i, bc.args))
end

# Helper functions that repack arguments
@inline repack(x, ::Any) = x
@inline repack(x::ExtendedJumpArray, ::Val{:u}) = x.u
@inline repack(x::ExtendedJumpArray, ::Val{:jump_u}) = x.jump_u

# Repack args with generated function to do this in a type-stable way without recursion
@generated function repack_args(extract_symbol, args::NTuple{N, Any}) where {N}
    # Extract over the arg tuple
    extracted_args = [:(repack(args[$i], extract_symbol)) for i in 1:N]
    # Splat extracted args to another args tuple
    return quote
        ($(extracted_args...),)
    end
end

@inline function Base.copyto!(dest::ExtendedJumpArray,
        bc::Broadcast.Broadcasted{ExtendedJumpArrayStyle{US, JumpUS}}) where {
        US,
        JumpUS
}
    copyto!(dest.u, repack(bc, Val(:u)))
    copyto!(dest.jump_u, repack(bc, Val(:jump_u)))
    dest
end

Base.:*(x::ExtendedJumpArray, y::Number) = ExtendedJumpArray(y .* x.u, y .* x.jump_u)
Base.:*(y::Number, x::ExtendedJumpArray) = ExtendedJumpArray(y .* x.u, y .* x.jump_u)
Base.:/(x::ExtendedJumpArray, y::Number) = ExtendedJumpArray(x.u ./ y, x.jump_u ./ y)
function Base.:+(x::ExtendedJumpArray, y::ExtendedJumpArray)
    ExtendedJumpArray(x.u .+ y.u, x.jump_u .+ y.jump_u)
end

using JumpProcesses, DiffEqBase, SciMLBase
using Test
using StableRNGs
rng = StableRNG(12345)

rate = (u, p, t) -> u[1]
affect! = function (integrator)
    integrator.u[1] += 1
end
jump = ConstantRateJump(rate, affect!)

rate = (u, p, t) -> 0.5u[1]
affect! = function (integrator)
    integrator.u[1] -= 1
end
jump2 = ConstantRateJump(rate, affect!)

prob = DiscreteProblem([10.0], (0.0, 3.0))
jump_prob = JumpProblem(prob, Direct(), jump, jump2; rng = rng)

integrator = init(jump_prob, SSAStepper())
step!(integrator)
integrator.u[1]

# test different saving behaviors

sol = solve(jump_prob, SSAStepper())
@test SciMLBase.successful_retcode(sol)
@test sol.t[begin] == 0.0
@test sol.t[end] == 3.0

sol = solve(jump_prob, SSAStepper(), save_end = false)
@test sol.t[begin] == 0.0
@test sol.t[end] < 3.0

sol = solve(jump_prob, SSAStepper(), save_start = false)
@test sol.t[begin] > 0.0
@test sol.t[end] == 3.0

jump_prob = JumpProblem(prob, Direct(), jump, jump2, save_positions = (false, false);
    rng = rng)
sol = solve(jump_prob, SSAStepper(), save_start = false, save_end = false)
@test isempty(sol.t) && isempty(sol.u)

sol = solve(jump_prob, SSAStepper(), saveat = 0.0:0.1:2.9)
@test sol.t == collect(0.0:0.1:3.0)

"""
A file with helper functions for spatial simulations
"""

"""
stores info for a spatial jump
"""
struct SpatialJump{J}
    "source location"
    src::J

    "index of jump as a hop or reaction"
    jidx::Int

    "destination location, equal to src for within-site reactions"
    dst::J
end

function Base.show(io::IO, ::MIME"text/plain", jump::SpatialJump)
    println(io,
        "SpatialJump with source $(jump.src), destination $(jump.dst) and index $(jump.jidx).")
end

######################## helper routines for all spatial SSAs ########################
"""
    sample_jump_direct(p, site)

sample jump at site with direct method
"""
function sample_jump_direct(p, site)
    if rand(p.rng) * (total_site_rate(p.rx_rates, p.hop_rates, site)) <
       total_site_rx_rate(p.rx_rates, site)
        rx = sample_rx_at_site(p.rx_rates, site, p.rng)
        return SpatialJump(site, rx + p.numspecies, site)
    else
        species_to_diffuse,
        target_site = sample_hop_at_site(p.hop_rates, site, p.rng,
            p.spatial_system)
        return SpatialJump(site, species_to_diffuse, target_site)
    end
end

function total_site_rate(rx_rates::RxRates, hop_rates::AbstractHopRates, site)
    total_site_hop_rate(hop_rates, site) + total_site_rx_rate(rx_rates, site)
end

function update_rates_after_reaction!(p, integrator, site, reaction_id)
    u = integrator.u
    update_rx_rates!(p.rx_rates, p.dep_gr[reaction_id], integrator, site)
    update_hop_rates!(p.hop_rates, p.jumptovars_map[reaction_id], u, site, p.spatial_system)
end

function update_rates_after_hop!(p, integrator, source_site, target_site, species)
    u = integrator.u
    update_rx_rates!(p.rx_rates, p.vartojumps_map[species], integrator, source_site)
    update_hop_rate!(p.hop_rates, species, u, source_site, p.spatial_system)

    update_rx_rates!(p.rx_rates, p.vartojumps_map[species], integrator, target_site)
    update_hop_rate!(p.hop_rates, species, u, target_site, p.spatial_system)
end

"""
    update_state!(p, integrator)

updates state based on p.next_jump
"""
function update_state!(p, integrator)
    jump = p.next_jump
    if is_hop(p, jump)
        execute_hop!(integrator, jump.src, jump.dst, jump.jidx)
    else
        rx_index = reaction_id_from_jump(p, jump)
        @inbounds executerx!((@view integrator.u[:, jump.src]), rx_index,
            p.rx_rates.ma_jumps)
    end
    # save jump that was just executed
    p.prev_jump = jump
    nothing
end

"""
    is_hop(p, jump)

true if jump is a hop
"""
function is_hop(p, jump)
    jump.jidx <= p.numspecies
end

"""
    execute_hop!(integrator, jump)

documentation
"""
function execute_hop!(integrator, source_site, target_site, species)
    @inbounds integrator.u[species, source_site] -= 1
    @inbounds integrator.u[species, target_site] += 1
end

"""
    reaction_id_from_jump(p,jump)

return reaction id by subtracting the number of hops
"""
function reaction_id_from_jump(p, jump)
    jump.jidx - p.numspecies
end

# Implementation of the constant-complexity Next Reaction Method
# Kevin R. Sanft and Hans G. Othmer, Constant-complexity stochastic simulation
# algorithm with optimal binning,  Journal of Chemical Physics 143, 074108
# (2015). doi: 10.1063/1.4928635.

mutable struct CCNRMJumpAggregation{T, S, F1, F2, RNG, DEPGR, PT} <:
               AbstractSSAJumpAggregator{T, S, F1, F2, RNG}
    next_jump::Int
    prev_jump::Int
    next_jump_time::T
    end_time::T
    cur_rates::Vector{T}
    sum_rate::T
    ma_jumps::S
    rates::F1
    affects!::F2
    save_positions::Tuple{Bool, Bool}
    rng::RNG
    dep_gr::DEPGR
    ptt::PT
end

function CCNRMJumpAggregation(nj::Int, njt::T, et::T, crs::Vector{T}, sr::T,
        maj::S, rs::F1, affs!::F2, sps::Tuple{Bool, Bool},
        rng::RNG; num_specs, dep_graph = nothing,
        kwargs...) where {T, S, F1, F2, RNG}

    # a dependency graph is needed and must be provided if there are constant rate jumps
    if dep_graph === nothing
        if (get_num_majumps(maj) == 0) || !isempty(rs)
            error("To use ConstantRateJumps with the constant-complexity Next Reaction Method (CCNRM) algorithm a dependency graph must be supplied.")
        else
            dg = make_dependency_graph(num_specs, maj)
        end
    else
        dg = dep_graph

        # make sure each jump depends on itself
        add_self_dependencies!(dg)
    end

    binwidthconst = haskey(kwargs, :binwidthconst) ? kwargs[:binwidthconst] : 16
    numbinsconst = haskey(kwargs, :numbinsconst) ? kwargs[:numbinsconst] : 20
    ptt = PriorityTimeTable(zeros(T, length(crs)), zero(T), one(T),
        binwidthconst = binwidthconst, numbinsconst = numbinsconst) # We will re-initialize this in initialize!()

    affecttype = F2 <: Tuple ? F2 : Any
    CCNRMJumpAggregation{T, S, F1, affecttype, RNG, typeof(dg), typeof(ptt)}(
        nj, nj, njt, et,
        crs, sr, maj,
        rs, affs!, sps,
        rng, dg, ptt)
end

+############################# Required Functions ##############################
# creating the JumpAggregation structure (function wrapper-based constant jumps)
function aggregate(aggregator::CCNRM, u, p, t, end_time, constant_jumps,
        ma_jumps, save_positions, rng; kwargs...)

    # handle constant jumps using function wrappers
    rates, affects! = get_jump_info_fwrappers(u, p, t, constant_jumps)

    build_jump_aggregation(CCNRMJumpAggregation, u, p, t, end_time, ma_jumps,
        rates, affects!, save_positions, rng; num_specs = length(u),
        kwargs...)
end

# set up a new simulation and calculate the first jump / jump time
function initialize!(p::CCNRMJumpAggregation, integrator, u, params, t)
    p.end_time = integrator.sol.prob.tspan[2]
    initialize_rates_and_times!(p, u, params, t)
    generate_jumps!(p, integrator, u, params, t)
    nothing
end

# execute one jump, changing the system state
function execute_jumps!(p::CCNRMJumpAggregation, integrator, u, params, t, affects!)
    # execute jump
    u = update_state!(p, integrator, u, affects!)

    # update current jump rates and times
    update_dependent_rates!(p, u, params, t)
    nothing
end

# calculate the next jump / jump time
# just the first reaction in the first non-empty bin in the priority table
function generate_jumps!(p::CCNRMJumpAggregation, integrator, u, params, t)
    p.next_jump, p.next_jump_time = getfirst(p.ptt)

    # Rebuild the table if no next jump is found. 
    if p.next_jump == 0
        timestep = 1 / sum(p.cur_rates)
        min_time = minimum(p.ptt.times)
        rebuild!(p.ptt, min_time, timestep)
        p.next_jump, p.next_jump_time = getfirst(p.ptt)
    end

    nothing
end

######################## SSA specific helper routines ########################

# Recalculate jump rates for jumps that depend on the just executed jump (p.next_jump)
function update_dependent_rates!(p::CCNRMJumpAggregation, u, params, t)
    @inbounds dep_rxs = p.dep_gr[p.next_jump]
    (; ptt, cur_rates, rates, ma_jumps, end_time) = p
    num_majumps = get_num_majumps(ma_jumps)

    @inbounds for rx in dep_rxs
        oldrate = cur_rates[rx]
        times = ptt.times
        oldtime = times[rx]

        # update the jump rate
        @inbounds cur_rates[rx] = calculate_jump_rate(ma_jumps, num_majumps, rates, u,
            params, t, rx)

        # Calculate new jump times for dependent jumps
        if rx != p.next_jump && oldrate > zero(oldrate)
            if cur_rates[rx] > zero(eltype(cur_rates))
                update!(ptt, rx, oldtime, t + oldrate / cur_rates[rx] * (oldtime - t))
            else
                update!(ptt, rx, oldtime, floatmax(typeof(t)))
            end
        else
            if cur_rates[rx] > zero(eltype(cur_rates))
                update!(ptt, rx, oldtime, t + randexp(p.rng) / cur_rates[rx])
            else
                update!(ptt, rx, oldtime, floatmax(typeof(t)))
            end
        end
    end
    nothing
end

# Evaluate all the rates and initialize the times in the priority table. 
function initialize_rates_and_times!(p::CCNRMJumpAggregation, u, params, t)
    # Initialize next-reaction times for the mass action jumps
    majumps = p.ma_jumps
    cur_rates = p.cur_rates
    pttdata = Vector{typeof(t)}(undef, length(cur_rates))
    @inbounds for i in 1:get_num_majumps(majumps)
        cur_rates[i] = evalrxrate(u, i, majumps)
        pttdata[i] = t + randexp(p.rng) / cur_rates[i]
    end

    # Initialize next-reaction times for the constant rates
    rates = p.rates
    idx = get_num_majumps(majumps) + 1
    @inbounds for rate in rates
        cur_rates[idx] = rate(u, params, t)
        pttdata[idx] = t + randexp(p.rng) / cur_rates[idx]
        idx += 1
    end

    # Build the priority time table with the times and bin width. 
    timestep = 1 / sum(cur_rates)
    p.ptt.times = pttdata
    rebuild!(p.ptt, t, timestep)
    nothing
end

using JumpProcesses, DiffEqBase, DiffEqCallbacks
using Test
using StableRNGs
rng = StableRNG(12345)

rate = (u, p, t) -> u[1]
affect! = function (integrator)
    integrator.u[1] -= 1
    integrator.u[2] += 1
end
jump = ConstantRateJump(rate, affect!)

prob = DiscreteProblem([0.0, 0.0], (0.0, 10.0))
jump_prob = JumpProblem(prob, Direct(), jump; rng = rng)

sol = solve(jump_prob, SSAStepper())

@test sol.t == [0.0, 10.0]
@test sol.u == [[0.0, 0.0], [0.0, 0.0]]

condition(u, t, integrator) = t == 5
function fuel_affect!(integrator)
    integrator.u[1] += 100
    reset_aggregated_jumps!(integrator)
end
cb = DiscreteCallback(condition, fuel_affect!, save_positions = (false, true))

sol = solve(jump_prob, SSAStepper(); callback = cb, tstops = [5])
@test sol.t[1:2] == [0.0, 5.0] # no jumps between t=0 and t=5
@test sol(5 + 1e-10) == [100, 0] # state just after fueling before any decays can happen

# test can pass callbacks via JumpProblem
jump_prob2 = JumpProblem(prob, Direct(), jump; rng = rng, callback = cb)
sol2 = solve(jump_prob2, SSAStepper(); tstops = [5])
@test sol2.t[1:2] == [0.0, 5.0] # no jumps between t=0 and t=5
@test sol2(5 + 1e-10) == [100, 0] # state just after fueling before any decays can happen

# test that callback initializer/finalizer is called and add_tstop! works as expected
random_tstops = rand(rng, 100) .* 10 # 100 random Float64 between 0.0 and 10.0

function fuel_init!(cb, u, t, integrator)
    for tstop in random_tstops
        add_tstop!(integrator, tstop)
    end
    @test issorted(integrator.tstops)
end
finalizer_called = 0
fuel_finalize(cb, u, t, integrator) = global finalizer_called += 1

cb2 = DiscreteCallback(condition, fuel_affect!, initialize = fuel_init!, finalize = fuel_finalize)
sol = solve(jump_prob, SSAStepper(), callback = cb2)
for tstop in random_tstops
    @test tstop ∈ sol.t
end
@test finalizer_called == 1

# test for updating MassActionJump parameters
rs = [[1 => 1], [2 => 1]]
ns = [[1 => -1, 2 => 1], [1 => 1, 2 => -1]]
p = [1.0, 0.0]
maj = MassActionJump(rs, ns; param_idxs = [1, 2])
u₀ = [100, 0]
tspan = (0.0, 2000.0)
dprob = DiscreteProblem(u₀, tspan, p)
jprob = JumpProblem(dprob, Direct(), maj, save_positions = (false, false), rng = rng)
pcondit(u, t, integrator) = t == 1000.0
function paffect!(integrator)
    integrator.p[1] = 0.0
    integrator.p[2] = 1.0
    reset_aggregated_jumps!(integrator)
end
sol = solve(jprob, SSAStepper(), tstops = [1000.0], callback = DiscreteCallback(pcondit, paffect!))
@test all(p .== [0.0, 1.0])
@test sol[1, end] == 100

p .= [1.0, 0.0]
maj1 = MassActionJump([1 => 1], [1 => -1, 2 => 1]; param_idxs = 1)
maj2 = MassActionJump([2 => 1], [1 => 1, 2 => -1]; param_idxs = 2)
jprob = JumpProblem(dprob, Direct(), maj1, maj2, save_positions = (false, false), rng = rng)
sol = solve(jprob, SSAStepper(), tstops = [1000.0], callback = DiscreteCallback(pcondit, paffect!))
@test all(p .== [0.0, 1.0])
@test sol[1, end] == 100

p2 = [1.0, 0.0, 0.0]
maj3 = MassActionJump([1 => 1], [1 => -1, 2 => 1]; param_idxs = 3)
dprob = DiscreteProblem(u₀, tspan, p2)
jprob = JumpProblem(dprob, Direct(), maj1, maj2, maj3, save_positions = (false, false), rng = rng)
sol = solve(jprob, SSAStepper(), tstops = [1000.0], callback = DiscreteCallback(pcondit, paffect!))
@test all(p2 .== [0.0, 1.0, 0.0])
@test sol[1, end] == 100

p2 .= [1.0, 0.0, 0.0]
jprob = JumpProblem(dprob, Direct(), JumpSet(; massaction_jumps = [maj1, maj2, maj3]),
    save_positions = (false, false), rng = rng)
sol = solve(jprob, SSAStepper(), tstops = [1000.0], callback = DiscreteCallback(pcondit, paffect!))
@test all(p2 .== [0.0, 1.0, 0.0])
@test sol[1, end] == 100

p .= [1.0, 0.0]
dprob = DiscreteProblem(u₀, tspan, p)
maj4 = MassActionJump([[1 => 1], [2 => 1]], [[1 => -1, 2 => 1], [1 => 1, 2 => -1]];
    param_idxs = [1, 2])
jprob = JumpProblem(dprob, Direct(), maj4, save_positions = (false, false), rng = rng)
sol = solve(jprob, SSAStepper(), tstops = [1000.0], callback = DiscreteCallback(pcondit, paffect!))
@test all(p .== [0.0, 1.0])
@test sol[1, end] == 100

# test scale_rates kwarg
p .= [1.0]
dprob = DiscreteProblem(u₀, tspan, p)
maj5 = MassActionJump([[1 => 2]], [[1 => -1, 2 => 1]]; param_idxs = [1])
jprob = JumpProblem(dprob, Direct(), maj5, save_positions = (false, false), rng = rng)
@test all(jprob.massaction_jump.scaled_rates .== [0.5])
jprob = JumpProblem(dprob, Direct(), maj5, save_positions = (false, false), rng = rng, scale_rates = false)
@test all(jprob.massaction_jump.scaled_rates .== [1.0])

# test for https://github.com/SciML/JumpProcesses.jl/issues/239
maj6 = MassActionJump([[1 => 1], [2 => 1]], [[1 => -1, 2 => 1], [1 => 1, 2 => -1]];
    param_idxs = [1, 2])
p = (0.1, 0.1)
dprob = DiscreteProblem([10, 0], (0.0, 100.0), p)
jprob = JumpProblem(dprob, Direct(), maj6; save_positions = (false, false), rng = rng)
cbtimes = [20.0, 30.0]
affectpresets!(integrator) = integrator.u[1] += 10
cb = PresetTimeCallback(cbtimes, affectpresets!)
jsol = solve(jprob, SSAStepper(), saveat = 0.1, callback = cb)
@test (jsol(20.00000000001) - jsol(19.9999999999))[1] == 10

# test periodic callbacks working, i.e. #417
let
    rate(u, p, t) = 0.0
    affect!(integ) = (nothing)
    crj = ConstantRateJump(rate, affect!)
    dprob = DiscreteProblem([0], (0.0, 10.0))
    cbfun(integ) = (integ.u[1] += 1; nothing)
    cb = PeriodicCallback(cbfun, 1.0)
    jprob = JumpProblem(dprob, crj; rng)
    sol = solve(jprob; callback = cb)
    @test sol[1, end] == 9

    cb = PeriodicCallback(cbfun, 1.0; initial_affect = true)
    jprob = JumpProblem(dprob, crj; rng)
    sol = solve(jprob; callback = cb)
    @test sol[1, end] == 10

    cb = PeriodicCallback(cbfun, 1.0; initial_affect = true, final_affect = true)
    jprob = JumpProblem(dprob, crj; rng)
    sol = solve(jprob; callback = cb)
    @test sol[1, end] == 11
end

# test for tstops aliasing, i.e.#442
let
    rate(u, p, t) = 0.0
    affect!(integ) = (nothing)
    crj = ConstantRateJump(rate, affect!)
    dprob = DiscreteProblem([0], (0.0, 10.0))
    cbfun(integ) = (integ.u[1] += 1; nothing)
    cb = PeriodicCallback(cbfun, 1.0)
    jprob = JumpProblem(dprob, crj; rng)
    tstops = Float64[]
    # tests for when aliasing system is in place
    #sol = solve(jprob; callback = cb, tstops, alias_tstops = true) 
    # @test sol[1, end] == 9
    #@test tstops == 1.0:9.0    
    # empty!(tstops)
    # sol = solve(jprob; callback = cb, tstops, alias_tstops = false)
    # @test sol[1, end] == 9
    # @test isempty(tstops)
    sol = solve(jprob; callback = cb, tstops)
    @test sol[1, end] == 9
    @test isempty(tstops)

    empty!(tstops)
    integ = init(jprob, SSAStepper(); callback = cb, tstops)
    solve!(integ)
    @test integ.tstops !== tstops
    @test isempty(tstops)
end

# test callable tstops (e.g. SymbolicTstops) with SSAStepper
let
    rate(u, p, t) = p[1]
    affect!(integrator) = (integrator.u[1] += 1)
    crj = ConstantRateJump(rate, affect!)
    prob = DiscreteProblem([0], (0.0, 10.0), [10.0])
    jprob = JumpProblem(prob, Direct(), crj; rng)

    # basic callable tstops
    my_tstops = (p, tspan) -> [3.0, 6.0]
    sol = solve(jprob, SSAStepper(); tstops = my_tstops)
    @test sol.t[end] == 10.0
    @test 3.0 ∈ sol.t
    @test 6.0 ∈ sol.t

    # parameter-dependent callable tstops
    param_tstops = (p, tspan) -> [p[1] / 5.0, p[1] / 2.0]
    sol2 = solve(jprob, SSAStepper(); tstops = param_tstops)
    @test sol2.t[end] == 10.0
    @test 2.0 ∈ sol2.t   # 10.0 / 5.0
    @test 5.0 ∈ sol2.t   # 10.0 / 2.0

    # callable tstops with a DiscreteCallback that fires at callable tstop times
    condition(u, t, integrator) = t == 3.0
    cb_affect!(integrator) = (integrator.u[1] += 1000)
    cb = DiscreteCallback(condition, cb_affect!)
    sol3 = solve(jprob, SSAStepper(); tstops = my_tstops, callback = cb)
    @test sol3.t[end] == 10.0
    @test 3.0 ∈ sol3.t
    # verify the callback fired: use findlast to get post-callback state at t=3.0
    idx = findlast(==(3.0), sol3.t)
    @test sol3.u[idx][1] >= 1000

    # callable returning a tuple
    tuple_tstops = (p, tspan) -> (2.0, 7.0)
    sol4 = solve(jprob, SSAStepper(); tstops = tuple_tstops)
    @test sol4.t[end] == 10.0
    @test 2.0 ∈ sol4.t
    @test 7.0 ∈ sol4.t

    # callable tstops stored in JumpProblem via constructor kwarg
    jprob2 = JumpProblem(prob, Direct(), crj; rng, tstops = my_tstops)
    @test haskey(jprob2.kwargs, :tstops)
    sol5 = solve(jprob2, SSAStepper())
    @test sol5.t[end] == 10.0
    @test 3.0 ∈ sol5.t
    @test 6.0 ∈ sol5.t
end

# test that reset_aggregated_jumps! with update_jump_params kwarg dispatches correctly
# for SSAIntegrator (https://github.com/SciML/JumpProcesses.jl/issues/562)
let
    rate1(u, p, t) = p[1] * u[1] * u[2]
    affect1!(integrator) = (integrator.u[1] -= 1; integrator.u[2] += 1)
    jump1 = ConstantRateJump(rate1, affect1!)

    rate2(u, p, t) = p[2] * u[2]
    affect2!(integrator) = (integrator.u[2] -= 1; integrator.u[3] += 1)
    jump2 = ConstantRateJump(rate2, affect2!)

    p = (1.0, 1.0)
    prob = DiscreteProblem([990, 0, 0], (0.0, 250.0), p)
    jump_prob = JumpProblem(prob, Direct(), jump1, jump2; rng)

    # with update_jump_params = true, should behave same as without kwarg
    int = init(jump_prob, SSAStepper())
    int[2] = 10
    reset_aggregated_jumps!(int; update_jump_params = true)
    step!(int, 1000.0, true)
    @test int.u[3] > 0  # at least some recovered, confirming jumps fired

    # with update_jump_params = false, should also reset jump aggregation
    int2 = init(jump_prob, SSAStepper())
    int2[2] = 10
    reset_aggregated_jumps!(int2; update_jump_params = false)
    step!(int2, 1000.0, true)
    @test int2.u[3] > 0
end

using JumpProcesses, DiffEqBase, OrdinaryDiffEq
using Test, Graphs, LinearAlgebra
using StableRNGs
rng = StableRNG(12345)

reltol = 0.05
Nsims = 10^3

dim = 1
linear_size = 5
dims = Tuple(repeat([linear_size], dim))
num_nodes = prod(dims)
center_site = trunc(Int, (linear_size^dim + 1) / 2)
u0 = zeros(Int, 1, num_nodes)
end_time = 100.0
diffusivity = 1.0
death_rate = 0.1

num_species = 1
reactstoch = [Pair{Int64, Int64}[], [1 => 1]]
netstoch = [[1 => 1], [1 => -1]]
uniform_rates = ones(2, num_nodes)
uniform_rates[2, :] *= death_rate
non_uniform_rates = zeros(2, num_nodes)
non_uniform_rates[:, center_site] = uniform_rates[:, center_site]

# DiscreteProblem setup
tspan = (0.0, end_time)
prob = DiscreteProblem(u0, tspan, uniform_rates)

# spatial system
grid = Graphs.grid(dims)
hopping_constants = [diffusivity for i in u0]

# majumps
uniform_majumps_1 = SpatialMassActionJump(uniform_rates[:, 1], reactstoch, netstoch)
uniform_majumps_2 = SpatialMassActionJump(uniform_rates, reactstoch, netstoch)
uniform_majumps_3 = SpatialMassActionJump(
    [1.0], reshape(uniform_rates[2, :], 1, num_nodes),
    reactstoch, netstoch) # hybrid
uniform_majumps_4 = SpatialMassActionJump(MassActionJump(uniform_rates[:, 1], reactstoch,
    netstoch))
uniform_majumps = [
    uniform_majumps_1,
    uniform_majumps_2,
    uniform_majumps_3,
    uniform_majumps_4
]

non_uniform_majumps_1 = SpatialMassActionJump(non_uniform_rates, reactstoch, netstoch) # reactions are zero outside of center site
non_uniform_majumps_2 = SpatialMassActionJump([1.0],
    reshape(non_uniform_rates[2, :], 1,
        num_nodes), reactstoch, netstoch) # birth everywhere, death only at center site
non_uniform_majumps_3 = SpatialMassActionJump(
    [1.0 0.0 0.0 0.0 0.0;
     0.0 0.0 0.0 0.0 death_rate], reactstoch,
    netstoch) # birth on the left, death on the right
non_uniform_majumps = [non_uniform_majumps_1, non_uniform_majumps_2, non_uniform_majumps_3]

# put together the JumpProblem's
uniform_jump_problems = JumpProblem[JumpProblem(prob, NSM(), majump,
                                        hopping_constants = hopping_constants,
                                        spatial_system = grid,
                                        save_positions = (false, false), rng = rng)
                                    for majump in uniform_majumps]
# flattenned
append!(uniform_jump_problems,
    JumpProblem[JumpProblem(prob, NRM(), majump, hopping_constants = hopping_constants,
                    spatial_system = grid, save_positions = (false, false), rng = rng)
                for majump in uniform_majumps])

# non-uniform
non_uniform_jump_problems = JumpProblem[JumpProblem(prob, NSM(), majump,
                                            hopping_constants = hopping_constants,
                                            spatial_system = grid,
                                            save_positions = (false, false), rng = rng)
                                        for majump in non_uniform_majumps]

# testing
function get_mean_end_state(jump_prob, Nsims)
    end_state = zeros(size(jump_prob.prob.u0))
    for i in 1:Nsims
        sol = solve(jump_prob, SSAStepper())
        end_state .+= sol.u[end]
    end
    end_state / Nsims
end

function discrete_laplacian_from_spatial_system(spatial_system, hopping_rate)
    sites = 1:num_sites(spatial_system)
    laplacian = zeros(length(sites), length(sites))
    for site in sites
        laplacian[site, site] = -outdegree(spatial_system, site)
        for nb in neighbors(spatial_system, site)
            laplacian[site, nb] = 1
        end
    end
    laplacian .*= hopping_rate
    laplacian
end
L = discrete_laplacian_from_spatial_system(grid, diffusivity)

# birth and death everywhere
f(u, p, t) = L * u - death_rate * u + uniform_rates[1, :]
ode_prob = ODEProblem(f, zeros(num_nodes), tspan)
sol = solve(ode_prob, Tsit5())

for spatial_jump_prob in uniform_jump_problems
    solution = solve(spatial_jump_prob, SSAStepper())
    mean_end_state = get_mean_end_state(spatial_jump_prob, Nsims)
    mean_end_state = reshape(mean_end_state, num_nodes)
    diff = mean_end_state - sol.u[end]
    for (i, d) in enumerate(diff)
        @test abs(d) < reltol * sol.u[end][i]
    end
end

# birth and death zero outside of center site
function f2(u, p, t)
    L * u - diagm([0.0, 0.0, death_rate, 0.0, 0.0]) * u + [0.0, 0.0, 1.0, 0.0, 0.0]
end
ode_prob = ODEProblem(f2, zeros(num_nodes), tspan)
sol = solve(ode_prob, Tsit5())

solution = solve(non_uniform_jump_problems[1], SSAStepper())
mean_end_state = get_mean_end_state(non_uniform_jump_problems[1], Nsims)
mean_end_state = reshape(mean_end_state, num_nodes)
diff = mean_end_state - sol.u[end]
for (i, d) in enumerate(diff)
    @test abs(d) < reltol * sol.u[end][i]
end

# birth everywhere, death only at center site
f3(u, p, t) = L * u - diagm([0.0, 0.0, death_rate, 0.0, 0.0]) * u + ones(num_nodes)
ode_prob = ODEProblem(f3, zeros(num_nodes), tspan)
sol = solve(ode_prob, Tsit5())

solution = solve(non_uniform_jump_problems[2], SSAStepper())
mean_end_state = get_mean_end_state(non_uniform_jump_problems[2], Nsims)
mean_end_state = reshape(mean_end_state, num_nodes)
diff = mean_end_state - sol.u[end]
for (i, d) in enumerate(diff)
    @test abs(d) < reltol * sol.u[end][i]
end

# birth on left end, death on right end
function f4(u, p, t)
    L * u - diagm([0.0, 0.0, 0.0, 0.0, death_rate]) * u + [1.0, 0.0, 0.0, 0.0, 0.0]
end
ode_prob = ODEProblem(f4, zeros(num_nodes), tspan)
sol = solve(ode_prob, Tsit5())

solution = solve(non_uniform_jump_problems[3], SSAStepper())
mean_end_state = get_mean_end_state(non_uniform_jump_problems[3], Nsims)
mean_end_state = reshape(mean_end_state, num_nodes)
diff = mean_end_state - sol.u[end]
for (i, d) in enumerate(diff)
    @test abs(d) < reltol * sol.u[end][i]
end

using JumpProcesses, StochasticDiffEq, Test
using StableRNGs
rng = StableRNG(12345)

f = (du, u, p, t) -> (du[1] = u[1])
g = (du, u, p, t) -> (du[1] = u[1])
prob = SDEProblem(f, g, [1.0], (0.0, 1.0))
rate = (u, p, t) -> 200.0
affect! = integrator -> (integrator.u[1] = integrator.u[1] / 2)
jump = VariableRateJump(rate, affect!, save_positions = (false, true))
jump_prob = JumpProblem(prob, Direct(), jump; vr_aggregator = VR_FRM(), rng)
monte_prob = EnsembleProblem(jump_prob)
sol = solve(monte_prob, SRIW1(), EnsembleSerial(), trajectories = 3,
    save_everystep = false, dt = 0.001, adaptive = false)
first_event(traj) = traj.t[findfirst(>(traj.t[1]), traj.t)]
@test first_event(sol.u[1]) != first_event(sol.u[2]) != first_event(sol.u[3])

jump_prob = JumpProblem(prob, Direct(), jump; vr_aggregator = VR_Direct(), rng)
monte_prob = EnsembleProblem(jump_prob)
sol = solve(monte_prob, SRIW1(), EnsembleSerial(), trajectories = 3,
    save_everystep = false, dt = 0.001, adaptive = false)
@test allunique(sol.u[1].t)

jump_prob = JumpProblem(prob, Direct(), jump; vr_aggregator = VR_DirectFW(), rng)
monte_prob = EnsembleProblem(jump_prob)
sol = solve(monte_prob, SRIW1(), EnsembleSerial(), trajectories = 3,
    save_everystep = false, dt = 0.001, adaptive = false)
@test allunique(sol.u[1].t)

jump = ConstantRateJump(rate, affect!)
jump_prob = JumpProblem(prob, Direct(), jump; save_positions = (true, false), rng)
monte_prob = EnsembleProblem(jump_prob)
sol = solve(monte_prob, SRIW1(), EnsembleSerial(), trajectories = 3,
    save_everystep = false, dt = 0.001, adaptive = false)
@test sol.u[1].t[2] != sol.u[2].t[2] != sol.u[3].t[2]

# [Temporal Point Processes (TPP) with JumpProcesses and PointProcesses](@id tpp_advanced)

JumpProcesses was initially developed to simulate the trajectory of jump
processes. Therefore, those with a background in point process might find the
nomenclature in the library documentation confusing. In reality, jump and point
processes share many things in common, but diverge in scope. This tutorial will
cover JumpProcesses from the perspective of point process theory.

In this application tutorial, we show how to interface JumpProcesses and the
[PointProcesses.jl](https://github.com/JoseKling/PointProcesses.jl) library, and
leverage this interface to then illustrate many different aspects usually
discussed in point process theory. PointProcesses.jl offers an interface for
defining marked temporal point processes (TPPs). We will show how to link
JumpProcesses into this interface by implementing `SciMLPointProcess`, which is
a concrete implementation of PointProcesses' `AbstractPointProcess` that uses
solvers from JumpProcesses and SciML.

## [TPP Theory](@id tpp_theory)

TPPs describe a set of discrete points over continuous time. Conventionally, we
assume that time starts at ``0``. We can represent a TPP as a random integer
measure ``N( \cdot )``, this random function counts the number of points in
a set of intervals over the real line. For instance, ``N([5, 10])`` denotes the
number of points (or events) in between time ``5`` and ``10`` inclusive. The
number of points in this interval is a random variable. If ``N`` is a Poisson
process with conditional intensity (or rate) equal to ``1``, then ``N[5, 10]``
is distributed according to a Poisson distribution with parameter ``\lambda = 5``.

For convenience, we denote ``N(t) \equiv N[0, t)`` as the number of points since
the start of time until ``t``, exclusive of ``t``. A TPP is _simple_, if only a
single event can occur in any unit of time ``t``, that is, ``\Pr(N[t, t + \epsilon) > 2) = 0``. We can then define a differential of ``N``, ``dN``, which
describes the change in ``N(t)`` over an infinitesimal amount of time.

```math
dN(t) = \begin{cases}
  1 \text{ , if } N[t, t + \epsilon] = 1 \\
  0 \text{ , if } N[t, t + \epsilon] = 0.
\end{cases}
```

Therefore, we can use any TPP to define a stochastic differential equation
(SDE) with discontinuous jumps.

```math
du = f(u,p,t)dt + g(u,p,t) dW(t) + h(u,p,t) dN(t)
```

In the jump literature, ``N`` is usually a Poisson process which allows for
a number of convenient properties for jump modelling. See Björk [^2] and Hanson [^3]
for more theoretical discussions of SDE with discontinuous jumps.

We can start implementing our TPP interface in Julia by working with the
following SDE with discontinuous jumps.

```math
du = dN(t)
```

In this case, ``u(t)`` is a monotonic function which counts the total number of
points since the start of time. Therefore, there is a one-to-one map between
``N`` and ``u``.

A TPP is marked if, in addition to the temporal support ``\mathbb{R}``, there is
a mark space ``\mathcal{K}`` such that ``N`` is a random integer measure over
``\mathbb{R} \times \mathcal{K}``. Intuitively, for every point in the process
there is a mark associated with it. If the mark space is discrete, we have
a multivariate TPP. There are different ways to interpret TPPs, and we will
move between these interpretations throughout the tutorial.

Since TPP sampling is
more efficient if we split any marked TPP into a sparsely connected
multivariate TPP, we define `SciMLPointProcess` as a multivariate TPP such
that each subcomponent is itself a marked TPP on a continuous space.
Therefore, we have that our structure includes a vector of sub-TPP
`jumps`, a vector of mark distributions `mark_dist` and the sparsely
connected graph `g`.

```@example tpp-advanced
using JumpProcesses
using PointProcesses

struct SciMLPointProcess{M, J <: JumpProcesses.AbstractJump, G, D, T <: Real} <:
       AbstractPointProcess{M}
    jumps::Vector{J}
    mark_dist::Vector{D}
    g::G
    p::Any
    tmin::T
    tmax::T
end

function Base.show(io::IO, pp::SciMLPointProcess)
    println(io,
        "SciMLPointProcess with $(length(pp.jumps)) processes on the interval [$(pp.tmin), $(pp.tmax)).")
end
```

In alignment with `PointProcesses` API we define methods for extracting the
boundaries of the time interval we will be working with.

```@example tpp-advanced
PointProcesses.min_time(pp::SciMLPointProcess) = pp.tmin
PointProcesses.max_time(pp::SciMLPointProcess) = pp.tmax
```

As we want to keep `SciMLPointProcess` as general as possible we define two
methods for initializing and resetting the parameters of the TPP. The usefulness
of these methods will become apparent further below.

```@example tpp-advanced
params(pp::SciMLPointProcess) = pp.p(pp)
params!(pp::SciMLPointProcess, p) = pp.p(pp, p)
nothing # hide
```

The likelihood of any _simple_ TPP is fully characterized by its conditional
intensity ``\lambda^\ast (t, k) \equiv \lambda^\ast(t) \times f^\ast (k \mid t)``, where ``f^\ast(k \mid t)`` is the mark distribution and
``\lambda^\ast(t)`` is the conditional intensity of the ground process which can
be further factorized as:

```math
\lambda^\ast (t) \equiv \lambda(t \mid H_{t^-} ) =
  \frac{p^\ast(t)}{1 - \int_{t^-}^{t_n} p^\ast(u) \, du},
```

The internal history of the process up to but not including ``t`` is ``H_{t^-} \equiv \{ (t_n, k_n) \mid 0 \leq t_n \leq t \}``. Following the convention in
the TPP literature, the superscript ``\ast`` denotes the conditioning of any
function on ``H_{t^-}``. So, ``p^\ast(t) \equiv p(t \mid H_{t^-})`` is the
density function corresponding to the probability of an event taking place at
time ``t`` given ``H_{t^-}``. The mark distribution denotes the density function
corresponding to the probability of observing mark ``k`` given the occurrence of
an event at time ``t`` and internal history ``H_{t^-}``. In summary, the
conditional intensity is the likelihood of observing a point in the next
infinitesimal unit of time, given that no point has occurred since the last
observed point in ``H_{t^-}``. Alternatively, we can interpret it as the number
of points that we expect to see in the next marginal interval ``E[dNt(dt \times d\mu(k))] = \lambda^\ast (t, k) dt d\mu(k)``. For more details, see Chapter 7,
Daley and Vere-Jones[^1].

PointProcesses provides a convenient interface for keeping track of the history
of a marked TPP called `History` (*note* this is just the definition in PointProcesses and not code that should be run as part of this tutorial):

```@example julia
mutable struct History{M, T <: Real}
    times::Vector{T}
    marks::Vector{M}
    tmin::T
    tmax::T
end
```

We next define a method for resetting the history, which can be useful during simulation.

```@example tpp-advanced
function reset!(h::History)
    empty!(event_times(h))
    empty!(event_marks(h))
end
nothing # hide
```

## [Marked Hawkes Process](@id marked_hawkes)

Until now, everything has been fairly theoretical. But we have enough to start
walking through a concrete example. Throughout this tutorial we will implement
a case of the Hawkes process. Hawkes processes are classic TPP models that show
self-exciting behavior whereby the occurrence of an event increases the
likelihood of other events nearby. They are useful models to describe
earthquakes, gang violence, bank defaults, etc. For a complete treatment of
Hawkes processes see Laub, Lee and Taimre [^4].

In this tutorial we propose a spatial Hawkes process as a simple model for call
detail records (CDRs). CDR records the time and location when a user starts
a mobile data session. Behind the scenes, anytime a user sees a message from
someone in their network, they are more likely to use their phone. In addition
to that, users tend to gravitate around their home, so the locations they visit
are spread around their home according to a Gaussian distribution.

Formally, consider a graph ``G`` with ``V`` nodes. Our Hawkes process is
characterized by ``V`` TPPs such that the conditional intensity rate of node
``i`` connected to a set of nodes ``E_i`` in the graph ``G`` is given by:

```math
\lambda_i^\ast (t) = \lambda
  + \sum_{j \in E_i} \sum_{t_{n_j} < t} \alpha \exp \left[ -\beta (t - t_{n_j}) \right]
```

This conditional intensity is known as a self-exciting, because the occurrence
of an event ``j`` at ``t_{n_j}`` will increase the conditional intensity of all
processes connected to it by ``alpha``. This influence will then decrease at
rate ``\beta``.

The conditional intensity of this process has a recursive formulation which we
can use to our advantage to significantly speed simulation. Let ``t_{N_i} = \max \{t_{n_j} < t \mid j \in E_i\}`` and ``\phi_i^\ast(t)`` below.

```math
\begin{split}
  \phi_i^\ast (t)
    &= \sum_{j \in E_i} \sum_{t_{n_j} < t} \alpha \exp \left[-\beta (t - t_{N_i} + t_{N_i} - t_{n_j}) \right] \\
    &= \exp \left[ -\beta (t - t_{N_i}) \right]
      \sum_{j \in E_i} \sum_{t_{n_j} \leq t_{N_i}} \alpha \exp \left[-\beta (t_{N_i} - t_{n_j}) \right] \\
    &= \exp \left[ -\beta (t - t_{N_i}) \right] \left( \alpha + \phi_i^\ast (t_{N_i}) \right)
\end{split}
```

Then the conditional intensity can be re-written in terms of ``\phi_i^\ast (t_{N_i})``.

```math
\lambda_i^\ast (t) = \lambda + \phi_i^\ast (t) =
    \lambda + \exp \left[ -\beta (t - t_{N_i}) \right] \left( \alpha + \phi_i^\ast (t_{N_i}) \right)
```

We translate these expressions to Julia by employing a closure which will allow
us to obtain the rate for each node ``i`` in ``G``.

```@example tpp-advanced
function hawkes_rate(i::Int, g)
    function rate(u, p, t)
        (; λ, α, β, ϕ, T) = p
        return λ + exp(-β * (t - T[i])) * ϕ[i]
    end
    return rate
end
nothing # hide
```

We assume that each sup-process `i` is a marked TPP. With probability ``(1 - \omega^\ast(t))``, we draw a mark from a 2-dimensional Gaussian
distribution centered in ``\mu_i`` with ``\sigma_1`` standard deviation; and
with probability ``\omega^\ast(t)`` we draw from a 2-dimensional Gaussian
distribution centered on the last location visited by ``i`` with ``\sigma_2``
standard deviation. Like the conditional intensity, ``\omega^\ast(t)`` decays
exponentially with rate ``-\beta``.

```math
\omega^\ast(t) = \exp [ -\beta (t - t_{n_i}) ]
```

In other words, node ``i`` tends to gravitate around its home location, but
given some recent activity the node will be more likely to be close to its most
recent location. Let ``k \equiv (i, m)``, then the mark distribution can be
represented as a mixture distribution.

```math
\begin{split}
f^\ast(k \mid t) =
  &\frac{\lambda_i^\ast (t)}{\sum_i \lambda_i^\ast (t)} \times \\
  &\left[ (1 - \omega(t)) \frac{1}{\sigma_1 \sqrt{2\pi}} \exp \left( -\frac{(m - \mu_i)^\top(m - \mu_i)}{2 \sigma_1^2} \right) +  \right. \\
  &\left. \omega(t) \frac{1}{\sigma_2 \sqrt{2\pi}} \exp \left( -\frac{(m_{n_i} - \mu_i)^\top(m_{n_i} - \mu_i)}{2 \sigma_2^2} \right) \right]
\end{split}
```

In Julia, we define a method for constructing Hawkes jumps. JumpProcesses define
different types of jumps that vary according to the behavior of the conditional
intensity and the intended simulation algorithm. Since the conditional intensity
of our Hawkes process is not fixed, we will use `VariableRateJump` to construct
the Hawkes jumps. The structure requires a `rate` which we defined above and an
`affect!` which tells the program what happens when a jump occurs and is when we
draw the marks from our distribution. In addition to that, since we intend to
use the `Coevolve` algorithm for simulation — see below —, we need to define the
rate upper-bound, the interval for which the upper-bound is valid, and,
optionally, a lower-bound for improved simulation efficiency.

```@example tpp-advanced
function hawkes_jump(i::Int, g, mark_dist)
    rate = hawkes_rate(i, g)
    urate = rate
    lrate(u, p, t) = p.λ
    rateinterval = (u, p, t) -> begin
        _lrate = lrate(u, p, t)
        _urate = urate(u, p, t)
        return _urate == _lrate ? typemax(t) : 1 / (2 * _urate)
    end
    function affect!(integrator)
        (; λ, α, β, ϕ, M, T, h) = integrator.p
        ω = exp(-β * (integrator.t - T[i]))
        for j in g[i]
            ϕ[j] = α + exp(-β * (integrator.t - T[j])) * ϕ[j]
            T[j] = integrator.t
        end
        m = rand() > ω ? rand(mark_dist[i]) : rand(MvNormal(collect(M[i]), [0.01, 0.01]))
        push!(h, integrator.t, (i, m); check = false)
    end
    return VariableRateJump(rate, affect!; lrate, urate, rateinterval)
end
nothing # hide
```

To initialize `SciMLPointProcess` we also need to define a function for
returning and resetting the parameters of our model.

```@example tpp-advanced
function hawkes_p(pp::SciMLPointProcess{M, J, G, D, T}) where {M, J, G, D, T}
    g = pp.g
    tmin = pp.tmin
    tmax = pp.tmax
    h = History(; times = T[], marks = Tuple{Int, M}[], tmin = tmin, tmax = tmax)
    return (λ = 0.5,
        α = 0.1,
        β = 2.0,
        ϕ = zeros(T, length(g)),
        M = map(d -> tuple(mean(d)...), pp.mark_dist),
        T = zeros(T, length(g)),
        h = h)
end

function hawkes_p(pp::SciMLPointProcess{M, J, G, D, T}, p) where {M, J, G, D, T}
    reset!(p.h)
    p.ϕ .= zero(p.ϕ)
    p.M .= map(d -> tuple(mean(d)...), pp.mark_dist)
    p.T .= zero(p.T)
end

nothing # hide
```

Now, we are ready to initialize our `SciMLPointProcess` as a Hawkes process.

```@example tpp-advanced
using Graphs
using Distributions
V = 10
G = erdos_renyi(V, 0.2)
g = [[[i]; neighbors(G, i)] for i in 1:nv(G)]
mark_dist = [MvNormal(rand(2), [0.2, 0.2]) for i in 1:nv(G)]
jumps = [hawkes_jump(i, g, mark_dist) for i in 1:nv(G)]
tspan = (0.0, 50.0)
hawkes = SciMLPointProcess{
    Vector{Real},
    eltype(jumps),
    typeof(g),
    eltype(mark_dist),
    eltype(tspan)
}(jumps,
    mark_dist,
    g,
    hawkes_p,
    tspan[1],
    tspan[2])
```

## [Sampling](@id tpp_sampling)

JumpProcesses shines in the simulation of SDEs with discontinuous jumps. The
mapping we introduced in the [previous Section](@ref tpp_theory) whereby ``du = dN(t)`` implies that JumpProcesses also excels in simulating TPPs.

JumpProcesses offers a plethora of simulation algorithms for TPPs. The library
call them _aggregators_ because these algorithms are methods for aggregating
a set of jumps to determine the next jump time. In [Jump Aggregators for Exact
Simulation](@ref), we discuss the trade-off between different simulation
algorithms.

To simulate a `SciMLPointProcess`, we start by overloading `Base.rand`. In our
implementation, we initialize a `JumpProblem` with the jumps and parameters
passed to the `SciMLPointProcess` as well as with the desired simulation
algorithm. In this tutorial we use the `Coevolve` _aggregator_ which is an
algorithm inspired by Ogata's algorithm for bounded TPPs with modifications to
improve efficiency and to allow for the concurrent evolution of the TPP and
simulation time.

Finally, we sample a path from our `JumpProblem` using the `SSAStepper`.
A stepper tells the solver how to step through time. When simulating TPPs, we do
not need to evolve time incrementally by small deltas. The `SSAStepper` allow us
to step through time one candidate at a time.

```@example tpp-advanced
using OrdinaryDiffEq
using Random

function Base.rand(rng::AbstractRNG, pp::SciMLPointProcess)
    return rand(rng, pp, min_time(pp), max_time(pp), 1)[1]
end

function Base.rand(rng::AbstractRNG, pp::SciMLPointProcess, n::Int)
    return rand(rng, pp, min_time(pp), max_time(pp), n)
end

function Base.rand(pp::SciMLPointProcess, n::Int)
    return rand(Random.default_rng(), pp, min_time(pp), max_time(pp), n)
end

function Base.rand(rng::AbstractRNG,
        pp::SciMLPointProcess{M, J, G, D, T},
        tmin::T,
        tmax::T,
        n::Int) where {M, J, G, D, T <: Real}
    tspan = (tmin, tmax)
    save_positions = (false, false)
    out = Array{History, 1}(undef, n)
    p = params(pp)
    dprob = DiscreteProblem([0], tspan, p)
    jprob = JumpProblem(dprob, Coevolve(), jumps...; dep_graph = pp.g, save_positions, rng)
    for i in 1:n
        params!(pp, p)
        solve(jprob, SSAStepper())
        out[i] = deepcopy(p.h)
    end
    return out
end
```

We can easily sample the Hawkes process introduced in the previous section.

```@example tpp-advanced
h = rand(hawkes)
```

It would be useful to visualize our sampled points to get a good feeling of our
simulation. Since PointProcesses does not offer recipes for visualizing TPP
samples, we propose a few options. First, we visualize our sample as a sequence
of points though time, each line represents the realization of one of the
sub-TPPs of `SciMLPointProcess`.

```@example tpp-advanced
using Plots
@userplot BarcodePlot
@recipe function f(x::BarcodePlot)
    h, ix = x.args
    times = event_times(h)
    marks = event_marks(h)
    histories = [times[filter(n -> marks[n][1] == i, 1:length(times))] for i in ix]
    seriestype := :scatter
    yticks --> (1:length(ix), ix)
    alpha --> 0.5
    markerstrokewidth --> 0
    markerstrokealpha --> 0
    markershape --> :circle
    ylims --> (0.0, length(ix) + 1.0)
    for i in 1:length(ix)
        @series begin
            label := ix[i]
            histories[i], fill(i, length(histories[i]))
        end
    end
end
```

Let's visualize our data as a barcode.

```@example tpp-advanced
barcodeplot(h, 1:10; legend = false)
```

In reality, we do not observe which components generated which points.
Therefore, a fairer representation of the data would be as a scatter plot. We
also plot the latent home locations which show that points are indeed clustered
around them.

```@example tpp-advanced
scatter(map(m -> tuple(m[2]...), event_marks(h)), label = "events")
scatter!(map(d -> tuple(mean(d)...), mark_dist), label = "cluster epicentre")
```

## [The Conditional Intensity](@id tpp_conditional_intensity)

The first Section of this tutorial introduced the conditional intensity. Here we
will delve deeper into this concept which plays a prominent role in TPP theory
due to its ability to fully characterize any TPP.

The conditional intensity is a stochastic process since it depends on the
realization of ``N``. Given a history of events ``H_{t^-}``, we can recover the
conditional intensity of any jump by evaluating its rate function. We can take
advantage of OrdinaryDiffEq to build a `DiscreteProblem` which we solve with the
`FunctionMap` stepper, which steps through time stopping on each event and on
specific locations specified by the user. Our method computes the conditional
intensity for each sub-TPP of the `SciMLPointProcess`, it returns the solution
of the `DiscreteProblem` and the final parameters.

```@example tpp-advanced
function intensity(pp::SciMLPointProcess, t, h; saveat = [], save_positions = (true, true))
    p = params(pp)
    times = event_times(h)
    marks = event_marks(h)
    tmin, tmax = min_time(pp), t
    tstops = typeof(saveat) <: Number ? collect(tmin:saveat:tmax) : copy(saveat)
    append!(tstops, times)
    sort!(tstops)
    unique!(tstops)
    rates(u, p, t) = [jump.rate(nothing, p, t) for jump in pp.jumps]
    condition(u, t, integrator) = t ∈ times
    function affect!(integrator)
        n = searchsortedfirst(times, integrator.t)
        mark = marks[n]
        ix = mark[1]
        pp.jumps[ix].affect!(integrator)
        # overwrite history with true mark
        integrator.p.h.marks[n] = mark
        integrator.u = rates(integrator.u, integrator.p, integrator.t)
    end
    callback = DiscreteCallback(condition, affect!; save_positions)
    dprob = DiscreteProblem(rates, rates(nothing, p, tmin), (tmin, tmax), p; callback,
        tstops, saveat)
    sol = solve(dprob, FunctionMap())
    return sol
end
nothing # hide
```

As an illustration, we plot the conditional intensity of the first sub-TPP of
our sampled Hawkes process.

```@example tpp-advanced
λ = intensity(hawkes, max_time(hawkes), h; saveat = 0.1)
plot(λ, idxs = 1)
```

Now, we can specialize a number of functions required by the interface defined
in PointProcesses.

```@example tpp-advanced
function ground_intensity(pp::SciMLPointProcess, t, h)
    λ = intensity(pp, t, h; saveat = [t], save_positions = (false, false))
    ground_intensity(pp, t, λ)
end

function ground_intensity(pp::SciMLPointProcess, t, λ::ODESolution)
    return vec(sum(λ(t), dims = 1))
end

function ground_intensity(pp::SciMLPointProcess, t::T, λ::ODESolution) where {T <: Number}
    return sum(λ(t))
end

function mark_distribution(pp::SciMLPointProcess, t, h)
    λ = intensity(pp, t, h)
    mark_distribution(pp, t, λ)
end

function mark_distribution(pp::SciMLPointProcess, t, λ)
    λt = λ(t)
    d = MixtureModel(pp.mark_dist, λt ./ sum(λt))
    return d
end

function intensity(pp::SciMLPointProcess, m, t, h)
    λ = intensity(pp, t, h)
    intensity(pp, m, t, λ)
end

function intensity(pp::SciMLPointProcess, m, t, λ::ODESolution)
    λt = λ(t)
    return sum([densityof(pp.mark_dist[i], m) * λt[i] for i in 1:length(pp.jumps)])
end

function log_intensity(pp::SciMLPointProcess, m, t, h)
    return log(intensity(pp, m, t, h))
end

nothing # hide
```

We can then visualize the ground intensity.

```@example tpp-advanced
plot(ground_intensity(hawkes, λ.t, λ))
```

## [The Compensator](@id tpp_compensator)

The compensator is defined as the integral of the conditional intensity.

```math
\Lambda(t, k) \equiv \int_0^t \lambda^\ast (u, k) du
```

With some abuse of notation, we obtain the compensator of the ground process by
integrating over the marks.

```math
\Lambda(t) \equiv \int_0^t \sum_{k \in \mathcal{K}} \lambda^\ast (u, k) du
```

In Julia, we can derive the compensator by simply integrating over the
conditional intensity using an ODEProblem.

```@example tpp-advanced
function integrated_intensity(pp::SciMLPointProcess,
        t,
        h;
        alg = nothing,
        saveat = [],
        save_positions = (true, true))
    p = params(pp)
    times = event_times(h)
    marks = event_marks(h)
    tspan = (min_time(pp), t)
    rates(u, p, t) = [jump.rate(nothing, p, t) for jump in pp.jumps]
    condition(u, t, integrator) = t ∈ times
    function affect!(integrator)
        n = searchsortedfirst(times, integrator.t)
        mark = marks[n]
        ix = mark[1]
        pp.jumps[ix].affect!(integrator)
        integrator.p.h.marks[n] = mark
    end
    callback = DiscreteCallback(condition, affect!; save_positions)
    prob = ODEProblem(rates,
        zeros(eltype(times), length(pp.jumps)),
        tspan,
        p;
        tstops = times,
        callback,
        saveat)
    sol = solve(prob, alg)
    return sol
end

nothing # hide
```

The PointProcess interface expects that we define a method for computing the
compensator of the ground process for a given interval. This will be useful in
the next section when we compute the log-likelihood.

```@example tpp-advanced
function integrated_ground_intensity(pp::SciMLPointProcess, h, a, b)
    Λ = integrated_intensity(pp,
        b,
        h;
        alg = Rodas4P(),
        saveat = [a, b],
        save_positions = (false, false))
    return sum(Λ(b)) - sum(Λ(a))
end

nothing # hide
```

In practice, we must pay close attention to the shape of the conditional
intensity. In the Hawkes case, the conditional intensity is highly stiff as
events will cause the intensity to spike. Therefore, we must select an ODE
solver that can deal with stiff problems like `Rodas4P()`.

```@example tpp-advanced
Λ = integrated_intensity(hawkes,
    max_time(hawkes),
    h;
    saveat = event_times(h),
    alg = Rodas4P())
plot(Λ)
```

The compensator of the Hawkes process lends itself to an analytical solution
which can be implemented in Julia as a `DiscreteProblem` much like the
conditional intensity above.

```@example tpp-advanced
function hawkes_integrated_intensity(pp::SciMLPointProcess, t, h; saveat = [])
    (; λ, α, β) = params(pp)
    p = (λ = λ, α = α, β = β, h = h)
    saveat = typeof(saveat) <: Number ? collect(min_time(h):saveat:t) : copy(saveat)
    tstops = copy(event_times(h))
    function compensator(u, p, t)
        (; λ, α, β, h) = p
        u = zeros(typeof(t), length(pp.jumps))
        for (i, Ei) in enumerate(pp.g)
            u[i] += λ * t
            for (_t, (_j, _)) in zip(event_times(h), event_marks(h))
                _t >= t && break
                _j ∉ Ei && continue
                u[i] += (α / β) * (1 - exp(-β * (t - _t)))
            end
        end
        return u
    end
    dprob = DiscreteProblem(compensator, zeros(eltype(event_times(h)), length(pp.jumps)),
        (min_time(h), t), p; tstops, saveat)
    sol = solve(dprob, FunctionMap())
    return sol
end
```

```@example tpp-advanced
Λ_exact = hawkes_integrated_intensity(hawkes, max_time(hawkes), h)
plot!(Λ_exact)
```

Time-change theorems for TPPs show that the compensator transforms a complex TPP
into a Poisson process with unit rate. We can interpret the compensator as
making the TPP as random as possible. We can check that this is indeed the case
for our model and simulation algorithm.

First, we define a method for filtering the history.

```@example tpp-advanced
function Base.filter(f, h::History)
    times = event_times(h)
    marks = event_marks(h)
    filtered_times = eltype(times)[]
    filtered_marks = eltype(marks)[]
    for (t, mark) in zip(times, marks)
        if f(t, mark)
            push!(filtered_times, t)
            push!(filtered_marks, mark)
        end
    end
    return History(;
        times = filtered_times,
        marks = filtered_marks,
        tmin = min_time(h),
        tmax = max_time(h))
end
```

And a recipe for QQ-plots.

```@example tpp-advanced
@userplot QQPlot
@recipe function f(x::QQPlot)
    empirical_quant, expected_quant = x.args
    max_empirical_quant = maximum(maximum, empirical_quant)
    max_expected_quant = maximum(expected_quant)
    upperlim = ceil(maximum([max_empirical_quant, max_expected_quant]))
    @series begin
        seriestype := :line
        linecolor := :lightgray
        label --> ""
        (x) -> x
    end
    @series begin
        seriestype := :scatter
        aspect_ratio := :equal
        xlims := (0.0, upperlim)
        ylims := (0.0, upperlim)
        xaxis --> "Expected quantile"
        yaxis --> "Empirical quantile"
        markerstrokewidth --> 0
        markerstrokealpha --> 0
        markersize --> 1.5
        size --> (400, 500)
        label --> permutedims(["quantiles $i" for i in 1:length(empirical_quant)])
        expected_quant, empirical_quant
    end
end
```

To produce the QQ-plots, we ran the simulation a reasonable number of times to
ensure an accurate estimation of the empirical quantiles of the inter-arrival
times. The `time_change` method comes from PointProcess which applies the
compensator to the input history. We take advantage of the fact that the
compensator is an `ODESolution` which overloads an interpolation method in
itself to produce the QQ-plot for the ground process.

```@example tpp-advanced
Δt̃ = []
for _ in 1:250
    _h = rand(hawkes)
    _Λ = integrated_intensity(hawkes,
        max_time(hawkes),
        _h;
        saveat = event_times(_h),
        alg = Rodas4P())
    _h̃ = time_change(_h, (t) -> sum(_Λ(t)))
    append!(Δt̃, diff(event_times(_h̃)))
end
empirical_quant = quantile(Δt̃, 0.01:0.01:0.99)
expected_quant = quantile(Exponential(1.0), 0.01:0.01:0.99)
qqplot(empirical_quant, expected_quant; legend = false)
```

Likewise, we can produce the QQ-plot for each sub-TPP.

```@example tpp-advanced
Δt̃ = [[] for _ in 1:nv(G)]
for _ in 1:250
    _h = rand(hawkes)
    _Λ = integrated_intensity(hawkes,
        max_time(hawkes),
        _h;
        saveat = event_times(_h),
        alg = Rodas4P())
    for i in 1:nv(G)
        _h̃ = time_change(filter((t, mark) -> mark[1] == i, _h), (t) -> Λ(t; idxs = i))
        append!(Δt̃[i], diff(event_times(_h̃)))
    end
end
empirical_quant = map(t -> quantile(t, 0.01:0.01:0.99), Δt̃)
expected_quant = quantile(Exponential(1.0), 0.01:0.01:0.99)
qqplot(empirical_quant, expected_quant)
```

## [The Log-Likelihood](@id tpp_loglikelihood)

Once we know how to compute the conditional intensity and the compensator, it is
very easy to obtain the log-likelihood of a TPP because it is simply the sum of
the log-conditional intensity at event times minus the compensator up to the end
of the observed time. For a full derivation, see Chapter 7, Daley and
Vere-Jones[^1].

```math
\ell (H_{T^-}) = \sum_{n=1}^N \left( \log \lambda^\ast(t_n, k_n) \right)
  - \int_0^T \sum_{k \in \mathcal{K}} \lambda^\ast (u, k) du
```

In Julia, we follow the PointProcess API to define a method for computing the log-likelihood.

```@example tpp-advanced
using DensityInterface

function DensityInterface.logdensityof(pp::SciMLPointProcess, h)
    T = max_time(pp)
    times = event_times(h)
    marks = event_marks(h)
    Λ = integrated_ground_intensity(pp, h, min_time(h), T)
    λ = intensity(pp, T, h; saveat = times, save_positions = (false, false))
    logλ = 0
    for (t, (i, m)) in zip(times, marks)
        logλ += log_intensity(pp, m, t, λ)
        log_intensity(pp, m, t, λ), intensity(pp, m, t, λ)
    end
    return logλ - Λ
end
```

This allows us to compute the log-likelihood of our sample.

```@example tpp-advanced
logdensityof(hawkes, h)
```

This tutorial demonstrated the versatility of the SciML library to model TPPs.
We made extensive use of JumpProcesses and OrdinaryDiffEq to fulfill the
interface specified by the PointProcess library. However, we have left out
a discussion about fitting the parameters of a TPP to the data. In many cases,
we cannot derive an analytical estimator via maximum likelihood, and we must tap
into machine learning tools like gradient descent and expectation-maximization
algorithms to minimize the log-likelihood function. Julia is a great tool for
these kinds of tasks with libraries such as Optimization and Flux which are
outside the scope this tutorial.

## References

[^1]: D. J. Daley and D. Vere-Jones, An Introduction to the Theory of Point
    Processes: Volume I: Elementary Theory and Methods, Springer-Verlag
    (2003). doi:10.1007/b97277.
[^2]: T., Björk, Point Processes and Jump Diffusions: An Introduction with
    Finance Applications, Cambridge University Press
    (2021). doi:10.1017/9781009002127.
[^3]: F. B. Hanson, Applied Stochastic Processes and Control for
    Jump-Diffusions: Modeling, Analysis and Computation, Society for
    Industrial and Applied Mathematics (2007). doi:10.1137/1.9780898718638.
[^4]: P. J. Laub, Y. Lee and T. Taimre, The Elements of Hawkes Processes,
    Springer International Publishing (2021). doi:10.1007/978-3-030-84639-8.

# FAQ

## My simulation is really slow and/or using a lot of memory, what can I do?

Exact methods simulate every jump, and by default save the state before and
after each jump. To reduce memory use, use `save_positions = (false, false)` in
the `JumpProblem` constructor as described [earlier](@ref save_positions_docs)
to turn off saving the system state before and after every jump. Combined with
use of `saveat` in the call to `solve`, to specify the specific times at which
to save the state, this can dramatically reduce memory usage.

While `Direct` is often fastest for systems with 10 or less `ConstantRateJump`s
and/or `MassActionJump`s, if your system has many jumps or one jump occurs most
frequently, other stochastic simulation algorithms may be faster. See [Jump
Aggregators for Exact Simulation](@ref) and the subsequent sections there for
guidance on choosing different SSAs (called aggregators in JumpProcesses). For
systems with bounded `VariableRateJump`s using `Coevolve` with `SSAStepper`
instead of an ODE/SDE time stepper can give a significant performance boost.

## When running many consecutive simulations, for example within an `EnsembleProblem` or loop, how can I update `JumpProblem`s?

In [Remaking `JumpProblem`s](@ref) we show how to modify parameters, the initial
condition, and other components of a generated `JumpProblem`. This can be useful
when trying to call `solve` many times while avoiding reallocations of the
internal aggregators for each new parameter value or initial condition.

## How can I define collections of many different jumps and pass them to `JumpProblem`?

We can use `JumpSet`s to collect jumps together, and then pass them into
`JumpProblem`s directly. For example, using a `MassActionJump` and
`ConstantRateJump` defined in the [second tutorial](@ref ssa_tutorial), we can
write

```julia
jset = JumpSet(mass_act_jump, birth_jump)
jump_prob = JumpProblem(prob, Direct(), jset)
sol = solve(jump_prob, SSAStepper())
```

If you have many jumps in tuples or vectors, it is easiest to use the keyword
argument-based constructor:

```julia
cj1 = ConstantRateJump(rate1, affect1!)
cj2 = ConstantRateJump(rate2, affect2!)
cjvec = [cj1, cj2]

vj1 = VariableRateJump(rate3, affect3!)
vj2 = VariableRateJump(rate4, affect4!)
vjtuple = (vj1, vj2)

jset = JumpSet(; constant_jumps = cjvec, variable_jumps = vjtuple,
    massaction_jumps = mass_act_jump)
```

## How can I set the random number generator used in the jump process sampling algorithms (SSAs)?

Random number generators can be passed to `JumpProblem` via the `rng` keyword
argument. Continuing the previous example:

```julia
#] add RandomNumbers
using RandomNumbers
jprob = JumpProblem(dprob, Direct(), maj,
    rng = Xorshifts.Xoroshiro128Star(rand(UInt64)))
```

uses the `Xoroshiro128Star` generator from
[RandomNumbers.jl](https://github.com/JuliaRandom/RandomNumbers.jl).

On version 1.7 and up, JumpProcesses uses Julia's built-in random number generator by
default. On versions below 1.7 it uses `Xoroshiro128Star`.

## What are these aggregators and aggregations in JumpProcesses?

JumpProcesses provides a variety of methods for sampling the time the next
`ConstantRateJump`, `MassActionJump`, or `VariableRateJump` occurs, and which
jump type happens at that time. These methods are examples of stochastic
simulation algorithms (SSAs), also known as Gillespie methods, Doob's method, or
Kinetic Monte Carlo methods. These are all names for jump (or point) processes
simulation methods used across the biology, chemistry, engineering, mathematics,
and physics literature. In the JumpProcesses terminology, we call such methods
"aggregators", and the cache structures that hold their basic data
"aggregations". See [Jump Aggregators for Exact Simulation](@ref) for a list of
the available SSA aggregators.

## How should jumps be ordered in dependency graphs?

Internally, JumpProcesses SSAs (aggregators) order all `MassActionJump`s first,
then all `ConstantRateJumps` and/or `VariableRateJumps`. i.e., in the example

```julia
using JumpProcesses
rs = [[1 => 1], [2 => 1]]
ns = [[1 => -1, 2 => 1], [1 => 1, 2 => -1]]
p = [1.0, 0.0]
maj = MassActionJump(rs, ns; param_idxs = [1, 2])
rate1(u, p, t) = u[1]
function affect1!(integrator)
    u[1] -= 1
end
cj1 = ConstantRateJump(rate1, affect1)
rate2(u, p, t) = u[2]
function affect2!(integrator)
    u[2] -= 1
end
cj2 = ConstantRateJump(rate2, affect2)
jset = JumpSet(; constant_jumps = [cj1, cj2], massaction_jump = maj)
```

The four jumps would be ordered by the first jump in `maj`, the second jump in
`maj`, `cj1`, and finally `cj2`. Any user-generated dependency graphs should
then follow this ordering when assigning an integer id to each jump.

See also [Jump Aggregators Requiring Dependency Graphs](@ref) for
more on dependency graphs needed for the various SSAs.

## How do I use callbacks with jump simulations?

Callbacks can be used with `ConstantRateJump`s, `MassActionJump`s, and
`VariableRateJump`s. When solving a pure jump system with `SSAStepper`, only
discrete callbacks can be used (otherwise a different time stepper is needed).
When using an ODE or SDE time stepper, any callback should work.

*Note, when modifying `u` or `p` within a callback, you must call
[`reset_aggregated_jumps!`](@ref) after making updates.* This ensures that the
underlying jump simulation algorithms know to reinitialize their internal data
structures. Omitting this call will lead to incorrect behavior!

A simple example that uses a `MassActionJump` and changes the parameters at a
specified time in the simulation using a `DiscreteCallback` is

```julia
using JumpProcesses
rs = [[1 => 1], [2 => 1]]
ns = [[1 => -1, 2 => 1], [1 => 1, 2 => -1]]
p = [1.0, 0.0]
maj = MassActionJump(rs, ns; param_idxs = [1, 2])
u₀ = [100, 0]
tspan = (0.0, 40.0)
dprob = DiscreteProblem(u₀, tspan, p)
jprob = JumpProblem(dprob, Direct(), maj)
pcondit(u, t, integrator) = t == 20.0
function paffect!(integrator)
    integrator.p[1] = 0.0
    integrator.p[2] = 1.0
    reset_aggregated_jumps!(integrator)
    nothing
end
sol = solve(jprob, SSAStepper(), tstops = [20.0],
    callback = DiscreteCallback(pcondit, paffect!))
```

Here at time `20.0` we turn off production of `u[2]` while activating production
of `u[1]`, giving

![callback_gillespie](assets/callback_gillespie.png)

## How can I access earlier solution values in callbacks?

When using an ODE or SDE time-stepper that conforms to the [integrator
interface](https://docs.sciml.ai/DiffEqDocs/stable/basics/integrator/), one
can simply use `integrator.uprev`. For efficiency reasons, the pure jump
[`SSAStepper`](@ref) integrator does not have such a field. If one needs
solution components at earlier times, one can save them within the callback
condition by making a functor:

```julia
# stores the previous value of u[2] and represents the callback functions
mutable struct UprevCondition{T}
    u2::T
end

# condition
function (upc::UprevCondition)(u, t, integrator)
    # condition for the callback is that the new value of u[2]
    # is smaller than the previous value
    condit = u[2] - upc.u2 < 0

    # save the new value as the previous value
    upc.u2 = u[2]

    condit
end

# affect!
function (upc::UprevCondition)(integrator)
    integrator.u[4] -= 1
    nothing
end

upc = UprevCondition(u0[2])
cb = DiscreteCallback(upc, upc)
```

# [Simple Poisson Processes in JumpProcesses](@id poisson_proc_tutorial)

In this tutorial, we show how to simulate several Poisson jump processes, for
several types of intensities and jump distributions.

Readers interested primarily in chemical or population process models, where
several types of jumps may occur, can skip directly to the [second
tutorial](@ref ssa_tutorial) for a tutorial covering similar material but
focused on the SIR model. Readers with a background in point process theory can
skip directly to [modelling temporal point processes with JumpProcesses](@ref
tpp_tutorial).

JumpProcesses allows the simulation of jump processes where the transition rate,
i.e., intensity or propensity, can be a function of the current solution, current
parameters, and current time. Throughout this tutorial these are denoted by `u`,
`p` and `t`. Likewise, when a jump occurs any
DifferentialEquations.jl-compatible change to the current system state, as
encoded by a [DifferentialEquations.jl
integrator](https://docs.sciml.ai/DiffEqDocs/stable/basics/integrator/), is
allowed. This includes changes to the current state or to parameter values (for
example via a callback).

This tutorial requires several packages, which can be added if not already
installed via

```julia
using Pkg
Pkg.add("JumpProcesses")
Pkg.add("Plots")
```

Let's also load our packages and set some defaults for our plot formatting

```@example tut1
using JumpProcesses, Plots
default(; lw = 2)
```

## `ConstantRateJump`s

Our first example will be to simulate a simple Poisson counting process,
``N(t)``, with a constant transition rate of λ. We can interpret this as a birth
process where new individuals are created at the constant rate λ. ``N(t)`` then
gives the current population size. In terms of a unit Poisson counting process,
``Y_b(t)``, we have

```math
N(t) = Y_b\left( \lambda t \right).
```

(Here by a unit Poisson counting process we just mean a Poisson counting process
with a constant rate of one.)

In the remainder of this tutorial we will use
*transition rate*, *rate*, *propensity*, and *intensity* interchangeably. Here
is the full program listing, which we will subsequently explain line by line

```julia
using JumpProcesses, Plots

rate(u, p, t) = p.λ
affect!(integrator) = (integrator.u[1] += 1)
crj = ConstantRateJump(rate, affect!)

u₀ = [0]
p = (λ = 2.0,)
tspan = (0.0, 10.0)

dprob = DiscreteProblem(u₀, tspan, p)
jprob = JumpProblem(dprob, Direct(), crj)

sol = solve(jprob, SSAStepper())
plot(sol, label = "N(t)", xlabel = "t", legend = :bottomright)
```

We can define and simulate our jump process as follows. We first load our
packages

```@example tut1
using JumpProcesses, Plots
```

To specify our jump process, we need to define two functions. One that given the
current state of the system, `u`, the parameters, `p`, and the time, `t`, can
determine the current transition rate (intensity)

```@example tut1
rate(u, p, t) = p.λ
```

This corresponds to the instantaneous probability per time a jump occurs when
the current state is `u`, current parameters are `p`, and the time is `t`. We
also give a function that updates the system state when a jump is known to have
occurred (at time `integrator.t`)

```@example tut1
affect!(integrator) = (integrator.u[1] += 1)
```

Here, the convention is to take a [DifferentialEquations.jl
integrator](https://docs.sciml.ai/DiffEqDocs/stable/basics/integrator/),
and directly modify the current solution value it stores. i.e., `integrator.u` is
the current solution vector, with `integrator.u[1]` the first component of this
vector. In our case, we will only have one unknown, so this will be the current
value of the counting process. As our jump process's transition rate is constant
between jumps, we can use a [`ConstantRateJump`](@ref) to encode it

```@example tut1
crj = ConstantRateJump(rate, affect!)
```

We then specify the parameters needed to simulate our jump process

```@example tut1
# the initial condition vector, notice we make it an integer
# since we have a discrete counting process
u₀ = [0]

# the parameters of the model, in this case a named tuple storing the rate, λ
p = (λ = 2.0,)

# the time interval to solve over
tspan = (0.0, 10.0)
```

Finally, we construct the associated SciML problem types and generate one
realization of the process. We first create a `DiscreteProblem` to encode that
we are simulating a process that evolves in discrete time steps.

```@example tut1
dprob = DiscreteProblem(u₀, tspan, p)
```

We next create a [`JumpProblem`](@ref) that wraps the discrete problem, and
specifies which sampling algorithm, called an aggregator in JumpProcesses, to
use for determining next jump times (and in the case of multiple possible jumps
the next jump type). We call them aggregators because these algorithms are
methods for aggregating a set of jumps to determine the next jump time and type.  Here
we use the classical `Direct` method, proposed by Gillespie in the chemical
reaction context, but going back to earlier work by Doob and others (and also
known as Kinetic Monte Carlo in the physics literature)

```@example tut1
# a jump problem, specifying we will use the Direct method to sample
# jump times and events, and that our jump is encoded by crj
jprob = JumpProblem(dprob, Direct(), crj)
```

We are finally ready to simulate one realization of our jump process, selecting
`SSAStepper` to handle time-stepping our system from jump to jump

```@example tut1
# now we simulate the jump process in time, using the SSAStepper time-stepper
sol = solve(jprob, SSAStepper())

plot(sol, labels = "N(t)", xlabel = "t", legend = :bottomright)
```

### More general `ConstantRateJump`s

The previous counting process could be interpreted as a birth process, where new
individuals were created with a constant transition rate λ. Suppose we also
allow individuals to be killed with a death rate of μ. The transition rate at
time `t` for some individual to die, assuming the deaths of individuals are
independent, is just ``\mu N(t)``. Suppose we also wish to keep track of the
number of deaths, ``D(t)``, that have occurred. We can store these as an
auxiliary variable in `u[2]`. Our processes are then given mathematically by

```math
\begin{align*}
N(t) &= Y_b(\lambda t) - Y_d \left(\int_0^t \mu N(s^-) \, ds \right), \\
D(t) &= Y_d \left(\int_0^t \mu N(s^-) \, ds \right),
\end{align*}
```

where ``Y_d(t)`` denotes a second, independent, unit Poisson counting process.

We can encode this as a second jump for our system
like

```@example tut1
deathrate(u, p, t) = p.μ * u[1]
deathaffect!(integrator) = (integrator.u[1] -= 1; integrator.u[2] += 1)
deathcrj = ConstantRateJump(deathrate, deathaffect!)
```

As the death rate is constant *between* jumps, we can encode this process as a
second `ConstantRateJump`. Overall, we keep track of four different processes,
the population size ``N(t)``, total deaths ``D(t)``, births ``Y_b(t)`` and deaths
``Y_d(t)``. The vector ``(N(t), D(t))`` is represented by ``u`` in our code, with ``Y_b(t)`` encoded by `crj`
and ``Y_d(t)`` by `death_crj`. We then construct the corresponding problems,
passing both jumps to `JumpProblem`, and can solve as before

```@example tut1
p = (λ = 2.0, μ = 1.5)
u₀ = [0, 0]   # (N(0), D(0))
dprob = DiscreteProblem(u₀, tspan, p)
jprob = JumpProblem(dprob, Direct(), crj, deathcrj)
sol = solve(jprob, SSAStepper())
plot(sol, labels = ["N(t)" "D(t)"], xlabel = "t", legend = :topleft)
```

In the next tutorial, we will also introduce [`MassActionJump`](@ref)s, which are
a special type of [`ConstantRateJump`](@ref)s that require a more specialized
form of transition rate and state update, but can offer better computational
performance. They can encode any mass action reaction, as commonly arise in
chemical and population process models, and essentially require that
`rate(u,p,t)` be a monomial in the components of `u` and state changes be given
by adding or subtracting a constant vector from `u`.

## `VariableRateJump`s for processes that are not constant between jumps

So far, we have assumed that our jump processes have transition rates that are
constant in between jumps. In many applications, this may be a limiting
assumption. To support such models, JumpProcesses has the
[`VariableRateJump`](@ref) type, which represents jump processes that have an
arbitrary time dependence in the calculation of the transition rate, including
transition rates that depend on states which can change in between two jumps
occurring. Let's consider the previous example, but now let the birth rate be
time-dependent, ``b(t) = \lambda \left(\sin(\pi t / 2) + 1\right)``, so that our
model becomes

```math
\begin{align*}
N(t) &= Y_b\left(\int_0^t \left( \lambda \sin\left(\tfrac{\pi s}{2}\right) + 1 \right) \, d s\right) - Y_d \left(\int_0^t \mu N(s^-) \, ds \right), \\
D(t) &= Y_d \left(\int_0^t \mu N(s^-) \, ds \right).
\end{align*}
```

The birth rate is cyclical, bounded between a lower-bound of ``λ`` and an
upper-bound of ``2 λ``. We'll then re-encode the first (birth) jump as a
`VariableRateJump`. Two types of `VariableRateJump`s are supported, general and
bounded. The latter are generally more performant, but are also more restrictive
in when they can be used. They also require specifying additional information
beyond just `rate` and `affect!` functions.

Let's see how to build a bounded `VariableRateJump` encoding our new birth
process. We first specify the rate and affect functions, just like for a
`ConstantRateJump`,

```@example tut1
rate1(u, p, t) = p.λ * (sin(pi * t / 2) + 1)
affect1!(integrator) = (integrator.u[1] += 1)
```

We next provide functions that determine a time interval over which the rate is
bounded from above given `u`, `p` and `t`. From these, we can construct the new
bounded `VariableRateJump`:

```@example tut1
# We require that rate1(u,p,s) <= urate(u,p,s)
# for t <= s <= t + rateinterval(u,p,t)
rateinterval(u, p, t) = typemax(t)
urate(u, p, t) = 2 * p.λ

# Optionally, we can give a lower bound over the same interval.
# This may boost computational performance.
lrate(u, p, t) = p.λ

# now we construct the bounded VariableRateJump
vrj1 = VariableRateJump(rate1, affect1!; lrate, urate, rateinterval)
```

Finally, to efficiently simulate the new jump process, we must also
specify a dependency graph. This indicates when a given jump occurs, which
jumps in the system need to have their rates and/or rate bounds
recalculated (for example, due to depending on changed components in `u`).
Internally, JumpProcesses preserves the relative ordering of jumps of each
distinct type, but always reorders all `ConstantRateJump`s to appear
before any `VariableRateJump`s. Irrespective of how `JumpProblem` is
initialized, internally the jumps will be ordered as the vector `[deathcrj, vrj1]`. Note, this vector of the jumps is distinct from our state variable vector, `u`.

We assume the convention that jumps depends on themselves. With regards to
`vrj1` that represents births, we have that when `vrj1` fires the
population ``N(t)`` increases by 1. Since `deathcrj` is proportional to
population size, then a birth event should trigger an update of the death
rate. Conversely, death events do not modify the birth rate, since births
only obey seasonal fluctuation. The dependency graph below, `dep_graph`, encodes this dependency such that `dep_graph[1]` is a vector of the dependents of death events and `dep_graph[2]` is a vector of the dependents of birth events.

```@example tut1
dep_graph = [[1], [1, 2]]
```

We can then construct the corresponding problem, passing both jumps to
`JumpProblem` as well as the dependency graph. We must use an aggregator that
supports bounded `VariableRateJump`s, in this case we choose the `Coevolve`
aggregator.

```@example tut1
jprob = JumpProblem(dprob, Coevolve(), vrj1, deathcrj; dep_graph)
sol = solve(jprob, SSAStepper())
plot(sol, labels = ["N(t)" "D(t)"], xlabel = "t", legend = :topleft)
```

If we did not know the upper rate bound or rate interval functions for the
time-dependent rate, we would have to use a continuous problem type and general
`VariableRateJump` to correctly handle calculating the jump times. Under this
assumption, we would define a general `VariableRateJump` as following:

```@example tut1
vrj2 = VariableRateJump(rate1, affect1!)
```

Since the death rate now depends on a variable, `u[2]`, modified by a general
`VariableRateJump` (i.e., one that is not bounded), we also need to redefine the
death jump process as a general `VariableRateJump`

```@example tut1
deathvrj = VariableRateJump(deathrate, deathaffect!)
```

To simulate our jump process, we now need to construct a continuous problem type
to couple the jumps to, for example an ordinary differential equation (ODE) or
stochastic differential equation (SDE). Let's use an ODE, encoded via an
`ODEProblem`. We simply set the ODE derivative to zero to preserve the state. We
are essentially defining a combined ODE-jump process, i.e., a [piecewise
deterministic Markov
process](https://en.wikipedia.org/wiki/Piecewise-deterministic_Markov_process),
but one where the ODE is trivial and does not change the state. To use this
problem type and the ODE solvers, we first load `OrdinaryDiffEq.jl` or
`DifferentialEquations.jl`. If neither is installed, we first

```julia
using Pkg
Pkg.add("OrdinaryDiffEq")
# or Pkg.add("DifferentialEquations")
```

and then load it via

```@example tut1
using OrdinaryDiffEq
# or using DifferentialEquations
```

We can then construct our ODE problem with a trivial ODE derivative component.
Note, to work with the ODE solver time stepper we must also change our initial
condition to be floating point valued

```@example tut1
function f!(du, u, p, t)
    du .= 0
    nothing
end
u₀ = [0.0, 0.0]
oprob = ODEProblem(f!, u₀, tspan, p)
jprob = JumpProblem(oprob, Direct(), vrj2, deathvrj)
```

We can now simulate our jump process, using the `Tsit5` ODE solver as the time
stepper, in place of `SSAStepper`

```@example tut1
sol = solve(jprob, Tsit5())
plot(sol, label = ["N(t)" "D(t)"], xlabel = "t", legend = :topleft)
```

For more details on when bounded vs. general `VariableRateJump`s can be used,
see the [next tutorial](@ref ssa_tutorial) and the [Jump Problems](@ref
jump_problem_type) documentation page.

## Having a Random Jump Distribution

Suppose we want to simulate a compound Poisson process, ``G(t)``, where

```math
G(t) = \sum_{i=1}^{N(t)} C_i
```

with ``N(t)`` a Poisson counting process with constant transition rate
``\lambda``, and the ``C_i`` independent and identical samples from a uniform
distribution over ``\{-1,1\}``. We can simulate such a process as follows.

We first ensure that we use the same random number generator as JumpProcesses. We
can either pass one as an input to [`JumpProblem`](@ref) via the `rng` keyword
argument, and make sure it is the same one we use in our `affect!` function, or
we can just use the default generator chosen by JumpProcesses if one is not
specified, `JumpProcesses.DEFAULT_RNG`. Let's do the latter

```@example tut1
rng = JumpProcesses.DEFAULT_RNG
```

Let's assume `u[1]` is ``N(t)`` and `u[2]` is ``G(t)``. We now proceed as in the
previous examples

```@example tut1
rate3(u, p, t) = p.λ

# define the affect function via a closure
affect3! = integrator -> let rng = rng
    # N(t) <-- N(t) + 1
    integrator.u[1] += 1

    # G(t) <-- G(t) + C_{N(t)}
    integrator.u[2] += rand(rng, (-1, 1))
    nothing
end
crj = ConstantRateJump(rate3, affect3!)

u₀ = [0, 0]
p = (λ = 1.0,)
tspan = (0.0, 100.0)
dprob = DiscreteProblem(u₀, tspan, p)
jprob = JumpProblem(dprob, Direct(), crj)
sol = solve(jprob, SSAStepper())
plot(sol, label = ["N(t)" "G(t)"], xlabel = "t")
```

# [Jumps, JumpProblem, and Aggregators](@id jump_problem_type)

## [Jump Types: Constant Rate, Mass Action, Variable Rate and Regular](@id jump_types)

Exact jump process simulation algorithms tend to describe the realization of
each jump event chronologically. Individual jumps are usually associated with
changes to the state variable `u`, which in turn changes the `rate`s at which
jump events occur. These jumps can be specified as a [`ConstantRateJump`](@ref),
[`MassActionJump`](@ref), or a [`VariableRateJump`](@ref).

Each individual type of jump that can occur is represented through (implicitly
or explicitly) specifying two pieces of information; a `rate` function (i.e.,
intensity or propensity) for the jump and an `affect!` function for the jump.
The former gives the probability per time a particular jump can occur given the
current state of the system, and hence determines the time at which jumps can
happen. The latter specifies the instantaneous change in the state of the system
when the jump occurs.

A specific jump type is a [`VariableRateJump`](@ref) if its rate function is
dependent on values which may change between the occurrence of any two jump
events of the process. Examples include jumps where the rate is an explicit
function of time, or depends on a state variable that is modified via continuous
dynamics such as an ODE or SDE. Such "general" `VariableRateJump`s can be
expensive to simulate because it is necessary to consider the (possibly
continuous) changes in the rate function when calculating the next jump time.

*Bounded* [`VariableRateJump`](@ref)s represent a special subset of
`VariableRateJump`s where one can specify functions that calculate a time window
over which the rate is bounded by a constant (presuming the state `u` is
unchanged due to another `ConstantRateJump`, `MassActionJump` or bounded
`VariableRateJump`). They can be simulated more efficiently using
rejection-sampling based approaches that leverage this upper bound.

[`ConstantRateJump`](@ref)s are more restricted in that they assume the rate
functions are constant at all times between two consecutive jumps of the system.
That is, any states or parameters that a rate function depends on must not
change between the times at which two consecutive jumps occur.

A [`MassActionJump`](@ref)s is a specialized representation for a collection of
`ConstantRateJump` jumps that can each be interpreted as a standard mass action
reaction. For systems comprised of many mass action reactions, using the
`MassActionJump` type will offer improved performance compared to using
multiple `ConstantRateJump`s. Note, only one `MassActionJump` should be defined
per [`JumpProblem`](@ref); it is then responsible for handling all mass action
reaction type jumps. For systems with both mass action jumps and non-mass action
jumps, one can create one `MassActionJump` to handle the mass action jumps, and
create a number of `ConstantRateJump`s or `VariableRateJump`s to handle the
non-mass action jumps.

Since exact methods simulate each individual jump, they may become
computationally expensive to simulate processes over timescales that involve
*many* jump occurrences. As an alternative, inexact τ-leaping methods take
discrete steps through time, over which they simultaneously execute many jumps.
These methods can be much faster as they do not need to simulate the realization
of every individual jump event. τ-leaping methods trade accuracy for speed, and
are best used when a set of jumps do not make significant changes to the
processes' state and/or rates over the course of one time-step (i.e., during a
leap interval). A single [`RegularJump`](@ref) is used to encode jumps for
τ-leaping algorithms. While τ-leaping methods can be proven to converge in the
limit that the time-step approaches zero, their accuracy can be highly dependent
on the chosen time-step. As a rule of thumb, if changes to the state variable
`u` during a time-step (i.e., leap interval) are "minimal" compared to the size of
the system, an τ-leaping method can often provide reasonable solution
approximations.

Currently, `ConstantRateJump`s, `MassActionJump`s, and `VariableRateJump`s can
be coupled to standard SciML ODE/SDE solvers since they are internally handled
via callbacks. For `ConstantRateJump`s, `MassActionJump`s, and bounded
`VariableRateJump` the determination of the next jump time and type is handled
by a user-selected *aggregator* algorithm. `RegularJump`s currently require
their own special time integrators.

#### Defining a Constant Rate Jump

The constructor for a [`ConstantRateJump`](@ref) is:

```julia
ConstantRateJump(rate, affect!)
```

  - `rate(u, p, t)` is a function which calculates the rate given the current
    state `u`, parameters `p`, and time `t`.
  - `affect!(integrator)` is the effect on the equation using the integrator
    interface. It encodes how the state should change due to *one* occurrence of
    the jump.

#### Defining a Mass Action Jump

The constructor for a [`MassActionJump`](@ref) is:

```julia
MassActionJump(reactant_stoich, net_stoich; scale_rates = true, param_idxs = nothing)
```

  - `reactant_stoich` is a vector whose `k`th entry is the reactant stoichiometry
    of the `k`th reaction. The reactant stoichiometry for an individual reaction
    is assumed to be represented as a vector of `Pair`s, mapping species integer
    id to stoichiometric coefficient.
  - `net_stoich` is assumed to have the same type as `reactant_stoich`; a
    vector whose `k`th entry is the net stoichiometry of the `k`th reaction. The
    net stoichiometry for an individual reaction is again represented as a vector
    of `Pair`s, mapping species id to the net change in the species when the
    reaction occurs.
  - `scale_rates` is an optional parameter that specifies whether the rate
    constants correspond to stochastic rate constants in the sense used by
    Gillespie, and hence need to be rescaled. *The default, `scale_rates = true`,
    corresponds to rescaling the passed in rate constants.* See below.
  - `param_idxs` is a vector of the indices within the parameter vector, `p`, that
    correspond to the rate constant for each jump.

**Notes for Mass Action Jumps**

  - When using `MassActionJump` the default behavior is to assume rate constants
    correspond to stochastic rate constants in the sense used by Gillespie (J.
    Comp. Phys., 1976, 22 (4)). This means that for a reaction such as ``2A \overset{k}{\rightarrow} B``, the jump rate function constructed by
    `MassActionJump` would be `k*A*(A-1)/2!`. For a trimolecular reaction like
    ``3A \overset{k}{\rightarrow} B`` the rate function would be
    `k*A*(A-1)*(A-2)/3!`. To *avoid* having the reaction rates rescaled (by `1/2`
    and `1/6` for these two examples), one can pass the `MassActionJump`
    constructor the optional named parameter `scale_rates = false`, i.e., use
    
    ```julia
    MassActionJump(reactant_stoich, net_stoich; scale_rates = false, param_idxs)
    ```

  - Zero order reactions can be passed as `reactant_stoich`s in one of two ways.
    Consider the ``\varnothing \overset{k}{\rightarrow} A`` reaction with rate
    `k=1`:
    
    ```julia
    p = [1.0]
    reactant_stoich = [[0 => 1]]
    net_stoich = [[1 => 1]]
    jump = MassActionJump(reactant_stoich, net_stoich; param_idxs = [1])
    ```
    
    Alternatively, one can create an empty vector of pairs to represent the reaction:
    
    ```julia
    p = [1.0]
    reactant_stoich = [Vector{Pair{Int, Int}}()]
    net_stoich = [[1 => 1]]
    jump = MassActionJump(reactant_stoich, net_stoich; param_idxs = [1])
    ```
  - For performance reasons, it is recommended to order species indices in
    stoichiometry vectors from smallest to largest. That is
    
    ```julia
    reactant_stoich = [[1 => 2, 3 => 1, 4 => 2], [2 => 2, 3 => 2]]
    ```
    
    is preferred over
    
    ```julia
    reactant_stoich = [[3 => 1, 1 => 2, 4 => 2], [3 => 2, 2 => 2]]
    ```

#### Defining a Variable Rate Jump

The constructor for a [`VariableRateJump`](@ref) is:

```julia
VariableRateJump(rate, affect!;
    lrate = nothing, urate = nothing, rateinterval = nothing,
    idxs = nothing, rootfind = true, save_positions = (true, true),
    interp_points = 10, abstol = 1e-12, reltol = 0)
```

  - `rate(u, p, t)` is a function which calculates the rate given the current
    state `u`, parameters `p`, and time `t`.
  - `affect!(integrator)` is the effect on the equation using the integrator
    interface. It encodes how the state should change due to *one* occurrence of
    the jump.

To define a bounded `VariableRateJump`, which can be simulated more efficiently
with bounded `VariableRateJump` supporting aggregators such as `Coevolve`, one
must also specify

  - `urate(u, p, t)`, a function which computes an upper bound for the rate in the
    interval `t` to `t + rateinterval(u, p, t)` at time `t` given state `u` and
    parameters `p`.
  - `rateinterval(u, p, t)`, a function which computes a time interval `t` to `t + rateinterval(u, p, t)` given state `u` and parameters `p` over which the
    `urate` bound will hold (and `lrate` bound if provided, see below).

For increased performance, one can also specify a lower bound that should be
valid over the same `rateinterval`

  - `lrate(u, p, t)`, a function which computes a lower bound for the rate in the
    interval `t` to `t + rateinterval(u, p, t)` at time `t` given state `u` and
    parameters `p`. `lrate` should remain valid under the same conditions as
    `urate`.

Note that

  - It is currently only possible to simulate `VariableRateJump`s with
    `SSAStepper` when using systems with bounded `VariableRateJump`s and the
    `Coevolve` aggregator.
  - Any `JumpProblem` with `VariableRateJump` that *does not use* the
    `Coevolve` aggregator  must be coupled to a continuous problem type such as
    an `ODEProblem` to handle time-stepping. Continuous time-stepper will ignore
    the provided aggregator and treat *all* `VariableRateJump`s as
    `ContinuousCallback`s, using the `rate(u, p, t)` function to construct the
    `condition` function that triggers a callback.
  - When using `Coevolve` with a `JumpProblem` coupled to a continuous problem
    such as an `ODEProblem`, the aggregator will handle the jumps in same way
    that it does with `SSAStepper`. However, *ensure that given `t` the bounds
    will hold for the duration of `rateinterval(t)` for the full coupled system's
    dynamics or the algorithm will not give correct samples*. Numerical and
    analytical solutions are generally not guaranteed to satisfy the same bounds,
    especially in large complicated models. Consider adding some slack on the
    bounds and approach complex models with care. In most simple cases the bounds
    should be close enough. For debugging purposes one might want to add safety
    checks in the bound functions.
  - In some circumstances with complex model of many variables it can be
    difficult to determine good a priori bounds on the ODE variables. For some
    discussion on the bound setting problem see Lemaire *et al.* [^1].

#### Defining a Regular Jump

The constructor for a [`RegularJump`](@ref) is:

```julia
RegularJump(rate, c, numjumps; mark_dist = nothing)
```

  - `rate(out, u, p, t)` is the function which computes the rate for every regular
    jump process
  - `c(du, u, p, t, counts, mark)` calculates the update given `counts` number of
    jumps for each jump process in the interval.
  - `numjumps` is the number of jump processes, i.e., the number of `rate`
    equations and the number of `counts`.
  - `mark_dist` is the distribution for a mark.

## [JumpProblem](@id defining_jump_problem)

To define a `JumpProblem`, one must first define the basic problem. This can be
a `DiscreteProblem` if there is no differential equation, or an ODE/SDE/DDE/DAE
if you would like to augment a differential equation with jumps. Denote this
previously defined problem as `prob`. Then the constructor for the jump problem
is:

```julia
JumpProblem(prob, aggregator, jumps::JumpSet;
    save_positions = prob isa AbstractDiscreteProblem ? (false, true) :
                     (true, true))
```

The aggregator is the method for simulating `ConstantRateJump`s,
`MassActionJump`s, and bounded `VariableRateJump`s (if supported by the
aggregator). They are called aggregators since they resolve all these jumps in a
single discrete simulation algorithm. The possible aggregators are given below.
`jumps` is a [`JumpSet`](@ref) which is just a collection of jumps. Instead of
passing a `JumpSet`, one may just pass a list of jumps as trailing positional
arguments. For example:

```julia
JumpProblem(prob, aggregator, jump1, jump2)
```

and the internals will automatically build the `JumpSet`. `save_positions`
determines whether to save the state of the system just before and/or after
jumps occur.

Note that a `JumpProblem`/`JumpSet` can only have 1 `RegularJump` (since a
`RegularJump` itself describes multiple processes together). Similarly, it can
only have one `MassActionJump` (since it also describes multiple processes
together).

## Jump Aggregators for Exact Simulation

Jump aggregators are methods for simulating `ConstantRateJump`s,
`MassActionJump`s, and bounded `VariableRateJump`s (if supported) exactly. They
are called aggregators since they combine all jumps to handle within a single
discrete simulation algorithm. Aggregators combine jumps in different ways and
offer different trade-offs. However, all aggregators describe the realization of
each and every individual jump chronologically. Since they do not skip any
jumps, they are considered exact methods. Note that none of the aggregators
discussed in this section can be used with `RegularJumps` which are used for
time-step based (inexact) τ-leaping methods.

The current aggregators are (note that an italicized name indicates the
aggregator requires various types of dependency graphs, see the next section):

  - `Direct`: The Gillespie Direct method SSA [^2].
  - `DirectFW`: the Gillespie Direct method SSA [^2] with `FunctionWrappers`. This
    aggregator uses a different internal storage format for collections of
    `ConstantRateJumps`.
  - `DirectCR`: The Composition-Rejection Direct method of Slepoy *et al.* [^3]. For
    large networks and linear chain-type networks, it will often give better
    performance than `Direct`. [Dependency graph required](@ref Jump-Aggregators-Requiring-Dependency-Graphs).
  - `SortingDirect`: The Sorting Direct Method of McCollum *et al.* [^4]. It will
    usually offer performance as good as `Direct`, and for some systems can offer
    substantially better performance. [Dependency graph required](@ref Jump-Aggregators-Requiring-Dependency-Graphs).
  - `RSSA`: The Rejection SSA (RSSA) method of Thanh *et al.* [^5][^6]. With `RSSACR`,
    for very large reaction networks, it often offers the best performance of all
    methods. [Dependency graph required](@ref Jump-Aggregators-Requiring-Dependency-Graphs).
  - `RSSACR`: The Rejection SSA (RSSA) with Composition-Rejection method of
    Thanh *et al.* [^7]. With `RSSA`, for very large reaction networks, it often offers
    the best performance of all methods. [Dependency graph required](@ref Jump-Aggregators-Requiring-Dependency-Graphs).
  - `RDirect`: A variant of Gillespie's Direct method [^2] that uses rejection to
    sample the next reaction.
  - `FRM`: The Gillespie first reaction method SSA [^2]. `Direct` should generally
    offer better performance and be preferred to `FRM`.
  - `FRMFW`: The Gillespie first reaction method SSA [^2] with `FunctionWrappers`.
  - `NRM`: The Gibson-Bruck Next Reaction Method [^8]. For some reaction network
    structures, this may offer better performance than `Direct` (for example,
    large, linear chains of reactions). [Dependency graph required](@ref Jump-Aggregators-Requiring-Dependency-Graphs).
  - `Coevolve`: An improvement of the COEVOLVE algorithm of Farajtabar *et al.*
    [^9]. Currently the only aggregator that also supports *bounded*
    `VariableRateJump`s. As opposed
    to COEVOLVE, this method syncs the thinning procedure with the stepper
    which allows it to handle dependencies on continuous dynamics. Essentially
    reduces to `NRM` in handling `ConstantRateJump`s and `MassActionJump`s. [Dependency graph required](@ref Jump-Aggregators-Requiring-Dependency-Graphs).

To pass the aggregator, pass the instantiation of the type. For example:

```julia
JumpProblem(prob, Direct(), jump1, jump2)
```

will build a problem where the jumps are simulated using Gillespie's Direct SSA
method.

## Jump Aggregators Requiring Dependency Graphs

Italicized constant rate jump aggregators above require the user to pass a
dependency graph to `JumpProblem`. `Coevolve`, `DirectCR`, `NRM`, and
`SortingDirect` require a jump-jump dependency graph, passed through the named
parameter `dep_graph`. i.e.,

```julia
JumpProblem(prob, DirectCR(), jump1, jump2; dep_graph = your_dependency_graph)
```

For systems with only `MassActionJump`s, or those generated from a
[Catalyst](https://docs.sciml.ai/Catalyst/stable/) `reaction_network`, this
graph will be auto-generated. Otherwise, you must construct the dependency graph
whenever the set of jumps include `ConstantRateJump`s and/or bounded
`VariableRateJump`s.

Dependency graphs are represented as a `Vector{Vector{Int}}`, with the `i`th
vector containing the indices of the jumps for which rates must be recalculated
when the `i`th jump occurs. Internally, all `MassActionJump`s are ordered before
`ConstantRateJump`s and bounded `VariableRateJump`s. General `VariableRateJump`s
are not handled by aggregators, and so not included in the jump ordering for
dependency graphs. Note that the relative order between `ConstantRateJump`s and
relative order between bounded `VariableRateJump`s is preserved. In this way, one
can precalculate the jump order to manually construct dependency graphs.

`RSSA` and `RSSACR` require two different types of dependency graphs, passed
through the following `JumpProblem` kwargs:

  - `vartojumps_map` - A `Vector{Vector{Int}}` mapping each variable index, `i`,
    to a set of jump indices. The jump indices correspond to jumps with rate
    functions that depend on the value of `u[i]`.
  - `jumptovars_map` - A `Vector{Vector{Int}}`  mapping each jump index to a set
    of variable indices. The corresponding variables are those that have their
    value, `u[i]`, altered when the jump occurs.

For systems generated from a [Catalyst](https://docs.sciml.ai/Catalyst/stable/)
`reaction_network` these will be auto-generated. Otherwise, you must explicitly
construct and pass in these mappings.

## Recommendations for exact methods

For representing and aggregating jumps

  - Use a `MassActionJump` to handle all jumps that can be represented as mass
    action reactions with constant rate between jumps. This will generally offer
    the fastest performance.
  - Use `ConstantRateJump`s for any remaining jumps with a constant rate between
    jumps.
  - Use `VariableRateJump`s for any remaining jumps with variable rate between
    jumps. If possible, construct a bounded [`VariableRateJump`](@ref) as
    described above and in the doc string. The tighter and easier to compute
    the bounds are, the faster the resulting simulation will be. Use the
    `Coevolve` aggregator to ensure such jumps are handled via the more
    efficient aggregator interface. `Coevolve` handles continuous steppers so
    can be coupled with a continuous problem type such as an `ODEProblem` as
    long as the bounds are satisfied given changes in `u` over `rateinterval`.

For systems with only `ConstantRateJump`s and `MassActionJump`s,

  - For a small number of jumps, < ~10, `Direct` will often perform as well as the
    other aggregators.
  - For > ~10 jumps `SortingDirect` will often offer better performance than
    `Direct`.
  - For large numbers of jumps with sparse chain like structures and similar jump
    rates, for example continuous time random walks, `RSSACR`, `DirectCR` and then
    `NRM` often have the best performance.
  - For very large networks, with many updates per jump, `RSSA` and `RSSACR` will
    often substantially outperform the other methods.

For pure jump systems, time-step using `SSAStepper()` with a `DiscreteProblem`
unless one has general (i.e., non-bounded) `VariableRateJump`s.

In general, for systems with sparse dependency graphs if `Direct` is slow, one
of `SortingDirect`, `RSSA` or `RSSACR` will usually offer substantially better
performance. See
[DiffEqBenchmarks.jl](https://docs.sciml.ai/SciMLBenchmarksOutput/stable/) for
benchmarks on several example networks.

## Remaking `JumpProblem`s

When running many simulations, it can often be convenient to update the initial
condition or simulation parameters without having to create and initialize a new
`JumpProblem`. In such situations `remake` can be used to change the initial
condition, time span, and the parameter vector. **Note,** the new `JumpProblem`
will alias internal data structures from the old problem, including core
components of the SSA aggregators. As such, only the new problem generated by
`remake` should be used for subsequent simulations.

As an example, consider the following SIR model:

```julia
rate1(u, p, t) = p[1] * u[1] * u[2]
function affect1!(integrator)
    integrator.u[1] -= 1
    integrator.u[2] += 1
end
jump = ConstantRateJump(rate1, affect1!)

rate2(u, p, t) = p[2] * u[2]
function affect2!(integrator)
    integrator.u[2] -= 1
    integrator.u[3] += 1
end
jump2 = ConstantRateJump(rate2, affect2!)
u0 = [999, 1, 0]
p = (0.1 / 1000, 0.01)
tspan = (0.0, 250.0)
dprob = DiscreteProblem(u0, tspan, p)
jprob = JumpProblem(dprob, Direct(), jump, jump2)
sol = solve(jprob, SSAStepper())
```

We can change any of `u0`, `p` and/or `tspan` by either making a new
`DiscreteProblem`

```julia
u02 = [10, 1, 0]
p2 = (0.1 / 1000, 0.0)
tspan2 = (0.0, 2500.0)
dprob2 = DiscreteProblem(u02, tspan2, p2)
jprob2 = remake(jprob, prob = dprob2)
sol2 = solve(jprob2, SSAStepper())
```

or by directly remaking with the new parameters

```julia
jprob2 = remake(jprob, u0 = u02, p = p2, tspan = tspan2)
sol2 = solve(jprob2, SSAStepper())
```

To avoid ambiguities, the following will give an error

```julia
jprob2 = remake(jprob, prob = dprob2, u0 = u02)
```

as will trying to update either `p` or `tspan` while passing a new
`DiscreteProblem` using the `prob` kwarg.

## References

[^1]: V. Lemaire, M. Thieullen and N. Thomas, Exact Simulation of the Jump
    Times of a Class of Piecewise Deterministic Markov Processes, Journal of
    Scientific Computing, 75 (3), 1776-1807 (2018). doi:10.1007/s10915-017-0607-4.
[^2]: D. T. Gillespie, A general method for numerically simulating the stochastic
    time evolution of coupled chemical reactions, Journal of Computational Physics,
    22 (4), 403–434 (1976). doi:10.1016/0021-9991(76)90041-3.
[^3]: A. Slepoy, A.P. Thompson and S.J. Plimpton, A constant-time kinetic Monte
    Carlo algorithm for simulation of large biochemical reaction networks, Journal
    of Chemical Physics, 128 (20), 205101 (2008). doi:10.1063/1.2919546.
[^4]: J. M. McCollum, G. D. Peterson, C. D. Cox, M. L. Simpson and N. F.
    Samatova, The sorting direct method for stochastic simulation of biochemical
    systems with varying reaction execution behavior, Computational Biology and
    Chemistry, 30 (1), 39049 (2006). doi:10.1016/j.compbiolchem.2005.10.007.
[^5]: V. H. Thanh, C. Priami and R. Zunino, Efficient rejection-based simulation
    of biochemical reactions with stochastic noise and delays, Journal of Chemical
    Physics, 141 (13), 134116 (2014). doi:10.1063/1.4896985.
[^6]: V. H. Thanh, R. Zunino and C. Priami, On the rejection-based algorithm for
    simulation and analysis of large-scale reaction networks, Journal of Chemical
    Physics, 142 (24), 244106 (2015). doi:10.1063/1.4922923.
[^7]: V. H. Thanh, R. Zunino, and C. Priami, Efficient constant-time complexity
    algorithm for stochastic simulation of large reaction networks, IEEE/ACM
    Transactions on Computational Biology and Bioinformatics, 14 (3), 657-667
    (2017). doi:10.1109/TCBB.2016.2530066.
[^8]: M. A. Gibson and J. Bruck, Efficient exact stochastic simulation of chemical
    systems with many species and many channels, Journal of Physical Chemistry A,
    104 (9), 1876-1889 (2000). doi:10.1021/jp993732q.
[^9]: M. Farajtabar, Y. Wang, M. Gomez-Rodriguez, S. Li, H. Zha, and L. Song,
    COEVOLVE: a joint point process model for information diffusion and network
    evolution, Journal of Machine Learning Research 18(1), 1305–1353 (2017). doi:
    10.5555/3122009.3122050.

# JumpProcesses.jl API

```@meta
CurrentModule = JumpProcesses
```

## Core Types

```@docs
JumpProblem
SSAStepper
reset_aggregated_jumps!
```

## Jump Types

```@docs
ConstantRateJump
MassActionJump
VariableRateJump
RegularJump
JumpSet
```

## Aggregator Types

Aggregators are the underlying algorithms used for sampling
[`ConstantRateJump`](@ref)s, [`MassActionJump`](@ref)s, and
[`VariableRateJump`](@ref)s.

```@docs
Coevolve
Direct
DirectCR
FRM
NRM
RDirect
RSSA
RSSACR
SortingDirect
```

# Private API Functions

```@docs
ExtendedJumpArray
SSAIntegrator
```

# Getting Started with JumpProcesses in Julia

Jumps and point processes are stochastic processes with discrete state changes
``du`` driven by a rate function. Let ``dN_i(t)`` be a stochastic process such
that ``dN_i(t) = 1`` with some probability and ``0`` otherwise. In a sense,
``dN_i(t)`` is a Bernoulli distribution over a tiny interval which represents
our jump. The rate in which we observe jumps is given by the intensity rate,
``E(dN_i(t)) = \lambda_i(t) dt``. As ``dN_i(t)`` is a function of time, any
differential equation can be extended by jumps.

For example, we have an ODE with jumps ``i``, denoted by

```math
du = f(u,p,t)dt + \sum_{i} h_i(u,p,t) dN_i(t) 
```

Functions ``f(u, p, t)`` and ``h(u, p, t)`` represent the impact of the drift and
jumps on the state variable respectively.

Extending a stochastic differential equation (SDE) to have jumps is commonly
known as a jump-diffusion, and is denoted by

```math
du = f(u,p,t)dt + \sum_{i}g_i(u,t)dW_i(t) + \sum_{j}h_i(u,p,t)dN_i(t)
```

By diffusion we mean a continuous stochastic process which is usually
represented as Gaussian white noise (i.e. ``W_j(t)`` is a Brownian Motion).

The general workflow with any of the jump processes above is to define the base
and jump problem, solve the jump problem and then analyze the solution. The full
code for a jump process with no other dynamics apart from jumps is:

```@example ex0
using JumpProcesses
u0 = [0]
tspan = (0.0, 10.0)
dprob = DiscreteProblem(u0, tspan)
rate(u, p, t) = 2.0
affect!(integrator) = (integrator.u[1] += 1)
jump = ConstantRateJump(rate, affect!)
jprob = JumpProblem(dprob, Direct(), jump)
sol = solve(jprob, SSAStepper())

using Plots
plot(sol, title = "Sample path from a jump process with constant rate",
    label = "N(t)", xlabel = "t", legend = :bottomright)
```

## Step 1: Defining a problem

The first thing you want to do is to define your base problem from the many
options available. For dynamics that involve only jumps we employ
a `DiscreteProblem` as our base problem.

```@example ex0
using JumpProcesses
u0 = [0]
tspan = (0.0, 10.0)
dprob = DiscreteProblem(u0, tspan)
```

For our example, notice that `u0` is a `Int[]` which is an appropriate choice in
this case because we will only be working with jumps. Since we will be modifying
`u0` only when a jump occurs via its `affect!`, we initialize `DiscreteProblem`
without any function mapping which means `DiscreteProblem` use the default
identity mapping.

JumpProcesses exports
[`DiscreteProblem`](https://docs.sciml.ai/DiffEqDocs/stable/types/discrete_types/)
from OrdinaryDiffEq. In case you want
to model the base dynamics as an
[`ODEProblem`](https://docs.sciml.ai/DiffEqDocs/stable/types/ode_types/) or as
an [`SDEProblem`](https://docs.sciml.ai/DiffEqDocs/stable/types/sde_types/)
you will need to import
OrdinaryDiffEq.

## Step 2: Defining a jump

Jumps are implemented as [callbacks
functions](https://docs.sciml.ai/DiffEqDocs/stable/features/callback_functions/)
from DifferentialEquations. Our library takes care of adding the appropriate
callbacks to the base problem to ensure that jumps are properly initialized and
executed.

Here we add a `ConstantRateJump` to the base problem. As such the user must
define the `rate` and `affect!` which determines the frequency and the effect of
the jumps on the base problem.

```@example ex0
rate(u, p, t) = 2.0
affect!(integrator) = (integrator.u[1] += 1)
jump = ConstantRateJump(rate, affect!)
```

There are many types of jumps. Some of them allow for variable rates. You can
read about [different jump types in this page](@ref jump_types).

Once the jump is defined, we initialize the `JumpProblem`. _Aggegators_ are
algorithms that determines jump times. We call them _aggregators_ because they
aggregate all jump callbacks into a single callback. Alternatively, we can think
of aggregators as the jump simulation algorithms. In this case we use the
`Direct` _aggregator_.

```@example ex0
jprob = JumpProblem(dprob, Direct(), jump)
```

JumpProblem can be initialized with different combination of jumps and
aggregators. If you want to understand more about the options available read
about [JumpProblem initialization in here](@ref defining_jump_problem).

In addition to that, aggregators come with different trade-offs. Not all
aggregators accept all jump types. To learn [more about _aggregators_ check this
section](@ref Jump-Aggregators-for-Exact-Simulation).

## Step 3: Solving a problem

After defining a problem, we solve it using `solve` with an appropriate stepper.

```@example ex0
sol = solve(jprob, SSAStepper())
```

Steppers tell how we evolve time in our base problem and required for any
numerical simulator. JumpProcesses offers the `SSAStepper` which steps through
time one jump candidate at a time.

If you are modelling other types of base problems like `ODEProblem` or
`SDEProblem`, you will not be able to use `SSAStepper` since these problems
require more fine-grained time evolution.

Apart from time-stepping, you might also be interested in controlling the saving
frequency of the state variable `u`. This control can be thought as orthogonal
to how the stepper evolves time. To avoid saving at every jump, we can
initialize jumps as following.

```@example ex0
jprob = JumpProblem(dprob, Direct(), jump; save_positions = (false, false))
```

Finally, to solve the problem at regular intervals we can use `saveat`.

```@example ex0
sol = solve(jprob, SSAStepper(); saveat = 1.0)
```

When you do not save the jump events, be careful when analysing interpolated
values as they will not be an accurate representation of the sampled path. This
can be particularly problematic plotting the data.

## Going Beyond the Poisson process: How to Use the Documentation

This tutorial covered only the basics of the Poisson process with constant rate.
We mostly focused on the basic pattern to define and solve a JumpProblem.

In case you want to go further, JumpProcesses is a component package in the
[SciML](https://sciml.ai/) ecosystem, and one of the core solver libraries
included in
[DifferentialEquations.jl](https://docs.sciml.ai/DiffEqDocs/stable/).

The documentation includes tutorials and examples:

  - [Simulating basic Poisson processes](@ref poisson_proc_tutorial)
  - [Simulating jump processes via SSAs (i.e., Gillespie methods)](@ref ssa_tutorial)
  - [Simulating jump-diffusion processes](@ref jump_diffusion_tutorial)
  - [Temporal point processes (TPP)](@ref tpp_tutorial)
  - [Spatial SSAs](@ref Spatial-SSAs-with-JumpProcesses.jl)

In addition to that the document contains references to guide you through:

  - [References on the types of jumps and available simulation methods](@ref jump_problem_type)
  - [References on jump time stepping methods](@ref jump_solve)
  - [FAQ with information on changing parameters between simulations and using callbacks](@ref FAQ)
  - [API documentation](@ref JumpProcesses.jl-API)

# [Continuous-Time Jump Processes and Gillespie Methods](@id ssa_tutorial)

In this tutorial, we will describe how to define and simulate continuous-time
jump (or point) processes, also known in biological fields as stochastic
chemical kinetics (i.e., Gillespie) models. It is not necessary to have read the
[first tutorial](@ref poisson_proc_tutorial). We will illustrate:

  - The different types of jumps that can be represented in JumpProcesses and their
    use cases.
  - How to speed up pure-jump simulations with only [`ConstantRateJump`](@ref)s,
    [`MassActionJump`](@ref)s, and bounded `VariableRateJump`s by using the
    [`SSAStepper`](@ref) time stepper.
  - How to define and use [`MassActionJump`](@ref)s, a more specialized type of
    [`ConstantRateJump`](@ref) that offers improved computational performance.
  - How to define and use bounded [`VariableRateJump`](@ref)s in pure-jump simulations.
  - How to use saving controls to reduce memory use per simulation.
  - How to use general [`VariableRateJump`](@ref)s and when they should be
    preferred over the other jump types.
  - How to create hybrid problems, mixing the various jump types with ODEs or SDEs.
  - How to use `RegularJump`s to enable faster, but approximate, time stepping via
    τ-leaping methods.

!!! note
    
    This tutorial assumes you have read the [Ordinary Differential Equations tutorial](https://docs.sciml.ai/DiffEqDocs/stable/getting_started/) in [`DifferentialEquations.jl`](https://docs.sciml.ai/DiffEqDocs/stable).

We begin by demonstrating how to build jump processes using
[JumpProcesses.jl](https://docs.sciml.ai/JumpProcesses/stable/)'s different jump types,
which encode the rate functions (i.e., transition rates, intensities, or
propensities) and state changes when a given jump occurs.

Note, the SIR model considered here is a type of stochastic chemical kinetics
jump process model, and as such the biological modeling functionality of
[Catalyst.jl](https://docs.sciml.ai/Catalyst/stable/) can be used to easily
specify the model and automatically calculate inputs needed for JumpProcesses's
optimized simulation algorithms. We summarize this alternative approach at the
beginning for users who may be interested in modeling chemical systems, but note
this tutorial is intended to explain the general jump process formulation of
JumpProcesses for all users. However, for those users constructing models that can
be represented as a collection of chemical reactions we strongly recommend using
Catalyst, which should ensure optimal jump types are selected to represent each
reaction, and necessary data structures for the simulation algorithms, such as
dependency graphs, are automatically calculated.

We'll make use of [JumpProcesses.jl](https://docs.sciml.ai/JumpProcesses/stable/)
together with [OrdinaryDiffEq.jl](https://docs.sciml.ai/OrdinaryDiffEq/stable/)
(for ODE solvers), Plots.jl, and (optionally) Catalyst.jl in this tutorial. If
not already installed, they can be added as follows:

```julia
using Pkg
Pkg.add("JumpProcesses")
Pkg.add("OrdinaryDiffEq")
Pkg.add("Plots")
Pkg.add("Catalyst")                # optional
```

Let's now load the required packages and set some default plot settings

```julia
using JumpProcesses, OrdinaryDiffEq, Plots, LinearAlgebra
default(; lw = 2)
```

```@setup tut2
using JumpProcesses, OrdinaryDiffEq, Plots, LinearAlgebra
default(; lw = 2)
```

## Illustrative Model: SIR Disease Dynamics

To illustrate the jump process solvers, we will build an SIR model which matches
the tutorial from [Gillespie.jl](https://github.com/sdwfrost/Gillespie.jl). SIR
stands for susceptible, infected, and recovered, and is a model of disease
spread. When a susceptible person comes in contact with an infected person, the
disease has a chance of infecting the susceptible person. This "chance" is
determined by the number of susceptible persons and the number of infected
persons, since in larger populations there is a greater chance that two people
come into contact. Every infected person will in turn have a rate at which they
recover. In our model, we'll assume there are no births or deaths, and a
recovered individual is protected from reinfection.

We'll begin by giving the mathematical equations for the jump processes of the
number of susceptible (``S(t)``), number of infected (``I(t)``), and number of
recovered (``R(t)``). In the next section, we give a more intuitive and
biological description of the model for users that are less familiar with jump
processes. Let ``Y_i(t)``, ``i = 1,2``, denote independent unit Poisson
processes. Our basic mathematical model for the evolution of
``(S(t),I(t),R(t))``, written using Kurtz's time-change representation, is then

```math
\begin{aligned}
S(t) &= S(0) - Y_1\left(  \int_0^t \beta S(s^{-}) I(s^{-}) \, ds\right) \\
I(t) &= I(0) + Y_1\left(  \int_0^t \beta S(s^{-}) I(s^{-}) \, ds\right)
        - Y_2 \left( \int_0^t \nu I(s^-)  \, ds \right) \\
R(t) &= R(0) + Y_2 \left( \int_0^t \nu I(s^-)  \, ds \right)
\end{aligned}
```

Notice, our model involves two jump processes with rate functions, also known as
intensities or propensities, given by ``\beta S(t) I(t)`` and ``\nu I(t)``
respectively. These give the probability per time a new infected individual is
created, and the probability per time some infected individual recovers.

For those less-familiar with the time-change representation, we next give a more
intuitive explanation of the model as a collection of chemical reactions, and
then demonstrate how these reactions can be written in
[Catalyst.jl](https://docs.sciml.ai/Catalyst/stable/) and seamlessly converted
into a form that can be used with the
[JumpProcesses.jl](https://docs.sciml.ai/JumpProcesses/stable/) solvers. Users
interested in how to directly define jumps using the lower-level JumpProcesses
interface can skip to [Building and Simulating the Jump Process Using the
JumpProcesses Low-Level Interface](@ref).

## Specifying the SIR Model with Chemical Reactions

The SIR model described above involves two basic chemical reactions,

```math
\begin{aligned}
S + I &\overset{\beta}{\to} 2 I \\
I &\overset{\nu}{\to} R,
\end{aligned}
```

where ``\beta`` and ``\nu`` are the rate constants of the reactions (with units
of probability per time). In a jump process (stochastic chemical kinetics)
model, we keep track of the non-negative integer number of each species at each
time (i.e., ``(S(t), I(t), R(t))`` above). Each reaction has an associated rate
function (i.e., intensity or propensity) giving the probability per time it can
occur when the system is in state ``(S(t),I(t),R(t))``:

```math
\begin{matrix}
\text{Reaction} & \text{Rate Functions} \\
\hline
S + I \overset{\beta}{\to} 2 I & \beta S(t) I(t) \\
I \overset{\nu}{\to} R & \nu I(t).
\end{matrix}
```

``\beta`` is determined by factors like the type of the disease. It can be
interpreted as the probability per time one pair of susceptible and infected
people encounter each other, with the susceptible person becoming sick. The
overall rate (i.e., probability per time) that some susceptible person gets sick
is then given by the rate constant multiplied by the number of possible pairs of
susceptible and infected people. This formulation is known as the [law of mass
action](https://en.wikipedia.org/wiki/Law_of_mass_action). Similarly, we have
that each individual infected person is assumed to recover with probability per
time ``\nu``, so that the probability per time *some* infected person recovers
is ``\nu`` times the number of infected people, i.e., ``\nu I(t)``.

Rate functions give the probability per time for each of the two types of jumps
to occur, and hence determine when the state of our system changes. To fully
specify our model, we also need to specify how the state changes when a jump
occurs, giving what are called `affect!` functions in JumpProcesses. For example,
when the $S + I \to 2 I$ reaction occurs, and some susceptible person becomes
infected, the subsequent (instantaneous) state change is that

```math
\begin{aligned}
S &\to S - 1 & I &\to I + 1.
\end{aligned}
```

Likewise, when the $I \to R$ reaction occurs so that some infected person becomes
recovered, the state change is

```math
\begin{aligned}
I &\to I - 1 & R \to R + 1.
\end{aligned}
```

In summary, our model is described by two chemical reactions, which each in turn
correspond to a jump process determined by a `rate` function specifying how
frequently jumps should occur, and an `affect!` function for how the state
should change when that jump type occurs.

## Building and Simulating the Jump Processes from Catalyst Models

Using [Catalyst.jl](https://docs.sciml.ai/Catalyst/stable/) we can input our full
reaction network in a form that can be easily used with JumpProcesses's solvers

```@example tut2
using Catalyst
sir_model = @reaction_network begin
    β, S + I --> 2I
    ν, I --> R
end
```

To build a pure jump process model of the reaction system we construct a
[`JumpProblem`](@ref) directly from the Catalyst `ReactionSystem`. We specify
`u₀`, the initial condition, `tspan`, the timespan, and `p`, the parameters.
Here, we will start with ``990`` susceptible people, ``10`` infected person, and
`0` recovered people, and solve the problem from `t=0.0` to `t=250.0`. We use
the parameters `β = 0.1/1000` and `ν = 0.01`.

```@example tut2
p = (:β => 0.1 / 1000, :ν => 0.01)
u₀ = [:S => 990, :I => 10, :R => 0]
tspan = (0.0, 250.0)
jump_prob = JumpProblem(sir_model, u₀, tspan, p)
```

*Notice, the initial populations are integers, since we want the exact number of
people in the different states.*

Here `Direct()` is the default aggregator, which determines the random times and
types of reactions using [Gillespie's Direct stochastic simulation algorithm
(SSA)](https://doi.org/10.1016/0021-9991(76)90041-3), also known as Doob's
method or Kinetic Monte Carlo. See [Jump Aggregators for Exact Simulation](@ref) for
other supported SSAs.

We now have a problem that can be evolved in time using the JumpProcesses solvers.
Since our model is a pure jump process (no continuously-varying components), we
will use `SSAStepper()` to handle time-stepping the `Direct` method from jump to
jump:

```@example tut2
sol = solve(jump_prob, SSAStepper())
```

This solve command takes the standard commands of the common interface, and the
solution object acts just like any other differential equation solution. Thus,
there exists a plot recipe, which we can plot with:

```@example tut2
plot(sol)
```

## Building and Simulating the Jump Process Using the JumpProcesses Low-Level Interface

We now show how to directly use JumpProcesses's low-level interface to construct
and solve our jump process model for ``(S(t),I(t),R(t))``. Each individual jump
that can occur is represented through specifying two pieces of information; a
`rate` function (i.e., intensity or propensity) for the jump and an `affect!`
function for the jump. The former gives the probability per time a particular
jump can occur given the current state of the system, and hence determines the
time at which jumps can happen. The latter specifies the instantaneous change in
the state of the system when the jump occurs.

In our SIR model, we have two possible jumps that can occur (one for susceptibles
becoming infected and one for infected becoming recovered), with the
corresponding (mathematical) rates and affects given by

```math
\begin{matrix}
\text{Rates} & \text{Affects}\\
\hline
\beta S(t) I(t) & S \to S - 1,\, I \to I + 1 \\
\nu I(t) & I \to I - 1, \, R \to R + 1.
\end{matrix}
```

JumpProcesses offers three different ways to (exactly) represent jumps:
`MassActionJump`, `ConstantRateJump`, and `VariableRateJump`. Choosing which to
use is a trade-off between the desired generality of the `rate` and `affect!`
functions vs. the computational performance of the resulting simulated system.
In general

| Jump Type                                                            | Performance                             | Generality                                                                                                                                 |
|:--------------------------------------------------------------------:|:---------------------------------------:|:------------------------------------------------------------------------------------------------------------------------------------------:|
| [`MassActionJump`](@ref MassActionJumpSect)                          | Fastest                                 | Restrictive rates/affects                                                                                                                  |
| [`ConstantRateJump`](@ref ConstantRateJumpSect)                      | Somewhat Slower than `MassActionJump`   | Rate function must be constant between jumps                                                                                               |
| [`VariableRateJump` with rate bounds](@ref VariableRateJumpWithBnds) | Somewhat Slower than `ConstantRateJump` | Rate functions can explicitly depend on time, but require an upper bound that is guaranteed constant between jumps over some time interval |
| [`VariableRateJump`](@ref VariableRateJumpSect)                      | Slowest                                 | Completely general                                                                                                                         |

It is recommended to try to encode jumps using the most performant option that
supports the desired generality of the underlying `rate` and `affect!`
functions. Below we describe the different jump types, and show how the SIR
model can be formulated using first `ConstantRateJump`s, then more performant
`MassActionJump`s, and finally with `VariableRateJump`s using rate bounds. We
conclude by presenting several completely general models that use
`VariableRateJump`s without rate bounds, and which require an ODE solver to
handle time-stepping.

We note, in the remainder we will refer to *bounded* `VariableRateJump`s as
those for which we can specify functions calculating a time window over which
the rate is bounded by a constant (as long as the state is unchanged), see [the
section on bounded `VariableRateJump`s for details](@ref VariableRateJumpWithBnds).
`VariableRateJump`s or *general* `VariableRateJump`s will refer to those for
which such functions are not available.

## [Defining the Jumps Directly: `ConstantRateJump`](@id ConstantRateJumpSect)

The constructor for a `ConstantRateJump` is:

```julia
jump = ConstantRateJump(rate, affect!)
```

where `rate` is a function `rate(u,p,t)` and `affect!` is a function of the
integrator `affect!(integrator)` (for details on the integrator, see the
[integrator interface
docs](https://docs.sciml.ai/DiffEqDocs/stable/basics/integrator/)). Here
`u` corresponds to the current state vector of the system; for our SIR model
`u[1] = S(t)`, `u[2] = I(t)` and `u[3] = R(t)`. `p` corresponds to the parameters of
the model, just as used for passing parameters to derivative functions in ODE
solvers. Thus, to define the two possible jumps for our model, we take (with
`β = .1/1000.0` and `ν = .01`).

```@example tut2
β = 0.1 / 1000.0
ν = 0.01;
p = (β, ν)
rate1(u, p, t) = p[1] * u[1] * u[2]  # β*S*I
function affect1!(integrator)
    integrator.u[1] -= 1         # S -> S - 1
    integrator.u[2] += 1         # I -> I + 1
    nothing
end
jump = ConstantRateJump(rate1, affect1!)

rate2(u, p, t) = p[2] * u[2]         # ν*I
function affect2!(integrator)
    integrator.u[2] -= 1        # I -> I - 1
    integrator.u[3] += 1        # R -> R + 1
    nothing
end
jump2 = ConstantRateJump(rate2, affect2!)
```

We will start with `990` susceptible people, `10` infected people, and `0`
recovered people, and solve the problem from `t=0.0` to `t=250.0` so that

```@example tut2
u₀ = [999, 10, 0]
tspan = (0.0, 250.0)
```

*Notice, the initial populations are integers, since we want the exact number of
people in the different states.*

Since we want the system state to change only at the discrete jump times, we
will build a
[`DiscreteProblem`](https://docs.sciml.ai/DiffEqDocs/stable/types/discrete_types/)

```@example tut2
prob = DiscreteProblem(u₀, tspan, p)
```

We can then use [`JumpProblem`](@ref) from JumpProcesses to augment the discrete
problem with jumps and select the stochastic simulation algorithm (SSA) to use
in sampling the jump processes. To create a `JumpProblem` we would simply do:

```@example tut2
jump_prob = JumpProblem(prob, Direct(), jump, jump2)
```

Here [`Direct()`](@ref) indicates that we will determine the random times and
types of jumps that occur using [Gillespie's Direct stochastic simulation
algorithm (SSA)](https://doi.org/10.1016/0021-9991(76)90041-3), also known as
Doob's method or Kinetic Monte Carlo. See [Jump Aggregators for Exact Simulation](@ref)
for other supported SSAs.

We now have a problem that can be evolved in time using the JumpProcesses solvers.
Since our model is a pure jump process with all rates being constant in between
jumps (i.e., no continuously-varying components), we will use
[`SSAStepper`](@ref) to handle time-stepping the `Direct` method from jump to
jump:

```@example tut2
sol = solve(jump_prob, SSAStepper())
```

This solve command takes the standard commands of the common interface, and the
solution object acts just like any other differential equation solution. Thus
there exists a plot recipe, which we can plot with:

```@example tut2
plot(sol, label = ["S(t)" "I(t)" "R(t)"])
```

Note, in systems with more than a few jumps (more than ~10), it can be
advantageous to use more sophisticated SSAs than `Direct`. For such systems it
is recommended to use [`SortingDirect`](@ref), [`RSSA`](@ref) or
[`RSSACR`](@ref), see the list of JumpProcesses SSAs at [Jump Aggregators for
Exact Simulation](@ref).

## SSAStepper

Any common interface algorithm can be used to perform the time-stepping, since it
is implemented over the callback interface. This allows for hybrid systems that
mix ODEs, SDEs and jumps. In many cases, we may have a pure jump system that only
involves `ConstantRateJump`s, `MassActionJump`s, and/or bounded
`VariableRateJump`s (see below). In those cases, a substantial performance
benefit may be gained by using [`SSAStepper`](@ref). Note, `SSAStepper` is a
more limited time-stepper which only supports discrete events, and does not
allow simultaneous coupled ODEs/SDEs, or general `VariableRateJump`s. It is,
however, very efficient for pure jump problems involving only
`ConstantRateJump`s, `MassActionJump`s, and bounded `VariableRateJump`s.

## [Defining the Jumps Directly: `MassActionJump`](@id MassActionJumpSect)

For `ConstantRateJump`s that can be represented as mass action reactions a
further specialization of the jump type is possible that offers improved
computational performance; [`MassActionJump`](@ref). Suppose the system has
``N`` chemical species ``\{S_1,\dots,S_N\}``. A general mass action reaction has
the form

```math
R_1 S_1 + R_2 S_2 + \dots + R_N S_N \overset{k}{\rightarrow} P_1 S_1 + P_2 S_2 + \dots + P_N S_N
```

where the non-negative integers ``(R_1,\dots,R_N)`` denote the *reactant
stoichiometry* of the reaction, and the non-negative integers
``(P_1,\dots,P_N)`` the *product stoichiometry*. The *net stoichiometry* is the
net change in each chemical species from the reaction occurring one time, given
by ``\mathbf{\nu} = (P_1-R_1,\dots,P_N-R_N)``. As such, the `affect!` function associated with
a `MassActionJump` simply changes the state, ``\mathbf{u}(t) = (u_1(t),\dots,u_N(t))``,
by updating

```math
\mathbf{u}(t) \to \mathbf{u}(t) + \mathbf{\nu}.
```

The default rate function, `ρ = rate(u,p,t)`, is based on stochastic chemical
kinetics and given by

```math
ρ(\mathbf{u}(t)) = k \prod_{i=1}^N \begin{pmatrix} u_i \\ R_i \end{pmatrix}
= k \prod_{i=1}^N \frac{u_i!}{R_i! (u_i - R_i)!}
= k \prod_{i=1}^N \frac{u_i (u_i - 1) \cdots (u_i - R_i + 1)}{R_i!}
```

where ``k`` denotes the rate constant of the reaction (in units of per time).

As an example, consider again the SIR model. The species are `u = (S,I,R)`. The
first reaction has rate `β`, reactant stoichiometry `(1, 1, 0)`, product
stoichiometry `(0, 2, 0)`, and net stoichiometry `(-1, 1, 0)`. The second reaction
has rate `ν`, reactant stoichiometry `(0, 1, 0)`, product stoichiometry `(0, 0, 1)`,
and net stoichiometry `(0, -1, 1)`.

We can manually encode this system as a mass action jump by specifying the
indexes of the rate constants in `p`, the reactant stoichiometry, and the net
stoichiometry. We note that the first two determine the rate function, with the
latter determining the affect function.

```@example tut2
rateidxs = [1, 2]           # i.e., [β, ν]
reactant_stoich = [
    [1 => 1, 2 => 1],         # 1*S and 1*I
    [2 => 1]                  # 1*I
]
net_stoich = [
    [1 => -1, 2 => 1],        # -1*S and 1*I
    [2 => -1, 3 => 1]         # -1*I and 1*R
]
mass_act_jump = MassActionJump(reactant_stoich, net_stoich; param_idxs = rateidxs)
```

Notice, one typically should define *one* `MassActionJump` that encodes each
possible jump that can be represented via a mass action reaction.
This contrasts with `ConstantRateJump`s or `VariableRateJump`s where separate instances
are created for each distinct jump type.

Just like for `ConstantRateJumps`, to then simulate the system we create
a `JumpProblem` and call `solve`:

```@example tut2
jump_prob = JumpProblem(prob, Direct(), mass_act_jump)
sol = solve(jump_prob, SSAStepper())
plot(sol; label = ["S(t)" "I(t)" "R(t)"])
```

For more details about MassActionJumps see [Defining a Mass Action Jump](@ref).
We note that one could include the factors of ``1 / R_i!`` directly in the rate
constant passed into a [`MassActionJump`](@ref), so that the desired rate
function that gets evaluated is

```math
\hat{k} \prod_{i=1}^N u_i (u_i - 1) \cdots (u_i - R_i + 1)
```

with ``\hat{k} = k / \prod_{i=1}^{N} R_i!`` the renormalized rate constant.
Passing the keyword argument `scale_rates = false` will disable
`MassActionJump`s internally rescaling the rate constant by ``(\prod_{i=1}^{N} R_i!)^{-1}``.

For chemical reaction systems Catalyst.jl automatically groups reactions
into their optimal jump representation.

### *Caution about ConstantRateJumps and MassActionJumps*

`ConstantRateJump`s and `MassActionJump`s are restricted in that they assume the
rate functions are constant at all times between two consecutive jumps of the
system. That is, any species/states or parameters that a rate function depends
on must not change between the times at which two consecutive jumps occur. Such
conditions are violated if one has a time-dependent parameter like ``\beta(t)``
or if some solution components, say `u[2]`, may also evolve through a
coupled ODE, SDE, or a general [`VariableRateJump`](@ref) (see below for
examples). For problems where the rate function may change between consecutive
jumps, bounded or general [`VariableRateJump`](@ref)s must be used.

Thus, in the examples above,

```julia
rate1(u, p, t) = p[1] * u[1] * u[2]
rate2(u, p, t) = p[2] * u[2]
```

both must be constant, besides changes due to some other `ConstantRateJump` or
`MassActionJump` (the same restriction applies to `MassActionJump`s). Since
these rates only change when `u[1]` or `u[2]` is changed, and `u[1]` and `u[2]`
only change when one of the jumps occur, this setup is valid. However, a rate of
`t*p[1]*u[1]*u[2]` would not be valid because the rate would change in between
jumps, as would `p[2]*u[1]*u[4]` when `u[4]` is the solution to a continuous
problem such as an ODE/SDE, or can be changed by a general `VariableRateJump`.
Thus, one must be careful to follow this rule when choosing rates.

In summary, if a particular jump process has a rate function that depends
explicitly or implicitly on a continuously changing quantity, you need to use a
[`VariableRateJump`](@ref).

## [Defining the Jumps Directly using a bounded `VariableRateJump`](@id VariableRateJumpWithBnds)

Assume that the infection rate is now decreasing over time. That is, when
individuals get infected, they immediately reach peak infectivity. The force of
infection then decreases exponentially to a basal level. In this case, we must
keep track of the time of infection events. Let the history ``H(t)`` contain the
timestamps of all ``I(t)`` active infections. The rate of infection is then

```math
\beta_1 S(t) I(t) + \alpha S(t) \sum_{t_i \in H(t)} \exp(-\gamma (t - t_i))
```

where ``\beta_1`` is the basal rate of infection, ``\alpha`` is the spike in
the rate of infection, and ``\gamma`` is the rate at which the spike decreases.
Here, we choose parameters such that infectivity rate due to a single infected
individual returns to the basal rate after spiking to ``\beta_1 + \alpha``. In
other words, we are modelling a situation in which infected individuals
gradually become less infectious prior to recovering. Finally, the vector
parameters will include a structure of active infections ``H`` which is
initialized with ``10`` random infections. We use a dictionary to ensure
insertions and deletions are ``\mathcal{O}(1)``. Our parameters are then

```@example tut2
β1 = 0.001 / 1000.0
α = 0.1 / 1000.0
γ = 0.05
H = Dict(zip(1:10, zeros(Float64, 10)))
sizehint!(H, 1000)
p1 = (β1, ν, α, γ, H)
```

We define an infection reaction as a bounded `VariableRateJump`, requiring
us to again provide `rate` and `affect` functions, but also give functions
that calculate an upper-bound on the rate (`urate(u,p,t)`), an optional
lower-bound on the rate (`lrate(u,p,t)`), and a time window over which the
bounds are valid as long as any states these three rates depend on are
unchanged (`rateinterval(u,p,t)`). The lower- and upper-bounds of the rate
should be valid from the time they are computed `t` until `t + rateinterval(u, p, t)`:

```@example tut2
function rate3(u, p, t)
    p[1] * u[1] * u[2] + p[3] * u[1] * sum(exp(-p[4] * (t - _t)) for _t in values(p[5]))
end
lrate = rate1              # β*S*I
urate = rate3
rateinterval(u, p, t) = 1 / (2 * urate(u, p, t))
function affect3!(integrator)
    integrator.u[1] -= 1     # S -> S - 1
    integrator.u[2] += 1     # I -> I + 1
    integrator.p[5][integrator.u[2] + integrator.u[3] + 1] = integrator.t # S + R + 1
    nothing
end
jump3 = VariableRateJump(rate3, affect3!; lrate, urate, rateinterval)
```

Note that here we set the lower bound rate to be the normal SIR infection rate,
and set the upper bound rate equal to the new rate of infection (`rate3`). As
required for bounded `VariableRateJump`s, we have for any `s` in `[t,t + rateinterval(u,p,t)]` the bound `lrate(u,p,t) <= rate3(u,p,s) <= urate(u,p,t)`
will hold provided the dependent states `u[1]` and `u[2]` have not changed.

Next, we redefine the recovery jump's `affect!` such that a random infection is
removed from `p[5]` for every recovery.

```@example tut2
rate4(u, p, t) = p[2] * u[2]         # ν*I
function affect4!(integrator)
    integrator.u[2] -= 1
    integrator.u[3] += 1
    length(integrator.p[5]) > 0 &&
        delete!(integrator.p[5], rand(integrator.p[5]))
    nothing
end
jump4 = ConstantRateJump(rate4, affect4!)
```

With the jumps defined, we can build a
[`DiscreteProblem`](https://docs.sciml.ai/DiffEqDocs/stable/types/discrete_types/).
Bounded `VariableRateJump`s over a `DiscreteProblem` can currently only be
simulated with `Coevolve`. The aggregator requires a dependency graph to
indicate when a given jump occurs and which other jumps in the system should
have their rate recalculated (i.e., their rate depends on states modified by
one occurrence of the first jump). This ensures that rates, rate bounds, and
rate intervals are recalculated when invalidated due to changes in `u`. For the
current example, both processes mutually affect each other, so we have

```@example tut2
dep_graph = [[1, 2], [1, 2]]
```

Here `dep_graph[2] = [1,2]` indicates that when the second jump occurs, both the
first and second jumps need to have their rates recalculated. We can then
construct our `JumpProblem` as before, specifying the `Coevolve` aggregator:

```@example tut2
prob = DiscreteProblem(u₀, tspan, p1)
jump_prob = JumpProblem(prob, Coevolve(), jump3, jump4; dep_graph)
```

We now have a problem that can be solved with `SSAStepper` to handle
time-stepping the `Coevolve` aggregator from jump to jump:

```@example tut2
sol = solve(jump_prob, SSAStepper())
plot(sol, label = ["S(t)" "I(t)" "R(t)"])
```

We see that the time-dependent infection rate leads to a lower peak of the
infection throughout the population.

Note that bounded `VariableRateJump`s over `DiscreteProblem`s can be quite
general. However, when handling rates that change according to an ODE/SDE
modified variable we will need a continuous integrator. One example is
discussed [below](@ref VariableRateJumpSect) in which we have a new reaction
added to the model with rate `p[2]*u[1]*u[4]` where `u[4]` is the solution of
an ODE. In such models, you will also need to be more careful in setting
rate bounds as they must be valid for the full coupled system's
dynamics.

## [Reducing Memory Use: Controlling Saving Behavior](@id save_positions_docs)

Note that jumps act via DifferentialEquations.jl's [callback
interface](https://docs.sciml.ai/DiffEqDocs/stable/features/callback_functions/),
which defaults to saving the state vector `u` at each event. This is
required in order to accurately resolve every discontinuity exactly (and
this is what allows for perfectly vertical lines in plots!). However, in
many cases when using jump problems, you may wish to decrease the saving
pressure given by large numbers of jumps. To do this, you set the
`save_positions` keyword argument to `JumpProblem`. Just like for other
[callbacks](https://docs.sciml.ai/DiffEqDocs/stable/features/callback_functions/),
this is a tuple `(bool1, bool2)` which sets whether to save `u` before and/or
after a jump. If we do not want to save at every jump, we would thus pass:

```@example tut2
prob = DiscreteProblem(u₀, tspan, p)
jump_prob = JumpProblem(prob, Direct(), jump, jump2; save_positions = (false, false))
```

Now the saving controls associated with the integrator should be specified, see the
main [SciML
Docs](https://docs.sciml.ai/DiffEqDocs/stable/basics/common_solver_opts/)
for saving options. For example, we can use `saveat = 10.0` to save at an evenly
spaced grid:

```@example tut2
sol = solve(jump_prob, SSAStepper(); saveat = 10.0)
plot(sol, label = ["S(t)" "I(t)" "R(t)"], marker = :o)
```

Notice that our plot is now defined at precisely the specified time points, and
for time values in between those points piecewise-linear interpolation is used
in graphing the solution. Note, however, that evaluation of the solution object
still treats the solution as piecewise constant, and so `sol` should not be
explicitly evaluated at any times besides the times at which it was saved, i.e.
notice that `sol(15.0)` does not interpolate the solution vectors at times `10`
and `20` below, but is instead the same as the solution at time `10`:

```@example tut2
sol(10.0), sol(15.0), sol(20.0)
```

*It is important to keep in mind that neither plotting or evaluation of the
solution object will be exact for a pure jump process when using `saveat` except
for the times given via `saveat`. This is because the solution values at jump
times have not been stored. i.e for `t` a time for which we did not save the
state, `sol(t)` will no longer give the exact value of the solution at `t`.*

In summary, the jump callback will save the state variable `u` before and after
the jump whenever `save_positions = (true, true)`. All other saving behavior is
delegated to the integrator and controlled via keyword arguments to `solve` such
as `saveat`.

## Defining the Jumps Directly: Mixing `ConstantRateJump`/`VariableRateJump` and `MassActionJump`

Suppose we now want to add in to the original SIR model another jump that
cannot be represented as a mass action reaction. We can create a new
`ConstantRateJump` and simulate a hybrid system using both the `MassActionJump`
for the two original reactions, and the new `ConstantRateJump`. Let's suppose we
want to let susceptible people be born with the following jump rate:

```@example tut2
birth_rate(u, p, t) = 10.0 * u[1] / (200.0 + u[1]) + 10.0
function birth_affect!(integrator)
    integrator.u[1] += 1
    nothing
end
birth_jump = ConstantRateJump(birth_rate, birth_affect!)
```

We can then simulate the hybrid system as

```@example tut2
jump_prob = JumpProblem(prob, Direct(), mass_act_jump, birth_jump)
sol = solve(jump_prob, SSAStepper())
plot(sol; label = ["S(t)" "I(t)" "R(t)"])
```

Note that we can combine `MassActionJump`s, `ConstantRateJump`s and bounded
`VariableRateJump`s using the `Coevolve` aggregators.

## Adding Jumps to a Differential Equation

If we instead used some form of differential equation via an `ODEProblem`
instead of a `DiscreteProblem`, we can couple the jumps/reactions to the
differential equation. Let's define an ODE problem, where the continuous part
only acts on some new 4th component:

```@example tut2
using OrdinaryDiffEq
function f(du, u, p, t)
    du[4] = u[2] * u[3] / 1e5 - u[1] * u[4] / 1e5
    nothing
end
u₀ = [990.0, 10.0, 0.0, 100.0]
prob = ODEProblem(f, u₀, tspan, p)
```

Notice we gave the 4th component a starting value of 100.0, and used
floating-point numbers for the initial condition, since some solution components now
evolve continuously. The same steps as above will allow us to solve this hybrid
equation when using `ConstantRateJump`s, `MassActionJump`s, or
`VariableRateJump`s. For example, we can solve it using the `Tsit5()` method
via:

```@example tut2
jump_prob = JumpProblem(prob, Direct(), jump, jump2)
sol = solve(jump_prob, Tsit5())
plot(sol; label = ["S(t)" "I(t)" "R(t)" "u₄(t)"])
```

Note that in general, the ODE derivative `f(du, u, p, t)` could modify any
element in `du` which the jump rate functions depend on. In this section,
`f(du, u, p, t)` does not modify the jump rates so it is safe to couple them with any
type of jump and use any type of aggregator. However, the implementation does
not enforce this requirement, so one must be careful. Alternatively, when `f(du, u, p, t)` *does* modify variables that affect the jump rate, we have to
implement another strategy as described in the next [next Section](@ref
VariableRateJumpSect).

## [Adding a general VariableRateJump that Depends on a Continuously Evolving Variable](@id VariableRateJumpSect)

Now let's consider adding a reaction whose rate changes continuously with the
differential equation. To continue our example, let there be a new reaction
with rate depending on `u[4]` of the form ``u_4 \to u_4 + \textrm{I}``, with a
rate constant of `1e-2`:

```@example tut2
rate5(u, p, t) = 1e-2 * u[4]
function affect5!(integrator)
    integrator.u[2] += 1    # I -> I + 1
    nothing
end
jump5 = VariableRateJump(rate5, affect5!)
```

Notice, since `rate5` depends on a variable that evolves continuously, and hence
is not constant between jumps, *we must either use a general `VariableRateJump` without
upper/lower bounds or a bounded `VariableRateJump`*.

In the general case, solving the equation is exactly the same:

```@example tut2
u₀ = [990.0, 10.0, 0.0, 1.0]
prob = ODEProblem(f, u₀, tspan, p)
jump_prob = JumpProblem(prob, Direct(), jump, jump2, jump5)
sol = solve(jump_prob, Tsit5())
plot(sol; label = ["S(t)" "I(t)" "R(t)" "u₄(t)"])
```

*Note that general `VariableRateJump`s require using a continuous problem, like
an ODE/SDE/DDE/DAE problem, and using floating point initial conditions.*

Alternatively, the case of bounded `VariableRateJump` requires some maths.
First, we need to obtain the upper bounds of `rate5` at time `t` given `u`.
Note that `rate5` evolves according to `u[4]` which is a separable first order
differential equation of the form ``x' = b - a x`` with general solution:

```math
x(t) = - \frac{e^{-a t - c_1 a}}{a} + \frac{b}{a}
```

This is bounded by ``b / a`` which is too high for our purposes since it would
lead to a high rate of rejection during sampling. However, since the function
is increasing we can compute the upper bound given an interval ``\Delta t``
as following:

```math
\bar{x}(s) = x(t) \, e^{-a (t + \Delta t)} + \frac{b}{a} (1 - e^{- a (t + \Delta t)}) \text{ , } \forall s \in [t, t + \Delta t]
```

However, when ``a = 0`` the differential equation becomes ``x' = b`` whose solution is ``x(t) = b t``. In which case, we obtain a different upper bound given by:

```math
\bar{x}(s) = x(t) + b * (t + \Delta t) \text{ , } \forall s \in [t, t + \Delta t]
```

These expressions allow us to write the upper-bound and the rate interval in
Julia. In this example we use analytical boundaries for *illustration
purposes*. However, in some circumstances with complex model of many variables
it can be difficult to determine good a priori bounds on the ODE variables.
Moreover, numerical and analytical solutions are generally not guaranteed to
strictly satisfy the same bounds. In most cases the bounds should be close
enough. Thus, consider adding some slack on the bounds and approach complex
models with care.

```@example tut2
function urate2(u, p, t)
    if u[1] > 0
        1e-2 * max(u[4],
            (u[4] * exp(-1 * u[1] / 1e5) +
             (u[2] * u[3] / u[1]) * (1 - exp(-1 * u[1] / 1e5))))
    else
        1e-2 * (u[4] + 1 * u[2] * u[3] / 1e5)
    end
end
rateinterval2(u, p, t) = 1
```

We can then formulate the jump problem. The only aggregator that supports
bounded `VariableRateJump`s is `Coevolve`. We formulate and solve the
jump problem with this aggregator. `Coevolve` can be formulated as either
a discrete or continuous problem. In this case, we must formulate the problem
as continuous as it depends on a continuous variable.

```@example tut2
jump6 = VariableRateJump(rate5, affect5!; urate = urate2, rateinterval = rateinterval2)
dep_graph2 = [[1, 2, 3], [1, 2, 3], [1, 2, 3]]
jump_prob = JumpProblem(prob, Coevolve(), jump, jump2, jump6; dep_graph = dep_graph2)
sol = solve(jump_prob, Tsit5())
plot(sol; label = ["S(t)" "I(t)" "R(t)" "u₄(t)"])
```

We obtain the same solution as with `Direct`, but `Coevolve` runs faster
because it doesn't need to compute the derivative of `rate5`. Each aggregator
faces a different trade-off, so the the choice of best aggregator will depend
on the problem at hand. `Coevolve` requires a good understanding of the
equations involved, passing a wrong boundary can result in silent bugs.

Lastly, we are not restricted to ODEs. For example, we can solve the same jump
problem except with multiplicative noise on `u[4]` by using an `SDEProblem`
instead:

```@example tut2
using StochasticDiffEq
function g(du, u, p, t)
    du[4] = 0.1u[4]
end
prob = SDEProblem(f, g, [999.0, 1.0, 0.0, 1.0], (0.0, 250.0), p)
jump_prob = JumpProblem(prob, Direct(), jump, jump2, jump5)
sol = solve(jump_prob, SRIW1())
plot(sol; label = ["S(t)" "I(t)" "R(t)" "u₄(t)"])
```

For more details about general `VariableRateJump`s see [Defining a Variable Rate
Jump](@ref).

## RegularJumps and τ-Leaping

The previous parts described how to use `ConstantRateJump`s, `MassActionJump`s,
and `VariableRateJump`s. However, in many cases one does not require the
exactness of stepping to every jump time. Instead, regular jumping (i.e.,
τ-leaping) allows pooling jumps together, and performing larger updates in a
statistically-correct but more efficient manner. The trade-off is the
introduction of a time-discretization error due to the time-stepping, but one
that is controlled and convergent as the time-step is reduced to zero.

Let's see how to define the SIR model in terms of a `RegularJump`. We need two
functions, `rate` and `change!`. `rate` is a vector equation which computes the
rates of each jump process

```@example tut2
function rate(out, u, p, t)
    out[1] = p[1] * u[1] * u[2]   # β * S * I
    out[2] = p[2] * u[2]          # ν * I
    nothing
end
```

We then define a function that given a vector storing the number of times each
jump occurs during a time-step, `counts`, calculates the change in the state,
`du`. For the SIR example, we do this by multiplying `counts` by a matrix that
encodes the change in the state due to one occurrence of each reaction (i.e., the
net stoichiometry matrix). Below `c[i,j]` gives the change in `u[i]` due to the
`j`th jump:

```@example tut2
c = zeros(3, 2)
# S + I --> I
c[1, 1] = -1    # S -> S - 1
c[2, 1] = 1     # I -> I + 1

# I --> R
c[2, 2] = -1    # I -> I - 1
c[3, 2] = 1     # R -> R + 1

function change(du, u, p, t, counts, mark)
    mul!(du, c, counts)
    nothing
end
```

We are now ready to create our `RegularJump`, passing in the rate function,
change function, and the number of jumps being encoded

```@example tut2
rj = RegularJump(rate, change, 2)
```

From there we build a `JumpProblem`

```@example tut2
u₀ = [1000.0, 50.0, 0.0]
prob = DiscreteProblem(u₀, tspan, p)
jump_prob = JumpProblem(prob, PureLeaping(), rj)
```
We pass the `PureLeaping` aggregator to indicate we will use a τ-leaping algorithm to simulate the process.
Note that when a `JumpProblem` has a `RegularJump`, τ-leaping algorithms are
required for simulating it. This is detailed on the [jump solvers page](@ref
jump_solve). One such algorithm is `SimpleTauLeaping`, which
we use as follows:

```@example tut2
sol = solve(jump_prob, SimpleTauLeaping(); dt = 0.001)
plot(sol; label = ["S(t)" "I(t)" "R(t)"])
```

# [Jump Problem and Jump Diffusion Solvers](@id jump_solve)

```julia
solve(prob::JumpProblem, alg; kwargs)
```

## Recommended Methods

`JumpProblem`s can be solved with two classes of methods, exact and inexact.
Exact algorithms currently sample realizations of the jump processes in
chronological order, executing individual jumps sequentially at randomly sampled
times. In contrast, inexact (τ-leaping) methods are time-step based, executing
multiple occurrences of jumps during each time-step. These methods can be much
faster as they only simulate the total number of jumps over each leap interval,
and thus do not need to simulate the realization of every single jump. Jumps for
use with exact simulation methods can be defined as `ConstantRateJump`s,
`MassActionJump`s, and/or `VariableRateJump`. Jumps for use with inexact
τ-leaping methods should be defined as `RegularJump`s.

There are special algorithms available for efficiently simulating an exact, pure
`JumpProblem` (i.e., a `JumpProblem` over a `DiscreteProblem`).  `SSAStepper()`
is an efficient streamlined integrator for time stepping such problems from
individual jump to jump. This integrator is named after Stochastic Simulation
Algorithms (SSAs), commonly used naming in chemistry and biology applications
for the class of exact jump process simulation algorithms. In turn, we denote by
"aggregators" the algorithms that `SSAStepper` calls to calculate the next jump
time and to execute a jump (i.e., change the system state appropriately). All
JumpProcesses aggregators can be used with `ConstantRateJump`s and
`MassActionJump`s, with a subset of aggregators also working with bounded
`VariableRateJump`s (see [the first tutorial](@ref poisson_proc_tutorial) for
the definition of bounded `VariableRateJump`s). Although `SSAStepper()` is
usually faster, it only supports discrete events (`DiscreteCallback`s), for pure
jump problems requiring continuous events (`ContinuousCallback`s) the less
performant `FunctionMap` time-stepper can be used.

If there is a `RegularJump`, then inexact τ-leaping methods must be used. The
current recommended method is `TauLeaping` if one needs adaptivity, events, etc.
If one only needs the most barebones fixed time-step leaping method, then
`SimpleTauLeaping` can have performance benefits.

## Special Methods for Pure Jump Problems

If you are using jumps with a differential equation, use the same methods
as in the case of the differential equation solving. However, the following
algorithms are optimized for pure jump problems.

### JumpProcesses.jl

  - `SSAStepper`: a stepping integrator for `JumpProblem`s defined over
    `DiscreteProblem`s involving `ConstantRateJump`s, `MassActionJump`s, and/or
    bounded `VariableRateJump`s . Supports handling of `DiscreteCallback`s and
    saving controls like `saveat`. Note that DifferentialEquations.jl treats
    jumps as similar to callbacks, and hence `SSAStepper` only implements a
    subset of ODE/SDE solver saving controls. In particular, `save_everystep` is
    not supported as saving jumps each step is controlled via the
    `save_positions` argument to [`JumpProblem`](@ref)s. Note, in contrast to
    when [`JumpProblem`](@ref)s are coupled with ODE and SDE timesteppers, with
    [`SSAStepper`](@ref), setting `save_positions = (false, true)`,
    `save_positions = (true, false)` or `save_positions = (true, true)` are
    equivalent and save only after the jump has occurred (as opposed to saving
    the state both before and after a jump). This is because the underlying
    [`SSAStepper`](@ref) generated-solution uses piecewise constant
    interpolation, and can therefore exactly evaluate the sampled solution
    path at any time when only saving the post-jump state for each jump.

## RegularJump Compatible Methods

### StochasticDiffEq.jl

These methods support mixing with event handling, other jump types, and all of
the features of the normal differential equation solvers.

  - `TauLeaping`: an adaptive tau-leaping algorithm with post-leap estimates.

### JumpProcesses.jl

  - `SimpleTauLeaping`: a tau-leaping algorithm for pure `RegularJump` `JumpProblem`s.
    Requires a choice of `dt`.
  - `RegularSSA`: a version of SSA for pure `RegularJump` `JumpProblem`s.

## Regular Jump Diffusion Compatible Methods

Regular jump diffusions are `JumpProblem`s where the internal problem is an `SDEProblem`
and the jump process has designed a regular jump.

### StochasticDiffEq.jl

  - `EM`: Explicit Euler-Maruyama.
  - `ImplicitEM`: Implicit Euler-Maruyama. See the SDE solvers page for more details.

# Spatial SSAs with JumpProcesses.jl

This tutorial shows how to use spatial solvers.

## Reversible binding model on a grid

A 5 by 5 Cartesian grid:

| <!-- --> | <!-- --> | <!-- --> | <!-- --> | <!-- --> |
|:-------- |:-------- |:-------- |:-------- |:-------- |
| .        | .        | .        | .        | B        |
| .        | .        | .        | .        | .        |
| .        | .        | .        | .        | .        |
| .        | .        | .        | .        | .        |
| A        | .        | .        | .        | .        |

Suppose we have a reversible binding system described by
$$A+B \to C$$ at rate $$k_1$$ and $$C \to A+B$$ at rate $$k_2$$.
Further, suppose that all $$A$$ molecules start in the lower-left corner,
while all $$B$$ molecules start in the upper-right corner of a 5 by 5 grid.
There are no $$C$$ molecules at the start.

We first create the grid:

```@example spatial
using JumpProcesses
dims = (5, 5)
num_nodes = prod(dims) # number of sites
grid = CartesianGrid(dims) # or use Graphs.grid(dims)
```

Now we set the initial state of the simulation. It has to be a matrix with entry $$(s,i)$$ being the number of species $$s$$ at site $$i$$ (with the standard column-major ordering of the grid).

```@example spatial
num_species = 3
starting_state = zeros(Int, num_species, num_nodes)
starting_state[1, 1] = 25
starting_state[2, end] = 25
starting_state
```

We now set the time-span of the simulation and the reaction rates. These can be chosen arbitrarily.

```@example spatial
tspan = (0.0, 3.0)
rates = [6.0, 0.05] # k_1 = rates[1], k_2 = rates[2]
```

Now we can create the `DiscreteProblem`:

```@example spatial
prob = DiscreteProblem(starting_state, tspan, rates)
```

Since both reactions are [mass action reactions](https://en.wikipedia.org/wiki/Law_of_mass_action), we put them together in a `MassActionJump`. In order to do that, we create two stoichiometry vectors. The net stoichiometry vector describes which molecules change in number and how much after each reaction; for example, `[1 => -1]` is the first molecule disappearing. The reaction stoichiometry vector describes what the reactants of each reaction are; for example, `[1 => 1, 2 => 1]` would mean that the reactants are one molecule of type 1, and one molecule of type 2.

```@example spatial
netstoch = [[1 => -1, 2 => -1, 3 => 1], [1 => 1, 2 => 1, 3 => -1]]
reactstoch = [[1 => 1, 2 => 1], [3 => 1]]
majumps = MassActionJump(rates, reactstoch, netstoch)
```

The last thing to set up is the hopping constants -- the probability per time of an individual molecule of each species hopping from one site to another site. In practice, this parameter, as well as reaction rates, are obtained empirically. Suppose that molecule $$C$$ cannot diffuse, while molecules $$A$$ and $$B$$ diffuse at probability per time 1 (i.e., the time of the diffusive hop is exponentially distributed with mean 1). Entry $$(s,i)$$ of `hopping_constants` is the hopping rate of species $$s$$ at site $$i$$ to any of its neighboring sites (diagonal hops are not allowed).

```@example spatial
hopping_constants = ones(num_species, num_nodes)
hopping_constants[3, :] .= 0.0
hopping_constants
```

We are now ready to set up the `JumpProblem` with the Next Subvolume Method.

```@example spatial
alg = NSM()
jump_prob = JumpProblem(prob, alg, majumps, hopping_constants = hopping_constants,
    spatial_system = grid, save_positions = (true, false))
```

The `save_positions` keyword tells the solver to save the positions just before the jumps. To solve the jump problem do

```@example spatial
solution = solve(jump_prob, SSAStepper())
```

## Animation

Visualizing solutions of spatial jump problems is best done with animations.

```@example spatial
using Plots
is_static(spec) = (spec == 3) # true if spec does not hop
"""
get frame k
"""
function get_frame(k, sol, linear_size, labels, title)
    num_species = length(labels)
    h = 1 / linear_size
    t = sol.t[k]
    state = sol.u[k]
    xlim = (0, 1 + 3h / 2)
    ylim = (0, 1 + 3h / 2)
    plt = plot(xlim = xlim, ylim = ylim, title = "$title, $(round(t, sigdigits=3)) seconds")

    species_seriess_x = [[] for i in 1:num_species]
    species_seriess_y = [[] for i in 1:num_species]
    CI = CartesianIndices((linear_size, linear_size))
    for ci in CartesianIndices(state)
        species, site = Tuple(ci)
        x, y = Tuple(CI[site])
        num_molecules = state[ci]
        sizehint!(species_seriess_x[species], num_molecules)
        sizehint!(species_seriess_y[species], num_molecules)
        if !is_static(species)
            randsx = rand(num_molecules)
            randsy = rand(num_molecules)
        else
            randsx = zeros(num_molecules)
            randsy = zeros(num_molecules)
        end
        for k in 1:num_molecules
            push!(species_seriess_x[species], x * h - h / 4 + 0.5h * randsx[k])
            push!(species_seriess_y[species], y * h - h / 4 + 0.5h * randsy[k])
        end
    end
    for species in 1:num_species
        scatter!(plt, species_seriess_x[species], species_seriess_y[species],
            label = labels[species], marker = 6)
    end
    xticks!(plt, range(xlim..., length = linear_size + 1))
    yticks!(plt, range(ylim..., length = linear_size + 1))
    xgrid!(plt, 1, 0.7)
    ygrid!(plt, 1, 0.7)
    return plt
end

"""
make an animation of solution sol in 2 dimensions
"""
function animate_2d(sol, linear_size; species_labels, title, verbose = true)
    num_frames = length(sol.t)
    anim = @animate for k in 1:num_frames
        verbose && println("Making frame $k")
        get_frame(k, sol, linear_size, species_labels, title)
    end
    anim
end
# animate
anim = animate_2d(solution, 5, species_labels = ["A", "B", "C"], title = "A + B <--> C",
    verbose = false)
fps = 5
gif(anim, fps = fps)
```

## Making changes to the model

Now suppose we want to make some changes to the reversible binding model above. There are three "dimensions" that can be changed: the topology of the system, the structure of hopping rates and the solver. The supported topologies are `CartesianGrid` -- used above, and any `AbstractGraph` from `Graphs`. The supported forms of hopping rates are $$D_{s,i}, D_{s,i,j}, D_s * L_{i,j}$$, and $$D_{s,i} * L_{i,j}$$, where $$s$$ denotes the species, $$i$$ -- the source site, and $$j$$ -- the destination. The supported solvers are `NSM`, `DirectCRDirect` and any of the standard non-spatial solvers.

### Topology

If our mesh is a grid (1D, 2D and 3D are supported), we can create the mesh as follows.

```@example spatial
dims = (2, 3, 4) # can pass in a 1-Tuple, a 2-Tuple or a 3-Tuple
num_nodes = prod(dims)
grid = CartesianGrid(dims)
```

The interface is the same as for [`Graphs.grid`](https://juliagraphs.org/Graphs.jl/dev/core_functions/simplegraphs_generators/#Graphs.SimpleGraphs.grid-Union%7BTuple%7BAbstractVector%7BT%7D%7D,%20Tuple%7BT%7D%7D%20where%20T%3C:Integer). If we want to use an unstructured mesh, we can simply use any `AbstractGraph` from `Graphs` as follows:

```@example spatial
using Graphs
graph = cycle_digraph(5) # directed cyclic graph on 5 nodes
```

Now, either `graph` or `grid` can be used as `spatial_system` in creation of the `JumpProblem`.

### Hopping rates

The most general form of hopping rates that is supported is $$D_{s,i,j}$$ -- each (species, source, destination) triple gets its own independent hopping rate. To use this, `hopping_constants` must be of type `Matrix{Vector{F}} where F <: Number` (usually `F` is `Float64`) with `hopping_constants[s,i][j]` being the hopping rate of species $$s$$ at site $$i$$ to neighbor at index $$j$$. Note that neighbors are in ascending order, like in `Graphs`. Here is an example where only hopping up and left is allowed.

```@example spatial
hopping_constants = Matrix{Vector{Float64}}(undef, num_species, num_nodes)
for ci in CartesianIndices(hopping_constants)
    (species, site) = Tuple(ci)
    hopping_constants[species, site] = zeros(outdegree(grid, site))
    for (n, nb) in enumerate(neighbors(grid, site))
        if nb < site
            hopping_constants[species, site][n] = 1.0
        end
    end
end
```

To pass in `hopping_constants` of form $$D_s * L_{i,j}$$ we need two vectors -- one for $$D_s$$ and one for $$L_{i,j}$$. Here is an example.

```@example spatial
species_hop_constants = ones(num_species)
site_hop_constants = Vector{Vector{Float64}}(undef, num_nodes)
for site in 1:num_nodes
    site_hop_constants[site] = ones(outdegree(grid, site))
end
hopping_constants = Pair(species_hop_constants, site_hop_constants)
```

We must combine both vectors into a pair, as in the last line above.

Finally, to use in `hopping_constants` of form $$D_{s,i} * L_{i,j}$$ we construct a matrix instead of a vector for $$D_{s,j}$$.

```@example spatial
species_hop_constants = ones(num_species, num_nodes)
site_hop_constants = Vector{Vector{Float64}}(undef, num_nodes)
for site in 1:num_nodes
    site_hop_constants[site] = ones(outdegree(grid, site))
end
hopping_constants = Pair(species_hop_constants, site_hop_constants)
```

We can use either of the four versions of `hopping_constants` to construct a `JumpProblem` with the same syntax as in the original example. The different forms of hopping rates are supported not only for convenience, but also for better memory usage and performance. So it is recommended that the most specialized form of hopping rates is used.

### Solvers

There are currently two specialized "spatial" solvers: `NSM` and `DirectCRDirect`. The former stands for Next Subvolume Method [^1]. The latter employs Composition-Rejection to sample the next site to fire, similar to the ordinary DirectCR method. For larger networks `DirectCRDirect` is expected to be faster. Both methods can be used interchangeably.

Additionally, all standard solvers are supported as well, although they are expected to use more memory and be slower. They "flatten" the problem, i.e., turn all hops into reactions, resulting in a much larger system. For example, to use the Next Reaction Method (`NRM`), simply pass in `NRM()` instead of `NSM()` in the construction of the `JumpProblem`. Importantly, you *must* pass in `hopping_constants` in the `D_{s,i,j}` or `D_{s,i}` form to use any of the non-specialized solvers.

## References

[^1]: Elf, Johan and Ehrenberg, Mäns. “Spontaneous separation of bi-stable biochemical systems into spatial domains of opposite phases”. In: _Systems biology_ 1.2 (2004), pp. 230–236.

# [Piecewise Deterministic Markov Processes and Jump Diffusion Equations](@id jump_diffusion_tutorial)

!!! note
    
    This tutorial assumes you have read the [Ordinary Differential Equations tutorial](https://docs.sciml.ai/DiffEqDocs/stable/getting_started/) in [`DifferentialEquations.jl`](https://docs.sciml.ai/DiffEqDocs/stable).

Jump Diffusion equations are stochastic differential equations (SDEs) with discontinuous
jumps. These can be written as:

```math
du = f(u,p,t)dt + \sum_{j}g_j(u,p,t)dW_j(t) + \sum_{i}h_i(u,p,t)dN_i(t)
```

The change in state vector ``u`` depends on three concurrent dynamics, (1)
deterministic drift ``dt`` with size ``f(u, p, t)``, (2) stochastic diffusions
``dW_j(t)`` with sizes ``g_j(u, p, t)``, and, (3) stochastic jumps
``dN_i(t)`` with sizes ``h_i(u, p, t)``. By diffusion we mean a continuous
stochastic process which is usually represented as Gaussian white noise (i.e. ``W_j(t)`` is a Brownian Motion).
By jump we mean a discrete stochastic process which is usually represented
by a Poisson process.

In this tutorial, we will show how to solve problems with jumps more
general than the homogeneous Poisson process. In the special case that
``g_j = 0`` for all ``j``, we'll call the resulting jump-ODE a [piecewise
deterministic Markov
process](https://en.wikipedia.org/wiki/Piecewise-deterministic_Markov_process).

Before running this tutorial, please install the following packages if they are
not already installed

```julia
using Pkg
Pkg.add("JumpProcesses")
Pkg.add("OrdinaryDiffEq")
Pkg.add("StochasticDiffEq")
Pkg.add("Plots")
```

We then load these packages, and set some plotting defaults, as

```@example tut3
using JumpProcesses, StochasticDiffEq, OrdinaryDiffEq, Plots
default(; lw = 2)
```

## Defining a `ConstantRateJump` Problem

To start, let's solve an ODE that is coupled to a [`ConstantRateJump`](@ref). A
jump is defined as being "constant rate" if the rate is only dependent on values
from other `ConstantRateJump`s or [`MassActionJump`](@ref)s (a special type of
`ConstantRateJump`). This means that its rate must not be coupled with time, the
solution to the differential equation, or a solution component that is changed
by a [`VariableRateJump`](@ref). `ConstantRateJumps` are cheaper to compute than
`VariableRateJump`s, and so should be preferred when mathematically appropriate.

(Note: if your rate is only "slightly" dependent on the solution of the differential
equation, then it may be okay to use a `ConstantRateJump`. Accuracy loss will be
related to the percentage that the rate changes over the jump intervals.)

Let's solve the following problem. We will have a linear ODE with a Poisson counter
of rate 2 (which is the mean and variance), where at each jump the current solution
will be halved. To solve this problem, we first define the `ODEProblem`:

```@example tut3
function f(du, u, p, t)
    du[1] = u[1]
    nothing
end

prob = ODEProblem(f, [0.2], (0.0, 10.0))
```

Notice that, even though our equation is scalar, we define it using the in-place
array form. Variable rate jump equations will require this form. Note that for
this tutorial, we solve a one-dimensional problem, but the same syntax applies
for solving a system of differential equations with multiple jumps.

Now we define our `rate` equation for our jump. Since it's just the constant
value 2, we do:

```@example tut3
rate(u, p, t) = 2
```

Now we define the `affect!` of the jump. This is the same as an `affect!` from a
[`DiscreteCallback`](https://docs.sciml.ai/DiffEqDocs/stable/features/callback_functions/),
and thus acts directly on the
[integrator](https://docs.sciml.ai/DiffEqDocs/stable/basics/integrator/).
Therefore, to make it halve the current value of `u`, we do:

```@example tut3
function affect!(integrator)
    integrator.u[1] = integrator.u[1] / 2
    nothing
end
```

Then we build our jump:

```@example tut3
const_jump = ConstantRateJump(rate, affect!)
```

Next, we extend our `ODEProblem` to a [`JumpProblem`](@ref) by attaching the
jump:

```@example tut3
jump_prob = JumpProblem(prob, Direct(), const_jump)
```

We can now solve this extended problem using any ODE solver:

```@example tut3
sol = solve(jump_prob, Tsit5())
plot(sol)
```

Note that every time a jump occurs the function peaks and then decreases
by half following our specification.

## Variable Rate Jumps

Now let's define a jump with a rate that is dependent on the differential
equation via the solution vector. Let's set the rate to be the current value of
the solution, that is:

```@example tut3
rate(u, p, t) = u[1]
```

Using the same `affect!` we build a [`VariableRateJump`](@ref):

```@example tut3
var_jump = VariableRateJump(rate, affect!)
```

We now couple the jump to the `ODEProblem`:

```@example tut3
jump_prob = JumpProblem(prob, Direct(), var_jump)
```

which we once again solve using an ODE solver:

```@example tut3
sol = solve(jump_prob, Tsit5())
plot(sol)
```

Again, when a jump occurs the function peaks and then decreases by half.
In contrast to our previous example, as the function value decreases the
rate of jumps also decreases.

In this way we have solved a mixed jump-ODE, i.e., a piecewise deterministic
Markov process.

## Multiple jumps

In this section we allow for multiple jumps in the SDE. Let's assume that the dynamics of our SDE is affected by the two jumps we defined in the previous sections. It is easy to re-use all the elements we defined above and initialize a `JumpProblem` with multiple jumps.

```@example tut3
jump_prob = JumpProblem(prob, Direct(), const_jump, var_jump)
```

which we solve in the same manner using an ODE solver:

```@example tut3
sol = solve(jump_prob, Tsit5())
plot(sol)
```

The constant jump ensures that the function jumps at more or less regular intervals, while the variable jump increases the frequency of jumps when the function reaches higher levels.

## Jump Diffusion

Now we will finally solve the jump diffusion problem. The steps are the same
as before, except we now start with a `SDEProblem` instead of an `ODEProblem`.
Using the same drift function `f` as before, we add multiplicative noise via:

```@example tut3
function g(du, u, p, t)
    du[1] = u[1]
    nothing
end

prob = SDEProblem(f, g, [0.2], (0.0, 10.0))
```

and couple it to the jumps:

```@example tut3
jump_prob = JumpProblem(prob, Direct(), const_jump, var_jump)
```

We then solve it using an SDE algorithm:

```@example tut3
sol = solve(jump_prob, SRIW1())
plot(sol)
```

The function now behaves different than before due to the diffusion
component which drifts randomly around zero. Again, note that jumps are
more frequent when the function obtains a higher value and the function
sharply decreases by half anytime a jump takes place.

## Coupling Jump Problems

THIS NEEDS UPDATING

In many applications one is interested in coupling two stochastic processes.
This has applications in Monte Carlo simulations and sensitivity analysis, for
example. Currently, the coupling that is implemented for jump processes is known
as the split coupling. The split coupling couples two jump processes by coupling
the underlying Poisson processes driving the jump components.

Suppose `prob` and `prob_control` are two problems we wish to couple. Then the
coupled problem is obtained by

```@example tut3
prob_coupled = SplitCoupledJumpProblem(jump_prob, jump_prob_control, Direct(), coupling_map)
```

Here, `coupling_map` specifies which jumps to couple. If `(j,i)` is in
`coupling_map`, then the `i`th jump in `prob` will be coupled to the `j`th jump
in `prob_control`. Note that currently `SplitCoupledJumpProblem` is only
implemented for `ConstantRateJump` problems.

As an example, consider a doubly stochastic Poisson process, that is, a Poisson
process whose rate is itself a stochastic process. In particular, we will take
the rate to randomly switch between zero and `10` at unit rates:

```@example tut3
rate(u, p, t) = 10 * u[2]
affect!(integrator) = integrator.u[1] += 1
jump1 = ConstantRateJump(rate, affect!)

rate(u, p, t) = u[2]
affect!(integrator) = (integrator.u[2] -= 1; integrator.u[3] += 1)
jump2 = ConstantRateJump(rate, affect!)

rate(u, p, t) = u[3]
affect!(integrator) = (integrator.u[2] += 1; integrator.u[3] -= 1)
jump3 = ConstantRateJump(rate, affect!)

prob = DiscreteProblem(u0, tspan)
jump_prob = JumpProblem(prob, Direct(), jump1, jump2, jump3)
```

The doubly stochastic Poisson process has two sources of randomness: one due to
the Poisson process, and another due to random evolution of the rate. This is
typical of many multiscale stochastic processes appearing in applications, and
it is often useful to compare such a process to one obtained by removing one
source of randomness. In present context, this means looking at an ODE with
constant jump rates, where the deterministic evolution between jumps is given by
the expected value of the Poisson process:

```@example tut3
function f(du, u, p, t)
    du[1] = 10 * u[2]
    du[2] = 0
    du[3] = 0
end
prob_control = ODEProblem(f, [0.0, 0.0, 1.0], tspan)
jump_prob_control = JumpProblem(prob_control, Direct(), jump2, jump3)
```

Let's couple the two problems by coupling the jumps corresponding to the
switching of the rate:

```@example tut3
coupling_map = [(2, 1), (3, 2)]
prob_coupled = SplitCoupledJumpProblem(jump_prob, jump_prob_control, Direct(), coupling_map)
```

Now `prob_coupled` can be solved like any other `JumpProblem`:

```@example tut3
sol = solve(prob_coupled, Tsit5())
```

# [Temporal Point Process (TPP) Simulation](@id tpp_tutorial)

JumpProcesses was initially developed to simulate the trajectory of jump
processes. Therefore, those with a background in point process might find
the nomenclature in the library documentation confusing. In reality, jump
and point processes share many things in common, but diverge in scope.
This tutorial will demonstrate how to simulate point processes using
JumpProcesses.

Historically, jump processes have been developed in the context of dynamical
systems to describe dynamics with sudden changes — the jumps — in a system's
value at random times. In contrast, the development of point processes has been
more focused on describing the occurrence of random events — the points — over
a support. The fact that any temporal point process (TPP) that satisfies some
basic assumptions can be described in terms of a stochastic differential
equation (SDE) with discontinuous jumps — more commonly known as a jump process
— means TPPs can be simulated with JumpProcesses.

Once you complete this tutorial, you might want to check our [advanced
tutorial on TPP](@ref tpp_advanced) that discusses more applications of
JumpProcesses to TPP.

## TPP Introduction

TPPs describe a set of discrete points over continuous time.
Conventionally, we assume that time starts at ``0``. We can represent
a TPP as a random integer measure ``N( \cdot )``. This random function
counts the number of points in a set of intervals over the real line. For
instance, ``N([5, 10])`` denotes the number of points (or events) in
between time ``5`` and ``10`` inclusive. The number of points in this
interval is a random variable.

For convenience, we denote ``N(t) \equiv N[0, t)`` as the number of points
since the start of time until ``t``, exclusive of ``t``. For simulation
purposes, ``N(t)`` will be the state of our system. In subsequent
sections, we will denote the state of the system as ``u(t) \equiv N(t)``
following SciML convention.

Any TPP can be characterized by its conditional intensity ``\lambda(t)``
which can be interpreted as the expected number of points per unit of
time. We assume ``N(t)`` changes according to the following dynamics on
any given infinitesimal unit of time.

```math
dN(t) = \begin{cases}
  1 \text{ , if } N[t, t + \epsilon] = 1 \\
  0 \text{ , if } N[t, t + \epsilon] = 0.
\end{cases}
```

It is possible to show that ``E(dN(t)) = \lambda(t) d(t)`` which
says that the expected number of points changes according to
``\lambda(t)`` over time. For this reason, ``\lambda(t)`` can also be
known as the rate of the TPP.

## Homogeneous Poisson Process

In this section, we specify a homogeneous Poisson process with unit rate,
which is the simplest TPP process with ``\lambda(t) = 1``. Let's start by
loading our packages.

```@example tpp-tutorial
using JumpProcesses, Plots
```

In JumpProcesses, a `ConstantRateJump` is a TPP whose rate is constant
between points. To specify the homogeneous Poisson process, we need to
declare the rate function which takes three inputs, the current state of
the system, `u`, the parameters, `p`, and the time, `t`. In this case, the
rate function is constant.

```@example tpp-tutorial
poisson_rate(u, p, t) = 1
```

We also need a function that updates the total count.

```@example tpp-tutorial
poisson_affect!(integrator) = (integrator.u[1] += 1)
```

Here, the convention is to take a [DifferentialEquations.jl
integrator](https://docs.sciml.ai/DiffEqDocs/stable/basics/integrator/),
and directly modify the current solution value it stores. i.e.,
`integrator.u` is the current solution vector, with `integrator.u[1]` the
first component of this vector.

Now, we can declare the Poisson process.

```@example tpp-tutorial
poisson_process = ConstantRateJump(poisson_rate, poisson_affect!)
```

Once we have declared the process we want to simulate, we need to specify
our simulation requirements. First, we determine the initial count and the
desired time span.

```@example tpp-tutorial
u0 = [0]
tspan = (0.0, 10.0)
```

We initialize a base problem containing our simulation specification.
Since we will not combine any other concurrent process with the Poisson
process, we create a `DiscreteProblem` which is the most basic problem for
simulating processes that evolve in discrete time steps as is the case
with our TPP.

```@example tpp-tutorial
dprob = DiscreteProblem(u0, tspan)
```

Apart from our base problem, we need to create a [`JumpProblem`](@ref) in which
we specify the simulation algorithm, i.e. the aggregator in JumpProcesses'
language, we intend to use for simulating the Poisson process. This aggregator
is responsible for sampling the times at which the process changes based on the
provided `poisson_rate` function, and for calling the user `poisson_affect!`
function to update the system state at these times. Here we use the `Direct`
method which is a type of thinning algorithm for simulating TPPs with a constant
rate between points.

```@example tpp-tutorial
jprob = JumpProblem(dprob, Direct(), poisson_process)
```

Finally, we can simulate one realization of our TPP. The solver requires that we
specify a time-stepper, which is a method that handles time-evolution in our
system. While the `Direct` algorithm above draws the next point in our process,
the stepper advances the system in time to that point. We use `SSAStepper` which
is a discrete stepper that only stops at the times proposed by our simulation
algorithm.

```@example tpp-tutorial
sol = solve(jprob, SSAStepper())
plot(sol)
```

By breaking the problem formulation and solver selection into specifying a
`DiscreteProblem`, a simulation algorithm (i.e. aggregator) via `JumpProblem`,
and generating a realization via `solve`, JumpProcesses' has the flexibility to
specify and simulate a broad variety of problem types. The base problem allow us
to combine TPPs with other types of dynamics such as ODEs or SDEs, by replacing
`DiscreteProblem` with `ODEProblem` or `SDEProblem` from
[DifferentialEquations.jl](https://docs.sciml.ai/DiffEqDocs/stable/). For
instance, we can declare a conditional intensity function that follows an ODE
using `ODEProblem`. The `JumpProblem` allows us to combine multiple TPPs
together as we will see in the next section. The simulation algorithm (i.e.
aggregator) allows us to simulate different types of TPPs including processes
with variable rates, using different algorithms that may offer improved
performance over `Direct` depending on the number of TPPs and their properties.
The time-stepper allow us to specify the time-evolution that allows the most
exotic dynamics to evolve in sync with base time.

## Multivariate TPPs

JumpProcesses allow us to simulate a multivariate TPP which is a TPP formed
by multiple TPPs whose rates can influence one another. In this section we
will illustrate a simple case with two TPPs. We assume that the first
process ``N_1`` is the homogeneous Poisson process from the previous
section. The second process ``N_2`` is a TPP whose intensity rate obeys
the following dynamics:

```math
\lambda_2(t) = \begin{cases}
  1 + \sin(t), & \text{if } N_1(t) \text{ is even} \\
  1 + \cos(t), & \text{if } N_1(t) \text{ is odd}.
\end{cases}
```

In this case, the intensity rate of the second process is variable. It not
only changes according to time but also according to the first process.

In JumpProcesses a `VariableRateJump` is a TPP whose rate is allowed to vary at
arbitrary times. Again, we start by declaring the rate function and the affect.

```@example tpp-tutorial
seasonal_rate(u, p, t) = 1 + (u[1] % 2 == 0 ? sin(t) : cos(t))
seasonal_affect!(integrator) = (integrator.u[2] += 1)
```

There are algorithms for simulating TPPs which can take
advantage of bounded variable rates. In our example, ``\lambda_2`` is
bounded above by ``2`` and below by ``1``. To initialize, a bounded
`VariableRateJump` we must supply the rate upper-bound and the
interval for which the upper-bound is valid. In this case, the bound is
valid throughout time. The lower-bound is optional but can improve the
speed of the simulation.

```@example tpp-tutorial
urate(u, p, t) = 2           # upper bound
rateinterval(u, p, t) = Inf  # time window bound is valid over
lrate(u, p, t) = 1           # lower bound
```

Now, we can declare the seasonal process as a `VariableRateJump`.

```@example tpp-tutorial
seasonal_process = VariableRateJump(seasonal_rate, seasonal_affect!;
    urate, rateinterval, lrate)
```

We initialize a new base problem with a different simulation
specification. Since we have a multivariate process, the state of the
system is a vector with two counts.

```@example tpp-tutorial
u0 = [0, 0]
tspan = (0.0, 10.0)
dprob = DiscreteProblem(u0, tspan)
```

We also need to modify [`JumpProblem`](@ref) to use a simulation algorithm (i.e.
aggregator) that supports bounded `VariableRateJump`s. In this case, we use the
`Coevolve` method, which is another type of thinning algorithm for multivariate
process and which is an improvement of the Ogata thinning method. This method
also requires a dependency graph that indicates for a given TPP which other TPPs
have rates that depend on states/variables altered in its affect function. Note
JumpProcesses' convention is that a given TPP should also always be a dependency
of itself. Internally, JumpProcesses preserves the relative ordering of point
processes of each distinct type, but always reorders all `ConstantRateJump`s to
appear before any `VariableRateJump`s. Irrespective of how `JumpProblem` is
initialized, internally the processes will be ordered as the vector
`[poisson_process, seasonal_process]` so that these will have the internal
indexes of `1` and `2` respectively. Note, this vector of the processes is
distinct from our state variable vector, `u`. When `poisson_process` fires
`u[1]` is altered, and as the rate for `seasonal_process` depends on it we have
that the dependencies of `poisson_process` are `[1,2]`. In contrast, the rate of
`poisson_process` is independent of `u[2]` which `seasonal_process` modifies,
and hence the dependencies of `seasonal_process` are only `[2]`.

Therefore, we obtain the following dependency graph:

```@example tpp-tutorial
dep_graph = [[1, 2], [2]]
```

We can then construct the corresponding problem `JumpProblem`, passing our
selected simulation algorithm, our processes and
the dependency graph.

```@example tpp-tutorial
jprob = JumpProblem(dprob, Coevolve(), poisson_process, seasonal_process; dep_graph)
sol = solve(jprob, SSAStepper())
plot(sol, labels = ["N_1(t)" "N_2(t)"], xlabel = "t", legend = :topleft)
```

## More TPPs

This tutorial demonstrated how to simulate simple TPPs. In addition to that,
JumpProcesses and the SciML ecosystem can be a powerful tool in describing more
general TPPs. We demonstrate this capability in the [advanced TPP tutorial](@ref
tpp_advanced), which shows how to interface JumpProcesses with
[PointProcesses.jl](https://github.com/JoseKling/PointProcesses.jl) and covers via
this interface many different aspects usually studied in point process theory.

# JumpProcesses.jl: Stochastic Simulation Algorithms for Jump Processes, Jump-ODEs, and Jump-Diffusions

JumpProcesses.jl provides methods for simulating jump and point processes.
Across different fields of science, such methods are also known as stochastic
simulation algorithms (SSAs), Doob's method, Gillespie methods, Kinetic Monte
Carlo's methods, thinning method, and Ogata's method. It also enables the
incorporation of jump processes into hybrid jump-ODE models, including
piecewise deterministic Markov processes, and into hybrid jump-SDE models,
including jump diffusions. It is a component package in the
[SciML](https://sciml.ai/) ecosystem, and one of the core solver libraries
included in
[DifferentialEquations.jl](https://docs.sciml.ai/DiffEqDocs/stable/).

Historically, jump processes have been developed in the context of dynamical
systems to describe dynamics with discontinuous changes — the jumps — in a system's
value at random times. In contrast, the development of point processes has been
more focused on describing the occurrence of random events — the points — over
a support. However, both jump and point processes share many things in common
which make JumpProcesses ideal for their study.

As jump and point processes are often considered from a variety of perspectives
across different fields, JumpProcesses provides three tutorials on using the
package for those with different backgrounds:

  - [Simulating basic Poisson processes](@ref poisson_proc_tutorial)
  - [Simulating jump processes via SSAs (i.e., Gillespie methods)](@ref ssa_tutorial)
  - [Simulating temporal point processes (TPPs)](@ref tpp_tutorial)

These tutorials also explain the types of jump/point processes that can be
mathematically modelled with JumpProcesses.jl. For more complicated models that
couple ODEs and/or SDEs with continuous noise to jump processes, we provide a
tutorial on

  - [Simulating jump-diffusion processes](@ref jump_diffusion_tutorial)

For jump processes that involve spatial transport on a graph/mesh, such
as Reaction-Diffusion Master Equation models, we provide a tutorial on

  - [Spatial SSAs](@ref Spatial-SSAs-with-JumpProcesses.jl)

Finally, we provide application tutorials which are more extensive tutorials that
interface with other libraries going deeper into a topic.

  - [Temporal Point Processes (TPP) with JumpProcesses and PointProcesses](@ref tpp_advanced)

We provide a mathematical overview of the library below, but note users may also
skip to the appropriate tutorial listed above to get started with using
JumpProcesses.

## Mathematical Overview

Let ``dN_i(t)`` be a stochastic process such that ``dN_i(t) = 1`` with some
probability and ``0`` otherwise. That is, ``dN_i(t)`` encodes that a "jump" in
the value of ``N_i(t)`` by one occurs at time ``t``. Denote the rate, i.e.
probability per time, that such jumps occur by the intensity function,
``\lambda_i(u(t), p, t)``. Here ``u(t)`` represents a vector of dynamic state
variables, that may change when ``N_i(t)`` jumps. For example, these could be
the size of a population changing due to births or deaths, or the number of
mRNAs and proteins within a cell (which jump when a gene is transcribed or an
mRNA is translated). ``p`` represents parameters the intensity may depend on.

In different fields ``\lambda_i`` can also be called a propensity, transition
rate function, or a hazard function. Note, if we denote ``N(t) \equiv N[0, t)``
as the number of points since the start of time until ``t``, exclusive of ``t``,
then ``N(t)`` is a stochastic random integer measure. In other words, we have a
temporal point process (TPP).

In JumpProcesses.jl's language, we call ``\lambda_i`` a rate function, and
expect users to provide a function, `rate(u,p,t)`, that returns its value at
time `t`. Given a collection of rates ``\{\lambda_i\}_{i=1}^I``, JumpProcesses
can then generate exact realizations of pure jump processes of the form

```math
du = \sum_{i=1}^I h_i(u,p,t) \, dN_i(t),
```

where ``h_i(u,p,t)`` represents the amount that ``u(t)`` changes when ``N_i(t)``
jumps. JumpProcesses encodes such changes via a user-provided `affect!`
function, which allows even more general changes to the state, ``u(t)``, when
``N_i(t)`` jumps than just incrementing it by ``h_i(u,p,t)``. For example, such
changes can themselves be random, allowing for the calculation of marks. In the
special case of just one jump, ``I = 1``, with ``h_1 = 1``, we recover the
temporal point process mentioned above.

JumpProcesses provides a variety of algorithms, called *aggregators*, for
determining the next time that a jump occurs, and which ``N_i(t)`` jumps at that
time. Many of these are optimized for contexts in which each ``N_i(t)`` only
changes the values of a few components in ``u(t)``, as common in many
applications such as stochastic chemical kinetics (where each ``N_i``
corresponds to a different reaction, and each component of ``u`` a different
species). To simulate ``u(t)`` users must then specify both an aggregator
algorithm to determine the time and type of jump that occurs, and a
time-stepping method to advance the state from jump to jump. See the tutorials
listed above, and reference links below, for more details and examples.

JumpProcesses also allows such jumps to be coupled into ODE models (i.e.
piecewise deterministic Markov Processes), or continuous-noise SDE models (i.e.
jump-diffusions). For example, a jump-diffusion JumpProcesses can
simulate would be

```math
du = f(u,p,t)dt + \sum_{i}g_i(u,t)dW_i(t) + \sum_{j}h_j(u,p,t)dN_j(t)
```

where ``f`` encodes the drift of the process, each ``g_i`` the strength of a
diffusion component of the process, and each ``W_i(t)`` denotes an independent
standard Brownian Motion.

JumpProcesses is designed to simulate all the types of jumps described above.

## Reference Documentation

In addition to the tutorials linked above, the documentation contains

  - [References on the types of jumps and available simulation methods](@ref jump_problem_type)
  - [References on jump time stepping methods](@ref jump_solve)
  - [An FAQ with information on changing parameters between simulations and using callbacks](@ref FAQ)
  - [API documentation](@ref JumpProcesses.jl-API)

## Installation

There are two ways to install `JumpProcesses.jl`. First, users may install the meta
`DifferentialEquations.jl` package, which installs and wraps `OrdinaryDiffEq.jl`
for solving ODEs, `StochasticDiffEq.jl` for solving SDEs, and `JumpProcesses.jl`,
along with a number of other useful packages for solving models involving ODEs,
SDEs and/or jump process. This single install will provide the user with all
the facilities for developing and solving Jump problems.

To install the `DifferentialEquations.jl` package, refer to the following link
for complete [installation
details](https://docs.sciml.ai/DiffEqDocs/stable).

If the user wishes to install the `JumpProcesses.jl` library separately, which is a
lighter dependency than `DifferentialEquations.jl`, then the following code will
install `JumpProcesses.jl` using the Julia package manager:

```julia
using Pkg
Pkg.add("JumpProcesses")
```

## Contributing and Getting Help

  - Please refer to the
    [SciML ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://github.com/SciML/ColPrac/blob/master/README.md)
    for guidance on PRs, issues, and other matters relating to contributing to SciML.

  - See the [SciML Style Guide](https://github.com/SciML/SciMLStyle) for common coding practices and other style decisions.
  - There are a few community forums for getting help and asking questions:
    
      + The #diffeq-bridged and #sciml-bridged channels in the
        [Julia Slack](https://julialang.org/slack/)
      + The #diffeq-bridged and #sciml-bridged channels in the
        [Julia Zulip](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
      + The [Julia Discourse forums](https://discourse.julialang.org)
      + See also the [SciML Community page](https://sciml.ai/community/)

## Reproducibility

```@raw html
<details><summary>The documentation of this SciML package was built using these direct dependencies,</summary>
```

```@example
using Pkg # hide
Pkg.status() # hide
```

```@raw html
</details>
```

```@raw html
<details><summary>and using this machine and Julia version.</summary>
```

```@example
using InteractiveUtils # hide
versioninfo() # hide
```

```@raw html
</details>
```

```@raw html
<details><summary>A more complete overview of all dependencies and their versions is also provided.</summary>
```

```@example
using Pkg # hide
Pkg.status(; mode = PKGMODE_MANIFEST) # hide
```

```@raw html
</details>
```

```@eval
using TOML
using Markdown
projtoml = joinpath("..", "..", "Project.toml")
version = TOML.parse(read(projtoml, String))["version"]
name = TOML.parse(read(projtoml, String))["name"]
link_manifest = "https://github.com/SciML/" * name * ".jl/tree/gh-pages/v" * version *
                "/assets/Manifest.toml"
link_project = "https://github.com/SciML/" * name * ".jl/tree/gh-pages/v" * version *
               "/assets/Project.toml"
Markdown.parse("""\nYou can also download the
[manifest]($link_manifest)
file and the
[project]($link_project)
file.
""")
```
